//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : CmnDef.h
//	ABSTRACT  : ʒ`pwb_[t@C
//	
//	CREATE    : Y.Yoshinobu	2006.9.27
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#ifndef _CMNDEF_H_
#define _CMNDEF_H_

#include "NpsCommand.h"
#include "NpsImg.h"

// 
// define`
#define	MyNPSIFVersion	0x0100				// {CuĂ NPS I/F ̃o[W

#define	PRTY_NORMAL		0x00000001			// ʏ
#define	PRTY_EXPRESS1	0x00000002			// }(Level1)
#define	PRTY_EXPRESS2	0x00000004			// }(Level2)
#define	PRTY_ALL		0xFFFFFFFF			// S

// 
// enum`
enum E_QueModeP
{	// vg̗D惂[h
	QUE_NORMAL,			// ʏ
	QUE_EXPRESS1,		// }(Level1)
	QUE_EXPRESS2,		// }(Level2)
};

enum E_QueModeM
{	// vg̃e[h
	QUE_PRINT,			// ʏvg
	QUE_MAINTENANCE,	// eiX
};

enum E_PrintCmdType
{	// vgR}h̃^Cv
	CMD_ORDER_START,	// I[_[Jn
	CMD_FRAME,			// R}
	CMD_BLANK_FRAME,	// 󔒃R}
	CMD_SORTER,			// \[^[
	CMD_DUPLEX_START,	// ʈJn
	CMD_DUPLEX_END,		// ʈI
	CMD_ORDER_END,		// I[_[I
	CMD_RETRANSMISSION_START,	// đJn		2011.11.21 A.Nagamatsu
	CMD_RETRANSMISSION_END,		// đI		2011.11.21 A.Nagamatsu
};

enum E_PrintOrderStep
{	// v^Ƀvgv𔭍sۂ̎菇ǉ
	STEP0_ORDER_NONE = 0,		// STEP-0	
	STEP1_ORDER_6000_0500,		// STEP-1	v^LJnς
	STEP2_ORDER_IMG_CONNECT,	// STEP-2	摜Mp|[gƂ̃RlNVmς
	STEP3_ORDER_6000_1200,		// STEP-3	vgIvVݒς
	STEP4_ORDER_6000_0600,		// STEP-4	v^LIς
};

// QSS̎dlsΉ	2007.03.14 Y.Yoshinobu
// QSS̏ꍇ 6000_0700 ŃXv[tԂĂĂtς݂ƂȂ̂
// vgv~ꍇɂ́A6000_0900(LZv)𔭍sȂ΂ȂȂB
// ̑Ή̂߂ɁASTEPA_FRAME_6000_0700_13 ̏ԂǉĊmFł悤ɂB
enum E_PrintFrameStep
{	// v^Ƀvgv𔭍sۂ̎菇ǉ
	STEP0_FRAME_NONE = 0,		// STEP-0	
	STEP1_FRAME_IMGPROC,		// STEP-1	摜쐬
	STEPA_FRAME_6000_0700_13,	// STEP-A	tJnŃXv[t
	STEP2_FRAME_6000_0700,		// STEP-2	tJnς
	STEP3_FRAME_IMG_SEND,		// STEP-3	摜Mς
	STEP4_FRAME_6000_0800,		// STEP-4	摜MmFς
	STEP5_SORT_COMPLETE,		// STEP-5	\[gς
	STEP6_DELETE,				// STEP-6	폜
};

enum E_UpdateOrderStatus
{	// I[_[ԍXV[h
	UPDATE_NORMAL,				// ʏ
	UPDATE_OFFLINE,				// ItC(ؒf)
};

// 
// \̒`

// IccsXmlŎgp
typedef struct t_IccsXml
{
	short	priority;					// Dx
	char	IccsCmdFilePath[MAX_PATH];	// 摜␳R}hXMLt@C̃tpX
} T_ICCSXML, *	PT_ICCSXML;

// npsGetTransmitTime()Ŏ擾钼߂̉摜]Ԋi[p\
typedef struct
{
	DWORD				dwOrderId;			// I[_[ID
	DWORD				dwPrintID;			// vgʎq
	DWORD				dwTime;				// ]
} T_TransmitTimeInfo;

// npsDevPrint()̈i[p\
typedef struct
{
} T_PrnParam;

typedef struct
{
	DWORD	dwPaperWidth;		// y[p[̕ (PʁF0.1mm)
	DWORD	dwSurface;			// y[p[̖ʎ
	DWORD	dwPaperLength;		// y[p[̑蒷 (PʁF0.1mm)
	DWORD	dwFeed;				// @
	CHAR	szPaperName[32];	// y[p[
	DWORD	dwPrintNum;			// vg
	DWORD	dwResolution;		// ͉𑜓x
	DWORD	dwPaperPresence;	// }KWw
	WORD	wPrintQuality;		// @
} T_DuplexPaperInfo;

// CPrintQue::GetNextProcData() Ŏ擾
typedef struct
{
	E_QueModeP			eQueModeP;	// vg̗D惂[h
	E_QueModeM			eQueModeM;	// vg̃e[h
	E_PrintCmdType		eCmdType;	// vgR}h̃^Cv
	DWORD				dwOption;	// ꏈIvV
	DWORD				dwOrderId;	// I[_[ID
	DWORD				dwIndexNo;	// CfbNXԍ
	DWORD				dwPrintId;	// vgID
	WORD				wNpsImgPort;// 摜Mp̃|[gԍ

	// >>>>> đJnɎ擾 2011.11.22 A.Nagamatsu
	WORD				wOrderState;	// f̃I[_[
	WORD				wMainSideState;	// ʃvg̕\ʊJnm点
	WORD				wBackSideState;	// ʃvg̗ʊJnm点
	WORD				wPrintSide;		// ʃvg̃vg
	// <<<<<

} T_NextCmd;

typedef struct
{
	E_PrintOrderStep	eOrderStep;			// vgv̔s
	BOOL				bNpsImgConnect;		// NpsImgRlNg邵Ȃ
	WORD				wPossessionNo;		// Lԍ
	WORD				wSorterNum;			// vg̎d
	WORD				wInterruptMode;		// 荞݃[hi 0:荞݂Ȃ, 1:荞݂ j
	BOOL				bReOccupy;			// }ݏI̍ĐLǂ(V^(RD-151)ɂĎgp)		@@@RD-151Ή 2012.05.08 T.Mizushima
	ULONG				dwExOptions;		// gIvV(Pvg) 2014.10.28 M.Yamamoto
} T_StartOrderData;

typedef struct
{
	E_PrintFrameStep	eFrameStep;			// vgv̔s
	DWORD				dwPrintId;			// vgID
	ULONG				nReceiptNo;			// tԍ
	DWORD				dwSortFrame;		// R}̃\[g@\
	DWORD				dwSourceType;		// 摜f[^[̎󂯓n@i 0:Ln, 1:t@Cn j
	DWORD				dwDataLength;		// 摜f[^̃oCgTCYiPʁFBytej
	DWORD				dwOffset;			// 摜f[^̊i[ĂItZbg
	char				szName[MAX_PATH];	// t@C}bsOIuWFNg̓t@C
	WORD				wPossessionNo;		// Lԍ
	void*				pCompletionProc;	// vg󋵒ʒmR[obN֐|C^
	NPS_PrintInfo		tPrnParam;			// vgvp[^(NPSpp[^)
	E_PrintOrderStep	eOrderStep;			// I[_[Ŝ̏	2007.01.10 T.Mizushima
	DWORD				dwClearInk;			// NACN ( 0:Ȃ, 1: )
	WORD				wFirstPossessionNo;	// Lԍi tJnv(6000H-0700)̃I[_[ʎqɎgp j
	BOOL				bIccsXml;			// IccsXmltO
											//    TRUE:		npsDevPrintIccsXmlviIccsCall.dllpĉ摜sj
											//    FALSE:	LȊO
	T_ICCSXML			tIccsXml;			// IccsXml
} T_FrameData;

typedef struct
{
	WORD				wPossessionNo;		// Lԍ
} T_SortData;

typedef struct
{
	WORD				wPossessionNo;		// Lԍ
} T_StartDuplexData;

typedef struct
{
	WORD				wPossessionNo;		// Lԍ
} T_EndDuplexData;

typedef struct
{
	E_PrintOrderStep	eOrderStep;			// vgv̔s
	WORD				wPossessionNo;		// Lԍ
} T_EndOrderData;

typedef struct
{
	WORD				wPossessionNo;		// Lԍ
} T_CreditOrderData;

typedef struct
{
	WORD				wPossessionNo;		// Lԍ
	NPS_InterruptOrderInfo	tInterruptOrderParam;		// fLZ
} T_InterruptOrderInfoData;

// 
// NX`

class CIcwInfo
{
public:
	CIcwInfo() { Clear(); };
	virtual ~CIcwInfo() { Clear(); };
	void Clear()
	{
		m_bSuccess			= FALSE;
		m_bDeleteFile		= FALSE;
		m_SourceType		= IMGSRC_SHAREDMEM;
		m_FileOffset		= 0;
		m_ImageFormat		= 0;
		m_ImageCapacity		= 0;
		m_ImageWidth		= 0;
		m_ImageHeight		= 0;
		m_Resolution		= 0;
		m_SpRect.top		= 0;
		m_SpRect.bottom		= 0;
		m_SpRect.left		= 0;
		m_SpRect.right		= 0;
		m_PaperSize.cx		= 0;
		m_PaperSize.cy		= 0;
		m_PaperAdjustLeft	= 0;
		m_PaperAdjustRight	= 0;
		m_Angle				= PROC_ANGLE0;
		m_Espc				= 0;
		m_PaperFitting		= PROC_REALSIZE;
		m_EdgeEnhancement	= FALSE;
		m_WB.top			= 0;
		m_WB.bottom			= 0;
		m_WB.left			= 0;
		m_WB.right			= 0;
		m_PrintCenterOffset	= 0;
		m_strCmsFileName.Empty();
		m_strFileName.Empty();
	};

	const CIcwInfo& operator=(const CIcwInfo& src)
	{
		m_bSuccess			= src.m_bSuccess;
		m_bDeleteFile		= src.m_bDeleteFile;
		m_SourceType		= src.m_SourceType;
		m_FileOffset		= src.m_FileOffset;
		m_ImageFormat		= src.m_ImageFormat;
		m_ImageCapacity		= src.m_ImageCapacity;
		m_ImageWidth		= src.m_ImageWidth;
		m_ImageHeight		= src.m_ImageHeight;
		m_Resolution		= src.m_Resolution;
		m_SpRect			= src.m_SpRect;
		m_PaperSize			= src.m_PaperSize;
		m_PaperAdjustLeft	= src.m_PaperAdjustLeft;
		m_PaperAdjustRight	= src.m_PaperAdjustRight;
		m_Angle				= src.m_Angle;
		m_Espc				= src.m_Espc;
		m_PaperFitting		= src.m_PaperFitting;
		m_EdgeEnhancement	= src.m_EdgeEnhancement;
		m_WB				= src.m_WB;
		m_PrintCenterOffset	= src.m_PrintCenterOffset;
		m_strCmsFileName	= src.m_strCmsFileName;
		m_strFileName		= src.m_strFileName;

		return *this;
	}

public:

	BOOL				m_bSuccess;				//  ( TRUE:, FALSE:s )
	BOOL				m_bDeleteFile;			// 摜t@C폜邩 ( TRUE:폜, FALSE:폜Ȃ )
	ULONG				m_SourceType;			// 摜f[^[̎󂯓n@i 0:Ln, 1:t@Cn j
	ULONG				m_FileOffset;			// 摜f[^̊i[ĂItZbg
	UCHAR				m_ImageFormat;			// 摜tH[}bg
	ULONG				m_ImageCapacity;		// 摜e
	USHORT				m_ImageWidth;			// 摜̕
	USHORT				m_ImageHeight;			// 摜̍
	USHORT				m_Resolution;			// 摜̉𑜓x
	RECT				m_SpRect;				// XsI[o[̃TCYiPʁFPixelj
	SIZE				m_PaperSize;			// o͉摜̃TCY(SP) iPʁFPixelj
	int					m_PaperAdjustLeft;		// y[p[␳(WB␳l) iPʁF0.1mmj
	int					m_PaperAdjustRight;		// y[p[␳(WB␳lE) iPʁF0.1mmj
	USHORT				m_Angle;				// ]px
	SHORT				m_Espc;					// IJnʒu␳ iPʁF0.1mmj
	USHORT				m_PaperFitting;			// y[p[tBbeBO
	BOOL				m_EdgeEnhancement;		// GbW ( TRUE:, FALSE:Ȃ )
	RECT				m_WB;					// 㕔 iPʁFPixelj
	SHORT				m_PrintCenterOffset;	// 呖vgZ^[ʒuItZbgl (PʁF0.1mm)
	CString				m_strCmsFileName;		// CMSŎgpDatt@C ( ̎CMS͍sȂ )
	CString				m_strFileName;			// ͉摜t@C
};

class CIcwProcParam
{
public:
	CIcwProcParam() { Clear(); };
	virtual ~CIcwProcParam() { Clear(); };
	void Clear()
	{
		m_objInitParam.Clear();
		m_objResultParam.Clear();
	};

public:

	CIcwInfo			m_objInitParam;			// p[^
	CIcwInfo			m_objResultParam;		// ʃp[^

};

#endif // _CMNDEF_H_
