//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : DataManager.h
//	ABSTRACT  : CDataManager NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2006.9.21
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DATAMANAGER_H__B6E310E2_718F_4C7A_A61D_1D8F23023DC9__INCLUDED_)
#define AFX_DATAMANAGER_H__B6E310E2_718F_4C7A_A61D_1D8F23023DC9__INCLUDED_

#include "Nps.h"
#include "NkcComApi.h"
#include "NpsCommand.h"
#include "NpsCallbackUnit.h"

class CNpsCallbackUnit;

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//----------------------------------------
// UTC[J^C
//----------------------------------------
SYSTEMTIME	NpsUPCToLocalTime( USHORT * a );

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CDataManager
//	ABSTRACT : v^ǗNX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2006.09.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CDataManager  
{
public:

	enum E_State				// v^̏ [m_eState]
	{
		// PC̃CXg[
		STATE_SELFINST=1,	// PC̃CXg[

		// 
		STATE_NOTREADY,		// v^
		STATE_OFFLINE,		// ItC
		STATE_END,			// I iv^Ƃ̒ʐMؒfj

		// ҂
		STATE_IDLENG,		// 

		// 
		STATE_IDLEOK,		// AChEt
		STATE_PRNNG,		// vgEts
		STATE_PRNOK,		// vgEt
	};

	enum E_OccupyState			// L		2006.11.07 T.Mizushima ǉ
	{
		OCCUPY_STATE_NONE = 0,	// L
		OCCUPY_STATE_NORMAL,	// ʏL
		OCCUPY_STATE_EXPRESS1,	// }L[x1]
		OCCUPY_STATE_EXPRESS2,	// }L[x2]
	};

	enum E_CustomCode				// JX^vt@C̃y[p[^CvR[h	2011.06.28 Y.Atoji
	{
		CUSTOM_CODE_MIN = 0x8000,	// ŏl
		CUSTOM_CODE_MAX = 0xFFFE,	// ől
	};

public:
	CDataManager();									// RXgN^
	virtual ~CDataManager();						// fXgN^

	//----------------------------------------
	// {ݒ
	//----------------------------------------

	void	Init(
		DWORD						dwIPAddress,			// v^IPAhX
		USHORT						wNpsPortNo,				// v^NPSp|[gԍ
		HPRINTER					hPrinter,				// v^nh
		CNpsCallbackUnit *			pCallbackUnit,			// jbgԕωCxgʒmNX
		void*						pFuncSetEvent,			// vg쓮֐|C^
		LPVOID						pParam					// eNX̃|C^
		);

	//----------------------------------------
	// Ԏ擾ݒ
	//----------------------------------------

	E_State	GetState();				// v^̏Ԃ擾

	BOOL	IsStateSELFINST();		// PC̃CXg[
	BOOL	IsStateINITNG();		// 
	BOOL	IsStateIDLNG();			// ҂
	BOOL	IsStateIDLOK();			// 
	BOOL	IsStateIDLOK2();		// 
	BOOL	IsStateIDLOK3();		// t\Es\

	void	SetStateOffline();	// ItCɕω
	void	RecvEventUnit( T_Nps6000H_F102H *pInfo );	// v^v^ԕύXʒm󂯂

	BOOL	IsPrintEnable( T_NextCmd* pNextCmd );		// vg\ȏԂǂ̊mF
	BOOL	IsEnableOccupy( T_NextCmd* pNextCmd, BOOL* pResume );		// v^L\ǂ̊mF

	//----------------------------------------
	// ݒ
	//----------------------------------------

	void	SetNpsVersion( USHORT NpsVersion );						// NPS I/F ̃o[W̐ݒ
	USHORT	GetNpsVersion();										// NPS I/F ̃o[W̎擾

	// 6000H	0101H
	void	SetPrinterBasic( T_Nps6000H_0101H* pNps6000H_0101H );	// v^{̐ݒ
	void	GetPrinterBasic( T_Nps6000H_0101H* pNps6000H_0101H );	// v^{̎擾
	void	GetPrinterBasicSoftName( CHAR* pSoftName );				// \tgEFA

	// 6000H	0201H
	void	SetPrinterSetup( T_Nps6000H_0201H* pNps6000H_0201H );	// v^ݒ̐ݒ
	void	GetPrinterSetup( T_Nps6000H_0201H* pNps6000H_0201H );	// v^ݒ̎擾
	ULONG	GetPrinterSetupRepeatCountMax();						// ő僊s[g
	USHORT	GetPrinterSetupSupportIntoPrinter();					// L݂̃T|[g
	UCHAR	GetPrinterSetupSorterStatus();							// \[^[̃gC̐
	USHORT	GetPrinterSetupSupportInterrupt();						// f݂̃T|[gԂ̎擾	@@@RD-151Ή	2012.02.09	T.Mizushima

	long	GetSetUpInfo( PNPS_SetUpInfo pSetUpInfo );				// ݒu擾
	long	GetTime ( PNPS_DateTime pTime );						// 擾

	// 6000H	0301H
	void	SetPrinterState( T_Nps6000H_0301H* pNps6000H_0301H );	// v^Ԃ̐ݒ
	void	GetPrinterState( T_Nps6000H_0301H* pNps6000H_0301H );	// v^Ԃ̎擾

	long	GetUnitInfo( PNPS_UnitInfo pUnitInfo );					// jbgԎ擾

	void	SetVersionInfo( T_Nps6002H_7305H* pNps6002H_7305H );	// v^o[W̐ݒ
	void	GetVersionInfo( T_Nps6002H_7305H* pNps6002H_7305H );	// v^o[W̎擾

	void	SetMachineSpecInfo( T_Nps6002H_732BH* pNps6002H_732BH );// @Bdl̐ݒ
	void	GetMachineSpecInfo( T_Nps6002H_732BH* pNps6002H_732BH );// @Bdl̎擾

	//----------------------------------------
	// }KW֘A
	//----------------------------------------

	void	SetMagInfo		( T_Nps6000H_0401H* pNps6000H_0401H );		// }KW񃊃Xg̐ݒ
	void	SetRegMagInfo	( T_Nps6000H_1301H* pNps6000H_1301H );		// o^}KW񃊃Xg̐ݒ

	long GetMagInfo( PNPS_MagInfo pMagInfo, DWORD* pdwSize );
	long GetAllMagInfo( PNPS_MagDetailInfo pMagDetailInfo, DWORD* pdwSize );

		// Ԃɂ}KWID̎擾
	UCHAR	GetMagazineID( UCHAR PaperPresence );

		// U\ȃ}KW
	USHORT	GetNumberOfMagazine();


		// v^ΉĂ}KWIdmF
	BOOL	IsEnableMagazineID( DWORD dwMagId );

		// y[p[^CvR[h擾
	BOOL	GetPaperTypeCode( DWORD dwWidth, DWORD dwPaperId, DWORD dwFeed, char* pPaperName, DWORD* pPaperTypeCode );

		// o^y[p[No`FbN (dDPp)
	BOOL	ChkRegistPaperNo( int nMaxCnt );

		// ZbgAbvĂy[p[ǂmF
	BOOL	IsSetupPaper( UCHAR PaperFeed, USHORT Resolution, USHORT PaperWidth, USHORT PaperLength, USHORT PaperId, CHAR* pPaperName );

		// WB␳l̎擾
	BOOL	GetPaperWBAdjust( UCHAR PaperFeed, USHORT Resolution, USHORT PaperWidth, USHORT PaperLength, USHORT PaperId, CHAR* pPaperName, SHORT* pWBAdjustLeft, SHORT* pWBAdjustRight );

		// y[p[̎擾
	BOOL	GetMagInfo( UCHAR PaperFeed, USHORT Resolution, USHORT PaperWidth, USHORT PaperLength, USHORT PaperId, CHAR* pPaperName, T_NpsRegMagInfo* pMagInfo );

	//----------------------------------------
	// v^Cxgʒm֘A
	//----------------------------------------

	BOOL	InsertEventInfo( T_Nps6000H_F202H* pEventInfo );					// CxgXgɒǉ
	BOOL	DeleteEventInfo( DWORD dwErrHandle );								// CxgXg폜
	BOOL	SelectEventInfo( DWORD dwErrHandle, T_Nps6000H_F202H* pEventInfo );	// nhCxg擾
	BOOL	SelectEventinfoByPos( DWORD dwPos, T_Nps6000H_F202H* pEventInfo );		// CfbNXCxg擾
	BOOL	DeleteEventInfo2( T_Nps6000H_F202H* pEventInfo, LONG* pSubCode, DWORD* pdwErrHandle );

	//----------------------------------------
	// ÑItCCxgʒm֌W
	//----------------------------------------
	BOOL	IsFirstConnect();						// Nǂ
	void	SetFirstConnect( BOOL bFirstConnect );	// N̐ݒ
	BOOL	IsEnableOfflineEvent();					// ItCCxgʒm邩ǂ
	void	SetEnableOfflineEvent( BOOL bEnable );	// ItCCxgʒm邩ǂ

	//----------------------------------------
	// }荞ݏ̍ĊJ^C~Ȍ
	//----------------------------------------
	void	SetRestartNormal( BOOL bRestartNormal );// }[Level1]荞ݏ̐LĊJ̏Ԃo^
	void	SetRestartExpress( BOOL bRestartExpress );// }[Level2]荞ݏ̐LĊJ̏Ԃo^

	// LԎ擾		2006.11.07 T.Mizushima
	E_OccupyState	GetOccupyState()	{	return m_OccupyState;	}
	// LԐݒ
	void			SetOccupyState( E_OccupyState state )	{	m_OccupyState = state;	}

	// ŏIM

	void	UpdateSendLastTime();					// ŏIMԂXV
	BOOL	IsSendConnectCheck();					// ڑmFv𔭍s邩ǂmF


	// 摜M(ԍŋ߂̑MԂi[)

	void	SetLastImgTransmitTime( T_TransmitTimeInfo *pstLastImgTransmitTime );				// ԍŋ߂ɉ摜𑗐MԂZbg
	void	GetLastImgTransmitTime( T_TransmitTimeInfo *pstLastImgTransmitTime );				// ԍŋ߂ɉ摜𑗐MԂ擾


#if defined(NKC_CMS_PROC)

	//----------------------------------------
	// 揈W[̓mF֌W
	//----------------------------------------
	void	SetExistGProProc( BOOL bExistGProProc );	// GProp摜W[CXg[Ă邩Zbgi TRUE:݂, FALSE:݂Ȃ j

	BOOL	IsEnableGProProc();							// GProp摜Lǂ𒲂ׂ

#endif // defined(NKC_CMS_PROC)

private:

		// y[p[TCYiPʁF0.1mmjvgTCYiPʁFPixelj
	BOOL	GetMagSizeToImgSize( DWORD dwPaperWidth, DWORD dwPaperLength, DWORD dwPaperResolution, DWORD* pWidth, DWORD* pHeight );

	//----------------------------------------
	// v^ݒ
	//----------------------------------------

	void	UpdateState( BOOL bIsOnline = TRUE );	// v^̏Ԃ̍XV

	void	SetDefault();				// v^ꎮftHgɂ

	void	SetDefaultNpsVersion();		// NPS I/F ̃o[W̃ftHgݒ
	void	SetDefaultPrinterBasic();	// v^{̃ftHgݒ
	void	SetDefaultPrinterSetup();	// v^ݒ̃ftHgݒ
	void	SetDefaultPrinterState();	// v^Ԃ̃ftHgݒ
	void	SetDefaultMagInfo();		// }KW񃊃Xg̃ftHgݒ
	void	SetDefaultAllMagInfo();		// S}KW񃊃Xg̃ftHgݒ

	void	ClearMagInfo();				// }KW񃊃Xg̃NA
	void	ClearAllMagInfo();			// S}KW񃊃Xg̃NA
	void	ClearEventInfo();			// Cxg񃊃Xg̃NA

	T_NpsRegMagInfo*	SelectMagInfo( USHORT PaperWidth, USHORT PaperId, UCHAR PaperFeed, CHAR* pPaperName );	// y[p[̎擾

	//----------------------------------------
	// jbgԕωʒm
	//----------------------------------------
	void	CallbackUnit( long lUnitId, short iNewStatus, short iOldStatus );
	void	CallbackUnitNps( const T_Nps6000H_0301H& PrinterStateNew, E_State eStateNew, const T_Nps6000H_0301H& PrinterStateOld, E_State eStateOld );

private:

	//----------------------------------------
	// {iv^ԕύXʒmɕKvȏj
	//----------------------------------------
	DWORD						m_dwIPAddress;				// v^IPAhX
	USHORT						m_wNpsPortNo;				// v^NPSp|[gԍ
	HPRINTER					m_hPrinter;					// v^nh
	CNpsCallbackUnit *			m_pCallbackUnit;			// jbgԕωCxgʒmNX
	void*						m_pFuncSetEvent;			// vg쓮֐|C^
	LPVOID						m_pParam;					// eNX̃|C^

	//----------------------------------------
	// v^̃A^Cȏ
	//----------------------------------------
	E_State							m_eState;				// v^̏

	USHORT							m_NpsVersion;			// NPS I/F ̃o[W

	T_Nps6000H_0101H				m_Nps6000H_0101H;		// v^{
	T_Nps6000H_0201H				m_Nps6000H_0201H;		// v^ݒ
	T_Nps6000H_0301H				m_Nps6000H_0301H;		// v^
	T_Nps6002H_7305H				m_Nps6002H_7305H;		// v^o[W	2006.12.01 T.Mizushima
	T_Nps6002H_732BH				m_Nps6002H_732BH;		// @Bdl				2008.01.23 Y.Yoshinobu
	std::vector<T_NpsMagInfo*>		m_vMagInfo;				// }KW񃊃Xg
	std::vector<T_NpsRegMagInfo*>	m_vAllMagInfo;			// S}KW񃊃Xg
	std::vector<T_Nps6000H_F202H*>	m_vEventInfo;			// v^CxgʒmXg

	CRITICAL_SECTION	m_CS;			// NeBJZNV

	//----------------------------------------
	// ÑItCCxgʒmɕKvȏ
	//----------------------------------------
	BOOL						m_bFirstConnect;			// ڑǂi TRUE:ڑ, FALSE:ڑłȂ j
	BOOL						m_bEnableOfflineEvent;		// ItCCxgʒm邩ǂi TRUE:ʒm, FALSE:ʒmȂ j

	//----------------------------------------
	// }荞ݏ̍ĊJ^C~Ȍ
	//----------------------------------------
	BOOL						m_bRestartNormal;			// }[x1]荞ݏ̐LĊJ̏ԁi TRUE:L[ĊJ҂], FALSE:L j
	BOOL						m_bRestartExpress;			// }[x2]荞ݏ̐LĊJ̏ԁi TRUE:L[ĊJ҂], FALSE:L j

	// L
	E_OccupyState				m_OccupyState;				// L		2006.11.07 T.Mizushima

	//----------------------------------------
	// ŏIM
	//----------------------------------------

	SYSTEMTIME					m_stSendLastTime;			// ŏIM

	//----------------------------------------
	// 摜M
	//----------------------------------------

	T_TransmitTimeInfo			m_stLastImgTransmitTime;	// 摜M(ԍŋ߂̑MԂi[)


#if defined(NKC_CMS_PROC)

	//----------------------------------------
	// 揈W[̓֌W
	//----------------------------------------
	BOOL						m_bExistGProProc;			// 摜W[GProgpł邩i TRUE:gpł, FALSE:gpłȂ j

#endif // defined(NKC_CMS_PROC)

};

#endif // !defined(AFX_DATAMANAGER_H__B6E310E2_718F_4C7A_A61D_1D8F23023DC9__INCLUDED_)
