#ifndef NKC_IMAGE_FILE_EXIFTAGS_H
#define NKC_IMAGE_FILE_EXIFTAGS_H
/*
	m[c|@p File I/O Interface: EXIF Tag Class

	Copyright(C) 2001 Ichikawa Soft Laboratory

	ClassJpeg Level-3  EXIF ^Ô߂ Class łB

*/

// unsigned long ŕ\킳镪
typedef struct NKC_Image_File_JPG_ExifTags_Rational {
	unsigned long numerator;	// q
	unsigned long denominator;	// 
} NKC_Image_File_JPG_ExifTags_Rational;

// signed long ŕ\킳镪
typedef struct NKC_Image_File_JPG_ExifTags_SRational {
	long numerator;	// q
	long denominator;	// 
} NKC_Image_File_JPG_ExifTags_SRational;

//WhitePoint
#define DEF_WhitePoint_RATIO_SIZE 2
//PrimaryChromaticities
#define DEF_PrimaryChromaticities_RATIO_SIZE 6
//YCbCrCoefficients
#define DEF_YCbCrCoefficients_RATIO_SIZE 3

//R[ȟ^
typedef enum
{
	EStrCode_ASCII = 0,	// ASCII
	EStrCode_JIS = 1,	// JIS
	EStrCode_UNICODE = 2,	// UNICODE
	EStrCode_UNDEFINED = 3	// UNDEFINED
} NKC_Image_File_JPG_ExifTags_StrCode;

#define DEF_COLOR_SPACE_SRGB     0x0001
#define DEF_COLOR_SPACE_ADOBERGB 0xFFFF


// ǂݍރobt@̍őoCgBchar* ^̏ꍇɎg܂
#define NKC_Image_File_JPG_ExifTags_MAXBUF	65534
#define NKC_Image_File_JPG_ExifTags_MAXWORD	(65534 / sizeof(WORD))


/*
Class Exif ^O߂̊֐݂̂L鏃z֐݂̂ō\ ClassƂĒ`܂B
Application͊{IɂClassInstance JPGConv.DLL ɗpӂ Create(4) ֐gpč쐬܂B
Set...() ͒lݒ肵܂B
Del...() ͐ݒ𖳌ɂ܂B
Get...() ͒l擾܂B
ϒ͎ 2 ނ܂B
char* ascii ƂȂĂ
	NULL ŏIĂ镶łBő NKC_Image_File_JPG_ExifTags_MAXBUF ǂݍ܂܂B
WORD* (ISOSpeedRatings)  BYTE* (CFAPattern)
Get...Count() ŗvf̐𓾂܂B
*/
class NKC_Image_File_JPG_ExifTags {
public:
	virtual ~NKC_Image_File_JPG_ExifTags() {};
public:
	// 摜͋@̃[J[
	virtual BOOL GetMake(char* ascii) = 0;
	virtual BOOL SetMake(char* ascii) = 0;
	virtual BOOL DelMake() = 0;

	// 摜͋@̃f
	virtual BOOL GetModel(char* ascii) = 0;
	virtual BOOL SetModel(char* ascii) = 0;
	virtual BOOL DelModel() = 0;

	virtual BOOL GetOrientation(WORD* orientation) = 0;
	virtual BOOL SetOrientation(WORD* orientation) = 0;
	virtual BOOL DelOrientation() = 0;

	virtual BOOL GetSoftware(char* ascii) = 0;
	virtual BOOL SetSoftware(char* ascii) = 0;
	virtual BOOL DelSoftware() = 0;

	virtual BOOL SetDateTime(char* ascii) = 0;
	virtual BOOL DelDateTime() = 0;

	virtual BOOL GetExifVersion(char* ascii) = 0;
	virtual BOOL SetExifVersion(char* ascii) = 0;
	virtual BOOL DelExifVersion() = 0;

	virtual BOOL SetInteroperabilityIndex(char* ascii) = 0;
	virtual BOOL DelInteroperabilityIndex() = 0;

	// 摜f[^̐
	virtual BOOL GetDateTimeOriginal(char* ascii) = 0;
	virtual BOOL SetDateTimeOriginal(char* ascii) = 0;
	virtual BOOL DelDateTimeOriginal() = 0;

	// fBW^f[^̐
	virtual BOOL GetDateTimeDigitized(char* ascii) = 0;
	virtual BOOL SetDateTimeDigitized(char* ascii) = 0;
	virtual BOOL DelDateTimeDigitized() = 0;

	// Io
	virtual BOOL GetExposureTime(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;

	// F io[
	virtual BOOL GetFNumber(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;

	// IovO
	virtual BOOL GetExposureProgram(WORD* n) = 0;

	// XyNgx
	virtual BOOL GetSpectralSensitivity(char* ascii) = 0;

	// ISO Xs[h[g
	// ۂ̗vf擾܂
	virtual BOOL GetISOSpeedRatings(WORD* pBuf) = 0;
	// vf (WORD) ̌擾܂
	virtual BOOL GetISOSpeedRatingsCount(int* count) = 0;

	// Vb^[Xs[h
	virtual BOOL GetShutterSpeedValue(NKC_Image_File_JPG_ExifTags_SRational* srational) = 0;

	// il
	virtual BOOL GetApertureValue(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;

	// Pxl
	virtual BOOL GetBrightnessValue(NKC_Image_File_JPG_ExifTags_SRational* srational) = 0;
	virtual BOOL SetBrightnessValue(NKC_Image_File_JPG_ExifTags_SRational* srational) = 0;
	virtual BOOL DelBrightnessValue() = 0;
	

	// I␳l
	virtual BOOL GetExposureBiasValue(NKC_Image_File_JPG_ExifTags_SRational* srational) = 0;

	// Yŏ F l
	virtual BOOL GetMaxApertureValue(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;

	// ʑ̋
	virtual BOOL GetSubjectDistance(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;
	virtual BOOL SetSubjectDistance(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;
	virtual BOOL DelSubjectDistance() = 0;

	// 
	virtual BOOL GetMeteringMode(WORD* mode) = 0;

	// 
	virtual BOOL GetLightSource(WORD* source) = 0;
	virtual BOOL SetLightSource(WORD* source) = 0;
	virtual BOOL DelLightSource() = 0;

	// tbV
	virtual BOOL GetFlash(WORD* n) = 0;
	virtual BOOL SetFlash(WORD* n) = 0;
	virtual BOOL DelFlash() = 0;
	
	// Yœ_
	virtual BOOL GetFocalLength(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;
	virtual BOOL SetFocalLength(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;
	virtual BOOL DelFocalLength() = 0;

	// tbVx
	virtual BOOL GetFlashEnergy(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;

	// œ_ʂ̉̕𑜓x
	virtual BOOL GetFocalPlaneXResolution(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;
	virtual BOOL SetFocalPlaneXResolution(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;
	virtual BOOL DelFocalPlaneXResolution() = 0;

	// œ_ʂ̍̉𑜓x
	virtual BOOL GetFocalPlaneYResolution(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;
	virtual BOOL SetFocalPlaneYResolution(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;
	virtual BOOL DelFocalPlaneYResolution() = 0;

	// œ_ʉ𑜓xP
	virtual BOOL GetFocalPlaneResolutionUnit(WORD* unit) = 0;
	virtual BOOL SetFocalPlaneResolutionUnit(WORD* unit) = 0;
	virtual BOOL DelFocalPlaneResolutionUnit() = 0;

	//SubjectArea
	virtual BOOL GetSubjectArea(WORD* pBuf) = 0;
	virtual BOOL SetSubjectArea(WORD* pBuf) = 0;
	virtual BOOL DelSubjectArea() = 0;
	virtual BOOL GetSubjectAreaCount(int* count) = 0;
	virtual BOOL SetSubjectAreaCount(int* count) = 0;

	// ʑ̈ʒu
	virtual BOOL GetSubjectLocation(WORD* x, WORD* y) = 0;
	virtual BOOL SetSubjectLocation(WORD* x, WORD* y) = 0;
	virtual BOOL DelSubjectLocation() = 0;

	//ȉAVKǉ(APP1)-------------------------
	//[U[Rg
	//virtual BOOL GetUserComment(char* ascii) = 0;
	//virtual BOOL SetUserComment(char* ascii) = 0;
	//virtual BOOL DelUserComment() = 0;
	//Vdl
	virtual BOOL SetUserComment(BYTE* pBuf, int* nSize, NKC_Image_File_JPG_ExifTags_StrCode* code) = 0;
	virtual BOOL GetUserComment(BYTE* pBuf, int* nSize) = 0;
	virtual BOOL GetUserCommentCount(int* count) = 0;
	virtual BOOL GetUserCommentCode(NKC_Image_File_JPG_ExifTags_StrCode* code) = 0;
	virtual BOOL DelUserComment() = 0;
	
	//ʉʏ
	virtual BOOL GetCustomRendered(WORD* rendered) = 0;
	virtual BOOL SetCustomRendered(WORD* rendered) = 0;
	virtual BOOL DelCustomRendered() = 0;

	//zCgoX
	virtual BOOL GetWhiteBalance(WORD* balance) = 0;
	virtual BOOL SetWhiteBalance(WORD* balance) = 0;
	virtual BOOL DelWhiteBalance() = 0;
	
	//fBW^Y[{
	virtual BOOL GetDigitalZoomRatio(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;
	virtual BOOL SetDigitalZoomRatio(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;
	virtual BOOL DelDigitalZoomRatio() = 0;

	//35mmZYœ_
	virtual BOOL GetFocalLengthIn35mmFilm(WORD* fl35mmfilm) = 0;
	virtual BOOL SetFocalLengthIn35mmFilm(WORD* fl35mmfilm) = 0;
	virtual BOOL DelFocalLengthIn35mmFilm() = 0;
	
	//BeV[^Cv
	virtual BOOL GetSceneCaptureType(WORD* capturetype) = 0;
	virtual BOOL SetSceneCaptureType(WORD* capturetype) = 0;
	virtual BOOL DelSceneCaptureType() = 0;

	//QC
	virtual BOOL GetGainControl(WORD*  gaincontrol) = 0;
	virtual BOOL SetGainControl(WORD*  gaincontrol) = 0;
	virtual BOOL DelGainControl() = 0;
	
	//BeRgXg
	virtual BOOL GetContrast(WORD* contrast) = 0;
	virtual BOOL SetContrast(WORD* contrast) = 0;
	virtual BOOL DelContrast() = 0;

	//Beʓx
	virtual BOOL GetSaturation(WORD* saturation) = 0;
	virtual BOOL SetSaturation(WORD* saturation) = 0;
	virtual BOOL DelSaturation() = 0;

	//BeV[vlX
	virtual BOOL GetSharpness(WORD* shapness) = 0;
	virtual BOOL SetSharpness(WORD* sharpness) = 0;
	virtual BOOL DelSharpness() = 0;

	//ʑ̋W
	virtual BOOL GetSubjectDistanceRange(WORD* range) = 0;
	virtual BOOL SetSubjectDistanceRange(WORD* range) = 0;
	virtual BOOL DelSubjectDistanceRange() = 0;

	//摜j[Nhc
	virtual BOOL GetImageUniqueID(char* ascii) = 0;
	virtual BOOL SetImageUniqueID(char* ascii) = 0;
	virtual BOOL DelImageUniqueID() = 0;

	// IoCfbNX
	virtual BOOL GetExposureIndex(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;

	// ZT[
	virtual BOOL GetSensingMethod(WORD* method) = 0;

	// t@C\[X
	virtual BOOL GetFileSource(WORD* source) = 0;

	// V[^Cv
	virtual BOOL GetSceneType(WORD* type) = 0;

	// CFA p^[
	// ۂ̗vf擾܂
	virtual BOOL GetCFAPattern(BYTE* pBuf) = 0;
	// vf (WORD) ̌擾܂
	virtual BOOL GetCFAPatternCount(int* count) = 0;

	// APP3̃^f[^̃o[W
	virtual BOOL SetMetadataVersionNum(char* ascii) = 0;
	virtual BOOL DelMetadataVersionNum() = 0;

	// 摜؂oTCY
	virtual BOOL SetIntendedPrintArea(WORD* printarea) = 0;
	virtual BOOL DelIntendedPrintArea() = 0;

	// 摜擾
	virtual BOOL SetImageSource(WORD* imagesource) = 0;
	virtual BOOL DelImageSource() = 0;

	// gpXLĩ\tgEFA
	virtual BOOL SetScannerSoftware(char* ascii) = 0;
	virtual BOOL DelScannerSoftware() = 0;

	// R}io[
	virtual BOOL SetScanFramSeqNum(WORD* scanframseqnum) = 0;
	virtual BOOL DelScanFramSeqNum() = 0;

	// tB̃TCY
	virtual BOOL SetFilmSize(WORD* filmsize) = 0;
	virtual BOOL DelFilmSize() = 0;

	// 摜̏C
	virtual BOOL SetEditTagArray(WORD* edittagarray) = 0;
	virtual BOOL DelEditTagArray() = 0;

	// tB̐ԍ
	virtual BOOL SetFilmProductCode(char* ascii) = 0;
	virtual BOOL DelFilmProductCode() = 0;

	//APSJ̃I[i[ID
	virtual BOOL SetCameraOwnerID(char* ascii) = 0;
	virtual BOOL DelCameraOwnerID() = 0;

	//APStB̃O[vLvV
	virtual BOOL SetGroupCaption(char* ascii) = 0;
	virtual BOOL DelGroupCaption() = 0;

	//I[_[ID
	virtual BOOL SetOrderID(char* ascii) = 0;
	virtual BOOL DelOrderID() = 0;

	//tB̎
	virtual BOOL SetFilmCategory(WORD* category) = 0;
	virtual BOOL DelFilmCategory() = 0;

	//tBGenCode
	virtual BOOL SetFilmgenCode(char* ascii) = 0;
	virtual BOOL DelFilmgenCode() = 0;

	//g嗦
	virtual BOOL SetMagnification(NKC_Image_File_JPG_ExifTags_Rational* rational) = 0;
	virtual BOOL DelMagnification() = 0;


	//QƔF_̐FxWl R/w
	//BOOL b_WhitePoint;
	//NKC_Image_File_JPG_ExifTags_SRational *m_WhitePoint[2];
	virtual BOOL GetWhitePoint(	NKC_Image_File_JPG_ExifTags_Rational* rational , int get_size ) = 0;

	//F̐FxWl R/w
	//BOOL b_PrimaryChromaticities;
	//NKC_Image_File_JPG_ExifTags_SRational m_PrimaryChromaticities[6];
	virtual BOOL GetPrimaryChromaticities( NKC_Image_File_JPG_ExifTags_Rational* rational , int get_size ) = 0;

	//Fϊ}gNXW R/w
	//BOOL b_YCbCrCoefficients;
	//NKC_Image_File_JPG_ExifTags_SRational m_YCbCrCoefficients[3];
	virtual BOOL GetYCbCrCoefficients( NKC_Image_File_JPG_ExifTags_Rational* rational , int get_size ) = 0;

	//Fԏ R/W
	//BOOL b_ColorSpace;
	//WORD m_ColorSpace;
	virtual BOOL GetColorSpace( WORD* ColorSpace ) = 0;
	virtual BOOL SetColorSpace( WORD* ColorSpace ) = 0;
	virtual BOOL DelColorSpace() = 0;

	//Io[h R
	//BOOL b_ExposureMode;
	//WORD m_ExposureMode;
	virtual BOOL GetExposureMode( WORD* ExposureMode ) = 0;

	//BeLq R
	//BOOL b_DeviceSettingDescription;
	//char m_DeviceSettingDescription[260];
	virtual BOOL GetDeviceSettingDescription( char* DeviceSettingDescription ) = 0;

	//ĐK} R
	//BOOL b_Gamma;
	//NKC_Image_File_JPG_ExifTags_SRational m_Gamma;
	virtual BOOL GetGamma( NKC_Image_File_JPG_ExifTags_Rational* rational ) = 0;

};

#endif
