//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : MakeCompositeImage.cpp
//	ABSTRACT  : CMakeCompositeImage NX̃Cve[V
//	
//	CREATE    : T.Isogai	2009.11.25	EZ Controller 6x6C` tHgubNΉ
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MakeCompositeImage.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CMakeCompositeImage::CMakeCompositeImage()
//	ABSTRACT : RXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CMakeCompositeImage::CMakeCompositeImage()
{
	m_strLastError = "";
	m_nLineNum = MAKE_COMPOSITE_IMAGE_LINE;
	Reset();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CMakeCompositeImage::~CMakeCompositeImage()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CMakeCompositeImage::~CMakeCompositeImage()
{
	Reset();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CMakeCompositeImage::Initialize()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note >
//
//	ARGUMENT :
//				nWidth			쐬摜TCYiP:1sNZj
//				nHeight			쐬摜TCYiP:1sNZj
//				strFilePath		쐬摜t@CpX
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CMakeCompositeImage::Initialize(int nWidth, int nHeight, CString strFilePath)
{
	m_nWidth = nWidth;
	m_nHeight = nHeight;
	m_strFilePath = strFilePath;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CMakeCompositeImage::Reset()
//	ABSTRACT : `施߃Zbg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//	
//	RETURN   : G[R[h
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CMakeCompositeImage::Reset()
{
	for(std::vector<CDrawObj*>::iterator itpObj = m_vDrawObj.begin(); m_vDrawObj.end() != itpObj; itpObj++)
	{
		CDrawObj* pObj = *itpObj;
		delete pObj;
	}

	m_vDrawObj.clear();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CMakeCompositeImage::DrawImage()
//	ABSTRACT : `施 摜t@C
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				Trim1			摜؂oʒuiP:1sNZj
//				Trim2			؂oꂽ̂̓\tʒuiP:1sNZj
//				strFilePath		摜rbg}bvt@CpX
//	
//	RETURN   : G[R[h
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CMakeCompositeImage::DrawImage(RECT Trim1, RECT Trim2, CString strFilePath)
{
	CDrawObjImage *pObj = new CDrawObjImage();

	pObj->m_Trim1 = Trim1;
	pObj->m_Trim2 = Trim2;
	pObj->m_strFilePath = strFilePath;

	m_vDrawObj.push_back(pObj);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CMakeCompositeImage::DrawLine()
//	ABSTRACT : `施 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				X1			JnʒuXiP:1sNZj
//				Y1			JnʒuYiP:1sNZj
//				X2			IʒuXiP:1sNZj
//				Y2			IʒuYiP:1sNZj
//				Color		F
//	
//	RETURN   : G[R[h
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CMakeCompositeImage::DrawLine(int X1, int Y1, int X2, int Y2, COLORREF Color)
{
	CDrawObjLine *pObj = new CDrawObjLine();

	pObj->m_P1.x = X1;
	pObj->m_P1.y = Y1;

	pObj->m_P2.x = X2;
	pObj->m_P2.y = Y2;

	pObj->m_Color = Color;

	m_vDrawObj.push_back(pObj);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CMakeCompositeImage::DrawRect()
//	ABSTRACT : `施 `
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				left			hԂ`ʒu iP:1sNZj
//				top				hԂ`ʒu iP:1sNZj
//				right			hԂ`ʒu EiP:1sNZj
//				bottom			hԂ`ʒu iP:1sNZj
//				Color			hԂF
//	
//	RETURN   : G[R[h
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CMakeCompositeImage::DrawRect(int left, int top, int right, int bottom, COLORREF Color)
{
	CDrawObjRect *pObj = new CDrawObjRect();

	pObj->m_Rect.left	= left;
	pObj->m_Rect.top	= top;
	pObj->m_Rect.right	= right;
	pObj->m_Rect.bottom	= bottom;

	pObj->m_Color = Color;

	m_vDrawObj.push_back(pObj);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CMakeCompositeImage::DrawNumber()
//	ABSTRACT : `施 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				x			ItZbgijʒu xiP:1sNZj
//				y			ItZbgijʒu yiP:1sNZj
//				Number		li4̐̐j
//				color		F
//				nDegree		]px(vA0, 90,180, 270 ̂ݗLj
//							i(0)́Av90x]́iJ̕KvȂ߁jj
//	
//	RETURN   : G[R[h
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CMakeCompositeImage::DrawNumber(int x, int y, int Number, COLORREF color, int nDegree)
{
	CDrawObjNumber *pObj = new CDrawObjNumber();

	pObj->m_Offset.x = x;
	pObj->m_Offset.y = y;

	pObj->m_bTransparent = TRUE;
	pObj->m_TxColor = color;
	pObj->m_nDegree = nDegree;
	pObj->SetNumber(Number);

	m_vDrawObj.push_back(pObj);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CMakeCompositeImage::MakeCompositeImage()
//	ABSTRACT : 摜쐬
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : G[R[h
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
#define BFT_BITMAP	0x4d42   // 'BM'
CMakeCompositeImage::ECODE CMakeCompositeImage::MakeCompositeImage()
{
	//--------------------------------------------------------------------------------
	// <ꂩs̐>
	// @o͉摜t@C쐬rbg}bvt@Cwb_
	// AƗpCobt@̊m
	// BCobt@̏ioh[vj
	// @-Cobt@ւ̕`
	// @-Cobt@̃t@Cւ̏o
	// C`IuWFNgIi`挳t@C̃N[Yj
	// DƃCobt@̊J
	// Eo͉摜t@C̃N[Y
	//--------------------------------------------------------------------------------

	int idx;

	//--------------------------------------------------------------------------------
	// @o͉摜t@C쐬rbg}bvt@Cwb_
	//--------------------------------------------------------------------------------
	CFile File;
	int RowByte	= NkcComApi::RowByte( m_nWidth );

	try
	{
		//--------------------------
		// t@CI[v
		//--------------------------
		CFileException ex;

		if( !File.Open(m_strFilePath,
			CFile::modeCreate | CFile::modeRead | CFile::modeWrite | CFile::typeBinary, &ex) )
		{
			TCHAR szCause[1024];
			ex.GetErrorMessage(szCause, 1024);
			m_strLastError.Format("Error File Open : %s / %s(%d)", m_strFilePath, szCause, ex.m_cause);
			return ERR_HEADER_WRITE;
		}

		//---------------------------
		// wb_̐ݒ
		//---------------------------

		// BITMAPFILEHEADER
		BITMAPFILEHEADER FileHeader;
		FileHeader.bfType = BFT_BITMAP;
		FileHeader.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + RowByte * m_nHeight;
		FileHeader.bfReserved1 = 0;
		FileHeader.bfReserved2 = 0;
		FileHeader.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER)+  + sizeof(BITMAPINFOHEADER);

		// BITMAPINFOHEADER \̂̏
		BITMAPINFOHEADER InfoHeader;
		InfoHeader.biSize = sizeof(BITMAPINFOHEADER);
		InfoHeader.biWidth = m_nWidth;
		InfoHeader.biHeight = m_nHeight;
		InfoHeader.biPlanes = 1;
		InfoHeader.biBitCount = 24;
		InfoHeader.biCompression = BI_RGB;
		InfoHeader.biSizeImage = RowByte * m_nHeight;
		InfoHeader.biXPelsPerMeter = 0;
		InfoHeader.biYPelsPerMeter = 0;
		InfoHeader.biClrUsed = 0;
		InfoHeader.biClrImportant = 0;

		//---------------------------
		// wb_̏
		//---------------------------
		File.Write(&FileHeader, sizeof(BITMAPFILEHEADER));
		File.Write(&InfoHeader, sizeof(BITMAPINFOHEADER));
	}
	catch (CFileException* e)
	{
		TCHAR szCause[255];
		e->GetErrorMessage( szCause, 255 );
		m_strLastError.Format("Error Header Write : %s / %s(%d)", m_strFilePath, szCause, e->m_cause);
		e->Delete();
		return ERR_HEADER_WRITE;
	}

	//--------------------------------------------------------------------------------
	// AƗpCobt@̊m
	//--------------------------------------------------------------------------------
	unsigned char* pData = new unsigned char[RowByte * m_nLineNum];

	if(NULL == pData)
	{
		File.Close();
		m_strLastError.Format("Error Alloc Memory : %d Byte", RowByte * m_nLineNum);
		return ERR_MEMORY;
	}

	//--------------------------------------------------------------------------------
	// BCobt@̏ioh[vj
	//--------------------------------------------------------------------------------
	ECODE ecode = SUCCESS;
	int nLineCount = 0;

	while((m_nLineNum * nLineCount) < m_nHeight)
	{
		//---------------------------
		// ̈̏
		//---------------------------
		int nLine = m_nLineNum;

		if(((m_nLineNum * nLineCount) + m_nLineNum) >= m_nHeight)
		{
			nLine = m_nHeight - (m_nLineNum * nLineCount);
		}

		int nLine1 = nLineCount * m_nLineNum;
		int nLine2 = nLineCount * m_nLineNum + nLine - 1;
		int nLineNum = nLine2 - nLine1 + 1;

		//---------------------------
		// ̈̔hԂ
		//---------------------------
		int size = nLineNum * RowByte;

		for(idx = 0; idx < size; idx++)
		{
			pData[idx] = 255;
		}

		//---------------------------
		// ̈̐ݒ
		//---------------------------

		// rbg}bv䂦̏㉺t]l

		RECT rect;

		rect.left	= 0;
		rect.top	= m_nHeight - nLine2 - 1;
		rect.right	= m_nWidth -1;
		rect.bottom	= m_nHeight - nLine1 - 1;

		//---------------------------
		// ꂼ̏
		//---------------------------
		for(std::vector<CDrawObj*>::iterator itpObj = m_vDrawObj.begin(); m_vDrawObj.end() != itpObj; itpObj++)
		{
			CDrawObj::ECODE drawobjecode = (*itpObj)->Draw(pData, rect);

			if(CDrawObj::SUCCESS != drawobjecode)
			{
				m_strLastError.Format("Error DrawObj(%d) : %s : %s",
					drawobjecode,
					(*itpObj)->GetInformation(),
					(*itpObj)->m_strLastError
					);
				ecode = ERR_DRAWOBJ;
				break;
			}
		}

		if(ecode != SUCCESS)
		{
			break;
		}

		//---------------------------
		// t@Co
		//---------------------------
		try
		{
			File.Write(pData, RowByte * nLineNum);
		}
		catch (CFileException* e)
		{
			TCHAR szCause[255];
			e->GetErrorMessage( szCause, 255 );
			m_strLastError.Format("Error Data Write : %s / %s(%d)", m_strFilePath, szCause, e->m_cause);
			e->Delete();
			ecode = ERR_DATA_WRITE;
			break;
		}

		nLineCount++;
	}

	//--------------------------------------------------------------------------------
	// C`IuWFNgIi`挳t@C̃N[Yj
	//--------------------------------------------------------------------------------
	for(std::vector<CDrawObj*>::iterator itpObj = m_vDrawObj.begin(); m_vDrawObj.end() != itpObj; itpObj++)
	{
		(*itpObj)->End();
	}

	//--------------------------------------------------------------------------------
	// DƃCobt@̊J
	//--------------------------------------------------------------------------------
	delete [] pData;

	//--------------------------------------------------------------------------------
	// Eo͉摜t@C̃N[Y
	//--------------------------------------------------------------------------------
	File.Close();

	return ecode;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CMakeCompositeImage::MakeDummyFileForError()
//	ABSTRACT : G[̂߂Ƀwb_[݂̂̉摜t@C쐬
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : G[R[h
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CMakeCompositeImage::ECODE CMakeCompositeImage::MakeDummyFileForError()
{
	//----------------------------------------------------
	// t@C݂Ă폜
	//----------------------------------------------------
	CFileFind find;

	if( find.FindFile( m_strFilePath ) )
	{
		::DeleteFile( m_strFilePath );
	}

	//----------------------------------------------------
	// wb_[݂̂̉摜t@C쐬
	//----------------------------------------------------
	CFile File;
	int RowByte	= NkcComApi::RowByte( m_nWidth );

	try
	{
		//--------------------------
		// t@CI[v
		//--------------------------
		CFileException ex;

		if( !File.Open(m_strFilePath,
			CFile::modeCreate | CFile::modeRead | CFile::modeWrite | CFile::typeBinary) )
		{
			TCHAR szCause[1024];
			ex.GetErrorMessage(szCause, 1024);
			m_strLastError.Format("Error File Open : %s / %s(%d)", m_strFilePath, szCause, ex.m_cause);
			return ERR_HEADER_WRITE;
		}

		//---------------------------
		// wb_̐ݒ
		//---------------------------

		// BITMAPFILEHEADER
		BITMAPFILEHEADER FileHeader;
		FileHeader.bfType = BFT_BITMAP;
		FileHeader.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + RowByte * m_nHeight;
		FileHeader.bfReserved1 = 0;
		FileHeader.bfReserved2 = 0;
		FileHeader.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

		// BITMAPINFOHEADER \̂̏
		BITMAPINFOHEADER InfoHeader;
		InfoHeader.biSize = sizeof(BITMAPINFOHEADER);
		InfoHeader.biWidth = m_nWidth;
		InfoHeader.biHeight = m_nHeight;
		InfoHeader.biPlanes = 1;
		InfoHeader.biBitCount = 24;
		InfoHeader.biCompression = BI_RGB;
		InfoHeader.biSizeImage = RowByte * m_nHeight;
		InfoHeader.biXPelsPerMeter = 0;
		InfoHeader.biYPelsPerMeter = 0;
		InfoHeader.biClrUsed = 0;
		InfoHeader.biClrImportant = 0;

		//---------------------------
		// wb_̏
		//---------------------------
		File.Write(&FileHeader, sizeof(BITMAPFILEHEADER));
		File.Write(&InfoHeader, sizeof(BITMAPINFOHEADER));
	}
	catch (CFileException* e)
	{
		TCHAR szCause[255];
		e->GetErrorMessage( szCause, 255 );
		m_strLastError.Format("Error Header Write : %s / %s(%d)", m_strFilePath, szCause, e->m_cause);
		e->Delete();
		return ERR_HEADER_WRITE;
	}

	File.Close();

	return SUCCESS;
}
