//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : Nps.cpp
//	ABSTRACT  : NpsdlAPI
//	
//	CREATE    : T.Isogai	2006.7.13
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "Nps.h"

#include "NpsControl.h"
#include "PseudoIPAddr.h"
#include "NpsGetIPAddr.h"
#include "math.h"

#include "SdkLayout.h"	// EZ Controller 6x6C` tHgubNΉ

extern CNpsControl*	g_pNpsControl;
extern CRITICAL_SECTION g_csSdk;	// _04382Ή Y.Yoshinobu 2007.04.24
extern char g_szLangName[MAX_PATH];	// eAvĂяǒ
extern char g_szTempFolder[MAX_PATH];
extern DWORD g_dwMode;				// 샂[h
extern DWORD g_dwConnectMode;		// iڑ[h
extern DWORD g_dwCompProcMode;		// ʒm̓샂[h 2007.11.12 N.Nakashima

void NpsLogReturn( CString str, long lResult )
{
	CString strTmp;
	CString	strTmp2;

	if( lResult == 1 )
	{
		strTmp	= "NPSERR_NORMAL";
	}
	else if( lResult == 4 )
	{
		strTmp	= "NPSERR_REJECT2";
	}
	else if( lResult == 5 )
	{
		strTmp	= "NPSERR_BADPARAM";
	}
	else if( lResult == 6 )
	{
		strTmp	= "NPSERR_SYSERR";
	}
	else if( lResult == 7 )
	{
		strTmp	= "NPSERR_PRNERR";
	}
	else if( lResult == 10 )
	{
		strTmp	= "NPSERR_REJECT3";
	}
	else if( lResult == 15 )
	{
		strTmp	= "NPSERR_REMAINING_DATA";
	}
	else if( lResult == 16 )
	{
		strTmp	= "NPSERR_TIMEOUT";
	}
	else
	{
		strTmp	= "unknown";
	}

	strTmp2.Format( "- return %s %s(%d)", str, strTmp, lResult );
	NPS_LOGOUT( strTmp2 );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : NpsLogReturn_npsDevGetUnitInfo()
//	ABSTRACT : NPS API ̃^[R[h𕶎ɕϊ
//	FUNCTION : 
//	CREATE	 : Y.Yoshinobu 2007.01.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CString GetReturnString( long lResult )
{
	CString str;

	switch ( lResult )
	{
	case  1:	str.Format( "NPSERR_NORMAL(%d)", lResult );			break;
	case  4:	str.Format( "NPSERR_REJECT2(%d)", lResult );		break;
	case  5:	str.Format( "NPSERR_BADPARAM(%d)", lResult );		break;
	case  6:	str.Format( "NPSERR_SYSERR(%d)", lResult );			break;
	case  7:	str.Format( "NPSERR_PRNERR(%d)", lResult );			break;
	case 10:	str.Format( "NPSERR_REJECT3(%d)", lResult );		break;
	case 15:	str.Format( "NPSERR_REMAINING_DATA(%d)", lResult );	break;
	case 16:	str.Format( "NPSERR_TIMEOUT(%d)", lResult );		break;
	default:	str.Format( "UNKNOWN(%d)", lResult );				break;
	}

	return str;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : NpsLogReturn_npsDevGetUnitInfo()
//	ABSTRACT : npsDevGetUnitInfo ̃Oo
//	FUNCTION : 
//	CREATE	 : Y.Yoshinobu 2007.01.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void NpsLogReturn_npsDevGetUnitInfo( PNPS_UnitInfo pUnitInfo, long lResult )
{
	CString strLog;

	if( NULL == pUnitInfo )
	{
		strLog.Format( "- return npsDevGetUnitInfo() %s ( pUnitInfo=NULL )", GetReturnString( lResult ) );
	}
	else
	{
		strLog.Format( "- return npsDevGetUnitInfo() %s pUnitInfo=( %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d )",
						GetReturnString( lResult ),
						pUnitInfo->dwPrinterStatus,
						pUnitInfo->dwAcceptStatus,
						pUnitInfo->dwPrinterPossession,
						pUnitInfo->dwAdvanceStatus,
						pUnitInfo->dwLaserStatus,
						pUnitInfo->dwDevelopmentStatus,
						pUnitInfo->dwProcessorStatus,
						pUnitInfo->dwReplenisherStatus,
						pUnitInfo->dwReplaceCartridgeStatus,
						pUnitInfo->dwStartUpChecksStatus,
						pUnitInfo->dwRefillWaterStatus,
						pUnitInfo->dwDailySetupStatus,
						pUnitInfo->dwControlStripStatus,
						pUnitInfo->dwMaintenanceStatus,
						pUnitInfo->dwFadStatus );
	}

	NPS_LOGOUT_DEBUG( strLog );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : NpsLogReturn_npsDevGetSetUpInfo()
//	ABSTRACT : npsDevGetSetUpInfo ̃Oo
//	FUNCTION : 
//	CREATE	 : Y.Yoshinobu 2007.01.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void NpsLogReturn_npsDevGetSetUpInfo( PNPS_SetUpInfo pSetUpInfo, long lResult )
{
	CString strLog;

	if( NULL == pSetUpInfo )
	{
		strLog.Format( "- return npsDevGetSetUpInfo() %s ( pSetUpInfo=NULL )", GetReturnString( lResult ) );
		NPS_LOGOUT_DEBUG( strLog );
	}
	else
	{
		strLog.Format( "   pSetUpInfo[1/3]=( %s, Soft=%s, %s, [%d][%d][%d][%d][%d][%d][%d][%d], Ver=0x%04X, Type=%d, MEM=%d )",
						pSetUpInfo->szMachineTypeName,
						pSetUpInfo->szSoftName,
						pSetUpInfo->szSerialNumber,
						pSetUpInfo->wSupportResolutions[0],
						pSetUpInfo->wSupportResolutions[1],
						pSetUpInfo->wSupportResolutions[2],
						pSetUpInfo->wSupportResolutions[3],
						pSetUpInfo->wSupportResolutions[4],
						pSetUpInfo->wSupportResolutions[5],
						pSetUpInfo->wSupportResolutions[6],
						pSetUpInfo->wSupportResolutions[7],
						pSetUpInfo->wNpsVersion,
						pSetUpInfo->wMachineTypeID,
						pSetUpInfo->dwTotalMemory );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pSetUpInfo[2/3]=( Min=%dx%d, MAX=%dx%d, MagNum=%d, Time=%04d/%02d/%02d %02d:%02d'%02d (%d), RepMax=%d, ImgFmt=[%d][%d][%d][%d][%d][%d][%d][%d][%d][%d][%d], Lami=%d )",
						pSetUpInfo->dwImageSizeMinWidth,
						pSetUpInfo->dwImageSizeMinHeight,
						pSetUpInfo->dwImageSizeMaxWidth,
						pSetUpInfo->dwImageSizeMaxHeight,
						pSetUpInfo->dwNumberOfMagazine,
						pSetUpInfo->PrinterTime.tDate.dwYear,
						pSetUpInfo->PrinterTime.tDate.dwMonth,
						pSetUpInfo->PrinterTime.tDate.dwDay,
						pSetUpInfo->PrinterTime.tTime.dwHour,
						pSetUpInfo->PrinterTime.tTime.dwMinute,
						pSetUpInfo->PrinterTime.tTime.dwSecond,
						pSetUpInfo->PrinterTime.tDate.dwDayofweek,
						pSetUpInfo->dwRepeatCountMax,
						pSetUpInfo->SupportImageFormat[0],
						pSetUpInfo->SupportImageFormat[1],
						pSetUpInfo->SupportImageFormat[2],
						pSetUpInfo->SupportImageFormat[3],
						pSetUpInfo->SupportImageFormat[4],
						pSetUpInfo->SupportImageFormat[5],
						pSetUpInfo->SupportImageFormat[6],
						pSetUpInfo->SupportImageFormat[7],
						pSetUpInfo->SupportImageFormat[8],
						pSetUpInfo->SupportImageFormat[9],
						pSetUpInfo->SupportImageFormat[10],
						pSetUpInfo->wLaminatorUnitAttach );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pSetUpInfo[3/3]=( Inst=%04d/%02d/%02d, Ope=%04d/%02d/%02d, %d, %d, %s, %d, %d, %d, %d, %d, %d, %d, %d, [%d][%d][%d][%d][%d][%d], %d, %d, %d )",
						pSetUpInfo->InstallationDate.dwYear,
						pSetUpInfo->InstallationDate.dwMonth,
						pSetUpInfo->InstallationDate.dwDay,
						pSetUpInfo->OperationStartDate.dwYear,
						pSetUpInfo->OperationStartDate.dwMonth,
						pSetUpInfo->OperationStartDate.dwDay,
						pSetUpInfo->wProcessorType,
						pSetUpInfo->wEmulsionNumber,
						pSetUpInfo->szPrinterNickname,
						pSetUpInfo->wSupportAngle,
						pSetUpInfo->wSupportIntoPrinter,
						pSetUpInfo->wSorterStatus,
						pSetUpInfo->wCvpStatus,
						pSetUpInfo->wSupportPaperFitting,
						pSetUpInfo->wSupportEdgeEnhancement,
						pSetUpInfo->wSupportWithBorder,
						pSetUpInfo->wMachinTypeForProfile,
						pSetUpInfo->wPaperTypeCode[0],
						pSetUpInfo->wPaperTypeCode[1],
						pSetUpInfo->wPaperTypeCode[2],
						pSetUpInfo->wPaperTypeCode[3],
						pSetUpInfo->wPaperTypeCode[4],
						pSetUpInfo->wPaperTypeCode[5],
						pSetUpInfo->wSupportCMS,
						pSetUpInfo->wSetupAlgorithm,
						pSetUpInfo->wSupportInterrupt );
		NPS_LOGOUT_DEBUG( strLog );

		NpsLogReturn( "npsDevGetSetUpInfo()", lResult );
	}

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsLibOpen ()
//	ABSTRACT : CũI[v
//	FUNCTION : Cugp\ɂ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR	\[XsȂǂɂsłȂ
//	
//	CREATE	 : Y.Yoshinobu 2006.11.9
//	UPDATE   : Y.Yoshinobu 2008.10.27	ݒ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsLibOpen (
	LPCSTR lpLogFileName
)
{
	if ( FALSE == g_pNpsControl->EnterLibOpen( lpLogFileName ) )
	{
		return NPSERR_BADPARAM;
	}

	// ݒ
	::ZeroMemory( g_szLangName, sizeof(g_szLangName) );
	::ZeroMemory( g_szTempFolder, sizeof(g_szTempFolder) );
	g_dwCompProcMode = 0;
	g_dwMode = 0;
	g_dwConnectMode = 0x00000000;

	// [IPAhXe[uI[v
	CPseudoIPAddr::Create();

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsLibOpen ()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR	\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai		2006.07.13
//	UPDATE   : N.Nakashima	2007.11.19	ݒ
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsLibClose ()
{
	// [IPAhXe[uN[Y
	CPseudoIPAddr::Close();

	if ( FALSE == g_pNpsControl->LeaveLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	// ݒ
	::ZeroMemory( g_szLangName, sizeof(g_szLangName) );
	::ZeroMemory( g_szTempFolder, sizeof(g_szTempFolder) );
	g_dwCompProcMode = 0;
	g_dwMode = 0;
	g_dwConnectMode = 0x00000000;

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsSearchPrinter ()
//	ABSTRACT : v^miSTEP-1j
//	FUNCTION : lbg[Nɂv^𒲂ׂ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_SYSERR	\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsSearchPrinter (
	LPWORD		pPrinterNum,		// v^̑䐔
	DWORD		dwWaitTime			// ҋ@(~b)
)
{
	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsSearchPrinter( pPrinterNum=0x%08X, dwWaitTime=%d )", pPrinterNum, dwWaitTime );
		NPS_LOGOUT_DEBUG( str );
	}

	long lResult = g_pNpsControl->SearchPrinter( FALSE, pPrinterNum, dwWaitTime );

	{	// Oo
		CString str;
		str.Format( "   npsSearchPrinter() *pPrinterNum=%d", *pPrinterNum );
		NPS_LOGOUT_DEBUG( str );
		NpsLogReturn( "npsSearchPrinter()", lResult );
	}
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsSearchPrinter2 ()
//	ABSTRACT : v^miSTEP-1j
//	FUNCTION : lbg[Nɂv^𒲂ׂi[vobNΉŁj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_SYSERR	\[XsȂǂɂsłȂ
//	
//	CREATE	 : Y.Yoshinobu	2008.10.28
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsSearchPrinter2 (
	LPWORD		pPrinterNum,		// v^̑䐔
	DWORD		dwWaitTime			// ҋ@(~b)
)
{
	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsSearchPrinter2( pPrinterNum=0x%08X, dwWaitTime=%d )", pPrinterNum, dwWaitTime );
		NPS_LOGOUT_DEBUG( str );
	}

	long lResult = g_pNpsControl->SearchPrinter( TRUE, pPrinterNum, dwWaitTime );

	{	// Oo
		CString str;
		str.Format( "   npsSearchPrinter2() *pPrinterNum=%d", *pPrinterNum );
		NPS_LOGOUT_DEBUG( str );
		NpsLogReturn( "npsSearchPrinter2()", lResult );
	}
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsGetPrinter ()
//	ABSTRACT : v^miSTEP-2j
//	FUNCTION : SearchPrinterŒׂv^̏擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL			I
//				REMAINING_DATA	pPrinterInfõobt@̈悪Ȃ
//				NPSERR_SYSERR			\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsGetPrinter (
	WORD				wBufferNum,		// pPrinterInfõobt@
	PNPS_PRINTER_ENUM	pPrinterInfo	// v^
)
{
	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsGetPrinter( wBufferNum=%d, pPrinterInfo=0x%08X )", wBufferNum, pPrinterInfo );
		NPS_LOGOUT_DEBUG( str );
	}

	if( NULL == pPrinterInfo )
	{
		NpsLogReturn( "npsGetPrinter()", NPSERR_SYSERR );
		return NPSERR_SYSERR;
	}
	else
	{
		// \̏
		ZeroMemory( pPrinterInfo, sizeof( NPS_PRINTER_ENUM ) * wBufferNum );
	}

	long	lResult;

	// obt@쐬擾
	T_NpsPrinterInfo* pNpsPrinterInfo;
	try
	{
		pNpsPrinterInfo = new T_NpsPrinterInfo[ wBufferNum ];
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [%d]", sizeof(T_NpsPrinterInfo) * wBufferNum );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return NPSERR_SYSERR;
	}
	ZeroMemory( pNpsPrinterInfo, sizeof( T_NpsPrinterInfo ) * wBufferNum );
	lResult	= g_pNpsControl->GetPrinterList( wBufferNum, pNpsPrinterInfo );

	// ̕ϊ
	int nIdx1;
	int nIdx2;

	for ( nIdx1=0; nIdx1 < wBufferNum ; nIdx1++ )
	{
		// IPAhX
		pPrinterInfo[nIdx1].dwIPAddress	= inet_addr( pNpsPrinterInfo[nIdx1].szIP );

		if( pNpsPrinterInfo[nIdx1].wType == 0 )
		{
			// v^
			strcpy( pPrinterInfo[nIdx1].szMachineTypeName, pNpsPrinterInfo[nIdx1].Nps000FH_0101H.MachineTypeName );
			strcpy( pPrinterInfo[nIdx1].szSoftName, pNpsPrinterInfo[nIdx1].Nps000FH_0101H.SoftName );
			strcpy( pPrinterInfo[nIdx1].szSerialNumber, pNpsPrinterInfo[nIdx1].Nps000FH_0101H.SerialNumber );

			for ( nIdx2=0 ; nIdx2 < 8; nIdx2++ )
			{
				pPrinterInfo[nIdx1].wSupportResolutions[nIdx2] = pNpsPrinterInfo[nIdx1].Nps000FH_0101H.SupportResolutions[nIdx2];
			}

			pPrinterInfo[nIdx1].wNpsVersion	= pNpsPrinterInfo[nIdx1].Nps000FH_0101H.NpsVersion;

			memcpy( pPrinterInfo[nIdx1].MacAddress, pNpsPrinterInfo[nIdx1].Nps000FH_0101H.MacAddress, 6 );
		}
		else
		{
			// v^
			strcpy( pPrinterInfo[nIdx1].szMachineTypeName, pNpsPrinterInfo[nIdx1].Nps000FH_0201H.MachineTypeName );
			strcpy( pPrinterInfo[nIdx1].szSoftName, pNpsPrinterInfo[nIdx1].Nps000FH_0201H.SoftName );
			strcpy( pPrinterInfo[nIdx1].szSerialNumber, pNpsPrinterInfo[nIdx1].Nps000FH_0201H.SerialNumber );

			for ( nIdx2=0 ; nIdx2 < 8; nIdx2++ )
			{
				pPrinterInfo[nIdx1].wSupportResolutions[nIdx2] = pNpsPrinterInfo[nIdx1].Nps000FH_0201H.SupportResolutions[nIdx2];
			}

			pPrinterInfo[nIdx1].wNpsVersion	= pNpsPrinterInfo[nIdx1].Nps000FH_0201H.NpsVersion;

			memcpy( pPrinterInfo[nIdx1].MacAddress, pNpsPrinterInfo[nIdx1].Nps000FH_0201H.HostMacAddress, 6 );
		}

		{	// Oo
			CString str;
			in_addr tAddr;
			tAddr.S_un.S_addr = pPrinterInfo[nIdx1].dwIPAddress;
			str.Format( "   npsGetPrinter() [%d] %d.%d.%d.%d, \"%s\", \"%s\", \"%s\", [%d][%d][%d][%d][%d][%d][%d][%d], 0x%04X, %02X-%02X-%02X-%02X-%02X-%02X",
				nIdx1 + 1,
				tAddr.S_un.S_un_b.s_b1,
				tAddr.S_un.S_un_b.s_b2,
				tAddr.S_un.S_un_b.s_b3,
				tAddr.S_un.S_un_b.s_b4,
				pPrinterInfo[nIdx1].szMachineTypeName,
				pPrinterInfo[nIdx1].szSoftName,
				pPrinterInfo[nIdx1].szSerialNumber,
				pPrinterInfo[nIdx1].wSupportResolutions[0],
				pPrinterInfo[nIdx1].wSupportResolutions[1],
				pPrinterInfo[nIdx1].wSupportResolutions[2],
				pPrinterInfo[nIdx1].wSupportResolutions[3],
				pPrinterInfo[nIdx1].wSupportResolutions[4],
				pPrinterInfo[nIdx1].wSupportResolutions[5],
				pPrinterInfo[nIdx1].wSupportResolutions[6],
				pPrinterInfo[nIdx1].wSupportResolutions[7],
				pPrinterInfo[nIdx1].wNpsVersion,
				pPrinterInfo[nIdx1].MacAddress[0],
				pPrinterInfo[nIdx1].MacAddress[1],
				pPrinterInfo[nIdx1].MacAddress[2],
				pPrinterInfo[nIdx1].MacAddress[3],
				pPrinterInfo[nIdx1].MacAddress[4],
				pPrinterInfo[nIdx1].MacAddress[5]);
			NPS_LOGOUT_DEBUG( str );
		}
	}

	delete [] pNpsPrinterInfo;

	NpsLogReturn( "npsGetPrinter()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevOpen ()
//	ABSTRACT : v^I[v
//	FUNCTION : v^𗘗p\ɂ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : T.Isogai	2009.01.06	EZ Controller 6x6C` tHgubNΉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevOpen (
	DWORD			dwIPAddress,	// v^IPAhX
	HPRINTER*		phPrinter,		// 擾nh̊i[
	NPSEVENTPROC	pEventProc,		// Cxgʒm֐
	NPSUNITPROC		pUnitProc		// jbgԕύXʒm֐
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		in_addr tAddr;
		tAddr.S_un.S_addr = dwIPAddress;
		str.Format( "npsDevOpen( dwIPAddress=%d.%d.%d.%d, phPrinter=0x%08X, pEventProc=0x%08X, pUnitProc=0x%08X )",
				tAddr.S_un.S_un_b.s_b1,
				tAddr.S_un.S_un_b.s_b2,
				tAddr.S_un.S_un_b.s_b3,
				tAddr.S_un.S_un_b.s_b4,
				phPrinter,
				pEventProc,
				pUnitProc );
		NPS_LOGOUT( str );
	}

	// [IPAhXAMACAhXNPSp|[gԍ擾
	USHORT NpsPortNo;
	USHORT ImgPortNo;
	TPseudoIPAddrRecord tRecord;
	if( CPseudoIPAddr::GetInstance()->FindByIPAddr( dwIPAddress, &tRecord ) )
	{
	/*
		// MACAhX玩PC̎IPAhX擾
		dwIPAddress = CNpsGetIPAddr::GetLocalIPAddress( tRecord.HostMacAddress );
		if( dwIPAddress == 0L )
		{	// PCMACAhXH
			// MACAhX瑼PC̎IPAhX擾
			dwIPAddress = CNpsGetIPAddr::GetRealIPAddress( tRecord.HostMacAddress, 3000L );
			if( dwIPAddress == 0L )
			{
				NpsLogReturn( "npsDevOpen()", NPSERR_TIMEOUT );
				return NPSERR_TIMEOUT;
			}
		}
	*/
		dwIPAddress = tRecord.HostIPAddress;
		NpsPortNo = tRecord.NpsPortNo;
		ImgPortNo = tRecord.ImgPortNo;
	}
	else
	{
		NpsPortNo = NPS_TCP_SERVER_PORT;
		ImgPortNo = NPS_TCP_SERVER_IMAGESEND_PORT;
	}

	CSdk	* pSdk;

	// IPAhXmF
	pSdk	= g_pNpsControl->GetSdk( dwIPAddress, NpsPortNo, ImgPortNo );

	if( NULL != pSdk )
	{
		NpsLogReturn( "npsDevOpen()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}
	
	try
	{
		// EZ Controller 6x6C` tHgubNΉ
		if( CSdkLayout::IsUseCSdkLayout() )
		{
			pSdk = new CSdkLayout;
			NPS_LOGOUT( "===Use CSdkLayout" );
		}
		else
		{
			pSdk = new CSdk;
			NPS_LOGOUT( "===Use CSdk" );
		}
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [CSdk]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return NPSERR_SYSERR;
	}

	long lResult;

	pSdk->SetPrinterHandle( g_pNpsControl->GetPrinterHandle() );
	lResult = pSdk->DevOpen(
							dwIPAddress,	// v^IPAhX
							NpsPortNo,		// NPSp|[gԍ
							ImgPortNo,		// NPS(摜f[^])p|[gԍ
							phPrinter,		// 擾nh̊i[
							pEventProc,		// Cxgʒm֐
							pUnitProc		// jbgԕύXʒm֐
							);

	if( NPSERR_NORMAL != lResult )
	{
		delete pSdk;
		NpsLogReturn( "npsDevOpen()", lResult );
		return NPSERR_SYSERR;
	}

	g_pNpsControl->AddSdk( pSdk );

	if( NULL != phPrinter )
	{
		NPS_LOGOUT_VALUE_PTR( *phPrinter );
	}
	NpsLogReturn( "npsDevOpen()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevClose ()
//	ABSTRACT : v^N[Y
//	FUNCTION : v^𗘗p֎~ɂ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevClose (
	HPRINTER	hPrinter	// v^̃nhw肷
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevClose( hPrinter=0x%08X )", hPrinter );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevClose()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult;

	lResult = pSdk->DevClose ();

	if( NPSERR_NORMAL != lResult )
	{
		NpsLogReturn( "npsDevClose()", lResult );
		return lResult;
	}

	g_pNpsControl->DeleteSdk( hPrinter );

	NpsLogReturn( "npsDevClose()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevGetUnitInfo ()
//	ABSTRACT : jbgԎ擾
//	FUNCTION : v^̃jbgԏ擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevGetUnitInfo (
	HPRINTER		hPrinter,	// v^̃nhw肷
	PNPS_UnitInfo	pUnitInfo	// jbgԍ\̂ւ̃AhX
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

#if defined(NPS_CUSTOM_LOG)
	{	// Oo
		CString str;
		str.Format( "npsDevGetUnitInfo( hPrinter=0x%08X, pUnitInfo=0x%08X )", hPrinter, pUnitInfo );
		NPS_LOGOUT( str );
	}
#endif	// NPS_CUSTOM_LOG

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevGetUnitInfo()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevGetUnitInfo (
							pUnitInfo	// jbgԍ\̂ւ̃AhX
							);

	// Oo
	//NpsLogReturn_npsDevGetUnitInfo( pUnitInfo, lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevGetMagInfo ()
//	ABSTRACT : }KW擾
//	FUNCTION : v^ɑĂ}KW̏擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevGetMagInfo (
	HPRINTER		hPrinter,	// v^̃nhw肷
	PNPS_MagInfo	pMagInfo,	// }KW󂯎obt@
	DWORD*			pdwSize		// obt@̃TCY
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

#if defined(NPS_CUSTOM_LOG)
	{	// Oo
		CString str;
		str.Format( "npsDevGetMagInfo( hPrinter=0x%08X, pMagInfo=0x%08X, pdwSize=0x%08X )", hPrinter, pMagInfo, pdwSize );
		NPS_LOGOUT( str );
	}
#endif	// NPS_CUSTOM_LOG

	//if( NULL != pdwSize )
	//{
	//	{	// Oo
	//		CString str;
	//		str.Format( "   npsDevGetMagInfo() *pdwSize=%d", *pdwSize );
	//		NPS_LOGOUT( str );
	//	}
	//}

	// \̏
	if(( NULL != pMagInfo ) && ( NULL != pdwSize ))
	{
		::ZeroMemory( pMagInfo, *pdwSize );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevGetMagInfo()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevGetMagInfo (
							pMagInfo,	// }KW󂯎obt@
							pdwSize		// obt@̃TCY
							);

	//NpsLogReturn( "npsDevGetMagInfo()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevGetSetUpInfo ()
//	ABSTRACT : ݒu擾
//	FUNCTION : v^̐ݒu擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevGetSetUpInfo (
	HPRINTER		hPrinter,	// v^̃nhw肷
	PNPS_SetUpInfo	pSetUpInfo	// ݒu\̂ւ̃AhX
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevGetSetUpInfo( hPrinter=0x%08X, pSetUpInfo=0x%08X )", hPrinter, pSetUpInfo );
		NPS_LOGOUT_DEBUG( str );
	}

	// \̏
	if( pSetUpInfo )
	{
		ZeroMemory( pSetUpInfo, sizeof( NPS_SetUpInfo ) );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevGetSetUpInfo()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevGetSetUpInfo (
							pSetUpInfo	// ݒu\̂ւ̃AhX
							);

	// Oo
	NpsLogReturn_npsDevGetSetUpInfo( pSetUpInfo, lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevGetPrintNumInfo ()
//	ABSTRACT : vg擾
//	FUNCTION : vg̖擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂB
//				NPSERR_PRNERR		v^G[B
//				NPSERR_SYSERR		\[XsȂǂɂsłȂB
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevGetPrintNumInfo (
	HPRINTER			hPrinter,		// v^̃nhw肷
	PNPS_PrintNumInfo	pPrintNumInfo	// vg\̂ւ̃AhX
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevGetPrintNumInfo( hPrinter=0x%08X, pPrintNumInfo=0x%08X )", hPrinter, pPrintNumInfo );
		NPS_LOGOUT_DEBUG( str );
	}

	// \̏
	if( pPrintNumInfo )
	{
		ZeroMemory( pPrintNumInfo, sizeof( NPS_PrintNumInfo ) );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevGetPrintNumInfo()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevGetPrintNumInfo (
							pPrintNumInfo	// vg\̂ւ̃AhX
							);

	if( pPrintNumInfo )
	{
		NPS_LOGOUT_VALUE_DEC( pPrintNumInfo->dwSdkReserver );
		NPS_LOGOUT_VALUE_DEC( pPrintNumInfo->dwFrmRatio );
		NPS_LOGOUT_VALUE_DEC( pPrintNumInfo->dwReserver );
		NPS_LOGOUT_VALUE_DEC( pPrintNumInfo->dwPrtNumber );
		NPS_LOGOUT_VALUE_DEC( pPrintNumInfo->dwProNumber );
		NPS_LOGOUT_VALUE_DEC( pPrintNumInfo->dwTotalCount );
	}
	NpsLogReturn( "npsDevGetPrintNumInfo()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevResetEvent ()
//	ABSTRACT : v^CxgNA
//	FUNCTION : v^ŔCxgNA
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevResetEvent (
	HPRINTER	hPrinter,		// v^̃nhw肷
	DWORD		dwErrHandle,	// NACxgnh
	DWORD		dwActionId		// Cxg̃ANVw肷
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevResetEvent( hPrinter=0x%08X, dwErrHandle=0x%08X, dwActionId=%d )", hPrinter, dwErrHandle, dwActionId );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevResetEvent()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevResetEvent (
							dwErrHandle,	// NACxgnh
							dwActionId		// Cxg̃ANVw肷
							);

	NpsLogReturn( "npsDevResetEvent()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevIsReady ()
//	ABSTRACT : vg`FbN
//	FUNCTION : vg\`FbN
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_REJECT2		toȂ 
//				NPSERR_REJECT3		tłȂ I[_[
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevIsReady (
	HPRINTER	hPrinter	// v^̃nhw肷
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevIsReady( hPrinter=0x%08X )", hPrinter );
		NPS_LOGOUT_DEBUG( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevIsReady()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevIsReady ();

	NpsLogReturn( "npsDevIsReady()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevStartOrder ()
//	ABSTRACT : I[_[Jn
//	FUNCTION : I[_[Jnw
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_REJECT3		tłȂԁBI[_[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : M.Yamamoto	2014.10.28	݃vg̏ԒZk@\ǉ(Pvg)
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevStartOrder (
	HPRINTER			hPrinter,	// v^̃nhw肷
	DWORD*				pdwOrderId,	// 擾I[_[IDi[
	NPSCOMPLETIONPROC	pEventProc,	// ʒmpR[obN֐ւ̃AhX
	DWORD				dwPriority,	// Dxw
	DWORD				dwSorterNum,// vg̎d
	DWORD				dwSortFrame	// R}̃\[g@\
)
{
	return npsDevStartOrderEx( hPrinter, pdwOrderId, pEventProc, dwPriority, dwSorterNum, dwSortFrame, EX_OPTIONS_NONE );
	/*
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevStartOrder( hPrinter=0x%08X, pdwOrderId=0x%08X, pEventProc=0x%08X, dwPriority=0x%08X, dwSorterNum=%d, dwSortFrame=%d )",
						hPrinter, pdwOrderId, pEventProc, dwPriority, dwSorterNum, dwSortFrame );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevStartOrder()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevStartOrder (
							pdwOrderId,	// 擾I[_[IDi[
							pEventProc,	// ʒmpR[obN֐ւ̃AhX
							dwPriority,	// Dxw
							dwSorterNum,// vg̎d
							dwSortFrame	// R}̃\[g@\
							);

	if( NULL != pdwOrderId )
	{
		NPS_LOGOUT_VALUE_DEC( *pdwOrderId );
	}
	NpsLogReturn( "npsDevStartOrder()", lResult );
	*/
}


//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevStartOrderEx ()
//	ABSTRACT : I[_[Jn
//	FUNCTION : I[_[Jnw
//			   npsDevStartOrder()ɍ݃vg̏ԒZk@\ǉ(Pvg)
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_REJECT3		tłȂԁBI[_[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : M.Yamamoto	2014.10.28
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevStartOrderEx(
	HPRINTER			hPrinter,	// v^̃nhw肷
	DWORD*				pdwOrderId,	// 擾I[_[IDi[
	NPSCOMPLETIONPROC	pEventProc,	// ʒmpR[obN֐ւ̃AhX
	DWORD				dwPriority,	// Dxw
	DWORD				dwSorterNum,// vg̎d
	DWORD				dwSortFrame,// R}̃\[g@\
	DWORD				dwExOptions	// gIvV(Pvg) 2014.10.28 M.Yamamoto
									// EX_OPTIONS_NONE        : gIvVȂ
									// EX_OPTIONS_SINGLE_LINE : Pvg
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevStartOrderEx( hPrinter=0x%08X, pdwOrderId=0x%08X, pEventProc=0x%08X, dwPriority=0x%08X, dwSorterNum=%d, dwSortFrame=%d, dwOptions=0x%08x )",
						hPrinter, pdwOrderId, pEventProc, dwPriority, dwSorterNum, dwSortFrame, dwExOptions );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevStartOrder()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevStartOrder (
							pdwOrderId,	// 擾I[_[IDi[
							pEventProc,	// ʒmpR[obN֐ւ̃AhX
							dwPriority,	// Dxw
							dwSorterNum,// vg̎d
							dwSortFrame,// R}̃\[g@\
							dwExOptions	// gIvV(Pvg)
							);

	if( NULL != pdwOrderId )
	{
		NPS_LOGOUT_VALUE_DEC( *pdwOrderId );
	}
	NpsLogReturn( "npsDevStartOrder()", lResult );
	return lResult;
}



//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevEndOrder ()
//	ABSTRACT : I[_[I
//	FUNCTION : I[_[Iw
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂB
//				NPSERR_SYSERR		\[XsȂǂɂsłȂB
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevEndOrder (
	HPRINTER	hPrinter,	// v^̃nhw肷
	DWORD		dwOrderId	// II[_[IDw肷
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevEndOrder( hPrinter=0x%08X, dwOrderId=%d )", hPrinter, dwOrderId );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevEndOrder()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevEndOrder (
							dwOrderId	// II[_[IDw肷
							);

	NpsLogReturn( "npsDevEndOrder()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevPrint ()
//	ABSTRACT : vgv
//	FUNCTION : vgv󂯕t
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : T.Isogai	2008.06.06 npsDevPrintIccsXml APIǉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevPrint (
	HPRINTER			hPrinter,	// v^̃nhw肷
	DWORD				dwOrderId,	// vgI[_[IDw肷
	LPDWORD				pPrintID,	// vgʎq
	NPSCOMPLETIONPROC	pEventProc,	// CxgʒmpR[obN֐ւ
									// AhX
	PNPS_PrintInfo		pPrintInfo	// vgvp[^
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevPrint( hPrinter=0x%08X, dwOrderId=%d, pPrintID=0x%08X, pEventProc=0x%08X, pPrintInfo=0x%08X )",
						hPrinter, dwOrderId, pPrintID, pEventProc, pPrintInfo );
		NPS_LOGOUT( str );
	}

	if( NULL != pPrintInfo )
	{
		CString strLog;
		strLog.Format( "   pPrintInfo[1/7]=( ImgFmt=%u, ClrSpc=%u, SrcType=%u, ImgLen=%u, ImgName=\"%s\" )",
								pPrintInfo->dwImageFormat,
								pPrintInfo->dwColorSpace,
								pPrintInfo->dwSourceType,
								pPrintInfo->dwDataLength,
								pPrintInfo->pName );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pPrintInfo[2/7]=( Offset=%u, ImgSize=%ux%u, Resol=%u, PaperSize=%ux%u )",
								pPrintInfo->dwOffset,
								pPrintInfo->dwImgWidth,
								pPrintInfo->dwImgHeight,
								pPrintInfo->dwResolution,
								pPrintInfo->dwPaperWidth,
								pPrintInfo->dwPaperLength );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pPrintInfo[3/7]=( CVP[1] Init=%u, Point=%u, Width=%u, Str=\"%s\" )",
								pPrintInfo->dwCvpInitialValue1,
								pPrintInfo->dwCvpPoint1,
								pPrintInfo->dwCvpInitialWidth1,
								pPrintInfo->szCvpLine1 );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pPrintInfo[4/7]=( CVP[2] Init=%u, Point=%u, Width=%u, Str=\"%s\" )",
								pPrintInfo->dwCvpInitialValue2,
								pPrintInfo->dwCvpPoint2,
								pPrintInfo->dwCvpInitialWidth2,
								pPrintInfo->szCvpLine2 );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pPrintInfo[5/7]=( Repeat=%u, Feed=%u, Surface=%u, Presence=%u, Espc=%d, CMS=%d )",
								pPrintInfo->dwPrintNum,
								pPrintInfo->dwFeed,
								pPrintInfo->dwSurface,
								pPrintInfo->dwPaperPresence,
								pPrintInfo->nEspc,
								pPrintInfo->wCMS );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pPrintInfo[6/7]=( Angle=%d, wPaperFitting=%d, Edge=%d, WB=[%d][%d][%d][%d], WBC=[%d][%d][%d], PName=\"%s\", Pcfms=%d, PntQly=%d, ImgElg=%d )",
								pPrintInfo->wAngle,
								pPrintInfo->wPaperFitting,
								pPrintInfo->wEdgeEnhancement,
								pPrintInfo->wWithBorderTop,
								pPrintInfo->wWithBorderBottom,
								pPrintInfo->wWithBorderLeft,
								pPrintInfo->wWithBorderRight,
								pPrintInfo->byWithBorderColor[0],
								pPrintInfo->byWithBorderColor[1],
								pPrintInfo->byWithBorderColor[2],
								pPrintInfo->szPaperName,
								pPrintInfo->nPcfms,
								pPrintInfo->wPrintQuality,			// Print quality
								pPrintInfo->byImageEnlargeType );	// Image enlarge algorithm
		NPS_LOGOUT_DEBUG( strLog );

		// 2011.11.1 A.Nagamatsu (D703/WG)
		strLog.Format( "   pPrintInfo[7/7]=( wLoadingCount=%d, wPrintedCount=%d, dwEventId=%d, wEventCodeMain=%d )",
								pPrintInfo->wLoadingCount,
								pPrintInfo->wPrintedCount,
								pPrintInfo->dwEventId,
								pPrintInfo->wEventCodeMain );
		NPS_LOGOUT_DEBUG( strLog );
		// 2011.11.1 A.Nagamatsu (D703/WG)
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevPrint()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevPrint (
							dwOrderId,	// vgI[_[IDw肷
							pPrintID,	// vgʎq
							pEventProc,	// CxgʒmpR[obN֐ւ
										// AhX
							pPrintInfo,	// vgvp[^
							NULL
							);

	if( NULL != pPrintID )
	{
		NPS_LOGOUT_VALUE_DEC( *pPrintID );
	}
	NpsLogReturn( "npsDevPrint()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevPrintIccsXml ()
//	ABSTRACT : vgviŏIo͉摜쐬Lj
//	FUNCTION : vgv󂯕t
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2008.6.6 npsDevPrintIccsXml APIǉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevPrintIccsXml (
	HPRINTER				hPrinter,	// v^̃nhw肷
	DWORD					dwOrderId,	// vgI[_[IDw肷
	LPDWORD					pPrintID,	// vgʎq
	NPSCOMPLETIONPROC		pEventProc,	// CxgʒmpR[obN֐ւ
										// AhX
	short					priority,	// 摜␳XbhDx
	PNPS_PrintInfoIccsXml	pPrintInfo	// vgvp[^
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevPrintIccsXml( hPrinter=0x%08X, dwOrderId=%d, pPrintID=0x%08X, pEventProc=0x%08X, priority=%d, pPrintInfo=0x%08X )",
						hPrinter, dwOrderId, pPrintID, pEventProc, priority, pPrintInfo );
		NPS_LOGOUT( str );
	}

#if defined( NKC_CMS_PROC )
	// 摜głł NPSERR_BADPARAM Ԃ
	NPS_LOGOUT( "Not support npsDevPrintIccsXml() in extended NPS library!" );
	NpsLogReturn( "npsDevPrintIccsXml()", NPSERR_BADPARAM );
	return NPSERR_BADPARAM;
#endif

	if( NULL != pPrintInfo )
	{
		CString strLog;
		strLog.Format( "   pPrintInfo[1/7]=( ImgFmt=%u, ClrSpc=%u, SrcType=%u, ImgLen=%u, ImgName=\"%s\" )",
								pPrintInfo->printInfo.dwImageFormat,
								pPrintInfo->printInfo.dwColorSpace,
								pPrintInfo->printInfo.dwSourceType,
								pPrintInfo->printInfo.dwDataLength,
								pPrintInfo->printInfo.pName );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pPrintInfo[2/7]=( Offset=%u, ImgSize=%ux%u, Resol=%u, PaperSize=%ux%u )",
								pPrintInfo->printInfo.dwOffset,
								pPrintInfo->printInfo.dwImgWidth,
								pPrintInfo->printInfo.dwImgHeight,
								pPrintInfo->printInfo.dwResolution,
								pPrintInfo->printInfo.dwPaperWidth,
								pPrintInfo->printInfo.dwPaperLength );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pPrintInfo[3/7]=( CVP[1] Init=%u, Point=%u, Width=%u, Str=\"%s\" )",
								pPrintInfo->printInfo.dwCvpInitialValue1,
								pPrintInfo->printInfo.dwCvpPoint1,
								pPrintInfo->printInfo.dwCvpInitialWidth1,
								pPrintInfo->printInfo.szCvpLine1 );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pPrintInfo[4/7]=( CVP[2] Init=%u, Point=%u, Width=%u, Str=\"%s\" )",
								pPrintInfo->printInfo.dwCvpInitialValue2,
								pPrintInfo->printInfo.dwCvpPoint2,
								pPrintInfo->printInfo.dwCvpInitialWidth2,
								pPrintInfo->printInfo.szCvpLine2 );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pPrintInfo[5/7]=( Repeat=%u, Feed=%u, Surface=%u, Presence=%u, Espc=%d, CMS=%d )",
								pPrintInfo->printInfo.dwPrintNum,
								pPrintInfo->printInfo.dwFeed,
								pPrintInfo->printInfo.dwSurface,
								pPrintInfo->printInfo.dwPaperPresence,
								pPrintInfo->printInfo.nEspc,
								pPrintInfo->printInfo.wCMS );
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pPrintInfo[6/7]=( Angle=%d, wPaperFitting=%d, Edge=%d, WB=[%d][%d][%d][%d], WBC=[%d][%d][%d], PName=\"%s\", Pcfms=%d, PntQly=%d, ImgElg=%d )",
								pPrintInfo->printInfo.wAngle,
								pPrintInfo->printInfo.wPaperFitting,
								pPrintInfo->printInfo.wEdgeEnhancement,
								pPrintInfo->printInfo.wWithBorderTop,
								pPrintInfo->printInfo.wWithBorderBottom,
								pPrintInfo->printInfo.wWithBorderLeft,
								pPrintInfo->printInfo.wWithBorderRight,
								pPrintInfo->printInfo.byWithBorderColor[0],
								pPrintInfo->printInfo.byWithBorderColor[1],
								pPrintInfo->printInfo.byWithBorderColor[2],
								pPrintInfo->printInfo.szPaperName,
								pPrintInfo->printInfo.nPcfms,
								pPrintInfo->printInfo.wPrintQuality,			// Print quality
								pPrintInfo->printInfo.byImageEnlargeType );	// Image enlarge algorithm
		NPS_LOGOUT_DEBUG( strLog );
		strLog.Format( "   pPrintInfo[7/7]=( IccsCmdFilePath=%s )",
								pPrintInfo->pIccsCmdFilePath);
		NPS_LOGOUT_DEBUG( strLog );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevPrintIccsXml()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	//---------------------------
	// IccsXmlݒ
	//---------------------------
	T_ICCSXML	stIccsXml;

	ZeroMemory( &stIccsXml, sizeof( T_ICCSXML ) );
	stIccsXml.priority	= priority;
	strcpy( stIccsXml.IccsCmdFilePath, pPrintInfo->pIccsCmdFilePath );

	long lResult = pSdk->DevPrint (
							dwOrderId,					// vgI[_[IDw肷
							pPrintID,					// vgʎq
							pEventProc,					// CxgʒmpR[obN֐ւ
														// AhX
							&(pPrintInfo->printInfo),	// vgvp[^
							&stIccsXml					// IccsXml
							);

	if( NULL != pPrintID )
	{
		NPS_LOGOUT_VALUE_DEC( *pPrintID );
	}
	NpsLogReturn( "npsDevPrintIccsXml()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevSort ()
//	ABSTRACT : \[gv
//	FUNCTION : \[gw
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevSort (
	HPRINTER	hPrinter,	// v^̃nhw肷
	DWORD		dwOrderId	// 擾I[_[IDw肷
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevSort( hPrinter=0x%08X, dwOrderId=%d )", hPrinter, dwOrderId );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevSort()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevSort (
							dwOrderId	// 擾I[_[IDw肷
							);

	NpsLogReturn( "npsDevSort()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevCancelPrintOrder ()
//	ABSTRACT : vgI[_[LZ
//	FUNCTION : 󂯕tĂvg1I[_[LZ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevCancelPrintOrder (
	HPRINTER	hPrinter,	// v^̃nhw肷
	DWORD		dwOrderId,	// LZI[_[IDw肷
	DWORD		dwPrintID	// vgʎq
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevCancelPrintOrder( hPrinter=0x%08X, dwOrderId=%d, dwPrintID=%d )", hPrinter, dwOrderId, dwPrintID );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevCancelPrintOrder()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevCancelPrintOrder (
							dwOrderId,	// LZI[_[IDw肷
							dwPrintID	// vgʎq
							);

	NpsLogReturn( "npsDevCancelPrintOrder()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevGetPrintStatus ()
//	ABSTRACT : vgԎ擾
//	FUNCTION : vgԂ擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevGetPrintStatus (
	HPRINTER	hPrinter,		// v^̃nhw肷
	DWORD		dwPrintID,		// vgʎq
	LPDWORD		pPrintStatus	// vg
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevGetPrintStatus( hPrinter=0x%08X, dwPrintID=%d, pPrintStatus=0x%08X )", hPrinter, dwPrintID, pPrintStatus );
		NPS_LOGOUT_DEBUG( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevGetPrintStatus()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevGetPrintStatus (
							dwPrintID,		// vgʎq
							pPrintStatus	// vg
							);

	if( NULL != pPrintStatus )
	{
		NPS_LOGOUT_VALUE_HEX( *pPrintStatus );
	}
	NpsLogReturn( "npsDevGetPrintStatus()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevSetTime ()
//	ABSTRACT : ݒ
//	FUNCTION : ݒ肷
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevSetTime (
	HPRINTER		hPrinter,	// v^̃nhw肷
	PNPS_DateTime	pTime		// ݒ肷
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevSetTime( hPrinter=0x%08X, pTime=0x%08X )", hPrinter, pTime );
		NPS_LOGOUT( str );
	}

	if( NULL != pTime )
	{
		CString str;
		str.Format( "   *pTime=%04d/%02d/%02d %02d:%02d:%02d (%d)",
						pTime->tDate.dwYear,
						pTime->tDate.dwMonth,
						pTime->tDate.dwDay,
						pTime->tTime.dwHour,
						pTime->tTime.dwMinute,
						pTime->tTime.dwSecond,
						pTime->tDate.dwDayofweek );
		NPS_LOGOUT_DEBUG( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevSetTime()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevSetTime (
							pTime		// ݒ肷
							);

	NpsLogReturn( "npsDevSetTime()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevGetTime ()
//	ABSTRACT : 擾
//	FUNCTION : 擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevGetTime (
	HPRINTER		hPrinter,	// v^̃nhw肷
	PNPS_DateTime	pTime		// 擾̊i[
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevGetTime( hPrinter=0x%08X, pTime=0x%08X )", hPrinter, pTime );
		NPS_LOGOUT( str );
	}

	// \̏
	if( pTime )
	{
		ZeroMemory( pTime, sizeof( NPS_DateTime ) );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevGetTime()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevGetTime (
							pTime		// 擾̊i[
							);

	if( NULL != pTime )
	{
		CString str;
		str.Format( "   *pTime=%04d/%02d/%02d %02d:%02d:%02d (%d)",
						pTime->tDate.dwYear,
						pTime->tDate.dwMonth,
						pTime->tDate.dwDay,
						pTime->tTime.dwHour,
						pTime->tTime.dwMinute,
						pTime->tTime.dwSecond,
						pTime->tDate.dwDayofweek );
		NPS_LOGOUT_DEBUG( str );
	}
	NpsLogReturn( "npsDevGetTime()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevCloseCheck ()
//	ABSTRACT : v^N[Y`FbN
//	FUNCTION : v^̎gp֎~(npsDevClose)\ł邩`FbN
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[(/vg/e)
//				NPSERR_SYSERR		\[XsȂǂɂsłȂBSDKI[vĂȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevCloseCheck (
	HPRINTER	hPrinter	// v^̃nhw肷
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevCloseCheck( hPrinter=0x%08X )", hPrinter );
		NPS_LOGOUT_DEBUG( str );
	}

	// ALL
	if( NPS_HPRIN_ALL == hPrinter )
	{
		long	lResult	= NPSERR_NORMAL;

		for( int i = 0; i < g_pNpsControl->GetSdkSize(); i++ )
		{
			CSdk * pSdk	= g_pNpsControl->GetSdkNo( i );
			lResult	= pSdk->DevCloseCheck();

			if( NPSERR_NORMAL != lResult )
			{
				break;
			}
		}

		NpsLogReturn( "npsDevCloseCheck()", lResult );
		return lResult;
	}
	// ONE
	else
	{
		CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

		if( NULL == pSdk )
		{
			NpsLogReturn( "npsDevCloseCheck()", NPSERR_BADPARAM );
			return NPSERR_BADPARAM;
		}

		long lResult = pSdk->DevCloseCheck();

		NpsLogReturn( "npsDevCloseCheck()", lResult );
		return lResult;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevGetAllMagInfo ()
//	ABSTRACT : S}KW擾
//	FUNCTION : v^ɓo^ĂŎgpłSẴ}KW̏擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevGetAllMagInfo (
	HPRINTER			hPrinter,		// v^̃nhw肷
	PNPS_MagDetailInfo	pMagDetailInfo,	// }KWڍ׏󂯎obt@
	DWORD*				pdwSize			// obt@̃TCY
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevGetAllMagInfo( hPrinter=0x%08X, pMagDetailInfo=0x%08X, pdwSize=0x%08X )", hPrinter, pMagDetailInfo, pdwSize );
		NPS_LOGOUT( str );
	}

	if( NULL != pdwSize )
	{
		NPS_LOGOUT_VALUE_DEC( *pdwSize );
	}

	// \̏
	if( pMagDetailInfo && pdwSize )
	{
		ZeroMemory( pMagDetailInfo, *pdwSize );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevGetAllMagInfo()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevGetAllMagInfo (
							pMagDetailInfo,	// o^}KW󂯎obt@
							pdwSize			// obt@̃TCY
							);

	NpsLogReturn( "npsDevGetAllMagInfo()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevCtrlPrint ()
//	ABSTRACT : vg
//	FUNCTION : vg𐧌䂷ivg~/vg~j
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.7.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevCtrlPrint (
	HPRINTER	hPrinter,	// v^̃nhw肷
	DWORD		dwCtrl		// ew肷
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevCtrlPrint( hPrinter=0x%08X, dwCtrl=%d )", hPrinter, dwCtrl );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevCtrlPrint()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevCtrlPrint (
								dwCtrl		// ew肷
								);

	NpsLogReturn( "npsDevCtrlPrint()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevExpressOrder ()
//	ABSTRACT : I[_[DxύX
//	FUNCTION : I[_[̗Dx}wɕύX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//				NPSERR_REJECT3		tłȂԁBI[_[
//	
//	CREATE	 : T.Isogai	2006.8.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevExpressOrder (
	HPRINTER	hPrinter,	// v^̃nhw肷
	DWORD		dwOrderId	// Dx}wɂI[_[IDw肷
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevExpressOrder( hPrinter=0x%08X, dwOrderId=%d )", hPrinter, dwOrderId );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevExpressOrder()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevExpressOrder (
									dwOrderId	// Dx}wɂI[_[IDw肷
									);

	NpsLogReturn( "npsDevExpressOrder()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : NPS_API npsGetNpsVersion ()
//	ABSTRACT : NPS I/F ̃o[W
//	FUNCTION : {CuNPS I/F ̃o[W擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_SYSERR	\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2006.9.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsGetNpsVersion (
	LPWORD	pNpsVersion	// NPS I/F ̃o[W
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsGetNpsVersion( pNpsVersion=0x%08X )", pNpsVersion );
		NPS_LOGOUT_DEBUG( str );
	}

	if( NULL == pNpsVersion )
	{
		NpsLogReturn( "npsGetNpsVersion()", NPSERR_SYSERR );
		return NPSERR_SYSERR;
	}

	*pNpsVersion	= MyNPSIFVersion;

	NPS_LOGOUT_VALUE_HEX( *pNpsVersion );

	NpsLogReturn( "npsGetNpsVersion()", NPSERR_NORMAL );
	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : NPS_API npsDevGetProfile ()
//	ABSTRACT : v^vt@C擾
//	FUNCTION : y[p[Ƀvt@C擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_SYSERR	\[XsȂǂɂsłȂ
//	
//	CREATE	 : Y.Yoshinobu 2006.11.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevGetProfile(
	HPRINTER hPrinter,			// v^̃nhw肷
	LPCSTR lpFileName,			// vt@Cf[^ot@Cw肷
	PNPS_PaperInfo pPaperInfo	// vt@C擾y[p[̏w肷
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevGetProfile( hPrinter=0x%08X, lpFileName=\"%s\", pPaperInfo=0x%08X )", hPrinter, lpFileName, pPaperInfo );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevGetProfile()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevGetProfile (
								lpFileName,		// vt@Cf[^ot@Cw肷
								pPaperInfo		// vt@C擾y[p[̏w肷
									);

	NpsLogReturn( "npsDevGetProfile()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsSetCompletionProcMode ()
//	ABSTRACT : ʒm̓샂[hZbg
//	FUNCTION : 
//	NOTE     : < RD-111 > 
//             < Note > 
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂB
//	
//	CREATE	 : N.Nakahsima	2007.11.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsSetCompletionProcMode( DWORD dwMode )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsSetCompletionProcMode( 0x%08X )", dwMode );
		NPS_LOGOUT_DEBUG( str );
	}
	
	g_dwCompProcMode = dwMode;
	
	NpsLogReturn( "npsSetCompletionProcMode()", NPSERR_NORMAL );

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevStartDuplex ()
//	ABSTRACT : ʈJn
//	FUNCTION : 
//	NOTE     : < RD-111 > 
//             < Note > 
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂB
//	
//	CREATE	 : Y.Yoshinobu	2008.5.16
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevStartDuplex( HPRINTER hPrinter, DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevStartDuplex( hPrinter=0x%08X, dwOrderId=%d )", hPrinter, dwOrderId );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevStartDuplex()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevStartDuplex (
									dwOrderId	// ʈJnɂI[_[IDw肷
									);

	NpsLogReturn( "npsDevStartDuplex()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevEndDuplex ()
//	ABSTRACT : ʈI
//	FUNCTION : 
//	NOTE     : < RD-111 > 
//             < Note > 
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂB
//	
//	CREATE	 : Y.Yoshinobu	2008.5.16
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevEndDuplex( HPRINTER hPrinter, DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevEndDuplex( hPrinter=0x%08X, dwOrderId=%d )", hPrinter, dwOrderId );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevEndDuplex()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevEndDuplex (
									dwOrderId	// ʈIɂI[_[IDw肷
									);

	NpsLogReturn( "npsDevEndDuplex()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevBlankPrint ()
//	ABSTRACT : 󔒃y[W̃vgv
//	FUNCTION : 
//	NOTE     : < RD-111 > 
//             < Note > 
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂB
//	
//	CREATE	 : Y.Yoshinobu	2008.5.16
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevBlankPrint( HPRINTER hPrinter, DWORD dwOrderId, LPDWORD pPrintID, NPSCOMPLETIONPROC pEventProc, PNPS_BlankPrintInfo pBlankPrintInfo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevBlankPrint( hPrinter=0x%08X, dwOrderId=%d )", hPrinter, dwOrderId );
		NPS_LOGOUT( str );
	}

	if( NULL != pBlankPrintInfo )
	{
		CString strLog;
		strLog.Format( "   pBlankPrintInfo[1/1]=( Resol=%u, PaperSize=%ux%u, Repeat=%u, Feed=%u, Surface=%u, Presence=%u, PName=\"%s\", PntQly=%d, LCount=%d, PCount=%d, EventId=%d, ECodeMain=%d )",
								pBlankPrintInfo->dwResolution,
								pBlankPrintInfo->dwPaperWidth,
								pBlankPrintInfo->dwPaperLength,
								pBlankPrintInfo->dwPrintNum,
								pBlankPrintInfo->dwFeed,
								pBlankPrintInfo->dwSurface,
								pBlankPrintInfo->dwPaperPresence,
								pBlankPrintInfo->szPaperName,
								pBlankPrintInfo->wPrintQuality,
								pBlankPrintInfo->wLoadingCount,
								pBlankPrintInfo->wPrintedCount,
								pBlankPrintInfo->dwEventId,
								pBlankPrintInfo->wEventCodeMain );
		NPS_LOGOUT_DEBUG( strLog );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevBlankPrint()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevBlankPrint (
									dwOrderId,
									pPrintID,
									pEventProc,
									pBlankPrintInfo
									);

	NpsLogReturn( "npsDevBlankPrint()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevNpsCommand1 ()
//	ABSTRACT : NPSʐMi^Cv1jiJj
//	FUNCTION : Cӂ̃C^[tF[XIDƃR}h̓ʐM
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL			I
//				NPSERR_BADPARAM		wp[^ł͎słȂB
//				NPSERR_TIMEOUT			^CAEgԓɉԂĂȂB
//				NPSERR_REMAINING_DATA	lpRecvBuf̃obt@̈悪ȂB
//				NPSERR_SYSERR			\[XsȂǂɂsłȂB
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevNpsCommand1 (
	HPRINTER	hPrinter,		// v^̃nhw肷
	WORD		wIfId,			// C^[tFCXID
	WORD		wSendCmdId,		// vp̃R}hID
	WORD		wSendBufLen,	// vp̃R}h̃obt@TCY
	LPVOID		lpSendBuf,		// vp̃R}h̃obt@
	WORD		wRecvCmdId,		// p̃R}hID
	LPWORD		pwRecvBufLen,	// p̃R}h̃obt@TCY
	LPVOID		lpRecvBuf,		// p̃R}h̃obt@
	DWORD		dwTimeOut		// ^CAEg(~b)
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevNpsCommand1( hPrinter=0x%08X, wIfId=0x%04X, wSendCmdId=0x%04X, wSendBufLen=%d, lpSendBuf=0x%08X, wRecvCmdId=0x%04X, pwRecvBufLen=0x%08X, lpRecvBuf=0x%08X, dwTimeOut=%d )",
							hPrinter, wIfId, wSendCmdId, wSendBufLen, lpSendBuf, wRecvCmdId, pwRecvBufLen, lpRecvBuf, dwTimeOut );
		NPS_LOGOUT_DEBUG( str );
	}

	if( pwRecvBufLen )
	{
		NPS_LOGOUT_VALUE_DEC( *pwRecvBufLen );
	}

	NPS_LOGOUT_VALUE_PTR( lpRecvBuf );
	NPS_LOGOUT_VALUE_DEC( dwTimeOut );

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevNpsCommand1()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevNpsCommand1 (
							wIfId,			// C^[tFCXID
							wSendCmdId,		// vp̃R}hID
							wSendBufLen,	// vp̃R}h̃obt@TCY
							lpSendBuf,		// vp̃R}h̃obt@
							wRecvCmdId,		// p̃R}hID
							pwRecvBufLen,	// p̃R}h̃obt@TCY
							lpRecvBuf,		// p̃R}h̃obt@
							dwTimeOut		// ^CAEg(~b)
							);

	NpsLogReturn( "npsDevNpsCommand1()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevNpsCommand2 ()
//	ABSTRACT : NPSʐMi^Cv2jiJj
//	FUNCTION : Cӂ̃C^[tF[XIDƃR}h̓ʐM
//				R[obN֐ŕԂ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL			I
//				NPSERR_BADPARAM		wp[^ł͎słȂB
//				NPSERR_TIMEOUT			^CAEgԓɉԂĂȂB
//				NPSERR_REMAINING_DATA	lpRecvBuf̃obt@̈悪ȂB
//				NPSERR_SYSERR			\[XsȂǂɂsłȂB
//	
//	CREATE	 : T.Isogai	2006.7.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevNpsCommand2 (
	HPRINTER	hPrinter,		// v^̃nhw肷
	WORD		wIfId,			// C^[tFCXID
	WORD		wSendCmdId,		// vp̃R}hID
	WORD		wSendBufLen,	// vp̃R}h̃obt@TCY
	LPVOID		lpSendBuf,		// vp̃R}h̃obt@
	WORD		wRecvCmdId,		// p̃R}hID
	LPWORD		pwRecvBufLen,	// p̃R}h̃obt@TCY
	RECVPROC	pRecvProc,		// ɌĂяo֐
	DWORD		dwTimeOut		// ^CAEg(~b)
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevNpsCommand2( hPrinter=0x%08X, wIfId=0x%04X, wSendCmdId=0x%04X, wSendBufLen=%d, lpSendBuf=0x%08X, wRecvCmdId=0x%04X, pwRecvBufLen=0x%08X, pRecvProc=0x%08X, dwTimeOut=%d )",
							hPrinter, wIfId, wSendCmdId, wSendBufLen, lpSendBuf, wRecvCmdId, pwRecvBufLen, pRecvProc, dwTimeOut );
		NPS_LOGOUT_DEBUG( str );
	}
	
	if( pwRecvBufLen )
	{
		NPS_LOGOUT_VALUE_DEC( *pwRecvBufLen );
	}

	NPS_LOGOUT_VALUE_PTR( pRecvProc );
	NPS_LOGOUT_VALUE_DEC( dwTimeOut );

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevNpsCommand2()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevNpsCommand2 (
							wIfId,			// C^[tFCXID
							wSendCmdId,		// vp̃R}hID
							wSendBufLen,	// vp̃R}h̃obt@TCY
							lpSendBuf,		// vp̃R}h̃obt@
							wRecvCmdId,		// p̃R}hID
							pwRecvBufLen,	// p̃R}h̃obt@TCY
							pRecvProc,		// ɌĂяo֐
							dwTimeOut		// ^CAEg(~b)
							);

	NpsLogReturn( "npsDevNpsCommand2()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevNpsNotice ()
//	ABSTRACT : NPS񓯊ʐMiJj
//	FUNCTION : v^̔񓯊ʐMM߂̃R[obN֐o^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂB
//				NPSERR_SYSERR	\[XsȂǂɂsłȂB
//	
//	CREATE	 : T.Isogai	2006.9.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevNpsNotice (
	HPRINTER		hPrinter,		// v^̃nhw肷
	WORD			wIfId,			// C^[tFCXID
	WORD			wCmdId,			// R}hID
	NOTICEPROC		pNoticeProc		// ɌĂяo֐
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevNpsNotice( hPrinter=0x%08X, wIfId=0x%04X, wCmdId=0x%04X, pNoticeProc=0x%08X )",
							hPrinter, wIfId, wCmdId, pNoticeProc );
		NPS_LOGOUT_DEBUG( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevNpsNotice()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevNpsNotice (
							wIfId,			// C^[tFCXID
							wCmdId,			// R}hID
							pNoticeProc		// ɌĂяo֐
							);

	NpsLogReturn( "npsDevNpsNotice()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevCancelPrintAll ()
//	ABSTRACT : vgI[_[SLZiJj
//	FUNCTION : vgI[_[SăLZ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂB
//				NPSERR_PRNERR	v^G[B
//				NPSERR_SYSERR	\[XsȂǂɂsłȂB
//	
//	CREATE	 : T.Isogai	2006.9.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevCancelPrintAll (
	HPRINTER		hPrinter	// v^̃nhw肷
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevCancelPrintAll( hPrinter=0x%08X )", hPrinter );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevCancelPrintAll()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevCancelPrintAll ();

	NpsLogReturn( "npsDevCancelPrintAll()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevOccupyCheck ()
//	ABSTRACT : v^[LmF
//	FUNCTION : npsDevStartOrder APIŐLv^̐LImF
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	Iiv^𖢐Lj
//				NPSERR_BADPARAM	wp[^ł͎słȂB
//				NPSERR_REJECT3	v^L
//	
//	CREATE	 : Y.Yoshinobu 2007.02.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevOccupyCheck( HPRINTER hPrinter )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevOccupyCheck( hPrinter=0x%08X )", hPrinter );
		NPS_LOGOUT_DEBUG( str );
	}

	// ALL
	if( NPS_HPRIN_ALL == hPrinter )
	{
		long	lResult	= NPSERR_NORMAL;

		for( int i = 0; i < g_pNpsControl->GetSdkSize(); i++ )
		{
			CSdk * pSdk	= g_pNpsControl->GetSdkNo( i );
			lResult	= pSdk->DevOccupyCheck();

			if( NPSERR_NORMAL != lResult )
			{
				break;
			}
		}

		NpsLogReturn( "npsDevOccupyCheck()", lResult );
		return lResult;
	}
	// ONE
	else
	{
		CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

		if( NULL == pSdk )
		{
			NpsLogReturn( "npsDevOccupyCheck()", NPSERR_BADPARAM );
			return NPSERR_BADPARAM;
		}

		long lResult = pSdk->DevOccupyCheck();

		NpsLogReturn( "npsDevOccupyCheck()", lResult );
		return lResult;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsSetLanguage ()
//	ABSTRACT : ꖼZbg
//	FUNCTION : e
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//	
//	CREATE	 : Y.Yoshinobu 2007.05.02
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsSetLanguage( LPCSTR lpLangName )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsSetLanguage( %s )", lpLangName );
		NPS_LOGOUT_DEBUG( str );
	}

	if ( NULL == lpLangName )
	{
		::ZeroMemory( g_szLangName, sizeof(g_szLangName) );
	}
	else
	{
		::lstrcpy( g_szLangName, lpLangName );
	}

	NpsLogReturn( "npsSetLanguage()", NPSERR_NORMAL );

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsSetCustomMode ()
//	ABSTRACT : 샂[hZbg
//	FUNCTION : e
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//	
//	CREATE	 : Y.Yoshinobu 2007.05.09
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsSetCustomMode( DWORD dwMode )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsSetCustomMode( %08X )", dwMode );
		NPS_LOGOUT_DEBUG( str );
	}

	g_dwMode = dwMode;

	NpsLogReturn( "npsSetCustomMode()", NPSERR_NORMAL );

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsSetConnectMode ()
//	ABSTRACT : iڑ[hZbg
//	FUNCTION : e
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//	
//	CREATE	 : Y.Yoshinobu 2008.10.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsSetConnectMode( DWORD dwMode )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsSetConnectMode( %d )", dwMode );
		NPS_LOGOUT_DEBUG( str );
	}

	g_dwConnectMode = dwMode;

	NpsLogReturn( "npsSetConnectMode()", NPSERR_NORMAL );

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevGetTransmitTime ()
//	ABSTRACT : 摜]Ԃ̎擾
//	FUNCTION : e
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//	
//	CREATE	 : Y.Yoshinobu 2007.05.09
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevGetTransmitTime( HPRINTER hPrinter, LPDWORD pOrderId, LPDWORD pPrintID, LPDWORD pTime )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevGetTransmitTime( hPrinter=0x%08X, pOrderId=0x%08X, pPrintID=0x%08X, pTime=0x%08X )", hPrinter, pOrderId, pPrintID, pTime );
		NPS_LOGOUT_DEBUG( str );
	}

	if (( NULL == pOrderId ) || ( NULL == pPrintID ) || ( NULL == pTime ))
	{
		return NPSERR_BADPARAM;
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevGetTransmitTime()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevGetTransmitTime( pOrderId, pPrintID, pTime );

	// Oo
	NPS_LOGOUT_VALUE_DEC( *pOrderId );
	NPS_LOGOUT_VALUE_DEC( *pPrintID );
	NPS_LOGOUT_VALUE_DEC( *pTime );
	NpsLogReturn( "npsDevGetTransmitTime()", lResult );

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsSetTempFolder ()
//	ABSTRACT : ƃtH_̐ݒ
//	FUNCTION : 摜Ή
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//	
//	CREATE	 : Y.Yoshinobu 2008.01.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsSetTempFolder( LPCSTR lpFolderName )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsSetTempFolder( %s )", lpFolderName );
		NPS_LOGOUT_DEBUG( str );
	}

	if ( NULL == lpFolderName )
	{
		::ZeroMemory( g_szTempFolder, sizeof(g_szTempFolder) );
	}
	else
	{
		::lstrcpyn( g_szTempFolder, lpFolderName, sizeof(g_szTempFolder) );
	}

	NpsLogReturn( "npsSetTempFolder()", NPSERR_NORMAL );

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevStartFAD ()
//	ABSTRACT : FADgpJn
//	FUNCTION : FAD(Full Auto Dispenser)Ή@̂
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//	
//	CREATE	 : Y.Yoshinobu 2008.12.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevStartFAD( HPRINTER hPrinter, DWORD dwOrderId, LPCSTR lpOrderKey, LPDWORD lpdwResult, WORD wFadOut, LPCSTR lpFadFileName )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevStartFAD( hPrinter=0x%08X, dwOrderId=%d, lpOrderKey=%s, lpdwResult=0x%08X, wFadOut=%u, lpFadFileName=%s )",
						hPrinter, dwOrderId, lpOrderKey, lpdwResult, wFadOut, lpFadFileName );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevStartFAD()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevStartFAD (
							dwOrderId,		// 擾I[_[IDw肷
							lpOrderKey,		// I[_[̎ʎq
							lpdwResult,		// FAD
							wFadOut,		// vgro
							lpFadFileName	// FADrot@C̃pX
							);
	if( NULL != lpdwResult )
	{
		NPS_LOGOUT_VALUE_DEC( *lpdwResult );
	}
	NpsLogReturn( "npsDevStartFAD()", lResult );
	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevAdjustForPrint ()
//	ABSTRACT : vgJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//	
//	CREATE	 : Y.Yoshinobu 2009.03.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevAdjustForPrint( HPRINTER hPrinter )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevAdjustForPrint( hPrinter=0x%08X )", hPrinter );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevAdjustForPrint()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevAdjustForPrint ();

	NpsLogReturn( "npsDevAdjustForPrint()", lResult );

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevStartRetransmission ()
//	ABSTRACT : đJn	iJj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR	\[XsȂǂɂsłȂ
//	
//	CREATE	 : A.Nagamatsu 2011.11.02
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevStartRetransmission( HPRINTER hPrinter, DWORD dwOrderId, PNPS_InterruptOrderInfo pInterruptOrderInfo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevStartRetransmission( hPrinter=0x%08X, dwOrderId=%d )", hPrinter, dwOrderId );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevStartRetransmission()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevStartRetransmission ( dwOrderId, pInterruptOrderInfo );

	NpsLogReturn( "npsDevStartRetransmission()", lResult );

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevEndRetransmission ()
//	ABSTRACT : đI	iJj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR	\[XsȂǂɂsłȂ
//	
//	CREATE	 : A.Nagamatsu 2011.11.02
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevEndRetransmission( HPRINTER hPrinter, DWORD dwOrderId )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevEndRetransmission( hPrinter=0x%08X, dwOrderId=%d )", hPrinter, dwOrderId );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevEndRetransmission()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevEndRetransmission ( dwOrderId );

	NpsLogReturn( "npsDevEndRetransmission()", lResult );

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevInterruptPrintOrder ()
//	ABSTRACT : fLZ@iJj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL	I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR	\[XsȂǂɂsłȂ
//	
//	CREATE	 : A.Nagamatsu 2011.11.02
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevInterruptPrintOrder( HPRINTER hPrinter, DWORD dwOrderId, PNPS_InterruptOrderInfo pInterruptOrderInfo )
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevInterruptPrintOrder( hPrinter=0x%08X, dwOrderId=%d )", hPrinter, dwOrderId );
		NPS_LOGOUT( str );
	}

	CSdk * pSdk	= g_pNpsControl->GetSdk( hPrinter );

	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevInterruptPrintOrder()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}

	long lResult = pSdk->DevInterruptPrintOrder ( dwOrderId, pInterruptOrderInfo );

	NpsLogReturn( "npsDevInterruptPrintOrder()", lResult );

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : npsDevNpsNoticeEventProcEx ()
//	ABSTRACT : NPS񓯊ʐMiv^Cxggʒmo^j
//	FUNCTION : v^̔񓯊ʐMM邽߂̃R[obN֐o^܂

//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : A.Nagamatsu	2011.11.15
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long NPS_API npsDevNpsNoticeEventProcEx (
	HPRINTER		hPrinter,			// v^̃nhw肷
	NPSEVENTPROCEX 	pEventProcEx		// v^Cxggʒm֐
)
{
	NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

	if ( FALSE == g_pNpsControl->IsLibOpen() )
	{
		return NPSERR_BADPARAM;
	}

	{	// Oo
		CString str;
		str.Format( "npsDevNpsNoticeEventProcEx( pEventProcEx=0x%08X )", pEventProcEx );
		NPS_LOGOUT( str );
	}

	CSdk	* pSdk;

	pSdk	= g_pNpsControl->GetSdk( hPrinter );
	if( NULL == pSdk )
	{
		NpsLogReturn( "npsDevNpsNoticeEventProcEx()", NPSERR_BADPARAM );
		return NPSERR_BADPARAM;
	}
	
	long lResult = pSdk->DevNpsNoticeEventProcEx (
							pEventProcEx		// ɌĂяo֐
							);

	NpsLogReturn( "npsDevNpsNoticeEventProcEx()", lResult );


	return lResult;
}
