//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsCallbackControl.cpp
//	ABSTRACT  : CNpsCallbackControl NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.7.10
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsCallbackControl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCallbackControl::CNpsCallbackControl()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallbackControl::CNpsCallbackControl()
{
	InitializeCriticalSection( &m_CS );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCallbackControl::~CNpsCallbackControl()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallbackControl::~CNpsCallbackControl()
{
	{
		NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

		for( int i =0; i < m_vectorCallback.size(); i++ )
		{
			CNpsCallback* ptmpCallback	= ( CNpsCallback* ) m_vectorCallback[i];
			delete ptmpCallback;
		}

		m_vectorCallback.erase( m_vectorCallback.begin(), m_vectorCallback.end() );
	}

	DeleteCriticalSection( &m_CS );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallbackControl::AddCallback()
//	ABSTRACT : CNpsCallbackIuWFNgXgɒǉ
//	FUNCTION : CNpsCallbackIuWFNgXgɒǉ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCallbackControl::AddCallback( CNpsCallback * pCallback )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	if( GetCallback( pCallback->GetIfId(), pCallback->GetCmdId() ) )
	{
		// ɓo^ς
		return FALSE;
	}
	
	m_vectorCallback.push_back( pCallback );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallbackControl::GetCallbackNotCS()
//	ABSTRACT : CNpsCallbackIuWFNgXg擾iNeBJZNVȂj
//	FUNCTION : CNpsCallbackIuWFNgXg擾iNeBJZNVȂj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallback* CNpsCallbackControl::GetCallbackNotCS( WORD IfId, WORD CmdId )
{
	CNpsCallback* pCallback = NULL;

	for( int i =0; i < m_vectorCallback.size(); i++ )
	{
		CNpsCallback* ptmpCallback	= ( CNpsCallback* ) m_vectorCallback[i];

		if( ( IfId == ptmpCallback->GetIfId() ) && ( CmdId == ptmpCallback->GetCmdId() ) )
		{
			pCallback	= ptmpCallback;
			break;
		}
	}

	return pCallback;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallbackControl::GetCallback()
//	ABSTRACT : CNpsCallbackIuWFNgXg擾iNeBJZNVj
//	FUNCTION : CNpsCallbackIuWFNgXg擾iNeBJZNVj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallback* CNpsCallbackControl::GetCallback( WORD IfId, WORD CmdId )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	return GetCallbackNotCS( IfId, CmdId );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallbackControl::SetBuf()
//	ABSTRACT : CNpsCallbackIuWFNgփf[^
//	FUNCTION : CNpsCallbackIuWFNgփf[^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCallbackControl::SetBuf( WORD wIfId, WORD wCmdId, BYTE * lpBuff, unsigned long AttSize )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	CNpsCallback*	pCallback	= GetCallbackNotCS( wIfId, wCmdId );

	if( NULL == pCallback )
	{
		return FALSE;
	}

	CNpsCALLBACKDATA *	pCALLBACKDATA	= pCallback->CreateCALLBACKDATA();
	BYTE*	pBuf	= (BYTE*)pCALLBACKDATA->GetBuf();
	memcpy( pBuf, lpBuff, AttSize );
	pCALLBACKDATA->SetBufLenResult( AttSize );
	pCallback->SetEvent();

	return TRUE;
}