//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsNoticeRequest.cpp
//	ABSTRACT  : CNpsNoticeRequest NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.9.6
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsNoticeRequest.h"

extern BOOL g_bDetatch;

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsNoticeRequest::CNpsNoticeRequest()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.6
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsNoticeRequest::CNpsNoticeRequest(
					HPRINTER	hPrinter,		// v^̃nh
					DWORD		dwIPAddress,	// v^IPAhX
					WORD		IfId,			// C^[tFCXID
					WORD		CmdId,			// Mp̃R}hID
					void *		pFunc			// R[obN֐̃|C^
					)
{
	::InitializeCriticalSection( &m_csBufQue );

	m_hPrinter		= hPrinter;		// v^̃nh
	m_dwIPAddress	= dwIPAddress;	// v^IPAhX
	m_IfId			= IfId;			// C^[tFCXID
	m_CmdId			= CmdId;		// Mp̃R}hID
	m_pFunc			= pFunc;		// R[obN֐̃|C^

	int nPriority;
	#if defined(NPS_THREAD_PRIORITY_BELOW)
	nPriority = THREAD_PRIORITY_BELOW_NORMAL;
	#else  // defined(NPS_THREAD_PRIORITY_BELOW)
	nPriority = THREAD_PRIORITY_NORMAL;
	#endif // defined(NPS_THREAD_PRIORITY_BELOW)

	// Xbh̐
	m_hExitEvent    = CreateEvent( 0, FALSE, FALSE, 0 );		// IpCxg
	m_hEvent		= ::CreateSemaphore( NULL, 0, 1024, NULL );	// MmpCxg
	m_pWinThread	= AfxBeginThread( NoticeRequestThread, this, nPriority, 0, CREATE_SUSPENDED, NULL );
	m_pWinThread->m_bAutoDelete = FALSE;	// 폜Ȃ
	m_pWinThread->ResumeThread();			// Xbh̏Jn
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsNoticeRequest::~CNpsNoticeRequest()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsNoticeRequest::~CNpsNoticeRequest()
{
	// Ip̃Cxgݒ肵܂
	::SetEvent( m_hExitEvent );
	// XbhI҂
	if( g_bDetatch )
	{
		delete m_pWinThread;
	}
	else if( GetCurrentThreadId() != m_pWinThread->m_nThreadID )
	{
		// Xbhł͂ȂƂ
		HANDLE hThread;

		hThread = m_pWinThread->m_hThread;

		// eo[WAbvɂāANPS̒ʐMTIMEOUTɂȂ̑Ή
		::WaitForSingleObject( hThread, INFINITE );

		delete m_pWinThread;			// XbhpNX̍폜
		m_pWinThread = NULL;
	}else{
		// XbhĝƂ
		m_pWinThread->m_bAutoDelete = TRUE;		// 폜
	}

	// L[Ƀf[^cĂꍇɂ͉
	::EnterCriticalSection( &m_csBufQue );
	std::vector<CBuffer*>::iterator	itBufQue;
	for ( itBufQue=m_vBufQue.begin() ; m_vBufQue.end() != itBufQue ; itBufQue++ )
	{
		delete (*itBufQue);
	}
	m_vBufQue.clear();
	::LeaveCriticalSection( &m_csBufQue );

	// e㏈
	CloseHandle( m_hExitEvent );
	CloseHandle( m_hEvent );

	::DeleteCriticalSection( &m_csBufQue );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsNoticeRequest::AddData()
//	ABSTRACT : f[^Zbg
//	FUNCTION : Ōɍs
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.02.08
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsNoticeRequest::AddData( DWORD dwLen, LPBYTE lpBuf )
{
	CBuffer* pobjBuf;

	try
	{
		pobjBuf = new CBuffer;
	}
	catch (CMemoryException* e)
	{
		e->Delete();
		return FALSE;
	}

	if ( FALSE == pobjBuf->SetData( dwLen, lpBuf ) )
	{
		delete pobjBuf;
	}

	// L[ɒǉ
	::EnterCriticalSection( &m_csBufQue );
	m_vBufQue.push_back( pobjBuf );
	::LeaveCriticalSection( &m_csBufQue );

	::ReleaseSemaphore( m_hEvent, 1, NULL );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsNoticeRequest::NoticeRequestThread()
//	ABSTRACT : XbhiX^eBbNj
//	FUNCTION : XbhiX^eBbNj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT CNpsNoticeRequest::NoticeRequestThread( LPVOID pParam )
{
	return ((CNpsNoticeRequest*)pParam)->NoticeRequest();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsNoticeRequest::NoticeRequest()
//	ABSTRACT : Xbh
//	FUNCTION : Xbh
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.18
//	UPDATE   : J.Fukumori 2008.07.17 VS2005Ή@
//	UPDATE   : Y.Yoshinobu 2008.10.24 VS2005Ή~X̏C
//	                                  (NOTICEPROCIP2ByteԂĂȂs̏C)
//////////////////////////////////////////////////////////////////////////////
UINT CNpsNoticeRequest::NoticeRequest()
{
	CBuffer* pobjBuf;
	NPS_LOGOUT_DEBUG( "***** NpsNotice thread start" );

	HANDLE		evt[2] = { m_hExitEvent, m_hEvent };

	DWORD	dwState;
	while ( WAIT_OBJECT_0 + 1 == (dwState = WaitForMultipleObjects( COUNTOF( evt ), evt, FALSE, INFINITE)) )
	{
		pobjBuf = NULL;

		::EnterCriticalSection( &m_csBufQue );
		if ( 0 < m_vBufQue.size() )
		{
			pobjBuf = m_vBufQue.front();
			m_vBufQue.erase( m_vBufQue.begin() );
		}
		::LeaveCriticalSection( &m_csBufQue );

		if ( NULL != pobjBuf )
		{
			NPS_LOGOUT_DEBUG( "*********** start Notice Callback" );

			( ( NOTICEPROC )( m_pFunc ) )(
					m_hPrinter,					// v^̃nh
					(DWORD)m_dwIPAddress,		// v^IPAhX
					m_IfId,						// C^[tFCXID
					(WORD)m_CmdId,					// R}hID
					pobjBuf->GetDataBuf(),		// R}h̃obt@
					(WORD)pobjBuf->GetDataLen()		// R}h̃obt@TCY
				);

			NPS_LOGOUT_DEBUG( "*********** end Notice Callback" );

			delete pobjBuf;
		}
	}

	NPS_LOGOUT_DEBUG( "***** NpsNotice thread end" );

	return 0;
}
