//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsNoticeRequest.h
//	ABSTRACT  : CNpsNoticeRequest NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2006.9.6
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NPSNOTICEREQUEST_H__66A2B524_1184_408C_B119_C91A0F7D2C4C__INCLUDED_)
#define AFX_NPSNOTICEREQUEST_H__66A2B524_1184_408C_B119_C91A0F7D2C4C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NkcComApi.h"
#include "Nps.h"

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CBuffer
//	ABSTRACT : obt@ǗNX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : Y.yoshinobu	2008.02.08
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CBuffer
{
public:
	CBuffer()
	{
		m_dwBufLen = 0;
		m_lpBuf = NULL;
	};
	virtual ~CBuffer()
	{
		Clear();
	};

	void Clear()
	{
		m_dwBufLen = 0;
		if ( NULL != m_lpBuf )
		{
			delete m_lpBuf;
		}
	};

	BOOL SetData( const DWORD dwLen, LPBYTE lpBuf )
	{
		m_dwBufLen = dwLen;
		try
		{
			m_lpBuf	= new BYTE[ dwLen ];
		}
		catch (CMemoryException* e)
		{
			m_lpBuf = NULL;
			m_dwBufLen = 0;
			e->Delete();
			return FALSE;
		}
		::MoveMemory( m_lpBuf, lpBuf, dwLen );
		return TRUE;
	};

	DWORD GetDataLen() { return m_dwBufLen; };
	LPBYTE GetDataBuf() { return m_lpBuf; };

protected:

	// oϐ
	DWORD	m_dwBufLen;
	LPBYTE	m_lpBuf;
};

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CNpsNoticeRequest
//	ABSTRACT : 񓯊ʐMR[obN
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2006.8.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CNpsNoticeRequest  
{
public:
	virtual ~CNpsNoticeRequest();	// fXgN^

	CNpsNoticeRequest(				// RXgN^
					HPRINTER	hPrinter,		// v^̃nh
					DWORD		dwIPAddress,	// v^IPAhX
					WORD		IfId,			// C^[tFCXID
					WORD		CmdId,			// Mp̃R}hID
					void *		pFunc			// R[obN֐̃|C^
					);

	WORD	GetIfId()	{ return m_IfId; }		// C^[tFCXID
	WORD	GetCmdId()	{ return m_CmdId; }		// Mp̃R}hID
	BOOL	AddData( DWORD dwLen, LPBYTE lpBuf );	// f[^Zbg

protected:

	HPRINTER	m_hPrinter;		// v^̃nh
	DWORD		m_dwIPAddress;	// v^IPAhX

	WORD		m_IfId;			// C^[tFCXID
	WORD		m_CmdId;		// Mp̃R}hID
	void *		m_pFunc;		// R[obN֐̃|C^

	////////////////////////////////////////////////////////////////////////////
	// 㑤̊֐́AAfxBeginThread() ɗ^邽߂ static KvŁAł
	// NXϐɃANZX̂ʓ|Ȃ̂ŁANX֐̉֐Ăяo
	// sĂ܂
	CWinThread*		m_pWinThread;						// Xbhnh
	HANDLE			m_hEvent;							// Cxgnh
	HANDLE			m_hExitEvent;						// IpCxgnh
	static UINT		NoticeRequestThread( LPVOID pParam );// Xbh֐
	UINT			NoticeRequest();					// NoticeRequestThreadĂ΂֐

	//------------------------------------------------------------
	// Mf[^o^L[
	//------------------------------------------------------------
	std::vector<CBuffer*>	m_vBufQue;
	CRITICAL_SECTION		m_csBufQue;
};

#endif // !defined(AFX_NPSNOTICEREQUEST_H__66A2B524_1184_408C_B119_C91A0F7D2C4C__INCLUDED_)
