//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsRecvRequestControl.cpp
//	ABSTRACT  : CNpsRecvRequestControl NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.7.7
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsRecvRequestControl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsRecvRequestControl::CNpsRecvRequestControl()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsRecvRequestControl::CNpsRecvRequestControl()
{
	InitializeCriticalSection( &m_CS );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsRecvRequestControl::~CNpsRecvRequestControl()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.7
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CNpsRecvRequestControl::~CNpsRecvRequestControl()
{
	{
		NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

		for( int i =0; i < (int)m_vectorRecvRequest.size(); i++ )
		{
			CNpsRecvRequest* ptmpNpsRecvRequest	= ( CNpsRecvRequest* ) m_vectorRecvRequest[i];
			delete ptmpNpsRecvRequest;
		}

		m_vectorRecvRequest.erase( m_vectorRecvRequest.begin(), m_vectorRecvRequest.end() );
	}

	DeleteCriticalSection( &m_CS );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsRecvRequestControl::AddData()
//	ABSTRACT : CNpsRecvRequestIuWFNgXg֒ǉ
//	FUNCTION : CNpsRecvRequestIuWFNgXg֒ǉ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsRecvRequestControl::AddRequest( CNpsRecvRequest * pRecvRequest )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );
	m_vectorRecvRequest.push_back( pRecvRequest );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsRecvRequestControl::GetRequestNotCS()
//	ABSTRACT : CNpsRecvRequestIuWFNg擾iNeBJZNVȂj
//	FUNCTION : CNpsRecvRequestIuWFNg擾iNeBJZNVȂj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.24
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CNpsRecvRequest* CNpsRecvRequestControl::GetRequestNotCS( WORD IfId, WORD CmdId )
{
	CNpsRecvRequest* pNpsRecvRequest = NULL;

	for( int i =0; i < (int)m_vectorRecvRequest.size(); i++ )
	{
		CNpsRecvRequest* ptmpNpsRecvRequest	= ( CNpsRecvRequest* ) m_vectorRecvRequest[i];

		if( ( IfId == ptmpNpsRecvRequest->GetIfId() ) && ( CmdId == ptmpNpsRecvRequest->GetCmdId() ) )
		{
			pNpsRecvRequest	= ptmpNpsRecvRequest;
			break;
		}
	}

	return pNpsRecvRequest;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsRecvRequestControl::GetRequestNotDoneNotCS()
//	ABSTRACT : CNpsRecvRequestIuWFNg擾iRecvĂȂ́jiNeBJZNVȂj
//	FUNCTION : CNpsRecvRequestIuWFNg擾iRecvĂȂ́jiNeBJZNVȂj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.1
//	UPDATE   : J.Fukumori 2008.07.17 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
CNpsRecvRequest* CNpsRecvRequestControl::GetRequestNotDoneNotCS( WORD IfId, WORD CmdId )
{
	CNpsRecvRequest* pNpsRecvRequest = NULL;

	for( int i =0; i < (int)m_vectorRecvRequest.size(); i++ )
	{
		CNpsRecvRequest* ptmpNpsRecvRequest	= ( CNpsRecvRequest* ) m_vectorRecvRequest[i];

		if( ( FALSE == ptmpNpsRecvRequest->IsDone() ) && 
			( IfId == ptmpNpsRecvRequest->GetIfId() ) && ( CmdId == ptmpNpsRecvRequest->GetCmdId() ) )
		{
			pNpsRecvRequest	= ptmpNpsRecvRequest;
			break;
		}
	}

	if( ( pNpsRecvRequest == NULL ) && ( CmdId < 0xF000) )
	{
		CString	str;
		str.Format( "CNpsRecvRequestControl: Request not found.( SerchId=0x%04XH-0x%04XH )", IfId, CmdId );
		NPS_LOGOUT_FATAL( str );

		for( i =0; i < (int)m_vectorRecvRequest.size(); i++ )
		{
			CNpsRecvRequest* ptmpNpsRecvRequest	= ( CNpsRecvRequest* ) m_vectorRecvRequest[i];
			str.Format( "RecvRequest vector=0x%04XH-0x%04XH, %d",
									ptmpNpsRecvRequest->GetIfId(),
									ptmpNpsRecvRequest->GetCmdId(),
									ptmpNpsRecvRequest->IsDone() );
			NPS_LOGOUT( str );
		}
	}

	return pNpsRecvRequest;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :  CNpsRecvRequestControl::GetRequest()
//	ABSTRACT : CNpsRecvRequestIuWFNg擾iNeBJZNVj
//	FUNCTION : CNpsRecvRequestIuWFNg擾iNeBJZNVj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsRecvRequest* CNpsRecvRequestControl::GetRequest( WORD IfId, WORD CmdId )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	return GetRequestNotCS( IfId, CmdId );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :  CNpsRecvRequestControl::DeleteRequest()
//	ABSTRACT : CNpsRecvRequestIuWFNg폜
//	FUNCTION : CNpsRecvRequestIuWFNg폜
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.7
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsRecvRequestControl::DeleteRequest( HANDLE hEvent )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	for( int i =0; i < (int)m_vectorRecvRequest.size(); i++ )
	{
		CNpsRecvRequest* ptmpNpsRecvRequest	= ( CNpsRecvRequest* ) m_vectorRecvRequest[i];

		if( hEvent == ptmpNpsRecvRequest->GetEvent() )
		{
			m_vectorRecvRequest.erase( m_vectorRecvRequest.begin() + i );
			i--;
			delete ptmpNpsRecvRequest;
			break;
		}
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsRecvRequestControl::SetBuf()
//	ABSTRACT : CNpsRecvRequestIuWFNgփf[^
//	FUNCTION : CNpsRecvRequestIuWFNgփf[^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsRecvRequestControl::SetBuf( WORD wIfId, WORD wCmdId, BYTE * lpBuff, unsigned long AttSize )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	CNpsRecvRequest* pNpsRecvRequest = NULL;

	pNpsRecvRequest	= GetRequestNotDoneNotCS( wIfId, wCmdId );
	
	if( NULL == pNpsRecvRequest )
	{
		return FALSE;
	}

	pNpsRecvRequest->SetDone();

	// obt@TCỸ`FbN
	if( AttSize > pNpsRecvRequest->GetBufLen() )
	{
		pNpsRecvRequest->SetShortage();
	}
	else
	{
		BYTE * pBuf		= (BYTE*)pNpsRecvRequest->GetBuf();
		memcpy( pBuf, lpBuff, AttSize );
	}

	pNpsRecvRequest->SetBufLen( (WORD)AttSize );
	pNpsRecvRequest->EndFunc();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsRecvRequestControl::GetRequestNotDoneNotCSBySendCmdId()
//	ABSTRACT : CNpsRecvRequestIuWFNg擾iRecvĂȂ́jiNeBJZNVȂj
//	FUNCTION : CNpsRecvRequestIuWFNg擾iRecvĂȂ́jiNeBJZNVȂj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.8
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CNpsRecvRequest* CNpsRecvRequestControl::GetRequestNotDoneNotCSBySendCmdId( WORD IfId, WORD CmdId )
{
	CNpsRecvRequest* pNpsRecvRequest = NULL;

	for( int i =0; i < (int)m_vectorRecvRequest.size(); i++ )
	{
		CNpsRecvRequest* ptmpNpsRecvRequest	= ( CNpsRecvRequest* ) m_vectorRecvRequest[i];

		if( ( FALSE == ptmpNpsRecvRequest->IsDone() ) && 
			( IfId == ptmpNpsRecvRequest->GetIfId() ) && ( CmdId == ptmpNpsRecvRequest->GetSendCmdId() ) )
		{
			pNpsRecvRequest	= ptmpNpsRecvRequest;
			break;
		}
	}

	return pNpsRecvRequest;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsRecvRequestControl::NoticeNotSupport()
//	ABSTRACT : R}hT|[gԂꂽ
//	FUNCTION : R}hT|[gԂꂽ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsRecvRequestControl::NoticeNotSupport( WORD wIfId, WORD wCmdId )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	CNpsRecvRequest* pNpsRecvRequest = NULL;

	pNpsRecvRequest	= GetRequestNotDoneNotCSBySendCmdId( wIfId, wCmdId );
	
	if( NULL == pNpsRecvRequest )
	{
		return FALSE;
	}

	pNpsRecvRequest->SetNotSupport();
	pNpsRecvRequest->EndFunc();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsRecvRequestControl::EventAllSetOffline()
//	ABSTRACT : ItCȂǂ̏ꍇɁAIɃCxgZbgďI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2007.1.12
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsRecvRequestControl::EventAllSetOffline()
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	CNpsRecvRequest* pNpsRecvRequest = NULL;

	for( int i =0; i < (int)m_vectorRecvRequest.size(); i++ )
	{
		pNpsRecvRequest	= ( CNpsRecvRequest* ) m_vectorRecvRequest[i];

		if ( FALSE == pNpsRecvRequest->IsDone() )
		{
			pNpsRecvRequest->SetOffline();
			pNpsRecvRequest->EndFunc();
		}
	}

	return TRUE;
}
