// OutputLog.cpp: COutputLog NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OutputLog.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COutputLog::LogToMemory()
//	ABSTRACT : RXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
COutputLog::COutputLog(
	LPCSTR lpFileName,			// Ot@C
	LPCSTR lpBackupFileName,	// ÕobNAbvt@CiP㕪pj
	DWORD dwBackupSize,			// obNAbvt@Cɐ؂ւt@CTCY
	DWORD dwMemSize )			// Oe
{
	m_eUsedVer = ORIGINAL;
	m_pNkcLogCommon = NULL;

	////////////////////////////////////////
	// Log֌W̕ϐ̏
	////////////////////////////////////////

	char	drive[_MAX_DRIVE];
	char	dir[_MAX_DIR];
	char	fname[_MAX_FNAME];
	char	ext[_MAX_EXT];
	char	szLogFilePath[MAX_PATH];
	char	szMutexName[MAX_PATH];

	m_dwWriteAdrs = 0;
	m_dwSize = dwMemSize;
	m_pBuffer = NULL;
	m_hMutex = NULL;
	m_dwBackupSize = dwBackupSize;

	try
	{
		m_pBuffer = new char [m_dwSize];
	}
	catch ( CMemoryException* e )
	{
		m_pBuffer = NULL;
		e->Delete();
	}

	////////////////////////////////////////
	// Ot@C̍쐬
	////////////////////////////////////////
	// W[̎spXɁAw肳ꂽt@CŃO쐬
	//   A^CpF[W[̎spX]\[lpFileName].log
	//   obNAbvpF[W[̎spX]\[lpBackupFileName].log

	// AvP[V̐΃pX擾i΃pXj
	::GetModuleFileName( NULL, szLogFilePath, MAX_PATH );
	::_splitpath( szLogFilePath, drive, dir, fname, ext );

	// obNAbvp̃t@C쐬
	if ( NULL != lpBackupFileName )
	{
		::_makepath( szLogFilePath, drive, dir, lpBackupFileName, "log" );
		m_strBackupFilePath = szLogFilePath;
	}

	// A^Cp̃t@C쐬
	::_makepath( szLogFilePath, drive, dir, lpFileName, "log" );
	m_strFilePath = szLogFilePath;



	////////////////////////////////////////
	// ~[ebNXIuWFNg쐬
	////////////////////////////////////////
	// DLL̃Ot@CȂ̂ŁAꃂW[NĂrł悤
	// ~[ebNXIuWFNg̖O쐬
	int nIdx;
	int nCnt;

	// t@Cւ̏o͂ɑ΂Ĕrs悤ɂ邽߁AOt@C~[ebNXɂ
	::lstrcpy( szMutexName, szLogFilePath );

	// ~[ebNXIuWFNg̖OɁu \ v͎gpłȂ߃A_[o[ɕϊ
	nCnt = (int)strlen( szMutexName );
	for( nIdx=0 ; nCnt > nIdx ; nIdx++ )
	{
		if( '\\' == szMutexName[nIdx] )
		{
			szMutexName[nIdx] = '_';
		}
	}

	// ZLeB[̐ݒ
	SECURITY_ATTRIBUTES sa;
	SECURITY_DESCRIPTOR SD;

	// VZLeBLqq
	if ( !InitializeSecurityDescriptor( &SD, SECURITY_DESCRIPTOR_REVISION ) )
	{
		return;
	}
	// ZLeBLqq DACLiӃANZX䃊Xgjݒ肷
	if ( !SetSecurityDescriptorDacl( &SD, TRUE, (PACL)NULL, FALSE ) )
	{
		return;
	}
	sa.nLength = sizeof(sa);
	sa.lpSecurityDescriptor = &SD;
	sa.bInheritHandle = TRUE;

	// Mutex̍쐬
	m_hMutex = ::CreateMutex( &sa, FALSE, szMutexName );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COutputLog::LogToMemory()
//	ABSTRACT : RXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : J.Fuumori(AVASYS) 2008.07.17 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
COutputLog::COutputLog(
	LPCSTR configFile		// Oݒt@C
)
{
	int nValue;
	m_eUsedVer = VERSION_NONE;
	m_pNkcLogCommon = NULL;

	if ( NULL != configFile )
	{
		nValue = ::GetPrivateProfileInt( "log", "memorysize", (-1), configFile );
		if ( (-1) == nValue )
		{	// CNkcLogCommon gp
			m_eUsedVer = VERSION_1;
			m_pNkcLogCommon = (LPVOID) new CNkcLogCommon( configFile );
		}
		else
		{	// CNkcLogCommon2 gp
			m_eUsedVer = VERSION_2;
			m_pNkcLogCommon = (LPVOID) new CNkcLogCommon2( configFile );
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COutputLog::~COutputLog()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
COutputLog::~COutputLog()
{
	switch ( m_eUsedVer )
	{
	case ORIGINAL:
		if ( NULL != m_pBuffer )
		{
			delete [] m_pBuffer;
		}

		if ( NULL != m_hMutex )
		{
			::CloseHandle( m_hMutex );
			m_hMutex = NULL;
		}
		break;
	case VERSION_1:
		delete ((CNkcLogCommon*)m_pNkcLogCommon);
		m_pNkcLogCommon = NULL;
		break;
	case VERSION_2:
		delete ((CNkcLogCommon2*)m_pNkcLogCommon);
		m_pNkcLogCommon = NULL;
		break;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COutputLog::LogToMemory()
//	ABSTRACT : Oɏ݃t@Cɏo͂
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
void COutputLog::LogToMemory(
	int nLevel,			// Ox
	LPCSTR lpFileName,	// OɋL^\[Xt@C
	int nLineNumber,	// OɋL^\[Xt@C̍sԍ
	LPCSTR lpMes )		// ObZ[W̕
{
	switch ( m_eUsedVer )
	{
	case ORIGINAL:
		LogToMemoryA( nLevel, lpFileName, nLineNumber, lpMes );
		break;
	case VERSION_1:
	case VERSION_2:
		LogToMemoryB( nLevel, lpFileName, nLineNumber, lpMes );
		break;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COutputLog::LogToMemoryA()
//	ABSTRACT : Oɏ݃t@Cɏo͂
//	FUNCTION : ƎO
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void COutputLog::LogToMemoryA(
	int nLevel,			// Ox
	LPCSTR lpFileName,	// OɋL^\[Xt@C
	int nLineNumber,	// OɋL^\[Xt@C̍sԍ
	LPCSTR lpMes )		// ObZ[W̕
{

	#if !defined(_DEBUG)
	if( LOG_DEBUG == nLevel )
	{
		// _DEBUGłȂꍇLOG_DEBUG̃O͏oȂ
		return;
	}
	#endif

	// rJn
	Use();

	int nMsgLen;
	char szLevel[16];
	CString	strMes;
	SYSTEMTIME	tLocalTime;

	switch ( nLevel )
	{
	case LOG_FATAL:	::lstrcpy( szLevel, "FATAL" )	;break;
	case LOG_WARN:	::lstrcpy( szLevel, "WARN " )	;break;
	case LOG_INFO:	::lstrcpy( szLevel, "INFO " )	;break;
	case LOG_DEBUG:	::lstrcpy( szLevel, "DEBUG" )	;break;
	}

	// ݎ̎擾
	::GetLocalTime( &tLocalTime );

	// ɃOo
//	#if defined(_DEBUG)
	strMes.Format( "%02d/%02d %02d:%02d:%02d.%03d [%08X] [%08X] [%s] [%-32s] [%5d] - %s\r\n",
				tLocalTime.wMonth, tLocalTime.wDay,
				tLocalTime.wHour, tLocalTime.wMinute, tLocalTime.wSecond, tLocalTime.wMilliseconds,
				::GetCurrentProcessId(), ::GetCurrentThreadId(),
				szLevel, ::PathFindFileName(lpFileName), nLineNumber, lpMes );
//	#else  // #if defined(_DEBUG)
//	strMes.Format( "%02d/%02d %02d:%02d:%02d.%03d [%08X] [%08X] [%s] - %s\r\n",
//				tLocalTime.wMonth, tLocalTime.wDay,
//				tLocalTime.wHour, tLocalTime.wMinute, tLocalTime.wSecond, tLocalTime.wMilliseconds,
//				::GetCurrentProcessId(), ::GetCurrentThreadId(),
//				szLevel, lpMes );
//	#endif // #if defined(_DEBUG)

	nMsgLen = strMes.GetLength();
	::MoveMemory( m_pBuffer + m_dwWriteAdrs, strMes.GetBuffer(nMsgLen), nMsgLen );

	m_dwWriteAdrs += nMsgLen;

	Flush();

	// rI
	Release();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COutputLog::LogToMemoryB()
//	ABSTRACT : Oɏ݃t@Cɏo͂
//	FUNCTION : ʃO
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
void COutputLog::LogToMemoryB(
	int nLevel,			// Ox
	LPCSTR lpFileName,	// OɋL^\[Xt@C
	int nLineNumber,	// OɋL^\[Xt@C̍sԍ
	LPCSTR lpMes )		// ObZ[W̕
{
	CString str;
	str.Format( "[%08X] %s", ::GetCurrentThreadId(), lpMes );

	switch ( m_eUsedVer )
	{
	case VERSION_1:
		((CNkcLogCommon*)m_pNkcLogCommon)->LogToMemory( nLevel, lpFileName, nLineNumber, str );
		break;
	case VERSION_2:
		((CNkcLogCommon2*)m_pNkcLogCommon)->LogToMemory( nLevel, lpFileName, nLineNumber, str );
		break;
	}
}

// ɒ~ςĂ郍Ot@Cɓfo

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COutputLog::Flush()
//	ABSTRACT : ̓et@Cɏo
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
void COutputLog::Flush()
{
	switch ( m_eUsedVer )
	{
	case ORIGINAL:
		FlushA();
		break;
	case VERSION_1:
	case VERSION_2:
		FlushB();
		break;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COutputLog::FlushA()
//	ABSTRACT : ̓et@Cɏo
//	FUNCTION : ƎO
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void COutputLog::FlushA()
{
	BOOL	bResult;
	BOOL	bRename=FALSE;
	HANDLE	hFile;
	DWORD	dwOffSet;
	DWORD	dwSize;
	DWORD	dwWriteCount;
	DWORD	dwFileSize;
	LONG	nDistanceLow;


	dwSize = m_dwWriteAdrs;
	m_dwWriteAdrs = 0;

	////////////////////////////////////////
	// ̓et@Cɏo
	////////////////////////////////////////

	// t@C̃I[v
	hFile = ::CreateFile( m_strFilePath, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
	if ( hFile != INVALID_HANDLE_VALUE )
	{

		// ItZbgI[Ɉړ
		nDistanceLow = 0;
		dwOffSet = ::SetFilePointer( hFile, nDistanceLow, NULL, FILE_END );
		if ( dwOffSet == INVALID_SET_FILE_POINTER )
		{
			::CloseHandle(hFile);
			return;
		}

		// Ȍ
		if ( NULL != m_pBuffer )
		{
			bResult = WriteFile( hFile, m_pBuffer, dwSize, &dwWriteCount, NULL );
			if ( FALSE == bResult )
			{
				::CloseHandle(hFile);
				return;
			}
		}

		// Ot@C̗eʊmF
		dwFileSize = ::GetFileSize( hFile, NULL );
		if ( 0xFFFFFFFF != dwFileSize )
		{
			if ( m_dwBackupSize < dwFileSize )
			{
				bRename = TRUE;
			}
		}

		// t@C̃N[Y
		bResult = ::CloseHandle(hFile);
		if ( FALSE == bResult )
		{
			return;
		}

	}

	////////////////////////////////////////
	// obNAbvt@C̍쐬
	////////////////////////////////////////
	// eʈȏł΃t@Cl[

	if ( TRUE == bRename )
	{
		if ( FALSE == m_strBackupFilePath.IsEmpty() )
		{
			::DeleteFile( m_strBackupFilePath );
			::MoveFile( m_strFilePath, m_strBackupFilePath );
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COutputLog::FlushB()
//	ABSTRACT : ̓et@Cɏo
//	FUNCTION : ʃO
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
void COutputLog::FlushB()
{
	switch ( m_eUsedVer )
	{
	case VERSION_1:
		((CNkcLogCommon*)m_pNkcLogCommon)->FileOut();
		break;
	case VERSION_2:
		((CNkcLogCommon2*)m_pNkcLogCommon)->FileOut();
		break;
	}
}


//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COutputLog::Use()
//	ABSTRACT : rJni~[ebNXIuWFNgj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void COutputLog::Use()
{
	if ( NULL != m_hMutex )
	{
		::WaitForSingleObject( m_hMutex, INFINITE );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COutputLog::Release()
//	ABSTRACT : rIi~[ebNXIuWFNgj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void COutputLog::Release()
{
	if ( NULL != m_hMutex )
	{
		ReleaseMutex( m_hMutex );
	}
}

