//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : PrintThread.h
//	ABSTRACT  : CPrintThread NX̃C^[tFCX
//	
//	CREATE    : Y.Yoshinobu	2006.10.8
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PRINTTHREAD_H__12B700DC_7742_4156_AF32_7E9CB2E44C69__INCLUDED_)
#define AFX_PRINTTHREAD_H__12B700DC_7742_4156_AF32_7E9CB2E44C69__INCLUDED_

#include "PrintQue.h"
#if defined(NKC_CMS_PROC)
#include "CorrectWrapDllCom.h"
#endif // defined(NKC_CMS_PROC)

#if defined(NPS_CUSTOM_EDG)
#pragma pack(push, 2)
#include "NKC_Image_File_JPG_L6.h"
#include "NKC_Image_File_BMP_L2.h"
#include "NKC_Image_File_TIF_L1.h"
#pragma pack(pop)
#endif  // defined(NPS_CUSTOM_EDG)

#include "IccsCall.h"
typedef CIccsCall* (__stdcall *CREATEICCSCALL)( void );
typedef void (__stdcall *RELEASEICCSCALL)( CIccsCall* );

class	CSdk;

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct {				// CMS̃p[^
	DWORD	dwCmsMode;			// CMS̃[h (1:Normal, 2:Custom)
	DWORD	dwColorSpace;		// 摜̐F (0:sRGB, 1:AdobeRGB)
	DWORD	dwPaperWidth; 		// y[p[̕ (PʁF0.1mm)
	DWORD	dwPaperId;			// y[p[ID
	DWORD	dwFeed;				// @
	CHAR	szPaperName[32];	// y[p[
} T_CmsProcParam;

typedef struct {
	BOOL	bEnableCms;			// CMSsǂ ( TRUE:s, FALSE:sȂ )
	DWORD	dwSourceType;		// 摜f[^̎󂯓n@ ( IMGSRC_SHAREDMEM | IMGSRC_FILE )
	CHAR	szImgFile[MAX_PATH];// ̓t@C
	DWORD	dwImgFileOffset;	// ̓f[^̃ItZbg
	DWORD	dwImgFileLength;	// ̓f[^̃TCY
	UCHAR	ImageFormat;		// 摜tH[}bg ( IMGFMT_JPEG | IMGFMT_BMP | IMGFMT_RAW24 )
	T_CmsProcParam	tCmsParam;	// CMS̃p[^
} T_CmsProcParamIn;

typedef struct {
	BOOL	bOriginalImgFile;	// ͉摜Ɠǂ ( TRUE:, FALSE:Ⴄ )
	DWORD	dwSourceType;		// 摜f[^̎󂯓n@ ( 0:Ln, 1:t@Cn )
	DWORD	dwImageCapacity;	// o̓f[^̃TCY
	DWORD	dwOffset;			// o̓f[^̃ItZbg
	UCHAR	ImageFormat;		// 摜tH[}bg ( IMGFMT_JPEG | IMGFMT_BMP | IMGFMT_RAW24 )
	CHAR	szImgFile[MAX_PATH];// o͉摜t@C
} T_CmsProcParamOut;

// vg̃Xbh̃Gg
unsigned int WINAPI PrintThreadEntry( LPVOID pParam );

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CPrintThread
//	ABSTRACT : vgNX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : Y.Yoshinobu 2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CPrintThread  
{
public:
	CPrintThread();
	virtual ~CPrintThread();

	//----------------------------------------------------------------------------
	// XbhǗ
	//----------------------------------------------------------------------------

		// XbhJn
	BOOL	InitInstance();
		// Xbh
	void	ExecProc();
		// XbhI
	BOOL	ExitInstance();
		// XbhIv
	void	EndThread();

		// vgvꎞ~
	void	PrintPause();
		// vgvĊJ
	void	PrintRestart();

		// vgJnCxg쓮
	void	SetPrintEvent();

		// ImFpCxg̎擾
	HANDLE	GetStartEventHandle();

		// XbhImFpCxg擾	2006.11.06 T.Mizushima
	HANDLE	GetFinishEventHandle();

	//----------------------------------------------------------------------------
	// vgL[
	//----------------------------------------------------------------------------

		// vgL[IuWFNg̓o^
	void	SetPrintQue( CPrintQue* pPrintQue );
		// R}hMIuWFNg̓o^
	void	SetNpsCmd( CNpsCmd* pNpsCmd );
		// 摜MIuWFNg̓o^
	void	SetNpsImgMng( CNpsImgManager* pNpsImgMng );

	//----------------------------------------------------------------------------
	// v^Ǘ
	//----------------------------------------------------------------------------

		// v^ǗIuWFNg̓o^
	void	SetDataManager( CDataManager* pDataManager );

		//	lbg[NʐMG[
	void	ErrorNoticeON_6681( LONG nSubNo );

		// v^ʂǗIuWFNg̓o^
	void	SetSdk( CSdk* pSdk );


private:

	//----------------------------------------------------------------------------
	// vg
	//----------------------------------------------------------------------------

		// vgC֐
	void	PrintProcMain();
		// I[_[Jnv
	void	PrintProcOrderStart( T_NextCmd* pNextCmd );
		// R}v
	BOOL	PrintProcFrame( T_NextCmd* pNextCmd, const short nRetry );
	void	MakeCmd_6000_0700( const T_FrameData &tFrameData, T_Nps6000H_0700H &tNps6000H_0700H );
		// 󔒃R}v
	void	PrintProcBlankFrame( T_NextCmd* pNextCmd );
		// \[^[v
	void	PrintProcSort( T_NextCmd* pNextCmd );
		// ʈJn
	void	PrintProcDuplexStart( T_NextCmd* pNextCmd );
		// ʈI
	void	PrintProcDuplexEnd( T_NextCmd* pNextCmd );
		// I[_[Iv
	void	PrintProcOrderEnd( T_NextCmd* pNextCmd );

		// NWbgJn
	BOOL	PrintProcCreditStart( T_NextCmd* pNextCmd );
		// NWbgI
	BOOL	PrintProcCreditEnd( T_NextCmd* pNextCmd );

		// [hύX
	BOOL	PrintProcModeChange( T_NextCmd* pNextCmd, WORD wMode );

		// đJn
	void	PrintProcRetransmissionStart( T_NextCmd* pNextCmd );

		// đI
	void	PrintProcRetransmissionEnd( T_NextCmd* pNextCmd );

#if defined(NKC_CMS_PROC)

	//----------------------------------------------------------------------------
	// NKCp
	//----------------------------------------------------------------------------

		// 摜
	void	IcwMainProc( CIcwProcParam* pParam );
	void	IcwSubProc1( CIcwInfo& objParam );		// 摜tH[}bgϊ
	void	IcwSubProc21( CIcwInfo& objParam );		// ەϊ (tBbeBOΉ)
	void	IcwSubProc22( CIcwInfo& objParam );		// ەϊ (tBbeBOΉ)

		// 摜p[^̃Oo
	void	WriteLogIcwParam( CIcwInfo& objParam, LPCTSTR lpMessage );

		// CMSŎgpDatt@C̃pX擾
	BOOL	GetFileNameOfCmsDat( DWORD dwCms, DWORD dwColorSpace, DWORD dwPaperTypeCode, T_Nps6000H_0101H* pNps6000H_0101H, T_Nps6000H_0201H* pNps6000H_0201H, BOOL* pDeleteCmsDatFile, CString* pstrFileName );

		// CMSŎgpDatt@C̃pX擾(Op␳AS)
	BOOL	GetFileNameOfCmsDat1( DWORD dwCms, DWORD dwColorSpace, DWORD dwPaperTypeCode, T_Nps6000H_0101H* pNps6000H_0101H, CString* pstrFileName );

		// CMSŎgpDatt@C̃pX擾(ICMAS)
	BOOL	GetFileNameOfCmsDat2( DWORD dwCms, DWORD dwColorSpace, DWORD dwPaperTypeCode, int nSetupType, T_Nps6000H_0101H* pNps6000H_0101H, T_Nps6000H_0201H* pNps6000H_0201H, CString* pstrFileName );

		// CMSf[^̓ǂݍ
	LPVOID	LoadCmsFile( LPCTSTR lpFileName );

		// ƗptH_̃tpXԂ܂
	CString	MakeTempFolderFullPath();

		// Ɨpt@C̃tpXԂ܂
	CString	MakeTempFileFullPath( LPCTSTR lpFileName );


#endif // defined(NKC_CMS_PROC)


private:

	//----------------------------------------------------------------------------
	// XbhǗ
	//----------------------------------------------------------------------------

	enum
	{	// m_hEvent
		EVENT_STOP = 0,						// XbhIpCxgnh
		EVENT_PRINT,						// vgJnCxgnh
#if defined(EVENT_TIMER_ON)
		EVENT_TIMER,						// ^C}[Cxg
#endif // defined(EVENT_TIMER_ON)
		EVENT_FINISH,						// XbhImFpCxg	2006.11.06 T.Mizushima
		EVENT_CNT
	};

	HANDLE				m_hEvent[EVENT_CNT];	// Cxgvz

	HANDLE				m_hStartEvent;			// ImFpCxg

	//----------------------------------------------------------------------------
	// vgǗ
	//----------------------------------------------------------------------------

	BOOL				m_bPrintPause;			// vgꎞ~tOi TRUE:ꎞ~, FALSE:ꎞ~Ȃ j
	CRITICAL_SECTION	m_csPrintPause;			// NeBJZNV

	//----------------------------------------------------------------------------
	// vgL[
	//----------------------------------------------------------------------------
	CPrintQue*			m_pPrintQue;			// vgL[ǗNX̃|C^
	CNpsCmd*			m_pNpsCmd;				// R}hMNX̃|C^
	CNpsImgManager*		m_pNpsImgMng;			// \PbgʐMNXǗ(r)NX

	//----------------------------------------------------------------------------
	// v^Ǘ
	//----------------------------------------------------------------------------
	CDataManager*		m_pDataManager;			// v^ǗNX̃|C^

	//----------------------------------------------------------------------------
	// FILE I/O vOC֌W
	//----------------------------------------------------------------------------
	HMODULE				m_hImgFileJpgL6;	// JPEG
	HMODULE				m_hImgFileBmpL2;	// BMP
	HMODULE				m_hImgFileTifL1;	// TIFF

	//----------------------------------------------------------------------------
	// 摜֌W
	//----------------------------------------------------------------------------
	LPVOID				m_hNkcICorrGPro;		// GPro摜IuWFNg̃nh

	CSdk*				m_pSdk;					// v^ʂǗNX̃|C^
	BOOL				m_ImgPortRetry;			// 摜]pؒfɂ0700HđtO	2007.01.11 T.Mizushima

	//----------------------------------------------------------------------------
	// ICCSXML
	//----------------------------------------------------------------------------
	HMODULE				m_hIccsCall;
	CIccsCall*			m_pIccsCall;
};

#endif // !defined(AFX_PRINTTHREAD_H__12B700DC_7742_4156_AF32_7E9CB2E44C69__INCLUDED_)
