//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : PseudoIPAddr.cpp
//	ABSTRACT  : CPseudoIPAddr NX̃Cve[V
//	
//	CREATE    : H.Kamiya 2015.12.03
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PseudoIPAddr.h"
#include <imagehlp.h>
#pragma comment(lib, "imagehlp.lib")



#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define	PSEUDO_IP_ADDR_RECORD_MAX	1024

class MutexLocker
{
public:
	explicit MutexLocker( HANDLE hMutex )
	{
		m_hMutex = hMutex;
		::WaitForSingleObject( m_hMutex, INFINITE );
	}
	virtual ~MutexLocker()
	{
		::ReleaseMutex( m_hMutex );
	}
protected:
	HANDLE m_hMutex;
};

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
CPseudoIPAddr* CPseudoIPAddr::sInstance = NULL;

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::Create()
//	ABSTRACT : VOgCX^X
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CPseudoIPAddr* CPseudoIPAddr::Create()
{
	if( !sInstance )
	{
		sInstance = new CPseudoIPAddr();
	}
	return sInstance;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::Close()
//	ABSTRACT : VOgCX^Xj
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPseudoIPAddr::Close()
{
	if( sInstance )
	{
		delete sInstance;
		sInstance = NULL;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::GetInstance()
//	ABSTRACT : VOgCX^X擾
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CPseudoIPAddr* CPseudoIPAddr::GetInstance()
{
	return sInstance;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::Add()
//	ABSTRACT : [IPAhX𐶐MACAhXNPSp|[gԍƂRtR[he[u֒ǉ
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CPseudoIPAddr::Add( DWORD HostIPAddr, UCHAR HostMacAddress[], USHORT NpsPortNo, USHORT ImgPortNo, ULONG PrinterIPAddress, UCHAR PrinterMacAddress[] )
{
	MutexLocker locker( m_hMutex );

	TPseudoIPAddrRecord tRecord = {0};
	//DWORD IPAddress = Generate();
	DWORD PseudoIPAddress = PseudoIPGenerate( HostIPAddr, NpsPortNo );

	tRecord.Flag = 1;
	tRecord.PseudoIPAddress = PseudoIPAddress;			// [IP
	tRecord.HostIPAddress = HostIPAddr;
	memcpy( tRecord.HostMacAddress, HostMacAddress, sizeof( tRecord.HostMacAddress ) );
	tRecord.NpsPortNo = NpsPortNo;
	tRecord.ImgPortNo = ImgPortNo;
	tRecord.PrinterIPAddress = PrinterIPAddress;
	memcpy( tRecord.PrinterMacAddress, PrinterMacAddress, sizeof( tRecord.PrinterMacAddress ) );

	TPseudoIPAddrRecord* ptr = ( ( TPseudoIPAddrView* )m_pView )->Record;
	for( int ii = 0; ii < PSEUDO_IP_ADDR_RECORD_MAX; ii++ )
	{
		if( ptr->Flag == 0 )
		{
			memcpy( ptr, &tRecord, sizeof( tRecord ) );
			
			struct in_addr PseudoIPAddress = {0}, HostAddr = {0}, PrtAddr = {0};
			PseudoIPAddress.S_un.S_addr = tRecord.PseudoIPAddress;
			HostAddr.S_un.S_addr = tRecord.HostIPAddress;
			PrtAddr.S_un.S_addr = tRecord.PrinterIPAddress;
				
			CString str;
			str.Format( " [Add Pseudo IP Addr Tabel] PseudoIP=%s, HostIP=%s, HostMacAddr=%02X-%02X-%02X-%02X-%02X-%02X, NpsPort=%d, ImgPort=%d, PritnerIPAddr=%s, PrinterMacAddr=%02X-%02X-%02X-%02X-%02X-%02X",
			CString( A2T( inet_ntoa( PseudoIPAddress ) ) ),
			CString( A2T( inet_ntoa( HostAddr ) ) ),
			tRecord.HostMacAddress[0], tRecord.HostMacAddress[1], tRecord.HostMacAddress[2], tRecord.HostMacAddress[3], tRecord.HostMacAddress[4], tRecord.HostMacAddress[5],
			tRecord.NpsPortNo,
			tRecord.ImgPortNo,
			CString( A2T( inet_ntoa( PrtAddr ) ) ),
			tRecord.PrinterMacAddress[0], tRecord.PrinterMacAddress[1], tRecord.PrinterMacAddress[2], tRecord.PrinterMacAddress[3], tRecord.PrinterMacAddress[4], tRecord.PrinterMacAddress[5]
			);
			NPS_LOGOUT( str );
			
			break;
		}
		++ptr;
	}

	
	return tRecord.PseudoIPAddress;
}
#if 0
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::FindByMacAddr()
//	ABSTRACT : MACAhXNPSp|[gԍIPAhX擾
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CPseudoIPAddr::FindByMacAddr(UCHAR MacAddress[], USHORT NpsPortNo )
{
	MutexLocker locker( m_hMutex );

	DWORD IPAddress = 0L;

	TPseudoIPAddrRecord* ptr = ( ( TPseudoIPAddrView* )m_pView )->Record;
	for( int ii = 0; ii < PSEUDO_IP_ADDR_RECORD_MAX; ii++ )
	{
		if( ptr->Flag != 0 )
		{
			if( !memcmp(ptr->MacAddress, MacAddress, sizeof( ptr->MacAddress ) ) &&
				ptr->NpsPortNo == NpsPortNo
				)
			{
				IPAddress = ptr->IPAddress;
				break;
			}
		}
		++ptr;
	}

	return IPAddress;
}
#endif
#if 0
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::FindByPrinterIPAddr()
//	ABSTRACT : Printer IPAhXIPAhX擾i̍XVsj
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : M.Hirono 2016/4/4
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CPseudoIPAddr::FindByPrinterIPAddr(UCHAR MacAddress[], USHORT NpsPortNo, USHORT ImgPortNo, ULONG PrinterIPAddress, UCHAR PrinterMacAddress[])
{
	MutexLocker locker( m_hMutex );

	DWORD IPAddress = 0L;

	TPseudoIPAddrRecord* ptr = ( ( TPseudoIPAddrView* )m_pView )->Record;
	for( int ii = 0; ii < PSEUDO_IP_ADDR_RECORD_MAX; ii++ )
	{
		if( ptr->Flag != 0 )
		{
			if( ptr->PrinterIPAddress == PrinterIPAddress )
			{
				IPAddress = ptr->PseudoIPAddress;
				
				if( memcmp(ptr->MacAddress, MacAddress, sizeof( ptr->MacAddress ) ) ||
					ptr->NpsPortNo != NpsPortNo	||
					ptr->ImgPortNo != ImgPortNo	||
					memcmp(ptr->PrinterMacAddress, PrinterMacAddress, sizeof( ptr->PrinterMacAddress ) )
				)
				{
					// e[u̍XV
					memcpy( ptr->MacAddress, MacAddress, sizeof( ptr->MacAddress ) );
					ptr->NpsPortNo = NpsPortNo;
					ptr->ImgPortNo = ImgPortNo;
					memcpy( ptr->PrinterMacAddress, PrinterMacAddress, sizeof( ptr->PrinterMacAddress ) );
					
					struct in_addr addr;
					addr.s_addr = ptr->IPAddress;
					
					CString str;
					str.Format( " [Upadate Pseudo IP Addr Tabel] PseudoIP=%s, RipMacAddr=%02X-%02X-%02X-%02X-%02X-%02X, NpsPort=%d, ImgPort=%d, PrinterMacAddr=%02X-%02X-%02X-%02X-%02X-%02X",
					inet_ntoa(addr),
					ptr->MacAddress[0], ptr->MacAddress[1], ptr->MacAddress[2], ptr->MacAddress[3], ptr->MacAddress[4], ptr->MacAddress[5],
					ptr->NpsPortNo,
					ptr->ImgPortNo,
					ptr->PrinterMacAddress[0], ptr->PrinterMacAddress[1], ptr->PrinterMacAddress[2], ptr->PrinterMacAddress[3], ptr->PrinterMacAddress[4], ptr->PrinterMacAddress[5]
					);
					NPS_LOGOUT( str );
				}
				
				break;
			}
		}
		++ptr;
	}

	return IPAddress;
}
#endif
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::FindByRipIPAddr()
//	ABSTRACT : Host-PC IPAhX, NPS PortԍL[ɋ[IPAhX擾
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : M.Hiorno 2016/4/4
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CPseudoIPAddr::FindByHostIPAddr( DWORD HostIPAddr, UCHAR HostMacAddress[], USHORT NpsPortNo, USHORT ImgPortNo, ULONG PrinterIPAddress, UCHAR PrinterMacAddress[] )
{
	MutexLocker locker( m_hMutex );

	DWORD IPAddress = 0L;

	TPseudoIPAddrRecord* ptr = ( ( TPseudoIPAddrView* )m_pView )->Record;
	for( int ii = 0; ii < PSEUDO_IP_ADDR_RECORD_MAX; ii++ )
	{
		if( ptr->Flag != 0 )
		{
			if( ptr->HostIPAddress == HostIPAddr &&
				ptr->NpsPortNo == NpsPortNo
				)
			{
				IPAddress = ptr->PseudoIPAddress;
				
				// zXgIPANPS|[gԍȊÔꂩقȂĂ΃e[uXV
				if( 0 != memcmp(ptr->HostMacAddress, HostMacAddress, sizeof( ptr->HostMacAddress ) ) ||
					ptr->ImgPortNo != ImgPortNo ||
					0 != memcmp(ptr->PrinterMacAddress, PrinterMacAddress, sizeof( ptr->PrinterMacAddress ) )
				)
				{
					// e[u̍XV
					memcpy( ptr->HostMacAddress, HostMacAddress, sizeof( ptr->HostMacAddress ) );
					ptr->NpsPortNo = NpsPortNo;
					ptr->ImgPortNo = ImgPortNo;
					memcpy( ptr->PrinterMacAddress, PrinterMacAddress, sizeof( ptr->PrinterMacAddress ) );
					
					struct in_addr addr;
					addr.s_addr = IPAddress;
					
					CString str;
					str.Format( " [Upadate Pseudo IP Addr Tabel] PseudoIP=%s, HostIP=%s, HostMacAddr=%02X-%02X-%02X-%02X-%02X-%02X, NpsPort=%d, ImgPort=%d, PrinterMacAddr=%02X-%02X-%02X-%02X-%02X-%02X",
					inet_ntoa(addr),
					ptr->HostIPAddress,
					ptr->HostMacAddress[0], ptr->HostMacAddress[1], ptr->HostMacAddress[2], ptr->HostMacAddress[3], ptr->HostMacAddress[4], ptr->HostMacAddress[5],
					ptr->NpsPortNo,
					ptr->ImgPortNo,
					ptr->PrinterMacAddress[0], ptr->PrinterMacAddress[1], ptr->PrinterMacAddress[2], ptr->PrinterMacAddress[3], ptr->PrinterMacAddress[4], ptr->PrinterMacAddress[5]
					);
					NPS_LOGOUT( str );
				}
				
				break;
			}
		}
		++ptr;
	}

	return IPAddress;
}


//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::FindByIPAddr()
//	ABSTRACT : [IPAhX烌R[h擾
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
TPseudoIPAddrRecord* CPseudoIPAddr::FindByIPAddr(DWORD PseudoIPAddress, TPseudoIPAddrRecord* pRecord)
{
	MutexLocker locker( m_hMutex );

	TPseudoIPAddrRecord* ptr = ( ( TPseudoIPAddrView* )m_pView )->Record;
	for( int ii = 0; ii < PSEUDO_IP_ADDR_RECORD_MAX; ii++ )
	{
		if( ptr->Flag != 0 )
		{
			if( ptr->PseudoIPAddress == PseudoIPAddress )
			{
				memcpy( pRecord, ptr, sizeof( TPseudoIPAddrRecord ) );
				break;
			}
		}
		++ptr;
	}

	if( ii < PSEUDO_IP_ADDR_RECORD_MAX )
	{
		return pRecord;
	}
	else
	{
		return NULL;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::CPseudoIPAddr()
//	ABSTRACT : RXgN^
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CPseudoIPAddr::CPseudoIPAddr()
{
	SECURITY_DESCRIPTOR sd = { 0 };
	SECURITY_ATTRIBUTES sa = { 0 };

	InitializeSecurityDescriptor( &sd, SECURITY_DESCRIPTOR_REVISION );
	SetSecurityDescriptorDacl( &sd, TRUE, NULL, FALSE );

	sa.nLength = sizeof(sa);
	sa.lpSecurityDescriptor = &sd;
	sa.bInheritHandle = FALSE;

	// VXehCu擾
	char szWinDir[_MAX_PATH] = {0};
	char szDrive[_MAX_PATH] = {0};
	GetWindowsDirectory( szWinDir, _MAX_PATH );
	_splitpath( szWinDir, szDrive, NULL, NULL, NULL );
	// e[ut@Co͐fBNg쐬
	CString strOutputDir;
	strOutputDir.Format( "%s\\Noritsu\\", szDrive );
	CString strPseudoIPTblFilePath = strOutputDir + "PseudoIPAddrTable.dat";
	if( !MakeSureDirectoryPathExists(strOutputDir) )
	{
		NPS_LOGOUT( "Failure Create PseudoIP Table Dir" );
	}

	// e[urIuWFNg
	m_hMutex = ::CreateMutex(
			&sa,
			FALSE,
			"_NPS_PSEUDO_IP_ADDR_TABLE_MUTEX_" );

	// w肵pX̃t@CI[v
	m_hFile = ::CreateFile(
			strPseudoIPTblFilePath,							// [IPAhXe[ut@CpX
			GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ | FILE_SHARE_WRITE,
			&sa,
			OPEN_ALWAYS,
			FILE_ATTRIBUTE_NORMAL,
			NULL );

	if( INVALID_HANDLE_VALUE == m_hFile )
	{
		return;
	}

	// t@CTCY擾
	m_dwSize = ::GetFileSize( m_hFile, NULL );
	if( INVALID_FILE_SIZE == m_dwSize )
	{
		// t@CTCY0ɂ
		m_dwSize = 0;
		return;
	}

	// I[vt@C̃t@C}bsO쐬
	m_hMapping = ::CreateFileMapping(
			m_hFile,
			&sa,
			PAGE_READWRITE,
			0,
			sizeof( TPseudoIPAddrHeader ) + sizeof( TPseudoIPAddrRecord ) * PSEUDO_IP_ADDR_RECORD_MAX,
			NULL );
	if( NULL == m_hMapping )
	{
		return;
	}

	// t@C̃r[}bv
	m_pView = ::MapViewOfFile(
			m_hMapping,
			FILE_MAP_ALL_ACCESS,
			0,
			0,
			0 );
	if( NULL == m_pView )
	{
		return;
	}
	// o[W̏
	if( ( ( TPseudoIPAddrView* )m_pView )->Header.Version < PSEUDO_IP_ADDR_RECORD_VERSION )
	{
		( ( TPseudoIPAddrView* )m_pView )->Header.Version = PSEUDO_IP_ADDR_RECORD_VERSION;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::~CPseudoIPAddr()
//	ABSTRACT : fXgN^
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CPseudoIPAddr::~CPseudoIPAddr()
{
	if( NULL != m_pView )
	{
		::UnmapViewOfFile( m_pView );
	}

	if( NULL != m_hMapping )
	{
		::CloseHandle( m_hMapping );
	}

	if( INVALID_HANDLE_VALUE != m_hFile )
	{
		::CloseHandle( m_hFile );
	}

	if( INVALID_HANDLE_VALUE != m_hMutex )
	{
		::CloseHandle( m_hMutex );
	}
}
#if 0
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::Generate()
//	ABSTRACT : [IPAhX
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CPseudoIPAddr::Generate()
{
	MutexLocker locker( m_hMutex );

	DWORD nBaseAddr = ( ( TPseudoIPAddrView* )m_pView )->BaseAddr;

	if( 0 == nBaseAddr )
	{
		nBaseAddr = 0x0100000a;					// e[ul̏ꍇ10.0.0.1琶n߂
	}
	
	BYTE b1 = (BYTE)( (nBaseAddr & 0xFF000000) >> 24 );			// xxx.xxx.xxx.000
	BYTE b2 = (BYTE)( (nBaseAddr & 0x00FF0000) >> 16 );			// xxx.xxx.000.xxx
	BYTE b3 = (BYTE)( (nBaseAddr & 0x0000FF00) >> 8 );			// xxx.000.xxx.xxx
	DWORD genAddr = nBaseAddr;

	nBaseAddr &= 0x000000FF;

	if( 0 == ++b1 )
	{
		if( 0 == ++b2 )
		{
			++b3;
		}
		++b1;
	}

	nBaseAddr |= ((UINT)(b1) << 24);
	nBaseAddr |= ((UINT)(b2) << 16);
	nBaseAddr |= ((UINT)(b3) << 8);

	( ( TPseudoIPAddrView* )m_pView )->BaseAddr = nBaseAddr;

	return genAddr;
}
#endif
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPseudoIPAddr::PseudoIPGenerate()
//	ABSTRACT : [IPAhX
//	FUNCTION :
//	
//	NOTE     : Host IPAhXƃ|[gԍ[IPAhX
//             (HostIP[xxx.yyy.yyy.yyy]y̒lƃ|[gԍƂ)
//	
//	RETURN   : 
//	
//	CREATE	 : M.Hirono 2016.04.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CPseudoIPAddr::PseudoIPGenerate( DWORD dwIPAddr, USHORT NpsPortNo )
{
	DWORD dwGenIPAddr = 0;
	DWORD dwPortIndex = 254;
	
	switch( NpsPortNo )
	{
		case 31582: 	dwPortIndex = 1; 	break;
		case 32582: 	dwPortIndex = 2; 	break;
		case 33582: 	dwPortIndex = 3; 	break;
		case 34582: 	dwPortIndex = 4; 	break;
		default:		dwPortIndex = 254;  break;
	}
	
	dwGenIPAddr = dwIPAddr >> 8;
	dwGenIPAddr += dwPortIndex << 24; 
	
	return dwGenIPAddr;
}
