#include "CmnApi.h"

namespace CMNAPI {

//--------------------------------------------------------------------
//	MODULE   : WriteLog()
//	ABSTRACT : Oo͊֐
//--------------------------------------------------------------------
CRITICAL_SECTION g_csWriteLog;
void WriteLogStart()
{
	::InitializeCriticalSection( &g_csWriteLog );
}

void WriteLogEnd()
{
	::DeleteCriticalSection( &g_csWriteLog );
}

void WriteLog( LPCTSTR lpFormat, ... )
{
	va_list pArg;
	TCHAR szLog[2048] = { 0 };
	CString strLog;
	SYSTEMTIME stTime;

	::GetLocalTime( &stTime );

	try
	{
		va_start( pArg, lpFormat );
		vsprintf_s( szLog, lpFormat, pArg );
		va_end(pArg);
	}
	catch (...)
	{
		strcpy_s( szLog, "WriteLog() BUFFER FULL ERROR" );
	}

	strLog.Format( "%02d/%02d %02d:%02d:%02d'%03d [%08X] %s\r\n",
					stTime.wMonth, stTime.wDay,
					stTime.wHour, stTime.wMinute, stTime.wSecond, stTime.wMilliseconds,
					GetCurrentThreadId(),
					szLog );

	// Wo͂
	printf( "%s", strLog );

	// t@Cɏo͂
	char	drive[_MAX_DRIVE];
	char	dir[_MAX_DIR];
	char	fname[_MAX_FNAME];
	char	ext[_MAX_EXT];
	char	szLogFilePath[MAX_PATH];

	CStdioFile objFile;

	::GetModuleFileName( NULL, szLogFilePath, MAX_PATH );
	::_splitpath_s( szLogFilePath, drive, dir, fname, ext );

	// A^Cp̃t@C쐬
	::_makepath_s( szLogFilePath, drive, dir, fname, "log" );

	{//Ot@Cւ̃ANZX邽߂ɁÃXR[v͔rs
		CMNAPI::CCSScopeLock objScopeLock( &g_csWriteLog );

		// t@C̃I[v
		HANDLE hFile = NULL;
		LONG nDistanceLow = 0;
		DWORD dwWriteCount = 0;
		hFile = ::CreateFile( szLogFilePath, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
		if ( INVALID_HANDLE_VALUE != hFile )
		{

			// ItZbgI[Ɉړ
			if ( INVALID_SET_FILE_POINTER != ::SetFilePointer( hFile, nDistanceLow, NULL, FILE_END ) )
			{
				::WriteFile( hFile, strLog.GetBuffer(0), strLog.GetLength(), &dwWriteCount, NULL );
			}

			// t@C̃N[Y
			::CloseHandle(hFile);

		}
	}
}

//--------------------------------------------------------------------
//	MODULE   : GetModuleFolder()
//	ABSTRACT : W[̂tH_pX擾
//--------------------------------------------------------------------
CString GetModuleFolder()
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char szModuleFilePath[MAX_PATH];
	char szModuleFolderPath[MAX_PATH];

	::GetModuleFileName( NULL, szModuleFilePath, MAX_PATH );
#if _MSC_VER >= 1400
	::_splitpath_s( szModuleFilePath, drive, dir, fname, ext );
	::_makepath_s( szModuleFolderPath, drive, dir, NULL, NULL );
#else
	::_splitpath( szModuleFilePath, drive, dir, fname, ext );
	::_makepath( szModuleFolderPath, drive, dir, NULL, NULL );
#endif

	return CString( szModuleFolderPath );
}

//--------------------------------------------------------------------
//	MODULE   : GetFileSize()
//	ABSTRACT : t@C̃TCY擾܂
//--------------------------------------------------------------------
unsigned long GetFileSize( LPCTSTR lpFilePath )
{
	BOOL	bRet;
	HANDLE	hFile;
	DWORD	dwSize;

	// 
	dwSize = 0;

	// t@C̃I[v
	hFile = ::CreateFile(
				lpFilePath,				// pointer to name of the file
				GENERIC_READ,			// access (read-write) mode
				FILE_SHARE_READ,		// share mode
				NULL,					// pointer to security attributes
				OPEN_EXISTING,			// how to create
				FILE_ATTRIBUTE_NORMAL,	// file attributes
				NULL
			);

	if ( hFile != INVALID_HANDLE_VALUE ) {

		// t@CTCY̊mF
		dwSize = ::GetFileSize( hFile, NULL );

		// t@C̃N[Y
		bRet = ::CloseHandle(hFile);
		if ( FALSE == bRet ) {
			return dwSize;
		}

	}

	return dwSize;
}

//--------------------------------------------------------------------
//	MODULE   : ConvIPAddress()
//	ABSTRACT : IPAhX4Byte^ɕϊ
//--------------------------------------------------------------------
unsigned long ConvIPAddress( UCHAR i1, UCHAR i2, UCHAR i3, UCHAR i4 )
{
	union _IPADDRESS_VAR {
		unsigned char	IP_CHAR[4];
		unsigned long	IP_LONG;
	};

	union _IPADDRESS_VAR var;

	var.IP_CHAR[0] = i1;
	var.IP_CHAR[1] = i2;
	var.IP_CHAR[2] = i3;
	var.IP_CHAR[3] = i4;

	return var.IP_LONG;
}

}	// namespace COMAPI
