// DevPrintTabDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "npsclient.h"
#include "DevPrintTabDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDevPrintTabDlg _CAO
// UPDATE: J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
/////////////////////////////////////////////////////////////////////////////

CDevPrintTabDlg::CDevPrintTabDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDevPrintTabDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevPrintTabDlg)
	m_CallTimes = 0;
	//}}AFX_DATA_INIT

	m_Type	= eDevPrint;
}


void CDevPrintTabDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevPrintTabDlg)
	DDX_Control(pDX, IDC_TAB1, m_Tab);
	DDX_Text(pDX, IDC_EDIT_CALL_TIMES, m_CallTimes);
	DDV_MinMaxUInt(pDX, m_CallTimes, 1, 100);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDevPrintTabDlg, CDialog)
	//{{AFX_MSG_MAP(CDevPrintTabDlg)
	ON_WM_DESTROY()
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnSelchangeTab1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevPrintTabDlg bZ[W nh

#define NPSCLIENT_TABMARGIN	10

BOOL CDevPrintTabDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ

	// ^ȕ
	char	szTmp[256];
	TCITEM	wItem;
	wItem.mask			= TCIF_TEXT;
    wItem.pszText		= szTmp;
    wItem.cchTextMax	= 256;

	CRect	recTabItem;
	CRect	recTab;

	m_Tab.GetItemRect( 0, recTabItem );
	m_Tab.GetWindowRect( recTab );
	ScreenToClient( recTab );

	recTab.top	+= recTabItem.Height();
	recTab.DeflateRect( NPSCLIENT_TABMARGIN, NPSCLIENT_TABMARGIN );

	CDevPrintDlg*	pDevPrintDlg;

	/////////////////////////////////////////////////////////////////////////////
	// BASIC_CAO̐
	pDevPrintDlg	= (CDevPrintDlg*) new CDevPrintBasicDlg();

	strcpy( szTmp, pDevPrintDlg->GetName() );
	m_Tab.InsertItem( m_Tab.GetItemCount(), &wItem );
	pDevPrintDlg->SetDataPointer( m_pNpsPrintInfo );
	pDevPrintDlg->Create( IDD_DIALOG_DEV_PRINT_BASIC, this );
	pDevPrintDlg->MoveWindow( recTab );
	m_tabArray.Add( pDevPrintDlg );

	/////////////////////////////////////////////////////////////////////////////
	// EXTEND_CAO̐
	pDevPrintDlg	= (CDevPrintDlg*) new CDevPrintExtendDlg();

	strcpy( szTmp, pDevPrintDlg->GetName() );
	m_Tab.InsertItem( m_Tab.GetItemCount(), &wItem );
	pDevPrintDlg->SetDataPointer( m_pNpsPrintInfo );
	pDevPrintDlg->Create( IDD_DIALOG_DEV_PRINT_EXTEND, this );
	pDevPrintDlg->MoveWindow( recTab );
	m_tabArray.Add( pDevPrintDlg );

	if( m_Type == eDevPrintIccsXml )
	{
		/////////////////////////////////////////////////////////////////////////////
		// ICCSXML_CAO̐
		pDevPrintDlg	= (CDevPrintDlg*) new CDevPrintIccsXmlDlg();

		strcpy( szTmp, pDevPrintDlg->GetName() );
		m_Tab.InsertItem( m_Tab.GetItemCount(), &wItem );
		pDevPrintDlg->SetDataPointer( m_pNpsPrintInfo );
		pDevPrintDlg->Create( IDD_DIALOG_DEV_PRINT_ICCSXML, this );
		pDevPrintDlg->MoveWindow( recTab );
		m_tabArray.Add( pDevPrintDlg );
	}

	/////////////////////////////////////////////////////////////////////////////
	TabUpdate();

	/////////////////////////////////////////////////////////////////////////////
	// LvV
	if( m_Type == eDevPrintIccsXml )
	{
		SetWindowText( "DevPrintIccsXml" );
	}
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDevPrintTabDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	for( int nCnt = 0; nCnt < m_tabArray.GetSize(); nCnt++ )
	{
		CDevPrintDlg* pDevPrintDlg = m_tabArray.GetAt( nCnt );
		pDevPrintDlg->DestroyWindow();
		delete pDevPrintDlg;
	}

	m_tabArray.RemoveAll();
}

void CDevPrintTabDlg::TabUpdate()
{
	char	szTmp[256];
	TCITEM	wItem;
	wItem.mask			= TCIF_TEXT;
    wItem.pszText		= szTmp;
    wItem.cchTextMax	= 256;

	m_Tab.GetItem( m_Tab.GetCurSel(), &wItem );

	for( int nCnt = 0; nCnt < m_tabArray.GetSize(); nCnt++ )
	{
		CDevPrintDlg* pDevPrintDlg = m_tabArray.GetAt( nCnt );
		
		if( 0 == strcmp( wItem.pszText, pDevPrintDlg->GetName() ) )
		{
			pDevPrintDlg->ShowWindow( SW_SHOW );
			pDevPrintDlg->EnableWindow( TRUE );
		}
		else
		{
			pDevPrintDlg->ShowWindow( SW_HIDE );
			pDevPrintDlg->EnableWindow( FALSE );
		}
	}
}

void CDevPrintTabDlg::OnSelchangeTab1(NMHDR* pNMHDR, LRESULT* pResult)
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	TabUpdate();
	
	*pResult = 0;
}

void CDevPrintTabDlg::OnOK()
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ

	//--------------------------------------
	// ^u̍ŐV̐ݒ̍XV
	//--------------------------------------
	for( int nCnt = 0; nCnt < m_tabArray.GetSize(); nCnt++ )
	{
		CDevPrintDlg* pDevPrintDlg = m_tabArray.GetAt( nCnt );
		pDevPrintDlg->UpdateMemberData();
	}
	
	CDialog::OnOK();
}
