//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : ErrorInfo.cpp
//	ABSTRACT  : G[ǗNX
//	
//	CREATE    : Y.Yoshinobu	2006.9.15
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

// ErrorInfo.cpp: CErrorInfo NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "npsserver.h"
#include "ErrorInfo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CErrorInfo::CErrorInfo()
{
	// ACprm
	InitializeCriticalSection( &m_pErrorLock );
}

CErrorInfo::~CErrorInfo()
{
	int nIndex;
	int nCount;
	CError* pErr;

	EnterCriticalSection( &m_pErrorLock );

	nCount = m_apError.GetSize();

	for( nIndex=0 ; nCount > nIndex ; nIndex++ )
	{
		pErr = m_apError.GetAt( 0 );
		delete pErr;
	}
	m_apError.RemoveAll();

	LeaveCriticalSection( &m_pErrorLock );

	// ACprJ
	DeleteCriticalSection( &m_pErrorLock );
}

int CErrorInfo::GetCountErrorInfo()
{
	int nCount=0;

	EnterCriticalSection( &m_pErrorLock );

	nCount = m_apError.GetSize();

	LeaveCriticalSection( &m_pErrorLock );

	return nCount;
}

BOOL CErrorInfo::InsertErrorInfo( DWORD dwEventId, DWORD dwEventCodeMain, DWORD dwEventCodeSub )
{
	// G[Cxgɑ݂Ȃo^Ȃ
	// 2006.10.06 T.Mizushima
	if(SearchError2(dwEventId, dwEventCodeMain, dwEventCodeSub) == TRUE)
	{
		return TRUE;
	}

	CError* pErr;

	pErr = new CError;
	pErr->dwEventId			= dwEventId;
	pErr->dwEventCodeMain	= dwEventCodeMain;
	pErr->dwEventCodeSub	= dwEventCodeSub;

	EnterCriticalSection( &m_pErrorLock );

	m_apError.Add( pErr );

	LeaveCriticalSection( &m_pErrorLock );

	return TRUE;
}

BOOL CErrorInfo::DeleteErrorInfo( DWORD dwEventCodeMain, DWORD dwEventCodeSub )
{
	int nIndex;
	int nCount;
	BOOL bResult=FALSE;
	CError* pErr;

	EnterCriticalSection( &m_pErrorLock );

	nCount = m_apError.GetSize();

	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pErr = m_apError.GetAt( nIndex );
		if (( dwEventCodeMain == pErr->dwEventCodeMain ) &&
			( dwEventCodeSub == pErr->dwEventCodeSub )) {
			delete pErr;
			m_apError.RemoveAt( nIndex );
			bResult = TRUE;
			break;
		}
	}

	LeaveCriticalSection( &m_pErrorLock );

	return bResult;
}

BOOL CErrorInfo::SelectErrorInfo1( DWORD dwEventId, LPDWORD lpdwEventCodeMain, LPDWORD lpdwEventCodeSub )
{
	int nIndex;
	int nCount;
	BOOL bResult=FALSE;
	CError* pErr;

	EnterCriticalSection( &m_pErrorLock );

	nCount = m_apError.GetSize();

	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pErr = m_apError.GetAt( nIndex );
		if ( dwEventId == pErr->dwEventId ) {
			if ( NULL != lpdwEventCodeMain ) {
				*lpdwEventCodeMain = pErr->dwEventCodeMain;
			}
			if ( NULL != lpdwEventCodeSub ) {
				*lpdwEventCodeSub = pErr->dwEventCodeSub;
			}
			bResult = TRUE;
			break;
		}
	}

	LeaveCriticalSection( &m_pErrorLock );

	return bResult;
}

BOOL CErrorInfo::SelectErrorInfo2( DWORD dwEventCodeMain, DWORD dwEventCodeSub, LPDWORD lpdwEventId )
{
	int nIndex;
	int nCount;
	BOOL bResult=FALSE;
	CError* pErr;

	EnterCriticalSection( &m_pErrorLock );

	nCount = m_apError.GetSize();

	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pErr = m_apError.GetAt( nIndex );
		if (( dwEventCodeMain == pErr->dwEventCodeMain ) &&
			( dwEventCodeSub == pErr->dwEventCodeSub )) {
			if ( NULL != lpdwEventId ) {
				*lpdwEventId = pErr->dwEventId;
			}
			bResult = TRUE;
			break;
		}
	}

	LeaveCriticalSection( &m_pErrorLock );

	return bResult;
}

// Ԃ甭G[
// 2006.09.22 T.Mizushima
BOOL CErrorInfo::SearchError(DWORD dwEventCodeMain)
{
	int nIndex;
	int nCount;
	BOOL bResult=FALSE;
	CError* pErr;

	EnterCriticalSection( &m_pErrorLock );

	nCount = m_apError.GetSize();

	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pErr = m_apError.GetAt( nIndex );
		if ( dwEventCodeMain == pErr->dwEventCodeMain ) {
			bResult = TRUE;
			break;
		}
	}

	LeaveCriticalSection( &m_pErrorLock );

	return bResult;
}

// SĂ̕ێĂG[CxgNCAg֒ʒm
// ɓ̂͂܂ǂȂ悤ȋC邪...
// 2006.10.06 T.Mizushima
void CErrorInfo::NotifyAllErrors( CWS2Tcp* pSock )
{
	int nIndex;
	int nCount;
	CError* pErr;

	EnterCriticalSection( &m_pErrorLock );

	nCount = m_apError.GetSize();

	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pErr = m_apError.GetAt( nIndex );
		::GetServerTcpCmd()->OnNotifyPrinterError( pSock, pErr->dwEventId, pErr->dwEventCodeMain, pErr->dwEventCodeSub, 0, 0, 0, 0 );
	}

	LeaveCriticalSection( &m_pErrorLock );
}

// CxgIDAԁAԂ甭G[
// 2006.10.06 T.Mizushima
BOOL CErrorInfo::SearchError2(DWORD dwEventId, DWORD dwEventCodeMain, DWORD dwEventCodeSub)
{
	int nIndex;
	int nCount;
	BOOL bResult=FALSE;
	CError* pErr;

	EnterCriticalSection( &m_pErrorLock );

	nCount = m_apError.GetSize();

	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pErr = m_apError.GetAt( nIndex );
		if( ( dwEventId == pErr->dwEventId ) &&
			( dwEventCodeMain == pErr->dwEventCodeMain ) &&
			( dwEventCodeSub == pErr->dwEventCodeSub )) {
			bResult = TRUE;
			break;
		}
	}

	LeaveCriticalSection( &m_pErrorLock );

	return bResult;
}
