//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : IniFile.cpp
//	ABSTRACT  : ini t@C ̍ANZX NX
//
//	CREATE    : Y.Yoshinobu	2004.9.30
//	UPDATE    : 
//
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

// IniFile.cpp: CIniFile NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "IniFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CIniKey NX

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::CIniSection::CIniKey::UpdateValue()
//	ABSTRACT : lXV
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CIniFile::CIniSection::CIniKey::UpdateValue(const CString& strValue)
{
	int		nSeparator;
	int		nValueStart;
	int		nValueEnd;
	int		nValueLength;

	// L[̔
	nSeparator = m_strBuffer.FindOneOf( _T("=") );
	if ( 0 <= nSeparator ) {
		nValueStart = nSeparator + 1;
		nValueEnd = m_strBuffer.Find( m_strValue, nValueStart ) + m_strValue.GetLength();
		nValueLength = nValueEnd - nValueStart;
		m_strBuffer.Delete( nValueStart, nValueLength );
		m_strBuffer.Insert( nValueStart, strValue );
	} else {
		ASSERT( NULL );
	}

	m_strValue = strValue;
}

//////////////////////////////////////////////////////////////////////
// CIniSection NX

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::CIniSection::AddSection()
//	ABSTRACT : ZNVǉ
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CIniFile::CIniSection::AddSection(const CString& strBuffer)
{
	CIniKey	cKey;

	cKey.m_nDivision = CIniKey::SECTION;
	cKey.m_strBuffer = strBuffer;

	m_vKey.push_back( cKey );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::CIniSection::AddKey()
//	ABSTRACT : L[ǉ
//	FUNCTION : ini t@C => ini 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CIniFile::CIniSection::AddKey(const CString& strBuffer)
{
	CString	strKey;
	CString	strValue;
	CIniKey	cKey;

	if ( TRUE == GetKey( strBuffer, strKey, strValue ) ) {
		cKey.m_strKey = strKey;
		cKey.m_strValue = strValue;
		cKey.m_nDivision = CIniKey::KEY;
		cKey.m_strBuffer = strBuffer;
	} else {
		cKey.m_strKey = strKey;
		cKey.m_strValue = strValue;
		cKey.m_nDivision = CIniKey::COMMENT;
		cKey.m_strBuffer = strBuffer;
	}

	m_vKey.push_back( cKey );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::CIniSection::AddKey()
//	ABSTRACT : L[ǉ
//	FUNCTION : WriteString() => ini 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CIniFile::CIniSection::AddKey(const CString& strKey, const CString& strValue)
{
	CIniKey	cKey;

	cKey.m_strKey = strKey;
	cKey.m_strValue = strValue;
	cKey.m_nDivision = CIniKey::KEY;
	cKey.m_strBuffer.Format( "%s=%s", strKey, strValue );

	m_vKey.push_back( cKey );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::CIniSection::FindKey()
//	ABSTRACT : L[CfbNXT
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : m_vKey ̃CfbNX	( -1 : YȂ )
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CIniFile::CIniSection::FindKey(const CString& strKey)
{
	int	nIndex;
	int	nCount;

	nCount = m_vKey.size();
	for ( nIndex=0 ; nCount > nIndex ; nIndex++ )
	{
		if ( 0 == m_vKey[nIndex].m_strKey.CollateNoCase( strKey ) ) {
			return nIndex;
		}
	}

	return -1;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::CIniSection::GetKey()
//	ABSTRACT : Ps̃f[^AL[ƒl擾
//	FUNCTION : ini t@C => ini 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CIniFile::CIniSection::GetKey(const CString& strBuffer, CString& strKey, CString& strValue)
{
	int		nSeparator;
	int		nLength;

	// L[̔
	nSeparator = strBuffer.FindOneOf( _T("=") );
	nLength    = strBuffer.GetLength();
	if ( 0 <= nSeparator ) {
		strKey   = strBuffer.Left( nSeparator );
		strValue = strBuffer.Right( nLength - nSeparator - 1 );
		CutDisuseString( strKey );
		CutDisuseString( strValue );
		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::CIniSection::CutDisuseString()
//	ABSTRACT : L[l̑Oɂ]ȕr
//	FUNCTION : rF" "p, "\t"^u
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CIniFile::CIniSection::CutDisuseString(CString& strBuffer)
{
	LPTSTR	lpBuffer;
	LPTSTR	lpS;
	LPTSTR	lpE;

	lpBuffer = strBuffer.GetBufferSetLength( strBuffer.GetLength() );

	for ( lpS=lpBuffer ; '\0' != lpS ; lpS++ )
	{
		if ( ' ' == *lpS ) {
			continue;
		}
		if ( '\t' == *lpS ) {
			continue;
		}

		break;
	}

	for ( lpE=lpS ; '\0' != *lpE ; lpE++ )	;

	if ( lpS == lpE ) {
		*lpBuffer = '\0';
	} else {
		for ( lpE-- ; lpS < lpE ; lpE-- )
		{
			if ( ' ' == *lpE ) {
				continue;
			}
			if ( '\t' == *lpE ) {
				continue;
			}

			break;
		}

		for ( ; lpS <= lpE ; lpBuffer++, lpS++ )
		{
			*lpBuffer = *lpS;
		}
		*lpBuffer = '\0';
	}

	strBuffer.ReleaseBuffer(-1);
}

//////////////////////////////////////////////////////////////////////
// CIniFile NX

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::CIniFile()
//	ABSTRACT : RXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CIniFile::CIniFile()
{
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::~CIniFile()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CIniFile::~CIniFile()
{
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::Load()
//	ABSTRACT : ini t@Cɓǂݍ
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CIniFile::Load(LPCTSTR lpszFileName)
{
	BOOL		bResult(FALSE);
	CStdioFile	cFile;
	CString		strBuffer;
	CString		strSection;
	CString		strSectionNew;

	DeleteAllSection();

	// t@C̃I[v
	if ( TRUE == cFile.Open( lpszFileName, CFile::modeRead, NULL ) ) {

		bResult = TRUE;

		// 1sÂǍ
		while ( TRUE == cFile.ReadString( strBuffer ) )
		{
			if ( TRUE == GetSection( strBuffer, strSectionNew ) ) {
				strSection = strSectionNew;
			}
			AddSection( strSection, strBuffer );
		}

		cFile.Close();

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::Save()
//	ABSTRACT : ̃f[^ ini t@Cɏ
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CIniFile::Save(LPCTSTR lpszFileName)
{
	int		nKeyIdx;
	int		nKeyCnt;
	int		nSecCnt;
	int		nSecIdx;
	BOOL		bResult(FALSE);
	CStdioFile	cFile;
	CString		strBuffer;

	// t@C̃I[v
	if ( TRUE == cFile.Open( lpszFileName, CFile::modeCreate | CFile::modeWrite, NULL ) ) {

		bResult = TRUE;

		// 1sÂ
		nSecCnt = GetCountSection();
		for ( nSecIdx=0 ; nSecCnt > nSecIdx ; nSecIdx++ )
		{
			nKeyCnt = GetCountKey( nSecIdx );
			for ( nKeyIdx=0 ; nKeyCnt > nKeyIdx ; nKeyIdx++ )
			{
				strBuffer = Select( nSecIdx, nKeyIdx ) + _T("\n");
				try {
					cFile.WriteString( strBuffer );
				}
				catch (CFileException* e) {
					bResult = FALSE;
					e->Delete();
					break;
				}
			}
		}

		cFile.Close();

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::Close()
//	ABSTRACT : ̃f[^ɂ
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CIniFile::Close()
{
	DeleteAllSection();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::WriteString()
//	ABSTRACT : WritePrivateProfileString ̃ANZX
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CIniFile::WriteString( LPCTSTR lpAppName, LPCTSTR lpKeyName, LPCTSTR lpString )
{
	int		nKeyIdx;
	int		nSecIdx;
	CString		strBuffer;

	nSecIdx = FindSection( lpAppName );
	if ( 0 <= nSecIdx ) {
		nKeyIdx = m_vSection[nSecIdx].FindKey( lpKeyName );
		if ( 0 <= nKeyIdx ) {
			m_vSection[nSecIdx].m_vKey[nKeyIdx].UpdateValue( lpString );
		} else {
			m_vSection[nSecIdx].AddKey( lpKeyName, lpString );
		}
	} else {
		nSecIdx = AddSection( lpAppName );
		m_vSection[nSecIdx].AddKey( lpKeyName, lpString );
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::GetString()
//	ABSTRACT : GetPrivateProfileString ̃ANZX
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CString CIniFile::GetString( LPCTSTR lpAppName, LPCTSTR lpKeyName, LPCTSTR lpDefault )
{
	int		nSecIdx;
	int		nKsyIdx;
	CString	strReturnedString;

	nSecIdx = FindSection( lpAppName );
	if ( 0 <= nSecIdx ) {
		nKsyIdx = m_vSection[nSecIdx].FindKey( lpKeyName );
		if ( 0 <= nKsyIdx ) {
			return m_vSection[nSecIdx].m_vKey[nKsyIdx].m_strValue;
		}
	}

	return CString( lpDefault );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::GetSection()
//	ABSTRACT : Ps̃f[^AZNV擾
//	FUNCTION : ini t@C => ini 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CIniFile::GetSection(const CString& strBuffer, CString& strSection)
{
	int		nStart;
	int		nEnd;
	int		nLength;
	int		nComment;

	if ( IsSection( strBuffer ) ) {

		// ZNV̔
		nStart  = strBuffer.FindOneOf( _T("[") );
		nStart += 1;
		nEnd    = strBuffer.FindOneOf( _T("]") );
		nLength = nEnd - nStart;
		nComment = strBuffer.FindOneOf( _T(";") );

		if ( 0 < nLength ) {
			if ( 0 <= nComment ) {
				if ( nComment < nStart ) {
					return FALSE;
				}
			}
			strSection = strBuffer.Mid( nStart, nLength );
			CutDisuseString( strSection );
			return TRUE;
		}

	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::IsSection()
//	ABSTRACT : ZNV̍sǂ𔻒f܂
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.10.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CIniFile::IsSection(const CString& strBuffer)
{
	LPCTSTR	lpBuffer;
	LPCTSTR	lpS;

	lpBuffer = strBuffer;

	for ( lpS=lpBuffer ; '\0' != lpS ; lpS++ )
	{
		if ( ' ' == *lpS ) {
			continue;
		}
		if ( '\t' == *lpS ) {
			continue;
		}

		break;
	}

	if ( '[' != *lpS ) {
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::CutDisuseString()
//	ABSTRACT : L[l̑Oɂ]ȕr
//	FUNCTION : rF" "p, "\t"^u
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CIniFile::CutDisuseString(CString& strBuffer)
{
	LPTSTR	lpBuffer;
	LPTSTR	lpS;
	LPTSTR	lpE;

	lpBuffer = strBuffer.GetBufferSetLength( strBuffer.GetLength() );

	for ( lpS=lpBuffer ; '\0' != lpS ; lpS++ )
	{
		if ( ' ' == *lpS ) {
			continue;
		}
		if ( '\t' == *lpS ) {
			continue;
		}

		break;
	}

	for ( lpE=lpS ; '\0' != *lpE ; lpE++ )	;

	if ( lpS == lpE ) {
		*lpBuffer = '\0';
	} else {
		for ( lpE-- ; lpS < lpE ; lpE-- )
		{
			if ( ' ' == *lpE ) {
				continue;
			}
			if ( '\t' == *lpE ) {
				continue;
			}

			break;
		}

		for ( ; lpS <= lpE ; lpBuffer++, lpS++ )
		{
			*lpBuffer = *lpS;
		}
		*lpBuffer = '\0';
	}

	strBuffer.ReleaseBuffer(-1);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::GetCountSection()
//	ABSTRACT : ZNV̐擾
//	FUNCTION : ini 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CIniFile::GetCountSection()
{
	return m_vSection.size();
}

int CIniFile::GetCountKey(int nSectionIdx)
{
	return m_vSection[nSectionIdx].m_vKey.size();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::AddSection()
//	ABSTRACT : ZNVǉ
//	FUNCTION : ini t@C => ini 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CIniFile::AddSection(const CString& strSection, const CString& strBuffer)
{
	int	nSectionIdx;

	nSectionIdx = FindSection( strSection );

	if ( 0 <= nSectionIdx ) {
		m_vSection[nSectionIdx].AddKey( strBuffer );
	} else {
		CIniSection	cSection;
		cSection.m_strSection = strSection;
		cSection.AddSection( strBuffer );
		m_vSection.push_back( cSection );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::AddSection()
//	ABSTRACT : ZNVǉ
//	FUNCTION : WriteString() => ini 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CIniFile::AddSection(const CString& strSection)
{
	CIniSection	cSection;
	CString	strBuffer;

	strBuffer.Format( "[%s]", strSection );

	cSection.m_strSection = strSection;
	cSection.AddSection( strBuffer );

	m_vSection.push_back( cSection );

	return ( m_vSection.size() - 1 );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::FindSection()
//	ABSTRACT : ZNVCfbNXT
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : m_vSection ̃CfbNX	( -1 : YȂ )
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CIniFile::FindSection(const CString& strSection)
{
	int	nIndex;
	int	nCount;

	nCount = m_vSection.size();
	for ( nIndex=0 ; nCount > nIndex ; nIndex++ )
	{
		if ( 0 == m_vSection[nIndex].m_strSection.CollateNoCase( strSection ) ) {
			return nIndex;
		}
	}

	return -1;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::Select()
//	ABSTRACT : ZNVƃL[̃CfbNXAs̃f[^擾
//	FUNCTION : ini  => ini t@C
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CString CIniFile::Select(int nSectionIdx, int nKeyIdx)
{
	return m_vSection[nSectionIdx].m_vKey[nKeyIdx].m_strBuffer;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CIniFile::DeleteAllSection()
//	ABSTRACT : ini  ̃f[^NA
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.9.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CIniFile::DeleteAllSection()
{
	m_vSection.clear();
}
