//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : IniFile.h
//	ABSTRACT  : ini t@C ̍ANZX NX
//
//				gp@
//					Load()			ini t@Cɓǂݍ
//					Save()			̃f[^ ini t@Cɏ
//					WriteString()	WritePrivateProfileString ̃ANZX
//					GetString()		GetPrivateProfileString ̃ANZX
//					Close()			̃f[^ɂ
//
//	CREATE    : Y.Yoshinobu	2004.9.30
//	UPDATE    : 
//
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
// IniFile.h: CIniFile NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INIFILE_H__25FF0A16_491C_458F_AD5A_D1F335840D3D__INCLUDED_)
#define AFX_INIFILE_H__25FF0A16_491C_458F_AD5A_D1F335840D3D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "vector"

//////////////////////////////////////////////////////////////////////
// CIniFile NX
class CIniFile  
{
public:

	CIniFile();
	virtual ~CIniFile();

	BOOL Load(LPCTSTR lpszFileName);
	BOOL Save(LPCTSTR lpszFileName);
	BOOL WriteString(LPCTSTR lpAppName, LPCTSTR lpKeyName, LPCTSTR lpString);
	CString GetString(LPCTSTR lpAppName, LPCTSTR lpKeyName, LPCTSTR lpDefault);
	BOOL Close();

private:
	int GetCountSection();
	int GetCountKey(int nSectionIdx);
	void AddSection(const CString& strSection, const CString& strBuffer);
	int AddSection(const CString& strSection);
	int FindSection(const CString& strSection);
	CString Select(int nSectionIdx, int nKeyIdx);
	void DeleteAllSection();

	BOOL IsSection(const CString& strBuffer);
	void CutDisuseString(CString& strBuffer);
	BOOL GetSection(const CString& strBuffer, CString& strSection);

	////////////////////////////////////////
	// CIniSection NX
	class CIniSection {
	public:
		void AddKey(const CString& strBuffer);
		void AddKey(const CString& strKey, const CString& strValue);
		void AddSection(const CString& strBuffer);
		int FindKey(const CString& strKey);
		BOOL GetKey(const CString& strBuffer, CString& strKey, CString& strValue);
		void CutDisuseString(CString& strBuffer);

		////////////////////////////////////////
		// CIniKey NX
		class CIniKey {
		public:
			void UpdateValue(const CString& strValue);
			enum
			{	// m_nDivision ̒l
				COMMENT=0,							// Rgs
				SECTION,							// ZNVs
				KEY,								// L[s
			};
			int		m_nDivision;					// s̎
			CString	m_strKey;						// L[		ipj
			CString	m_strValue;						// l		ipj
			CString	m_strBuffer;					// s̕
		};
		CString					m_strSection;		// ZNVipj
		std::vector<CIniKey>	m_vKey;				// ZNVɊ܂܂L[ERei
		////////////////////////////////////////
	};
	////////////////////////////////////////
	std::vector<CIniSection>	m_vSection;			// ɓǂݍ ini t@CɊ܂܂ZNVERei
};

#endif // !defined(AFX_INIFILE_H__25FF0A16_491C_458F_AD5A_D1F335840D3D__INCLUDED_)
