// PrintQue.cpp: CPrintQue NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "npsserver.h"
#include "PrintQue.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CPrintQue::CPrintQue()
{
	// ACprm
	InitializeCriticalSection( &m_bDuplexEnableLock );
	InitializeCriticalSection( &m_pPrintStopLock );
	InitializeCriticalSection( &m_apPhoto1Lock );
	InitializeCriticalSection( &m_apPhoto2Lock );
	InitializeCriticalSection( &m_apFrameLock );
	InitializeCriticalSection( &m_pFrameLock );

	m_pReceivingFrame = NULL;
	m_psvReceivingFrame = NULL;		// @@@RD-151Ή	2012.02.17	T.Mizushima
	m_nImageReceivSize = 0;

	time( &m_nLatestPrintTime );

	m_nPrintStopCount = 0;

	m_bDuplexEnable = FALSE;
	m_dwDuplexSeqNo = 0;
}

CPrintQue::~CPrintQue()
{
	int nIndex;
	int nCount;
	CFrame* pFrame;
	CPhoto* pPhoto;

	// M̃R}NX
	EnterCriticalSection( &m_pFrameLock );

		if ( NULL != m_pReceivingFrame ) {
			delete m_pReceivingFrame;
			m_pReceivingFrame = NULL;
			m_nImageReceivSize = 0;
		}

	LeaveCriticalSection( &m_pFrameLock );

	// R}NX̊Ǘ̈
	EnterCriticalSection( &m_apFrameLock );

		// vgL[̊J
		nCount = m_apFrame.GetSize();
		for( nIndex=0 ; nIndex < nCount ; nIndex++ )
		{
			pFrame = (CFrame*)(m_apFrame.GetAt(0));
			m_apFrame.RemoveAt(0);
			delete pFrame;
		}

		// ޔ𒆂̃R}		@@@RD-151Ή	2012.02.16	T.Mizushima
		// vgL[̊J
		nCount = m_svFrame.GetSize();
		for( nIndex=0 ; nIndex < nCount ; nIndex++ )
		{
			pFrame = (CFrame*)(m_svFrame.GetAt(0));
			m_svFrame.RemoveAt(0);
			delete pFrame;
		}
		nCount = m_svExpFrame.GetSize();
		for( nIndex=0 ; nIndex < nCount ; nIndex++ )
		{
			pFrame = (CFrame*)(m_svExpFrame.GetAt(0));
			m_svExpFrame.RemoveAt(0);
			delete pFrame;
		}

	LeaveCriticalSection( &m_apFrameLock );

	// ̊Ǘ̈
	EnterCriticalSection( &m_apPhoto2Lock );

		// vgL[̊J
		nCount = m_apPhoto2.GetSize();
		for( nIndex=0 ; nIndex < nCount ; nIndex++ )
		{
			pPhoto = (CPhoto*)(m_apPhoto2.GetAt(0));
			m_apPhoto2.RemoveAt(0);
			delete pPhoto;
		}

	LeaveCriticalSection( &m_apPhoto2Lock );

	// vg̊Ǘ̈
	EnterCriticalSection( &m_apPhoto1Lock );

		// vgL[̊J
		nCount = m_apPhoto1.GetSize();
		for( nIndex=0 ; nIndex < nCount ; nIndex++ )
		{
			pPhoto = (CPhoto*)(m_apPhoto1.GetAt(0));
			m_apPhoto1.RemoveAt(0);
			delete pPhoto;
		}

	LeaveCriticalSection( &m_apPhoto1Lock );

	// ACprJ
	DeleteCriticalSection( &m_pFrameLock );
	DeleteCriticalSection( &m_apFrameLock );
	DeleteCriticalSection( &m_apPhoto2Lock );
	DeleteCriticalSection( &m_apPhoto1Lock );
	DeleteCriticalSection( &m_pPrintStopLock );
	DeleteCriticalSection( &m_bDuplexEnableLock );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::ReciveStartFrame()
//	ABSTRACT : R}̒ǉiMJnj
//	FUNCTION : 
//	
//	NOTE     : < QSS System > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.4
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::ReciveStartFrame( CFrame* pFrame )
{
	BOOL bResult=FALSE;

	EnterCriticalSection( &m_pFrameLock );

	if ( NULL == m_pReceivingFrame ) {

		m_pReceivingFrame = new CFrame;

		*m_pReceivingFrame = *pFrame;

		bResult = TRUE;

	}

	LeaveCriticalSection( &m_pFrameLock );

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::GetReceivingFrameStatus()
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
CFrame::STATUS CPrintQue::GetReceivingFrameStatus()
{
	CFrame::STATUS eStatus = CFrame::WAITING;

	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {
		eStatus = m_pReceivingFrame->GetStatus();
	}

	LeaveCriticalSection( &m_pFrameLock );

	return eStatus;
}

void CPrintQue::SetReceivingFrameStatus( CFrame::STATUS eStatus )
{
	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {
		m_pReceivingFrame->SetStatus( eStatus );
	}

	LeaveCriticalSection( &m_pFrameLock );
}

ULONG CPrintQue::GetReceivingFrameReceiptNo()
{
	ULONG nReceiptNo=0;

	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {
		nReceiptNo = m_pReceivingFrame->GetReceiptNo();
	}

	LeaveCriticalSection( &m_pFrameLock );

	return nReceiptNo;
}

UCHAR CPrintQue::GetReceivingFrameImageFormat()
{
	UCHAR nImageFormat=99;

	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {
		nImageFormat = m_pReceivingFrame->GetImageFormat();
	}

	LeaveCriticalSection( &m_pFrameLock );

	return nImageFormat;
}

ULONG CPrintQue::GetReceivingFrameImageCapacity()
{
	ULONG nImageCapacity=0;

	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {
		nImageCapacity = m_pReceivingFrame->GetImageCapacity();
	}

	LeaveCriticalSection( &m_pFrameLock );

	return nImageCapacity;
}

ULONG CPrintQue::GetReceivingFrameImageReceivSize()
{
	ULONG nImageReceivSize=0;

	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {
		nImageReceivSize = m_nImageReceivSize;
	}

	LeaveCriticalSection( &m_pFrameLock );

	return nImageReceivSize;
}

void CPrintQue::SetReceivingFrameImageReceivSize( ULONG nRemainSize )
{
	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {
		m_nImageReceivSize = max( 0, m_pReceivingFrame->GetImageCapacity() - nRemainSize );
	}

	LeaveCriticalSection( &m_pFrameLock );
}

USHORT CPrintQue::GetReceivingFrameImageWidth()
{
	USHORT nImageWidth=0;

	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {
		nImageWidth = m_pReceivingFrame->GetImageWidth();
	}

	LeaveCriticalSection( &m_pFrameLock );

	return nImageWidth;
}

USHORT CPrintQue::GetReceivingFrameImageHeight()
{
	USHORT nImageHeight=0;

	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {
		nImageHeight = m_pReceivingFrame->GetImageHeight();
	}

	LeaveCriticalSection( &m_pFrameLock );

	return nImageHeight;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::ReciveEndFrame()
//	ABSTRACT : MI
//	FUNCTION : 
//	
//	NOTE     : < QSS System > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.4
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintQue::ReciveEndFrame( ULONG nReceiptNo )
{
	BOOL bResult=FALSE;

	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {

		if ( nReceiptNo == m_pReceivingFrame->GetReceiptNo() ) {

			m_pReceivingFrame->SetStatus( CFrame::RECEIVED );

			// 2006.10.25 T.Mizushima	wE51	2006.11.26 Y.Yoshinobu }x2Ή
			switch ( ::GetVirtualPrinter()->GetPossessionState() )
			{
			case CVirtualPrinter::EXPRESS1:		// }[x1]L
				m_pReceivingFrame->SetExpressPrint( CFrame::EXPRESS_L1 );
				break;
			case CVirtualPrinter::EXPRESS2:		// }[x2]L
				m_pReceivingFrame->SetExpressPrint( CFrame::EXPRESS_L2 );
				break;
			}

			EnterCriticalSection( &m_apFrameLock );

			m_apFrame.InsertAt( 0, m_pReceivingFrame );

			LeaveCriticalSection( &m_apFrameLock );

			m_pReceivingFrame = NULL;
			m_nImageReceivSize = 0;

			bResult = TRUE;

			CheckPrinterMemory();	// v^[̃`FbN Added by H.Yoshida	2007.12.05
		}

	}

	LeaveCriticalSection( &m_pFrameLock );

	return bResult;
}

BOOL CPrintQue::ReciveCancelFrame( ULONG nReceiptNo )
{
	BOOL bResult=FALSE;

	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {

		if ( nReceiptNo == m_pReceivingFrame->GetReceiptNo() ) {

			delete m_pReceivingFrame;

			m_pReceivingFrame = NULL;
			m_nImageReceivSize = 0;

			bResult = TRUE;

		}

	}

	LeaveCriticalSection( &m_pFrameLock );

	return bResult;
}

BOOL CPrintQue::ReciveCancelFrame()
{
	BOOL bResult=FALSE;

	EnterCriticalSection( &m_pFrameLock );

	if ( NULL != m_pReceivingFrame ) {

		delete m_pReceivingFrame;

		m_pReceivingFrame = NULL;
		m_nImageReceivSize = 0;

		bResult = TRUE;

	}

	LeaveCriticalSection( &m_pFrameLock );

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintQue::RemoveFrame()
//	ABSTRACT : R}̊J
//	FUNCTION : 
//	
//	NOTE     : < QSS System > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.4
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::RemoveFrame( ULONG nReceiptNo )
{
	EnterCriticalSection( &m_apFrameLock );

	int nIndex;
	int nCount;
	CFrame* pFrame;

	// vgL[̊J
	nCount = m_apFrame.GetSize();
	for( nIndex=0 ; nIndex < nCount ; nIndex++ )
	{
		pFrame = (CFrame*)(m_apFrame.GetAt(nIndex));

		if ( nReceiptNo == pFrame->GetReceiptNo() ) {
			m_apFrame.RemoveAt(nIndex);
			delete pFrame;

			CheckPrinterMemory();	// v^[̃`FbN Added by H.Yoshida	2007.12.05
		}
	}

	LeaveCriticalSection( &m_apFrameLock );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :  CPrintQue::OnTime100ms()
//	ABSTRACT : Ăяo(100ms)
//	FUNCTION : 
//	
//	NOTE     : < QSS System >
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintQue::OnTime100ms()
{
	int nIndex;
	int nCount;
	time_t nNowTime;
	CFrame* pFrame;
	CPhoto* pPhoto;

	time( &nNowTime );

#if 0
	if ( 0 == GetPrintStopCount() ) {
#else
	// 2006.10.02 T.Mizushima
	if (( 0 == GetPrintStopCount() ) &&
		( ::GetVirtualPrinter()->m_cPrinterState.GetAdvanceStatus() != 1 ) &&
		( ::GetVirtualPrinter()->m_cPrinterState.GetLaserStatus() == 3 ) &&
		( ::GetVirtualPrinter()->m_cPrinterState.GetDevelopmentStatus() != 1 ) &&
		( ::GetVirtualPrinter()->m_cPrinterState.GetProcessorStatus() == 3 )) {
#endif
		if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() &&
			 0 != ::GetVirtualPrinter()->m_cErrorInfo.GetCountErrorInfo() )
		{
			// Added by H.Yoshida	2007.12.05
			// 1FCNWFbg^CvłAG[m点̓vgɍsȂ
		}
		else
		{
			//////////////////////////////
			// R}̃vgJn
			//////////////////////////////
			EnterCriticalSection( &m_apFrameLock );
			nCount = m_apFrame.GetSize();
			for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
			{
				pFrame = m_apFrame.GetAt( nIndex );

				// AOvg3bo߂Ă
				// ̂΃vgJn
				if ( nNowTime >= (m_nLatestPrintTime + ::GetVirtualPrinter()->m_cPrinterInfo.GetStartInterval()) ) {				// O̘IJn3bo

					{	// Oo
						CString str;
						str.Format( "                         ReceiptNo = %d [WAIT] -> [PRINT START]", pFrame->GetReceiptNo() );
						NPS_LOGOUT( str );
					}
					pFrame->IncrementPrintCount();
					m_nLatestPrintTime = nNowTime;
					::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 1, pFrame->GetPrintCount() );	// vg󋵒ʒmi1:vgJnj

					// vgJnL[ɓo^
					pPhoto = new CPhoto( pFrame->GetReceiptNo(), pFrame->GetPrintCount(), pFrame->GetDuplexSeqNo(), nNowTime + ::GetVirtualPrinter()->m_cPrinterInfo.GetPrintInterval(), pFrame->GetSock() );
					EnterCriticalSection( &m_apPhoto1Lock );
					m_apPhoto1.InsertAt( 0, pPhoto );
					LeaveCriticalSection( &m_apPhoto1Lock );

					::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 10, pFrame->GetPrintCount() );	// vg󋵒ʒmi10:[fBOJnj

					// SăvgJnIuWFNg폜
					if ( TRUE == pFrame->IsPrintEnd() ) {
						delete pFrame;
						m_apFrame.RemoveAt( nIndex );

						CheckPrinterMemory();	// v^[̃`FbN Added by H.Yoshida	2007.12.05
					}

					break;
				}


			}
			LeaveCriticalSection( &m_apFrameLock );
		}
	}

	//////////////////////////////
	// vg̏
	//////////////////////////////
	EnterCriticalSection( &m_apPhoto1Lock );
	nCount = m_apPhoto1.GetSize();
	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pPhoto = m_apPhoto1.GetAt( nIndex );

		if ( TRUE == pPhoto->IsNotify( nNowTime ) ) {

			{	// Oo
				CString str;
				str.Format( "                         ReceiptNo = %d [WAIT] -> [PRINT END]", pPhoto->GetReceiptNo() );
				NPS_LOGOUT( str );
			}
			::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pPhoto->GetSock(), pPhoto->GetReceiptNo(), 2, pPhoto->GetRepeat() );	// vg󋵒ʒmi2Fvgj

			EnterCriticalSection( &m_apPhoto2Lock );
			pPhoto->UpdateNotifyTime( nNowTime + ::GetVirtualPrinter()->m_cPrinterInfo.GetAdvanceInterval() );	// ʒmԍXV
			m_apPhoto2.InsertAt( 0, pPhoto );
			LeaveCriticalSection( &m_apPhoto2Lock );

			m_apPhoto1.RemoveAt( nIndex );

		}
	}
	LeaveCriticalSection( &m_apPhoto1Lock );

	//////////////////////////////
	// ̏
	//////////////////////////////
	EnterCriticalSection( &m_apPhoto2Lock );
	nCount = m_apPhoto2.GetSize();
	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pPhoto = m_apPhoto2.GetAt( nIndex );

		if ( TRUE == pPhoto->IsNotify( nNowTime ) ) {

			{	// Oo
				CString str;
				str.Format( "                         ReceiptNo = %d [WAIT] -> [PRINT OUT]", pPhoto->GetReceiptNo() );
				NPS_LOGOUT( str );
			}
			::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pPhoto->GetSock(), pPhoto->GetReceiptNo(), 3, pPhoto->GetRepeat() );	// vg󋵒ʒmi3Fvgroj
			::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pPhoto->GetSock(), pPhoto->GetReceiptNo(),11, pPhoto->GetRepeat() );	// vg󋵒ʒmi11Fvgro(đp)j	2011.11.24 A.Nagamatsu

			delete pPhoto;
			m_apPhoto2.RemoveAt( nIndex );

		}
	}
	LeaveCriticalSection( &m_apPhoto2Lock );
}

// L[CÕvg擾
ULONG CPrintQue::GetQueueingCount()
{
	int nIndex;
	int nCount;
	CFrame* pFrame;
	ULONG nQueueingCount=0;

	EnterCriticalSection( &m_apFrameLock );

	nCount = m_apFrame.GetSize();
	for( nIndex=0 ; nCount > nIndex ; nIndex++ )
	{
		pFrame = m_apFrame.GetAt( nIndex );
		nQueueingCount += pFrame->GetNonPrintCount();
	}

	LeaveCriticalSection( &m_apFrameLock );

	return nQueueingCount;
}

// L[CỎ摜eʎ擾
ULONG CPrintQue::GetQueueingImageCapacity()
{
	int nIndex;
	int nCount;
	CFrame* pFrame;
	ULONG nQueueingImageCapacity=0;

	EnterCriticalSection( &m_apFrameLock );

	nCount = m_apFrame.GetSize();
	for( nIndex=0 ; nCount > nIndex ; nIndex++ )
	{
		pFrame = m_apFrame.GetAt( nIndex );
		nQueueingImageCapacity += pFrame->GetImageCapacity();
	}

	LeaveCriticalSection( &m_apFrameLock );

	return nQueueingImageCapacity;
}

// vg̃vg擾
ULONG CPrintQue::GetPrintingCount()
{
	ULONG nPrintingCount=0;

	EnterCriticalSection( &m_apFrameLock );

	nPrintingCount = m_apPhoto1.GetSize();

	LeaveCriticalSection( &m_apFrameLock );

	return nPrintingCount;
}

// ̃vg擾
ULONG CPrintQue::GetAdvancingCount()
{
	ULONG nAdvancingCount=0;

	EnterCriticalSection( &m_apFrameLock );

	nAdvancingCount = m_apPhoto2.GetSize();

	LeaveCriticalSection( &m_apFrameLock );

	return nAdvancingCount;
}

// vgꎞ~
int CPrintQue::PrintStopCountIncrement()
{
	int nPrintStopCount;

	EnterCriticalSection( &m_pPrintStopLock );

	m_nPrintStopCount++;

	nPrintStopCount = m_nPrintStopCount;

	LeaveCriticalSection( &m_pPrintStopLock );

	return nPrintStopCount;
}

int CPrintQue::PrintStopCountDecrement()
{
	int nPrintStopCount;

	EnterCriticalSection( &m_pPrintStopLock );

	if ( 0 < m_nPrintStopCount ) {
		m_nPrintStopCount--;
	}

	nPrintStopCount = m_nPrintStopCount;

	LeaveCriticalSection( &m_pPrintStopLock );

	return nPrintStopCount;
}

int CPrintQue::GetPrintStopCount()
{
	int nPrintStopCount;

	EnterCriticalSection( &m_pPrintStopLock );

	nPrintStopCount = m_nPrintStopCount;

	LeaveCriticalSection( &m_pPrintStopLock );

	return nPrintStopCount;
}

// tԍ̑݊mF
BOOL CPrintQue::IsExistReceiptNo( ULONG nReceiptNo )
{
	int nIndex;
	int nCount;
	CFrame* pFrame;
	CPhoto* pPhoto;
	BOOL bExist=FALSE;

	// 2006.10.30 T.Mizushima	wE55
	//////////////////////////////
	// M
	//////////////////////////////
	if( NULL != m_pReceivingFrame )
	{
		EnterCriticalSection( &m_pFrameLock );
		if ( nReceiptNo == m_pReceivingFrame->GetReceiptNo() ) {
			bExist = TRUE;
		}
		LeaveCriticalSection( &m_pFrameLock );
	}

	if ( TRUE == bExist ) {
		return TRUE;
	}

	//////////////////////////////
	// L[CO
	//////////////////////////////
	EnterCriticalSection( &m_apFrameLock );
	nCount = m_apFrame.GetSize();
	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pFrame = m_apFrame.GetAt( nIndex );

		if ( nReceiptNo == pFrame->GetReceiptNo() ) {
			bExist = TRUE;
			break;
		}
	}
	LeaveCriticalSection( &m_apFrameLock );

	if ( TRUE == bExist ) {
		return TRUE;
	}

	//////////////////////////////
	// vg
	//////////////////////////////
	EnterCriticalSection( &m_apPhoto1Lock );
	nCount = m_apPhoto1.GetSize();
	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pPhoto = m_apPhoto1.GetAt( nIndex );

		if ( nReceiptNo == pPhoto->GetReceiptNo() ) {
			bExist = TRUE;
			break;
		}
	}
	LeaveCriticalSection( &m_apPhoto1Lock );

	if ( TRUE == bExist ) {
		return TRUE;
	}

	//////////////////////////////
	// 
	//////////////////////////////
	EnterCriticalSection( &m_apPhoto2Lock );
	nCount = m_apPhoto2.GetSize();
	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pPhoto = m_apPhoto2.GetAt( nIndex );

		if ( nReceiptNo == pPhoto->GetReceiptNo() ) {
			bExist = TRUE;
			break;
		}
	}
	LeaveCriticalSection( &m_apPhoto2Lock );

	if ( TRUE == bExist ) {
		return TRUE;
	}

	return FALSE;
}

// vgv
BOOL CPrintQue::CancelRequest( ULONG nReceiptNo )
{
	int nIndex;
	int nCount;
	CFrame* pFrame;
	BOOL bResult=FALSE;

	// 2006.10.30 T.Mizushima	wE55
	//////////////////////////////
	// M
	//////////////////////////////
	if( NULL != m_pReceivingFrame )
	{
		EnterCriticalSection( &m_pFrameLock );
		if ( nReceiptNo == m_pReceivingFrame->GetReceiptNo() ) {

			{	// Oo
				CString str;
				str.Format( "                         ReceiptNo = %d [WAIT] -> [CANCEL]", m_pReceivingFrame->GetReceiptNo() );
				NPS_LOGOUT( str );
			}

			::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)m_pReceivingFrame->GetSock(), m_pReceivingFrame->GetReceiptNo(), 7, m_pReceivingFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi7:vgLZj

			// IuWFNg폜
			delete m_pReceivingFrame;
			m_pReceivingFrame = NULL;
			bResult = TRUE;
		}
		LeaveCriticalSection( &m_pFrameLock );
	}

	//////////////////////////////
	// L[CO
	//////////////////////////////
	EnterCriticalSection( &m_apFrameLock );
	nCount = m_apFrame.GetSize();
	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pFrame = m_apFrame.GetAt( nIndex );

		if ( nReceiptNo == pFrame->GetReceiptNo() ) {

			{	// Oo
				CString str;
				str.Format( "                         ReceiptNo = %d [WAIT] -> [CANCEL]", pFrame->GetReceiptNo() );
				NPS_LOGOUT( str );
			}

			::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 7, pFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi7:vgLZj

			// IuWFNg폜
			delete pFrame;
			m_apFrame.RemoveAt( nIndex );

			CheckPrinterMemory();	// v^[̃`FbN Added by H.Yoshida	2007.12.05

			bResult = TRUE;

			break;
		}
	}
	LeaveCriticalSection( &m_apFrameLock );

	return bResult;
}

// I[_[v		2012.04.12	T.Mizushima
BOOL CPrintQue::CancelOrderRequest( USHORT nPossessionNo )
{
	int nIndex;
	int nCount;
	CFrame* pFrame;
	BOOL bResult=FALSE;

	// 2006.10.30 T.Mizushima	wE55
	//////////////////////////////
	// M
	//////////////////////////////
	if( NULL != m_pReceivingFrame )
	{
		EnterCriticalSection( &m_pFrameLock );
		if ( nPossessionNo == m_pReceivingFrame->GetPossessionNo() ) {

			{	// Oo
				CString str;
				str.Format( "                         PossessionNo = %d, ReceiptNo = %ld [WAIT] -> [CANCEL]", nPossessionNo, m_pReceivingFrame->GetReceiptNo() );
				NPS_LOGOUT( str );
			}

			::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)m_pReceivingFrame->GetSock(), m_pReceivingFrame->GetReceiptNo(), 7, m_pReceivingFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi7:vgLZj

			// IuWFNg폜
			delete m_pReceivingFrame;
			m_pReceivingFrame = NULL;
			bResult = TRUE;
		}
		LeaveCriticalSection( &m_pFrameLock );
	}

	//////////////////////////////
	// L[CO
	//////////////////////////////
	EnterCriticalSection( &m_apFrameLock );
	nCount = m_apFrame.GetSize();
	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pFrame = m_apFrame.GetAt( nIndex );

		if ( nPossessionNo == pFrame->GetPossessionNo() ) {

			{	// Oo
				CString str;
				str.Format( "                         PossessionNo = %d, ReceiptNo = %ld [WAIT] -> [CANCEL]", nPossessionNo, pFrame->GetReceiptNo() );
				NPS_LOGOUT( str );
			}

			::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 7, pFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi7:vgLZj

			// IuWFNg폜
			delete pFrame;
			m_apFrame.RemoveAt( nIndex );

			CheckPrinterMemory();	// v^[̃`FbN Added by H.Yoshida	2007.12.05

			bResult = TRUE;
		}
	}
	LeaveCriticalSection( &m_apFrameLock );

	return bResult;
}

void CPrintQue::CancelAll()
{
	int nIndex;
	int nCount;
	CFrame* pFrame;

	//////////////////////////////
	// L[CO
	//////////////////////////////
	EnterCriticalSection( &m_apFrameLock );
	nCount = m_apFrame.GetSize();
	for( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
	{
		pFrame = m_apFrame.GetAt( nIndex );

		{	// Oo
			CString str;
			str.Format( "                         ReceiptNo = %d [WAIT] -> [CANCEL]", pFrame->GetReceiptNo() );
			NPS_LOGOUT( str );
		}

		::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 7, pFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi7:vgLZj

		// IuWFNg폜
		delete pFrame;
		m_apFrame.RemoveAt( nIndex );

	}

	CheckPrinterMemory();	// v^[̃`FbN Added by H.Yoshida	2007.12.05

	LeaveCriticalSection( &m_apFrameLock );

}

// }荞݂ɂAvgL[̊J
void CPrintQue::PossessionStop()
{
	int nIndex1;
	int nIndex2;
	int nCount1;
	int nCount2;
	BOOL bFirst=TRUE;
	CFrame* pFrame;
	CPtrArray apSock;

	//////////////////////////////
	// L[CÕf[^ɑ΂āAvg󋵒ʒmŐL荞݂ꂽƂ`
	//////////////////////////////
	EnterCriticalSection( &m_apFrameLock );
	nCount1 = m_apFrame.GetSize();
	for ( nIndex1=nCount1-1 ; 0 <= nIndex1 ; nIndex1-- )
	{
		pFrame = m_apFrame.GetAt( nIndex1 );

		// 2006.10.25 T.Mizushima	wE51
		if( pFrame->ChkExpressPrint() == TRUE )
		{	// }I[_[ΏۊO
			continue;
		}
		if( pFrame->ChkExpressPrint2() == TRUE )
		{	// }I[_[ΏۊO
			continue;
		}

		{	// Oo
			CString str;
			str.Format( "                         ReceiptNo = %d [WAIT] -> [EXPRESS_STOP]", pFrame->GetReceiptNo() );
			NPS_LOGOUT( str );
		}

		nCount2 = apSock.GetSize();
		for ( nIndex2=0 ; nCount2 > nIndex2 ; nIndex2++ )
		{
			if ( pFrame->GetSock() == apSock.GetAt( nIndex2 ) ) {
				break;
			}
		}
		if ( nCount2 == nIndex2 ) {

			if ( TRUE == bFirst ) {
				::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 5, pFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi5Fvg荞ݒfiĊJ҂j => v^ԕύXʒḿuv^L̏ԁv[1F荞ݒf̍ĊJ]ŐLĊJj
				bFirst = FALSE;
#if 0
				break;	// Pʒm炻̃R}ȍ~͒ʒmȂdlɔ̂Œǉ	2006.11.20 T.Mizushima
#endif
			} else {
				::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 6, pFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi6Fvg荞ݒfiĊJ҂j => v^ԕύXʒḿuv^L̏ԁv[0Fʏ]ŐLĊJj
#if 0
				break;	// Pʒm炻̃R}ȍ~͒ʒmȂdlɔ̂Œǉ	2006.11.20 T.Mizushima
#endif
			}
			apSock.Add( pFrame->GetSock() );	// ĂȂƕNCAgɒʒmłȂ	@@@RD-151Ή	2012.02.16	T.Mizushima
		}
	}

	// vgL[̊J
	for( nIndex1=0 ; m_apFrame.GetSize() > nIndex1 ; nIndex1++ )
	{
		pFrame = (CFrame*)(m_apFrame.GetAt(0));

		// 2006.10.25 T.Mizushima	wE51
		if( pFrame->ChkExpressPrint() == TRUE )
		{	// }I[_[ΏۊO
			continue;
		}
		if( pFrame->ChkExpressPrint2() == TRUE )
		{	// }I[_[ΏۊO
			continue;
		}

		delete pFrame;
		m_apFrame.RemoveAt( nIndex1 );

		// vf̈폜̂ŁAJEgfNg
		nIndex1--;
	}

	CheckPrinterMemory();	// v^[̃`FbN Added by H.Yoshida	2007.12.05

	// 2006.11.14 T.Mizushima
	if( NULL != m_pReceivingFrame )
	{
		delete m_pReceivingFrame;
		m_pReceivingFrame = NULL;
		m_nImageReceivSize = 0;
	}

	LeaveCriticalSection( &m_apFrameLock );

}

// }[x2]荞݂ɂAvgL[̊J
void CPrintQue::PossessionStop2()
{
	int nIndex1;
	int nIndex2;
	int nCount1;
	int nCount2;
	BOOL bFirst=TRUE;
	CFrame* pFrame;
	CPtrArray apSock;

	//////////////////////////////
	// L[CÕf[^ɑ΂āAvg󋵒ʒmŐL荞݂ꂽƂ`
	//////////////////////////////
	EnterCriticalSection( &m_apFrameLock );
	nCount1 = m_apFrame.GetSize();
	for ( nIndex1=nCount1-1 ; 0 <= nIndex1 ; nIndex1-- )
	{
		pFrame = m_apFrame.GetAt( nIndex1 );

		if( pFrame->ChkExpressPrint2() == TRUE )
		{	// }I[_[ΏۊO
			continue;
		}

		{	// Oo
			CString str;
			str.Format( "                         ReceiptNo = %d [WAIT] -> [EXPRESS_STOP2]", pFrame->GetReceiptNo() );
			NPS_LOGOUT( str );
		}

		nCount2 = apSock.GetSize();
		for ( nIndex2=0 ; nCount2 > nIndex2 ; nIndex2++ )
		{
			if ( pFrame->GetSock() == apSock.GetAt( nIndex2 ) ) {
				break;
			}
		}
		if ( nCount2 == nIndex2 ) {

			if ( TRUE == bFirst ) {
				::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 5, pFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi5Fvg荞ݒfiĊJ҂j => v^ԕύXʒḿuv^L̏ԁv[1F荞ݒf̍ĊJ]ŐLĊJj
				bFirst = FALSE;
#if 0
				break;
#endif
			} else {
				::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 6, pFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi6Fvg荞ݒfiĊJ҂j => v^ԕύXʒḿuv^L̏ԁv[0Fʏ]ŐLĊJj
#if 0
				break;
#endif
			}
			apSock.Add( pFrame->GetSock() );	// ĂȂƕNCAgɒʒmłȂ	@@@RD-151Ή	2012.02.16	T.Mizushima
		}
	}

	// vgL[̊J
	for( nIndex1=0 ; m_apFrame.GetSize() > nIndex1 ; nIndex1++ )
	{
		pFrame = (CFrame*)(m_apFrame.GetAt(0));

		if( pFrame->ChkExpressPrint2() == TRUE )
		{	// }I[_[ΏۊO
			continue;
		}

		m_apFrame.RemoveAt( nIndex1 );
		delete pFrame;

		// vf̈폜̂ŁAJEgfNg
		nIndex1--;
	}

	CheckPrinterMemory();	// v^[̃`FbN Added by H.Yoshida	2007.12.05

	if( NULL != m_pReceivingFrame )
	{
		delete m_pReceivingFrame;
		m_pReceivingFrame = NULL;
		m_nImageReceivSize = 0;
	}

	LeaveCriticalSection( &m_apFrameLock );

}

// }荞݂ɂAvgL[̑ޔ
// @@@RD-151Ή	2012.02.15	T.Mizushima
void CPrintQue::SavePrintQue( WORD wPossessionMode )
{
	int		i = 0;
	CFrame* pFrame;

	// RD-151p荞݂ł́AMR}ޔ̂
	// MI܂őҋ@6000H-0501HԂȂ
	// @ł͂ȂΉʓ|Ȃ̂...
	CFrame::STATUS	Sts;
	while( 1 )
	{
		Sts = GetReceivingFrameStatus();

		if( ( CFrame::RECEIVED == Sts) ||
			( CFrame::WAITING == Sts) )
		{
			break;
		}
		::Sleep( 1 );
	}

	// MR}ޔ
	EnterCriticalSection( &m_pFrameLock );
	if( m_pReceivingFrame != NULL )
	{
		m_psvReceivingFrame = m_pReceivingFrame;
		m_pReceivingFrame = NULL;
	}
	else
	{
		m_psvReceivingFrame = NULL;
	}
	LeaveCriticalSection( &m_pFrameLock );

	// D惌x̒ႢR}͑ޔ
	EnterCriticalSection( &m_apFrameLock );
	while( i < m_apFrame.GetSize() )
	{
		pFrame = (CFrame*)( m_apFrame.GetAt( i ) );

		if( wPossessionMode == 2 )
		{	// 荞񂾃I[_[}x1̏ꍇ
			if( ( pFrame->ChkExpressPrint() != TRUE ) &&
				( pFrame->ChkExpressPrint2() != TRUE ) )
			{	// ʏ탌x̃R}̂ݑޔ
				m_svFrame.Add( pFrame );
				m_apFrame.RemoveAt( i );
				continue;
			}
		}
		else if( wPossessionMode == 4 )
		{	// 荞񂾃I[_[}x2̏ꍇ
			if( pFrame->ChkExpressPrint2() != TRUE )
			{	// ʏ탌x,}x1̃R}ޔ
				if( pFrame->ChkExpressPrint() != TRUE )
				{	// ʏ탌x
					m_svFrame.Add( pFrame );
				}
				else
				{	// }x1
					m_svExpFrame.Add( pFrame );
				}
				m_apFrame.RemoveAt( i );
				continue;
			}
		}
		i++;
	}

	CheckPrinterMemory();	// v^[̃`FbN

	LeaveCriticalSection( &m_apFrameLock );
}

// }荞ݏĨvgL[̕A
// @@@RD-151Ή	2012.02.15	T.Mizushima
void CPrintQue::RecoveryPrintQue()
{
	// MR}A
	EnterCriticalSection( &m_pFrameLock );
	if( m_psvReceivingFrame != NULL )
	{
		m_pReceivingFrame = m_psvReceivingFrame;
		m_psvReceivingFrame = NULL;
	}
	LeaveCriticalSection( &m_pFrameLock );

	EnterCriticalSection( &m_apFrameLock );

	if( m_svExpFrame.GetSize() )
	{	// }xR}̑ޔ
		m_apFrame.InsertAt( 0, &m_svExpFrame );
		m_svExpFrame.RemoveAll();
	}
	if( m_svFrame.GetSize() )
	{	// ʏ탌xR}̑ޔ
		m_apFrame.InsertAt( 0, &m_svFrame );
		m_svFrame.RemoveAll();
	}

	LeaveCriticalSection( &m_apFrameLock );
}

// G[ɂSvgf
// 2006.09.25 T.Mizushima
void CPrintQue::ErrorPrintAbort()
{
	int nIndex;
	int nCount;
	CFrame* pFrame;
#if 0
	CPhoto* pPhoto;
#endif

	// R}NX̊Ǘ̈
	EnterCriticalSection( &m_apFrameLock );

#if 0
		nIndex = m_apFrame.GetUpperBound();
		if ( 0 <= nIndex ) {
			pFrame = (CFrame*)(m_apFrame.GetAt(nIndex));
			::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 4, pFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi4:vgsj
		}

		// vgL[̊J
		nCount = m_apFrame.GetSize();
		for( nIndex=0 ; nIndex < nCount ; nIndex++ )
		{
			pFrame = (CFrame*)(m_apFrame.GetAt(0));
			m_apFrame.RemoveAt(0);
			delete pFrame;
		}
#else
		// NCAgɒʒmł悤
		// @@@RD-151Ή	2012.02.16	T.Mizushima
		int			nIndex2;
		int			nCount2;
		CPtrArray	apSock;

		nCount = m_apFrame.GetSize();
		for ( nIndex = nCount - 1; 0 <= nIndex; nIndex-- )
		{
			pFrame = m_apFrame.GetAt( nIndex );

			nCount2 = apSock.GetSize();
			for ( nIndex2 = 0; nCount2 > nIndex2; nIndex2++ )
			{
				if( pFrame->GetSock() == apSock.GetAt( nIndex2 ) )
				{
					break;
				}
			}

			if( nCount2 == nIndex2 )
			{
				::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 4, pFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi4:vgsj
				apSock.Add( pFrame->GetSock() );
			}
		}

		// vgL[̊J
		for( nIndex = 0; nIndex < nCount; nIndex++ )
		{
			pFrame = (CFrame*)( m_apFrame.GetAt( 0 ) );
			m_apFrame.RemoveAt( 0 );
			delete pFrame;
		}

		// ޔ𒆂̃R}ɂĂʒm
		nCount = m_svFrame.GetSize();
		for ( nIndex = nCount - 1; 0 <= nIndex; nIndex-- )
		{
			pFrame = m_svFrame.GetAt( nIndex );

			nCount2 = apSock.GetSize();
			for ( nIndex2 = 0; nCount2 > nIndex2; nIndex2++ )
			{
				if( pFrame->GetSock() == apSock.GetAt( nIndex2 ) )
				{
					break;
				}
			}

			if( nCount2 == nIndex2 )
			{
				::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 4, pFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi4:vgsj
				apSock.Add( pFrame->GetSock() );
			}
		}

		// vgL[̊J
		for( nIndex = 0; nIndex < nCount; nIndex++ )
		{
			pFrame = (CFrame*)( m_svFrame.GetAt( 0 ) );
			m_svFrame.RemoveAt( 0 );
			delete pFrame;
		}

		nCount = m_svExpFrame.GetSize();
		for ( nIndex = nCount - 1; 0 <= nIndex; nIndex-- )
		{
			pFrame = m_svExpFrame.GetAt( nIndex );

			nCount2 = apSock.GetSize();
			for ( nIndex2 = 0; nCount2 > nIndex2; nIndex2++ )
			{
				if( pFrame->GetSock() == apSock.GetAt( nIndex2 ) )
				{
					break;
				}
			}

			if( nCount2 == nIndex2 )
			{
				::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pFrame->GetSock(), pFrame->GetReceiptNo(), 4, pFrame->GetPrintCount() + 1 );	// vg󋵒ʒmi4:vgsj
				apSock.Add( pFrame->GetSock() );
			}
		}

		// vgL[̊J
		for( nIndex = 0; nIndex < nCount; nIndex++ )
		{
			pFrame = (CFrame*)( m_svExpFrame.GetAt( 0 ) );
			m_svExpFrame.RemoveAt( 0 );
			delete pFrame;
		}
#endif
		CheckPrinterMemory();	// v^[̃`FbN Added by H.Yoshida	2007.12.05

	LeaveCriticalSection( &m_apFrameLock );

#if 0
	// ̊Ǘ̈
	EnterCriticalSection( &m_apPhoto2Lock );

		// vgL[̊J
		nCount = m_apPhoto2.GetSize();
		for( nIndex=0 ; nIndex < nCount ; nIndex++ )
		{
			pPhoto = (CPhoto*)(m_apPhoto2.GetAt(0));
			::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pPhoto->GetSock(), pPhoto->GetReceiptNo(), 4, pPhoto->GetRepeat() + 1 );	// vg󋵒ʒmi4:vgsj
			m_apPhoto2.RemoveAt(0);
			delete pPhoto;
		}

	LeaveCriticalSection( &m_apPhoto2Lock );

	// vg̊Ǘ̈
	EnterCriticalSection( &m_apPhoto1Lock );

		// vgL[̊J
		nCount = m_apPhoto1.GetSize();
		for( nIndex=0 ; nIndex < nCount ; nIndex++ )
		{
			pPhoto = (CPhoto*)(m_apPhoto1.GetAt(0));
			::GetServerTcpCmd()->OnNotifyPrintState( (CWS2Tcp*)pPhoto->GetSock(), pPhoto->GetReceiptNo(), 4, pPhoto->GetRepeat() + 1 );	// vg󋵒ʒmi4:vgsj
			m_apPhoto1.RemoveAt(0);
			delete pPhoto;
		}

	LeaveCriticalSection( &m_apPhoto1Lock );
#endif
}

// v^[̃`FbN
// Added by H.Yoshida	2007.12.05
void CPrintQue::CheckPrinterMemory()
{
	if ( 1 == ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
	{
		// Added by H.Yoshida	2007.12.05
		// 1FCNWFbg^Cv̏ꍇAI[_[ʈȏソ܂ƃ[tɂ
		if( 20 < m_apFrame.GetSize() )
		{
			::GetVirtualPrinter()->m_cPrinterState.SetMemoryStatus( 2 );
			// ʍXV
			::GetVirtualPrinter()->GetNpsServerDlg()->PostMessage(UM_DISPLAY_REDRAW, 0, 0);
		}
		else
		{
			::GetVirtualPrinter()->m_cPrinterState.SetMemoryStatus( 1 );
			// ʍXV
			::GetVirtualPrinter()->GetNpsServerDlg()->PostMessage(UM_DISPLAY_REDRAW, 0, 0);
		}	
	}
}

// ʈ
void CPrintQue::EnableDuplex()
{
	EnterCriticalSection( &m_bDuplexEnableLock );
	m_bDuplexEnable = TRUE;
	m_dwDuplexSeqNo = 1;
	LeaveCriticalSection( &m_bDuplexEnableLock );
}

void CPrintQue::DisableDuplex()
{
	EnterCriticalSection( &m_bDuplexEnableLock );
	m_bDuplexEnable = FALSE;
	m_dwDuplexSeqNo = 0;
	LeaveCriticalSection( &m_bDuplexEnableLock );
}

BOOL CPrintQue::IsEnableDuplex()
{
	BOOL bDuplexEnable;

	EnterCriticalSection( &m_bDuplexEnableLock );
	bDuplexEnable = m_bDuplexEnable;
	LeaveCriticalSection( &m_bDuplexEnableLock );

	return bDuplexEnable;
}

DWORD CPrintQue::GetDuplexSeqNo()
{
	DWORD dwDuplexSeqNo;

	EnterCriticalSection( &m_bDuplexEnableLock );
	dwDuplexSeqNo = m_dwDuplexSeqNo;
	LeaveCriticalSection( &m_bDuplexEnableLock );

	return dwDuplexSeqNo;
}

void CPrintQue::IncrementDuplexSeqNo()
{
	EnterCriticalSection( &m_bDuplexEnableLock );
	m_dwDuplexSeqNo++;
	LeaveCriticalSection( &m_bDuplexEnableLock );
}
