#include "stdafx.h"
#include "RecvNpsData.h"
//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : CRecvNpsData.cpp
//	ABSTRACT  : NPSf[^MNX
//	
//	CREATE    : Y.Yoshinobu   2008.12.1
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CNpsTagData::CNpsTagData()
//	ABSTRACT : RXgN^
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsTagData::CNpsTagData(void)
{
	m_wTagNo		= 0;	// ^Oԍ
	m_wTagStartPos	= 0;	// ^Ol̊Jnʒu
	m_wTagLen		= 0;	// ^Ol̒
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CNpsTagData::~CNpsTagData()
//	ABSTRACT : fXgN^
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsTagData::~CNpsTagData(void)
{
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::CRecvNpsData()
//	ABSTRACT : RXgN^
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CRecvNpsData::CRecvNpsData(void)
{
	InitializeCriticalSection( &m_csPublicAccess );

	// NPSR}hM̈
	try
	{
		m_lpRecvBuffer = new BYTE [RECV_NPS_DATA_MAX_SIZE];
	}
	catch (CMemoryException* e)
	{
		m_lpRecvBuffer = NULL;
		e->Delete();
	}

	// M̃Zbg
	Reset();
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::~CRecvNpsData()
//	ABSTRACT : fXgN^
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CRecvNpsData::~CRecvNpsData(void)
{
	if ( NULL != m_lpRecvBuffer )
	{
		delete [] m_lpRecvBuffer;
	}

	DeleteCriticalSection( &m_csPublicAccess );
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetRemainLengthOfHeader()
//	ABSTRACT : R}hwb_[̖M̒Ԃ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : R}hwb_[̖M̃oCg (P:1Byte)
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
WORD CRecvNpsData::GetRemainLengthOfHeader()
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	return m_wHeaderRemain;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::AddRemainLengthOfHeader()
//	ABSTRACT : R}hwb_[̎MTCYo^܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wRecvLen	R}hwb_[MoCg (P:1Byte)
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CRecvNpsData::AddRemainLengthOfHeader( WORD wRecvLen )
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	if ( m_wHeaderRemain > wRecvLen )
	{
		m_wHeaderRemain -= wRecvLen;
	}
	else
	{
		m_wHeaderRemain = 0;
	}
	m_wRecvLength += wRecvLen;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetRemainLengthOfTagHeader()
//	ABSTRACT : ^Owb_[̖M̒Ԃ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : ^Owb_[̖M̃oCg (P:1Byte)
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
WORD CRecvNpsData::GetRemainLengthOfTagHeader()
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	return m_wTagHeaderRemain;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::AddRemainLengthOfTagHeader()
//	ABSTRACT : ^Owb_[̎MTCYo^܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wRecvLen	^Owb_[MoCg (P:1Byte)
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CRecvNpsData::AddRemainLengthOfTagHeader( WORD wRecvLen )
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	if ( m_wTagHeaderRemain > wRecvLen )
	{
		m_wTagHeaderRemain -= wRecvLen;
	}
	else
	{
		m_wTagHeaderRemain = 0;

		WORD wTagStartPos = m_wRecvLength + wRecvLen;
		WORD wTagNo;
		WORD wTagLen;

		CopyMemory( &wTagNo, m_lpRecvBuffer + wTagStartPos - 4, sizeof(WORD) );
		CopyMemory( &wTagLen, m_lpRecvBuffer + wTagStartPos - 2, sizeof(WORD) );

		wTagNo = NkcComApi::ntohs( wTagNo );
		wTagLen = NkcComApi::ntohs( wTagLen );

		m_wTagValueRemain = wTagLen;

		AddTagData( wTagNo, wTagStartPos, wTagLen );

		// ^Ol̒0̏ꍇ́Ã^Oǂݍނ߂TAGZbg
		if (( 0 != wTagNo ) && ( 0 == wTagLen ))
		{
			m_wTagHeaderRemain	= 4;
			m_wTagValueRemain	= 0;
		}
	}
	m_wRecvLength += wRecvLen;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetRemainLengthOfTagValue()
//	ABSTRACT : ^Ol̖M̒Ԃ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : ^Ol̖M̃oCg (P:1Byte)
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
WORD CRecvNpsData::GetRemainLengthOfTagValue()
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	return m_wTagValueRemain;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::AddRemainLengthOfHeader()
//	ABSTRACT : ^Ol̎MTCYo^܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wRecvLen	^OlMoCg (P:1Byte)
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CRecvNpsData::AddRemainLengthOfTagValue( WORD wRecvLen )
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	if ( m_wTagValueRemain > wRecvLen )
	{
		m_wTagValueRemain -= wRecvLen;
	}
	else
	{
		// ̃^Oǂݍނ߂TAGZbg
		m_wTagHeaderRemain	= 4;
		m_wTagValueRemain	= 0;
	}
	m_wRecvLength += wRecvLen;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetRecvStatus()
//	ABSTRACT : f[^̎MԂ擾܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : f[^̎M
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
E_RECV_STATUS CRecvNpsData::GetRecvStatus()
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	if ( 0 < m_wHeaderRemain )
	{
		return E_RECV_CMD_HEADER;
	}

	if ( 0 < m_wTagHeaderRemain )
	{
		return E_RECV_TAG_HEADER;
	}

	if ( 0 < m_wTagValueRemain )
	{
		return E_RECV_TAG_VALUE;
	}

	return E_RECV_END;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetPointer()
//	ABSTRACT : Mf[^ۑ̈̃|C^Ԃ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Mf[^ސ擪AhX
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
LPBYTE CRecvNpsData::GetPointer()
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	if ( NULL == m_lpRecvBuffer )
	{
		return NULL;
	}

	return m_lpRecvBuffer + m_wRecvLength;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetLength()
//	ABSTRACT : MĂf[^̒Ԃ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : MĂf[^̒ (P:1Byte)
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
WORD CRecvNpsData::GetLength()
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	if ( NULL == m_lpRecvBuffer )
	{
		return 0;
	}

	return m_wRecvLength;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::Reset()
//	ABSTRACT : f[^̎MZbg܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CRecvNpsData::Reset()
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	m_wRecvLength		= 0;	// m_lpRecvBufferւ݈̏ʒu
	m_wHeaderRemain		= 4;	// wb_[̎cMTCY
	m_wTagHeaderRemain	= 4;	// ^Owb_[̎cMTCY
	m_wTagValueRemain	= 0;	// ^Ol̎cMTCY

	if ( NULL != m_lpRecvBuffer )
	{
		ZeroMemory( m_lpRecvBuffer, RECV_NPS_DATA_MAX_SIZE );
	}

	ClearTagData();
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetInterfaceId()
//	ABSTRACT : C^[tF[XID擾܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Mf[^̃C^[tF[XID
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
WORD CRecvNpsData::GetInterfaceId()
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	if ( NULL == m_lpRecvBuffer )
	{
		return 0;
	}

	WORD wInterfaceId = 0;

	CopyMemory( &wInterfaceId, m_lpRecvBuffer, sizeof(WORD) );

	return NkcComApi::ntohs( wInterfaceId );
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetCommandId()
//	ABSTRACT : R}hID擾܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Mf[^̃R}hID
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
WORD CRecvNpsData::GetCommandId()
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	if ( NULL == m_lpRecvBuffer )
	{
		return 0;
	}

	WORD wCommandId = 0;

	CopyMemory( &wCommandId, m_lpRecvBuffer + 2, sizeof(WORD) );

	return NkcComApi::ntohs( wCommandId );
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::AddTagData()
//	ABSTRACT : NPS^Of[^Reiɒǉ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wTagNo		^Oԍ
//	           wTagStartPos	^OJnʒu
//	           wTagLen		^O̒
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CRecvNpsData::AddTagData( const WORD wTagNo, const WORD wTagStartPos, const WORD wTagLen )
{
	CNpsTagData* pobjNpsTagData;

	try
	{
		pobjNpsTagData = new CNpsTagData;
	}
	catch (CMemoryException* e)
	{
		pobjNpsTagData = NULL;
		e->Delete();
	}

	if ( NULL != pobjNpsTagData )
	{
		pobjNpsTagData->m_wTagNo = wTagNo;
		pobjNpsTagData->m_wTagStartPos = wTagStartPos;
		pobjNpsTagData->m_wTagLen = wTagLen;

		m_vNpsTagData.push_back( pobjNpsTagData );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::SelectTagData()
//	ABSTRACT : ReiYNPS^Of[^擾܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wTagNo			:^Oԍ
//	           lpwTagStartPos	:m_lpRecvBufferɏ܂Ă^Ol̐擪ʒu
//	           lpwTagLen		:m_lpRecvBufferɏ܂Ă^Ol̃TCY
//	
//	RETURN   : TRUE		: w肳ꂽ^O݂
//	           FALSE	: w肳ꂽ^O݂͑Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
bool CRecvNpsData::SelectTagData( const WORD wTagNo, LPWORD lpwTagStartPos, LPWORD lpwTagLen )
{
	CNpsTagData* pobjNpsTagData;
	std::vector<CNpsTagData*>::iterator itNpsTagData;

	for ( itNpsTagData=m_vNpsTagData.begin() ; m_vNpsTagData.end() != itNpsTagData ; itNpsTagData++ )
	{
		pobjNpsTagData = *itNpsTagData;

		if ( wTagNo == pobjNpsTagData->m_wTagNo )
		{
			*lpwTagStartPos	= pobjNpsTagData->m_wTagStartPos;
			*lpwTagLen = pobjNpsTagData->m_wTagLen;
			return true;
		}
	}

	return false;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::ClearTagData()
//	ABSTRACT : NPS^Of[^̃ReiNA܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : Ȃ
//	
//	RETURN   : Ȃ
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CRecvNpsData::ClearTagData()
{
	CNpsTagData* pobjNpsTagData;
	std::vector<CNpsTagData*>::iterator itNpsTagData;

	for ( itNpsTagData=m_vNpsTagData.begin() ; m_vNpsTagData.end() != itNpsTagData ; itNpsTagData++ )
	{
		pobjNpsTagData = *itNpsTagData;
		delete pobjNpsTagData;
	}

	m_vNpsTagData.clear();
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetLengthOfTagValue()
//	ABSTRACT : ^Ol̒Ԃ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wTagNo	:^Oԍ
//	
//	RETURN   : w肳ꂽ^Oԍ܂Ă钷 (P:1Byte)
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT32 CRecvNpsData::GetLengthOfTagValue( const WORD wTagNo )
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	UINT32 nLength = 0;

	CNpsTagData* pobjNpsTagData;
	std::vector<CNpsTagData*>::iterator itNpsTagData;

	for ( itNpsTagData=m_vNpsTagData.begin() ; m_vNpsTagData.end() != itNpsTagData ; itNpsTagData++ )
	{
		pobjNpsTagData = *itNpsTagData;

		if ( wTagNo == pobjNpsTagData->m_wTagNo )
		{
			nLength = pobjNpsTagData->m_wTagLen;
			break;
		}
	}

	return nLength;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetTagValueInt8()
//	ABSTRACT : ^OlUCHAR^ŕԂ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wTagNo	:^Oԍ
//	           nIdx		:^Ol̗̒vfԍ (擪0Jn)
//	
//	RETURN   : ^Ol
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT8 CRecvNpsData::GetTagValueInt8( const WORD wTagNo, const INT32 nIdx )
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	UINT8 nValue = 0;

	CNpsTagData* pobjNpsTagData;
	std::vector<CNpsTagData*>::iterator itNpsTagData;

	for ( itNpsTagData=m_vNpsTagData.begin() ; m_vNpsTagData.end() != itNpsTagData ; itNpsTagData++ )
	{
		pobjNpsTagData = *itNpsTagData;

		if ( wTagNo == pobjNpsTagData->m_wTagNo )
		{
			CopyMemory( &nValue, m_lpRecvBuffer + pobjNpsTagData->m_wTagStartPos + ( sizeof(UINT8) * nIdx ), sizeof(UINT8) );
			break;
		}
	}

	return nValue;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetTagValueInt16()
//	ABSTRACT : ^OlUSHORT^ŕԂ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wTagNo	:^Oԍ
//	           nIdx		:^Ol̗̒vfԍ (擪0Jn)
//	
//	RETURN   : ^Ol
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT16 CRecvNpsData::GetTagValueInt16( const WORD wTagNo, const INT32 nIdx )
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	UINT16 nValue = 0;

	CNpsTagData* pobjNpsTagData;
	std::vector<CNpsTagData*>::iterator itNpsTagData;

	for ( itNpsTagData=m_vNpsTagData.begin() ; m_vNpsTagData.end() != itNpsTagData ; itNpsTagData++ )
	{
		pobjNpsTagData = *itNpsTagData;

		if ( wTagNo == pobjNpsTagData->m_wTagNo )
		{
			CopyMemory( &nValue, m_lpRecvBuffer + pobjNpsTagData->m_wTagStartPos + ( sizeof(UINT16) * nIdx ), sizeof(UINT16) );
			nValue = NkcComApi::ntohs( nValue );
			break;
		}
	}

	return nValue;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetTagValueInt32()
//	ABSTRACT : ^OlULONG^ŕԂ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wTagNo	:^Oԍ
//	           nIdx		:^Ol̗̒vfԍ (擪0Jn)
//	
//	RETURN   : ^Ol
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT32 CRecvNpsData::GetTagValueInt32( const WORD wTagNo, const INT32 nIdx )
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	UINT32 nValue = 0;

	CNpsTagData* pobjNpsTagData;
	std::vector<CNpsTagData*>::iterator itNpsTagData;

	for ( itNpsTagData=m_vNpsTagData.begin() ; m_vNpsTagData.end() != itNpsTagData ; itNpsTagData++ )
	{
		pobjNpsTagData = *itNpsTagData;

		if ( wTagNo == pobjNpsTagData->m_wTagNo )
		{
			CopyMemory( &nValue, m_lpRecvBuffer + pobjNpsTagData->m_wTagStartPos + ( sizeof(UINT32) * nIdx ), sizeof(UINT32) );
			nValue = NkcComApi::ntohl( nValue );
			break;
		}
	}

	return nValue;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetTagValueString()
//	ABSTRACT : ^OlCString^ŕԂ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wTagNo	:^Oԍ
//	
//	RETURN   : ^Ol̕
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CString CRecvNpsData::GetTagValueString( const WORD wTagNo )
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	CString strValue;

	CNpsTagData* pobjNpsTagData;
	std::vector<CNpsTagData*>::iterator itNpsTagData;

	for ( itNpsTagData=m_vNpsTagData.begin() ; m_vNpsTagData.end() != itNpsTagData ; itNpsTagData++ )
	{
		pobjNpsTagData = *itNpsTagData;

		if ( wTagNo == pobjNpsTagData->m_wTagNo )
		{
			CopyMemory( strValue.GetBufferSetLength( pobjNpsTagData->m_wTagLen + 1 ),
						m_lpRecvBuffer + pobjNpsTagData->m_wTagStartPos,
						pobjNpsTagData->m_wTagLen );
			strValue.ReleaseBuffer();
			break;
		}
	}

	return strValue;
}

//////////////////////////////////////////////////////////////////////////////
//	FUNCTION : CRecvNpsData::GetTagValueChar()
//	ABSTRACT : ^Olw肳ꂽ̈ɃRs[ĕԂ܂
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	ARGUMENT : wTagNo		:^Oԍ
//	           nBufferSize	:^Ol擾̈̃TCY (P:1Byte)
//	           lpBuffer		:^Ol擾̈̐擪|C^
//	
//	RETURN   : lpBufferɏ񂾃TCY (P:1Byte)
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT32 CRecvNpsData::GetTagValueChar( const WORD wTagNo, UINT32 nBufferSize, LPBYTE lpBuffer )
{
	CRecvNpsDataScopeLock objScopeLock( &m_csPublicAccess );

	UINT32 nLength = 0;

	CNpsTagData* pobjNpsTagData;
	std::vector<CNpsTagData*>::iterator itNpsTagData;

	for ( itNpsTagData=m_vNpsTagData.begin() ; m_vNpsTagData.end() != itNpsTagData ; itNpsTagData++ )
	{
		pobjNpsTagData = *itNpsTagData;

		if ( wTagNo == pobjNpsTagData->m_wTagNo )
		{
			ZeroMemory( lpBuffer, nBufferSize );
			nLength = min( pobjNpsTagData->m_wTagLen, nBufferSize );
			CopyMemory( lpBuffer, m_lpRecvBuffer + pobjNpsTagData->m_wTagStartPos, nLength );
			break;
		}
	}

	return nLength;
}
