//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : VirtualPrinter.cpp
//	ABSTRACT  : zv^̏ԂǗ
//	
//	CREATE    : Y.Yoshinobu	2006.7.30
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
// VirtualPrinter.cpp: CVirtualPrinter NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "VirtualPrinter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CVirtualPrinter::CVirtualPrinter()
{
	// rm
	InitializeCriticalSection( &m_csPossessionLock );

	m_dwEventId = 0;
	m_dwReciveNo = 0;

	m_cPrinterState;

	m_pNpsServerDlg = NULL;

	m_wPossessionNo = 0;
	m_wPossessionNoActive = 0;
	m_ePossessionState = NONE;
	m_pPossessionSock = NULL;
	m_wPort = 0;
	m_nReleaseTime = 0;

	// Xv[tH_̏ꏊo^
	m_strSpoolFolder = NkcComApi::MakeFullPath( "Spool" );
}

CVirtualPrinter::~CVirtualPrinter()
{
	m_awPossessionNo.RemoveAll();

	// rJ
	DeleteCriticalSection( &m_csPossessionLock );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CVirtualPrinter::GetIncrementEventId()
//	ABSTRACT : Cxgʒm̃j[Nԍ擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CVirtualPrinter::GetIncrementEventId()
{
	m_dwEventId++;

	return m_dwEventId;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CVirtualPrinter::GetIncrementReciveNo()
//	ABSTRACT : tJnvŕԂj[NȎMԍ擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CVirtualPrinter::GetIncrementReciveNo()
{
	m_dwReciveNo++;

	return m_dwReciveNo;
}


//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CVirtualPrinter::SetNpsServerDlg()
//	ABSTRACT : C_CAOCWndZbg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CVirtualPrinter::SetNpsServerDlg(CWnd* pWnd)
{
	m_pNpsServerDlg = pWnd;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CVirtualPrinter::GetNpsServerDlg()
//	ABSTRACT : C_CAOCWnd擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CWnd* CVirtualPrinter::GetNpsServerDlg()
{
	return m_pNpsServerDlg;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CVirtualPrinter::SetPossessionState()
//	ABSTRACT : L
//	FUNCTION : 
//  UPDATE	 : J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
BOOL CVirtualPrinter::SetPossessionState( WORD wPossessionMode, WORD wInterruptMode, WORD wPort, LPWORD pPossessionNo, LPVOID pPossessionSock, UCHAR IsMaintenance )
{
	BOOL bResult=FALSE;

	EnterCriticalSection( &m_csPossessionLock );

	switch ( m_ePossessionState )
	{
	case NONE:			// L
	case NORMAL_WAIT:	// LiʏĊJ҂j
		switch ( wPossessionMode )
		{
		case 0:		// 0Fʏ
		case 1:		// 1F荞ݒf̍ĊJ(ʏ)
			m_ePossessionState = CVirtualPrinter::NORMAL;
			m_wPort = wPort;
			m_IsMaintenance = IsMaintenance;
			if( *pPossessionNo != 0 )
			{	// Lԍw肳ꂽꍇ͂gp	@@@RD-151Ή	2012.02.17	T.Mizushima
				m_wPossessionNoActive = *pPossessionNo;
			}
			else
			{
				m_wPossessionNoActive = ++m_wPossessionNo;
			}
			m_pPossessionSock = pPossessionSock;
			bResult = TRUE;
			m_cPrinterState.SetPrinterPossession( 2 );	// 2FʏL
			break;
		case 2:		// 2F}[x1]
			if( m_cPrinterConfig.GetSupportInterrupt() == 2 )
			{	// V^荞ݑΉ	@@@RD-151Ή	2012.02.15	T.Mizushima
				// L[̃R}ޔ
				m_cPrintQue.SavePrintQue( wPossessionMode );
			}
			else
			{	// uʏLvꎞ~
				m_cPrintQue.PossessionStop();		// 2006.10.25 T.Mizushima	wE51
			}
			m_ePossessionState = CVirtualPrinter::EXPRESS1;
			m_wPort = wPort;
			m_IsMaintenance = IsMaintenance;
			if( *pPossessionNo != 0 )
			{	// Lԍw肳ꂽꍇ͂gp	@@@RD-151Ή	2012.02.17	T.Mizushima
				m_wPossessionNoActive = *pPossessionNo;
			}
			else
			{
				m_wPossessionNoActive = ++m_wPossessionNo;
			}
			m_pPossessionSock = pPossessionSock;
			bResult = TRUE;
			m_cPrinterState.SetPrinterPossession( 4 );	// 4F}[x1]L
			break;
		case 4:		// 4F}[x2]
			if( m_cPrinterConfig.GetSupportInterrupt() == 2 )
			{	// V^荞ݑΉ	@@@RD-151Ή	2012.02.15	T.Mizushima
				// L[̃R}ޔ
				m_cPrintQue.SavePrintQue( wPossessionMode );
			}
			else
			{	// u}[x1]vꎞ~
				m_cPrintQue.PossessionStop2();
			}
			m_ePossessionState = CVirtualPrinter::EXPRESS2;
			m_wPort = wPort;
			m_IsMaintenance = IsMaintenance;
			if( *pPossessionNo != 0 )
			{	// Lԍw肳ꂽꍇ͂gp	@@@RD-151Ή	2012.02.17	T.Mizushima
				m_wPossessionNoActive = *pPossessionNo;
			}
			else
			{
				m_wPossessionNoActive = ++m_wPossessionNo;
			}
			m_pPossessionSock = pPossessionSock;
			bResult = TRUE;
			m_cPrinterState.SetPrinterPossession( 6 );	// 6F}[x2]L
			break;
		}
		break;
	case NORMAL:		// ʏL
	case EXPRESS1_WAIT:				// Li}[x1]ĊJ҂j
		switch ( wPossessionMode )
		{
		case 0:		// 0Fʏ
		case 1:		// 1F荞ݒf̍ĊJ(ʏ)
			break;
		case 2:		// 2F}[x1]
			if( m_cPrinterConfig.GetSupportInterrupt() == 2 )
			{	// V^荞ݑΉ	@@@RD-151Ή	2012.02.15	T.Mizushima
				// L[̃R}ޔ
				m_cPrintQue.SavePrintQue( wPossessionMode );
			}
			else
			{	// uʏLvꎞ~
				m_cPrintQue.PossessionStop();
			}
			m_ePossessionState = CVirtualPrinter::EXPRESS1;
			m_wPort = wPort;
			m_IsMaintenance = IsMaintenance;
			m_awPossessionNo.Add( m_wPossessionNoActive );
			if( *pPossessionNo != 0 )
			{	// Lԍw肳ꂽꍇ͂gp	@@@RD-151Ή	2012.02.17	T.Mizushima
				m_wPossessionNoActive = *pPossessionNo;
			}
			else
			{
				m_wPossessionNoActive = ++m_wPossessionNo;
			}
			m_pPossessionSock = pPossessionSock;
			bResult = TRUE;
			m_cPrinterState.SetPrinterPossession( 4 );	// 4F}[x1]L
			break;
		case 4:		// 4F}[x2]
			if( m_cPrinterConfig.GetSupportInterrupt() == 2 )
			{	// V^荞ݑΉ	@@@RD-151Ή	2012.02.15	T.Mizushima
				// L[̃R}ޔ
				m_cPrintQue.SavePrintQue( wPossessionMode );
			}
			else
			{	// uʏLvꎞ~
				m_cPrintQue.PossessionStop2();
			}
			m_ePossessionState = CVirtualPrinter::EXPRESS2;
			m_wPort = wPort;
			m_IsMaintenance = IsMaintenance;
			m_awPossessionNo.Add( m_wPossessionNoActive );
			if( *pPossessionNo != 0 )
			{	// Lԍw肳ꂽꍇ͂gp	@@@RD-151Ή	2012.02.17	T.Mizushima
				m_wPossessionNoActive = *pPossessionNo;
			}
			else
			{
				m_wPossessionNoActive = ++m_wPossessionNo;
			}
			m_pPossessionSock = pPossessionSock;
			bResult = TRUE;
			m_cPrinterState.SetPrinterPossession( 6 );	// 4F}[x2]L
			break;
		}
		break;
	case EXPRESS1:		// }[x1]L
		switch ( wPossessionMode )
		{
		case 0:		// 0Fʏ
		case 1:		// 1F荞ݒf̍ĊJ(ʏ)
		case 2:		// 2F}[x1]
			break;
		case 4:		// 4F}[x2]
			if( m_cPrinterConfig.GetSupportInterrupt() == 2 )
			{	// V^荞ݑΉ	@@@RD-151Ή	2012.02.15	T.Mizushima
				// L[̃R}ޔ
				m_cPrintQue.SavePrintQue( wPossessionMode );
			}
			else
			{	// uʏLvꎞ~
				m_cPrintQue.PossessionStop2();
			}
			m_ePossessionState = CVirtualPrinter::EXPRESS2;
			m_wPort = wPort;
			m_IsMaintenance = IsMaintenance;
			m_awPossessionNo.Add( m_wPossessionNoActive );
			if( *pPossessionNo != 0 )
			{	// Lԍw肳ꂽꍇ͂gp	@@@RD-151Ή	2012.02.17	T.Mizushima
				m_wPossessionNoActive = *pPossessionNo;
			}
			else
			{
				m_wPossessionNoActive = ++m_wPossessionNo;
			}
			m_pPossessionSock = pPossessionSock;
			bResult = TRUE;
			m_cPrinterState.SetPrinterPossession( 6 );	// 4F}[x2]L
			break;
		}
		break;
	case EXPRESS2:		// }[x2]L
		break;
	}

	if ( TRUE == bResult )
	{
		*pPossessionNo = m_wPossessionNoActive;
	}

	LeaveCriticalSection( &m_csPossessionLock );

	// ʍXV
	m_pNpsServerDlg->PostMessage( UM_DISPLAY_REDRAW, 0, 0 );

	return bResult;
}

void CVirtualPrinter::ResetPossession()
{
	EnterCriticalSection( &m_csPossessionLock );

	switch ( m_ePossessionState )
	{
	default:
	case NORMAL:
		// LԂ𖢐LɕύX
		m_ePossessionState = CVirtualPrinter::NONE;
		m_wPort = 0;
		m_pPossessionSock = NULL;
		m_IsMaintenance = 0;
		m_cPrinterState.SetPrinterPossession( 1 );	// 1FL
		break;
	case EXPRESS1:
		if( ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportInterrupt() == 2 )
		{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.15	T.Mizushima
			// }荞ݏĨvgL[̕A
			m_cPrintQue.RecoveryPrintQue();
		}
		// }[x1]LԂ𖢐LiʏĊJ҂jɕύX
		m_ePossessionState = CVirtualPrinter::NORMAL_WAIT;
		m_wPort = 0;
		m_pPossessionSock = NULL;
		m_IsMaintenance = 0;
		m_cPrinterState.SetPrinterPossession( 3 );	// 3FLiʏĊJ҂j
		// LiĊJ҂jJ鎞ԂZbg
		::time( &m_nReleaseTime );
		m_nReleaseTime += WAIT_RELEASE_TIME;	// 5bɊJԂZbg
		break;
	case EXPRESS2:
		if( ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportInterrupt() == 2 )
		{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.15	T.Mizushima
			// }荞ݏĨvgL[̕A
			m_cPrintQue.RecoveryPrintQue();
		}
		// }[x2]LԂ𖢐Li}[x1]ĊJ҂jɕύX
		m_ePossessionState = CVirtualPrinter::EXPRESS1_WAIT;
		m_wPort = 0;
		m_pPossessionSock = NULL;
		m_IsMaintenance = 0;
		m_cPrinterState.SetPrinterPossession( 5 );	// 5FLi}[x1]ĊJ҂j
		// LiĊJ҂jJ鎞ԂZbg
		::time( &m_nReleaseTime );
		m_nReleaseTime += WAIT_RELEASE_TIME;	// 5bɊJԂZbg
		break;
	}

	m_wPossessionNoActive = 0;

	LeaveCriticalSection( &m_csPossessionLock );

	// ʍXV
	m_pNpsServerDlg->PostMessage( UM_DISPLAY_REDRAW, 0, 0 );
}

void CVirtualPrinter::RestartWaitCheck()
{
	BOOL bRedraw=FALSE;
	time_t nNowTime;

	::time( &nNowTime );

	EnterCriticalSection( &m_csPossessionLock );

	switch ( m_ePossessionState )
	{
	case CVirtualPrinter::NORMAL_WAIT:
		if ( m_nReleaseTime < nNowTime ) {
			// LiĊJ҂jԂ𖢐LɕύX
			m_ePossessionState = CVirtualPrinter::NONE;
			m_wPort = 0;
			m_pPossessionSock = NULL;
			m_cPrinterState.SetPrinterPossession( 1 );	// 1FL
			bRedraw = TRUE;
		}
		break;
	case CVirtualPrinter::EXPRESS1_WAIT:
		if ( m_nReleaseTime < nNowTime ) {
			// Li}[x1]ĊJ҂jԂ𖢐LiĊJ҂jɕύX
			m_ePossessionState = CVirtualPrinter::NORMAL_WAIT;
			m_wPort = 0;
			m_pPossessionSock = NULL;
			m_cPrinterState.SetPrinterPossession( 3 );	// 3FLiʏĊJ҂j
			bRedraw = TRUE;
			// LiĊJ҂jJ鎞ԂZbg
			::time( &m_nReleaseTime );
			m_nReleaseTime += WAIT_RELEASE_TIME;	// 5bɊJԂZbg
		}
		break;
	}

	LeaveCriticalSection( &m_csPossessionLock );

	if ( TRUE == bRedraw ) {
		// ʍXV
		m_pNpsServerDlg->PostMessage( UM_DISPLAY_REDRAW, 0, 0 );
	}
}

LPVOID CVirtualPrinter::GetPossessionSock()
{
	LPVOID pPossessionSock;

	EnterCriticalSection( &m_csPossessionLock );

	pPossessionSock = m_pPossessionSock;

	LeaveCriticalSection( &m_csPossessionLock );

	return pPossessionSock;
}

// 摜M|[g
WORD CVirtualPrinter::GetPort()
{
	WORD wPort;

	EnterCriticalSection( &m_csPossessionLock );

	wPort = m_wPort;

	LeaveCriticalSection( &m_csPossessionLock );

	return wPort;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CVirtualPrinter::GetPossessionNo()
//	ABSTRACT : Lԍ
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
WORD CVirtualPrinter::GetPossessionNo()
{
	return m_wPossessionNoActive;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CVirtualPrinter::IsWarikomiPossessionNo()
//	ABSTRACT : LԍL荞݂ꂽ𒲂ׂ ( TRUE:荞, FALSE:荞 )
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL CVirtualPrinter::IsWarikomiPossessionNo( WORD wPossessionNo )
{
	int nCount;
	int nIndex;
	BOOL bResult = FALSE;

	EnterCriticalSection( &m_csPossessionLock );

	nCount = m_awPossessionNo.GetSize();

	if ( 0 < nCount )
	{
		// V̂猟̂Ŕz̍ŌォQƂ
		for ( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
		{
			if ( wPossessionNo == m_awPossessionNo.GetAt( nIndex ) )
			{
				bResult = TRUE;
				break;
			}
		}

	}

	LeaveCriticalSection( &m_csPossessionLock );

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CVirtualPrinter::DeleteWarikomiPossessionNo()
//	ABSTRACT : 荞݂ɂ蒆fꂽLԍw̐Lԍ폜
//	FUNCTION : 
//	@@@RD-151Ή	2012.02.15	T.Mizushima
//////////////////////////////////////////////////////////////////////////////
void CVirtualPrinter::DeleteWarikomiPossessionNo( WORD wPossessionNo )
{
	int nCount;
	int nIndex;

	EnterCriticalSection( &m_csPossessionLock );

	nCount = m_awPossessionNo.GetSize();

	if ( 0 < nCount )
	{
		// V̂猟̂Ŕz̍ŌォQƂ
		for ( nIndex=nCount-1 ; 0 <= nIndex ; nIndex-- )
		{
			if ( wPossessionNo == m_awPossessionNo.GetAt( nIndex ) )
			{
				m_awPossessionNo.RemoveAt( nIndex );
				break;
			}
		}

	}

	LeaveCriticalSection( &m_csPossessionLock );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CVirtualPrinter::SetPrinterStateExt()
//	ABSTRACT : v^ԂύX
//	FUNCTION : 
//	ARGUMENT : UINT		ύXԎ(enuml)
//			   UCHAR	ύXl
//			   BOOL		ĕ`ʒm^Ȃ
//
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.09.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CVirtualPrinter::SetPrinterStateExt(UINT ChgSts, UCHAR value, BOOL post)
{
	switch(ChgSts)
	{
		case	STATE_PRN_STATE:	// v^Ŝ̏
				
					m_cPrinterState.SetPrinterStatus(value);
					break;

		case	STATE_PRN_ACCEPT:	// t
					m_cPrinterState.SetAcceptStatus(value);
					break;

		case	STATE_PRN_ADVANCE:	// v^Ŝ̏ԁinŚj
			     
					m_cPrinterState.SetAdvanceStatus(value);
					break;

		case	STATE_PRN_LASER:	// w[U[̏
					m_cPrinterState.SetLaserStatus(value);
					break;

		case	STATE_PRN_DEV:		// vZT[Ŝ̏ԁinŚj
					m_cPrinterState.SetDevelopmentStatus(value);
					break;

		case	STATE_PRN_PROC:		// ̏
					m_cPrinterState.SetProcessorStatus(value);
					break;

		case	STATE_PRN_REPL:		// [Ŝ̏
					m_cPrinterState.SetReplenisherStatus(value);
					break;

		case	STATE_PRN_CART:		// [J[gbW̌̉
					m_cPrinterState.SetReplaceCartridgeStatus(value);
					break;

		default:	break;
	}

	if(post == TRUE)
	{
		// ʍXV
		m_pNpsServerDlg->PostMessage(UM_DISPLAY_REDRAW, 0, 0);
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CVirtualPrinter::ChkNotAcceptError()
//	ABSTRACT : 󂯕tsȃG[ǂ`FbN
//	FUNCTION : 
//	ARGUMENT : 
//
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.09.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CVirtualPrinter::ChkNotAcceptError()
{
	BOOL	ret = FALSE;

	DWORD	errtbl[] =
	{
		6104, 6173, 6208, 6209, 1000, 1001, 1081,
		7119, 7120		// Added by H.Yoshida	2007.12.05
	};

	for(int i = 0; i < COUNTOF(errtbl); i++)
	{
		if(m_cErrorInfo.SearchError(errtbl[i]) == TRUE)
		{	// G[
			ret = TRUE;
			break;
		}
	}

	return ret;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CVirtualPrinter::RequestDspDateTime()
//	ABSTRACT : ݒ肳ꂽ̕\˗
//	FUNCTION : 
//	ARGUMENT : 
//
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CVirtualPrinter::RequestDspDateTime(CString strDateTime)
{
	m_strDateTime = strDateTime;
	m_pNpsServerDlg->PostMessage( UM_DISPLAY_DATETIME, 0, 0 );
}
