//////////////////////////////////////////////////////////////////////////////
//   FILE NAME   : WS2Tcp.cpp
//   ABSTRACT    : \PbgʐMNX (WinSock2.0Ή)
//
//                                     (C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include "WS2Tcp.h"
#include "ServerTcpCmd.h"

#pragma comment( lib , "Ws2_32.lib"  )			// WinSock 2.0 gp
#pragma comment( lib , "Mswsock.lib" )

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::CWS2Tcp
//   ABSTRACT : RXgN^
//   FUNCTION : \PbgǗNX̐s܂
//////////////////////////////////////////////////////////////////////////////
CWS2Tcp::CWS2Tcp()
{

	TRACE( "[%08X] CWS2Tcp::CWS2Tcp()\n", GetCurrentThreadId() );

	// Sendprm
	InitializeCriticalSection( &m_pSendLock );

	m_Socket      = INVALID_SOCKET;			// \Pbgnh𖳌ɂ܂
	m_bAutoDelete = FALSE;					// \PbgN[YɎIɍ폜Ȃ
	// CxgpXbh쐬
	m_ExitEvent    = WSACreateEvent();		// IpCxg
	m_NetworkEvent = WSACreateEvent();		// \PbgʐMpCxg
	m_pWinThread = AfxBeginThread(
						SocketEventThread , this , THREAD_PRIORITY_NORMAL ,
						CREATE_SUSPENDED , NULL );
	m_pWinThread->m_bAutoDelete = FALSE;	// 폜Ȃ
	m_pWinThread->ResumeThread();			// Xbh̏Jn
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::~CWS2Tcp
//   ABSTRACT : fXgN^
//   FUNCTION : \PbgǗNX̊Js܂
//////////////////////////////////////////////////////////////////////////////
CWS2Tcp::~CWS2Tcp()
{
	TRACE( "[%08X] CWS2Tcp::~CWS2Tcp()\n", GetCurrentThreadId() );

	// \PbgJĂꍇAJ܂
	if( m_Socket != INVALID_SOCKET )
		Close();		// ؒf
	// Ip̃Cxgݒ肵܂
	WSASetEvent( m_ExitEvent );
	// XbhI҂
	if( GetCurrentThreadId() != m_pWinThread->m_nThreadID )
	{
		// Xbhł͂ȂƂ
		HANDLE hThread;
		hThread = m_pWinThread->m_hThread;
		while ( WAIT_OBJECT_0 != ::MsgWaitForMultipleObjects( 1, &hThread, FALSE, INFINITE, QS_ALLEVENTS ) )
		{
			MSG msg;
			while ( PeekMessage( &msg , NULL , 0 , 0 , PM_NOREMOVE ) )
			{
				AfxGetThread()->PumpMessage();
			}
		}
		delete m_pWinThread;			// XbhpNX̍폜
		m_pWinThread = NULL;

        
	}else{
		// XbhĝƂ
		m_pWinThread->m_bAutoDelete = TRUE;		// 폜
	}

	// e㏈
	WSACloseEvent( m_NetworkEvent );		// Cxg܂
	WSACloseEvent( m_ExitEvent    );		// Cxg܂

	// SendprJ
	LeaveCriticalSection( &m_pSendLock );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Create
//   ABSTRACT : \Pbg̍쐬
//   FUNCTION : \Pbg̍쐬(`1)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Create( int nAddressFamily , int nSocketType , int nProtocol )
{
	TRACE( "[%08X] CWS2Tcp::Create()\n", GetCurrentThreadId() );

	// \Pbg̍쐬s܂
	return Create( NULL , nAddressFamily , nSocketType , nProtocol );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Create
//   ABSTRACT : \Pbg̍쐬
//   FUNCTION : \Pbg̍쐬(`2)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Create(
				LPWSAPROTOCOL_INFO lpProtocolInfo ,
  				int nAddressFamily ,
				int nSocketType    ,
				int nProtocol      )
{
	TRACE( "[%08X] CWS2Tcp::Create()\n", GetCurrentThreadId() );

	// \Pbg̍쐬s܂
	SOCKET		Socket = WSASocket(
					nAddressFamily ,
					nSocketType ,
					nProtocol ,
					lpProtocolInfo ,
					0 ,
					WSA_FLAG_OVERLAPPED );
	if( Socket == INVALID_SOCKET )
		return FALSE;		// \Pbg̍쐬G[

	// NXƌѕts܂
	if( !Attach( Socket , nAddressFamily ) )
		return FALSE;

	// NagleASY𖳌ɂ܂
	SetNoDelay( TRUE );

	// Mobt@TCY0ɂ܂
	SetSendBufSize( 0 );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Bind
//   ABSTRACT : \PbgɖOt܂
//   FUNCTION : \PbgɖOt܂(`1)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Bind( UINT nSocketPort , LPCTSTR lpszSocketAddress )
{
	TRACE( "[%08X] CWS2Tcp::Bind()\n", GetCurrentThreadId() );

	USES_CONVERSION;

	SOCKADDR_IN		SockAddr;ZeroMemory( &SockAddr , sizeof( SockAddr ) );

	// \Pbg̐ݒ
	SockAddr.sin_family		= m_nAddressFamily;		// AhXt@~[
	// \PbgAhX
	LPSTR lpszAscii = T2A((LPTSTR)lpszSocketAddress);
	if( lpszAscii == NULL )
	{
		// AhXwȂ
		SockAddr.sin_addr.s_addr = htonl( INADDR_ANY );
	}else{
		// AhXw
		DWORD lResult = inet_addr(lpszAscii);
		if (lResult == INADDR_NONE)
		{
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
		SockAddr.sin_addr.s_addr = lResult;
	}
	// |[gԍݒ
	SockAddr.sin_port = htons((u_short)nSocketPort);

	// 
	return Bind( (SOCKADDR*)&SockAddr , sizeof( SockAddr ) );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Bind
//   ABSTRACT : \PbgɖOt܂
//   FUNCTION : \PbgɖOt܂(`2)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Bind( const SOCKADDR* lpSockAddr, int nSockAddrLen )
{
	TRACE( "[%08X] CWS2Tcp::Bind()\n", GetCurrentThreadId() );

	return bind( m_Socket , lpSockAddr , nSockAddrLen ) == 0;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Listen
//   ABSTRACT : NCAgڑv󂯓鏀܂
//   FUNCTION : NCAgڑv󂯓鏀܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Listen( int nBackLog )
{
	TRACE( "[%08X] CWS2Tcp::Listen()\n", GetCurrentThreadId() );

	return listen( m_Socket , nBackLog ) == 0;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Accept
//   ABSTRACT : ڑv󂯓܂
//   FUNCTION : ڑv󂯓܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Accept( CWS2Tcp& sock , struct sockaddr *pAddr , int *pAddrLen )
{
	TRACE( "[%08X] CWS2Tcp::Accept()\n", GetCurrentThreadId() );

	SOCKET sTemp = WSAAccept(
				m_Socket ,
				pAddr ,
				pAddrLen ,
				NULL ,
				0 );
	if( sTemp != INVALID_SOCKET )
	{
		// \Pbg擾ł̂ŁAݒ肵܂
		if( !sock.Attach( sTemp , m_nAddressFamily ) )
			return FALSE;		// A^b`s
	}
	// ԂԂ܂
	return sTemp != INVALID_SOCKET;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Connect
//   ABSTRACT : T[o[ɐڑvs܂(1)
//   FUNCTION : T[o[ɐڑvs܂(1)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Connect( LPCTSTR lpszHostAddress, UINT nHostPort )
{
	TRACE( "[%08X] CWS2Tcp::Connect()\n", GetCurrentThreadId() );

	USES_CONVERSION;

	ASSERT(lpszHostAddress != NULL);

	// ݒp\̍\z&
	SOCKADDR_IN SockAddr;
	ZeroMemory( &SockAddr , sizeof( SockAddr ) );

	// \Pbg̐ݒ
	SockAddr.sin_family		= m_nAddressFamily;		// AhXt@~[
	LPSTR lpszAscii = T2A((LPTSTR)lpszHostAddress);	// T[o[AhXݒ
	SockAddr.sin_addr.s_addr = inet_addr(lpszAscii);
	if (SockAddr.sin_addr.s_addr == INADDR_NONE)
	{
		// zXgAIP AhX܂
		LPHOSTENT lphost;
		lphost = gethostbyname( lpszAscii );
		if (lphost != NULL)
		{
			SockAddr.sin_addr.s_addr = ((LPIN_ADDR)lphost->h_addr)->s_addr;
		}else{
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
	}
	SockAddr.sin_port = htons((u_short)nHostPort);	// |[gԍݒ

	return Connect((SOCKADDR*)&SockAddr, sizeof(SockAddr));
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Connect
//   ABSTRACT : T[o[ɐڑvs܂(2)
//   FUNCTION : T[o[ɐڑvs܂(2)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Connect( const SOCKADDR* lpSockAddr, int nSockAddrLen )
{
	TRACE( "[%08X] CWS2Tcp::Connect()\n", GetCurrentThreadId() );

	m_hConnectEvent = CreateEvent( NULL , TRUE , FALSE , NULL );
	if( WSAConnect( m_Socket , lpSockAddr , nSockAddrLen ,
						NULL , NULL , NULL , NULL ) )
	{
		if( GetLastError() == WSAEWOULDBLOCK )
		{
			// ڑ҂
			while ( WAIT_OBJECT_0 != MsgWaitForMultipleObjects( 1, &m_hConnectEvent, FALSE, INFINITE, QS_ALLEVENTS ) )
			{
				MSG msg;
				while ( PeekMessage( &msg , NULL , 0 , 0 , PM_NOREMOVE ) )
				{
					AfxGetThread()->PumpMessage();
				}
			}
			CloseHandle( m_hConnectEvent );
			return m_ConnectState;
		}else{
			CloseHandle( m_hConnectEvent );
			return FALSE;		// WSAEWOULDBLOCK ȊÔƂ̓G[
		}
	}
	CloseHandle( m_hConnectEvent );
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Send
//   ABSTRACT : f[^̑Ms܂(1)
//   FUNCTION : f[^̑Ms܂(1)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Send( const void* lpBuf , int nBufLen , DWORD dwFlags )
{
	//TRACE( "[%08X] CWS2Tcp::Send( %d )\n", GetCurrentThreadId(), nBufLen );
#if 1
	// Mf[^ݒpobt@
	WSABUF			WSABuf;
	WSABuf.buf		= (char*)lpBuf;		// obt@ւ̃|C^[
	WSABuf.len		= nBufLen;			// f[^̒

	// Mv
	return Send( &WSABuf , 1 , dwFlags );
#endif
	//return 0;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Send
//   ABSTRACT : f[^̑Ms܂(2)
//   FUNCTION : f[^̑Ms܂(2)
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Send( WSABUF* pBuf , int nCount , DWORD dwFlags )
{
	//TRACE( "[%08X] CWS2Tcp::Send()\n", GetCurrentThreadId() );

	// Mpf[^낢낢̂ŁAf[^̃Rs[s܂
	WSABUF*		pCopyBuf = (WSABUF*)malloc( sizeof( WSABUF ) * nCount );
	CopyMemory( pCopyBuf , pBuf , sizeof( WSABUF ) * nCount );

	//I[o[bv̂߂̏s܂
	WSAOVERLAPPED	WSAov;					// OVERLPPED \
	WSAov.hEvent	= WSACreateEvent();		// Cxg쐬

	WSABUF*		pSendBuf = pCopyBuf;		// |C^[Rs[܂
	while( nCount > 0 )
	{
		// f[^̑Ms܂
		DWORD		dwSend;
		if( SOCKET_ERROR == WSASend( m_Socket , pSendBuf , nCount ,
									 &dwSend , dwFlags , &WSAov , NULL ) )
		{
			if( GetLastError() == WSA_IO_PENDING )
				// OVERLAPPED Ȃ̂ŏI܂ő҂܂
				WSAGetOverlappedResult( m_Socket , &WSAov , &dwSend ,
										TRUE , &dwFlags );
			else
				return FALSE;		// ȊO̗\ʃG[
		}
		// MTCYf
		while( dwSend > 0 && nCount > 0 )
		{
			DWORD	dwSendLength = min( pSendBuf->len , dwSend );
			pSendBuf->len -= dwSendLength;
			if( pSendBuf->len == 0 )
			{
				pSendBuf++;
				nCount--;
			}else{
				pSendBuf->buf += dwSendLength;
			}
			dwSend -= dwSendLength;
		}
	}
	
	// M㏈
	free( pCopyBuf );
	WSACloseEvent( WSAov.hEvent );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::SendLock
//   ABSTRACT : f[^M̔rJn
//   FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CWS2Tcp::SendLock()
{
	EnterCriticalSection( &m_pSendLock );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::SendUnlock
//   ABSTRACT : f[^M̔rI
//   FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CWS2Tcp::SendUnlock()
{
	LeaveCriticalSection( &m_pSendLock );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Receive
//   ABSTRACT : f[^̎Ms܂
//   FUNCTION : f[^̎Ms܂
//////////////////////////////////////////////////////////////////////////////
int CWS2Tcp::Receive( void* lpBuf, int nBufLen, DWORD dwFlags )
{
	//TRACE( "[%08X] CWS2Tcp::Receive()\n", GetCurrentThreadId() );

	int		nRecvLeng = 0;		// M
	// M钷cĂԌJԂ܂
	while( nRecvLeng < nBufLen )
	{
		// f[^Ms܂
		int		nRecvLeng2 = WSARecvEx(
								m_Socket ,
								(char*)lpBuf + nRecvLeng ,
								nBufLen - nRecvLeng ,
								(int*)&dwFlags );
		if( nRecvLeng2 == SOCKET_ERROR ) {
			if ( 0 < nRecvLeng ) {
				return nRecvLeng;
			} else {
				return -1;
			}
		}
		if( dwFlags & MSG_PARTIAL ) {
			if ( 0 < nRecvLeng ) {
				return nRecvLeng;
			} else {
				return -1;
			}
		}
		// ̎MAhXZo
		nRecvLeng += nRecvLeng2;
	}
		
	return nRecvLeng;		// MԂ܂
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::GetReceiveSize
//   ABSTRACT : f[^̎MTCY擾܂
//   FUNCTION : f[^̎MTCY擾܂
//////////////////////////////////////////////////////////////////////////////
DWORD CWS2Tcp::GetReceiveSize()
{
	TRACE( "[%08X] CWS2Tcp::GetReceiveSize()\n", GetCurrentThreadId() );

	// MTCYo
	DWORD	dwLeng;
	if( 0 != ioctlsocket( m_Socket , FIONREAD , &dwLeng ) )
		return 0xFFFFFFFF;

	return dwLeng;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::SendDisconnect
//   ABSTRACT : MI錾
//   FUNCTION : MI錾
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::SendDisconnect()
{
	TRACE( "[%08X] CWS2Tcp::SendDisconnect()\n", GetCurrentThreadId() );

	WSABUF		WSABuf[1];

	WSABuf[0].buf	= NULL;
	WSABuf[0].len	= 0;

	return WSASendDisconnect( m_Socket , WSABuf ) != SOCKET_ERROR;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::ReceiveDisconnect
//   ABSTRACT : MI錾
//   FUNCTION : MI錾
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::ReceiveDisconnect()
{
	TRACE( "[%08X] CWS2Tcp::ReceiveDisconnect()\n", GetCurrentThreadId() );

	WSABUF		WSABuf[1];

	WSABuf[0].buf	= NULL;
	WSABuf[0].len	= 0;

	return WSARecvDisconnect( m_Socket , WSABuf ) != SOCKET_ERROR;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Close
//   ABSTRACT : ܂
//   FUNCTION : ܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Close()
{
	TRACE( "[%08X] CWS2Tcp::Close()\n", GetCurrentThreadId() );

	shutdown( m_Socket, SD_BOTH );
	closesocket( m_Socket );
	m_Socket = INVALID_SOCKET;
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::Attach
//   ABSTRACT : w\PbgA^b`܂
//   FUNCTION : w\PbgA^b`܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::Attach( SOCKET sock , int nAddressFamily )
{
	TRACE( "[%08X] CWS2Tcp::Attach()\n", GetCurrentThreadId() );

	ASSERT( m_Socket == INVALID_SOCKET );

	// \Pbgݒ
	m_Socket				= sock;
	m_nAddressFamily		= nAddressFamily;

	// A^b`sꂽƂ
	OnAttach();

	// \PbgCxgMݒ
	return SOCKET_ERROR != WSAEventSelect(
								m_Socket ,
								m_NetworkEvent ,
								FD_ACCEPT | FD_CLOSE | FD_CONNECT | FD_OOB |
								FD_QOS | FD_READ | FD_WRITE );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::SetRecvBufferSize
//   ABSTRACT : \Pbg̎Mobt@TCY̐ݒs܂
//   FUNCTION : \Pbg̎Mobt@TCY̐ݒs܂
//////////////////////////////////////////////////////////////////////////////
int CWS2Tcp::SetRecvBufferSize( int nSize )
{
	TRACE( "[%08X] CWS2Tcp::SetRecvBufferSize()\n", GetCurrentThreadId() );

	// \Pbg̎MTCY擾
	int nBaseSize;
	int nOptLeng = sizeof( nBaseSize );
	if( 0 != getsockopt( m_Socket , SOL_SOCKET , SO_RCVBUF , (char*)&nBaseSize , &nOptLeng ) )
		return -1;		// 擾s

	// \Pbg̎MTCYݒ
	if( 0 != setsockopt( m_Socket , SOL_SOCKET , SO_RCVBUF , (char*)&nSize , sizeof( nSize ) ) )
		return -1;		// ݒ莸s

	return nBaseSize;		// ƂƂ̎MTCYԂ܂
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::GetLastError
//   ABSTRACT : G[擾܂
//   FUNCTION : G[擾܂
//////////////////////////////////////////////////////////////////////////////
int CWS2Tcp::GetLastError()
{
	TRACE( "[%08X] CWS2Tcp::GetLastError()\n", GetCurrentThreadId() );

	return WSAGetLastError();
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::SetAutoDelete
//   ABSTRACT : \PbgؒfꂽƂɎIɃNX̍폜邩ǂݒ肵܂
//   FUNCTION : \PbgؒfꂽƂɎIɃNX̍폜邩ǂݒ肵܂
//////////////////////////////////////////////////////////////////////////////
void CWS2Tcp::SetAutoDelete( BOOL bAutoDelete )
{
	TRACE( "[%08X] CWS2Tcp::SetAutoDelete()\n", GetCurrentThreadId() );

	m_bAutoDelete = bAutoDelete;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::SocketEventThread
//   ABSTRACT : \PbgʐMCxgpXbh(1)
//   FUNCTION : \PbgʐMCxgpXbh(1)
//////////////////////////////////////////////////////////////////////////////
UINT CWS2Tcp::SocketEventThread( LPVOID pParam )
{
	TRACE( "[%08X] CWS2Tcp::SocketEventThread()\n", GetCurrentThreadId() );

	return ((CWS2Tcp*)pParam)->SocketEvent();
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::SocketEvent
//   ABSTRACT : \PbgʐMCxgpXbh(2)
//   FUNCTION : \PbgʐMCxgpXbh(2)
//////////////////////////////////////////////////////////////////////////////
UINT CWS2Tcp::SocketEvent()
{
	TRACE( "[%08X] CWS2Tcp::SocketEvent()\n", GetCurrentThreadId() );

	WSAEVENT		evt[2] = { m_ExitEvent , m_NetworkEvent };

	DWORD	dwState;
	while( WSA_WAIT_EVENT_0 + 1 == ( dwState = WSAWaitForMultipleEvents( COUNTOF( evt ), evt, FALSE, WSA_INFINITE, TRUE ) ) )
	{
		DWORD	dwThreadID = GetCurrentThreadId();
		// lbg[NCxgʎo
		WSANETWORKEVENTS		NetEvent;
		ZeroMemory( &NetEvent , sizeof( NetEvent ) );
		WSAEnumNetworkEvents( m_Socket , m_NetworkEvent , &NetEvent );


		if( NetEvent.lNetworkEvents & FD_ACCEPT )
		{	OnAccept( NetEvent.iErrorCode[FD_ACCEPT_BIT] );				}
		if( NetEvent.lNetworkEvents & FD_CONNECT )
		{	OnConnect( NetEvent.iErrorCode[FD_CONNECT_BIT] );			}
		if( NetEvent.lNetworkEvents & FD_OOB )
		{	OnOOB( NetEvent.iErrorCode[FD_OOB_BIT] );					}
		if( NetEvent.lNetworkEvents & FD_QOS )
		{	OnQOS( NetEvent.iErrorCode[FD_QOS_BIT] );					}
		if( NetEvent.lNetworkEvents & FD_READ )
		{	OnReceive( NetEvent.iErrorCode[FD_READ_BIT] );				}
		if( NetEvent.lNetworkEvents & FD_WRITE )
		{	OnSend( NetEvent.iErrorCode[FD_WRITE_BIT] );				}
		if( NetEvent.lNetworkEvents & FD_CLOSE )
		{	OnClose( NetEvent.iErrorCode[FD_CLOSE_BIT] );				}
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::OnAccept
//   ABSTRACT : I[o[Ch
//   FUNCTION : Accept p
//////////////////////////////////////////////////////////////////////////////rrrrr
void CWS2Tcp::OnAccept( int nErrorCode )
{
	TRACE( "[%08X] CWS2Tcp::OnAccept()\n", GetCurrentThreadId() );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::OnClose
//   ABSTRACT : I[o[Ch
//   FUNCTION : Close p
//////////////////////////////////////////////////////////////////////////////
void CWS2Tcp::OnClose( int nErrorCode )
{
	TRACE( "[%08X] CWS2Tcp::OnClose()\n", GetCurrentThreadId() );

	Close();		// \Pbg܂
	// NX̎폜莞͍폜s܂
	if( m_bAutoDelete )
		delete this;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::OnConnect
//   ABSTRACT : I[o[Ch
//   FUNCTION : OnConnect p
//////////////////////////////////////////////////////////////////////////////
void CWS2Tcp::OnConnect( int nErrorCode )
{
	TRACE( "[%08X] CWS2Tcp::OnConnect()\n", GetCurrentThreadId() );

	m_ConnectState = ( nErrorCode == 0 );
	SetEvent( m_hConnectEvent );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::OnOOB
//   ABSTRACT : I[o[Ch
//   FUNCTION : OOB p
//////////////////////////////////////////////////////////////////////////////
void CWS2Tcp::OnOOB( int nErrorCode )
{
	TRACE( "[%08X] CWS2Tcp::OnOOB()\n", GetCurrentThreadId() );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::OnQOS
//   ABSTRACT : I[o[Ch
//   FUNCTION : QOS p
//////////////////////////////////////////////////////////////////////////////
void CWS2Tcp::OnQOS( int nErrorCode )
{
	TRACE( "[%08X] CWS2Tcp::OnQOS()\n", GetCurrentThreadId() );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::OnReceive
//   ABSTRACT : I[o[Ch
//   FUNCTION : f[^M p
//////////////////////////////////////////////////////////////////////////////
void CWS2Tcp::OnReceive( int nErrorCode )
{
	TRACE( "[%08X] CWS2Tcp::OnReceive()\n", GetCurrentThreadId() );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::OnSend
//   ABSTRACT : I[o[Ch
//   FUNCTION : f[^M p
//////////////////////////////////////////////////////////////////////////////
void CWS2Tcp::OnSend( int nErrorCode )
{
	TRACE( "[%08X] CWS2Tcp::OnSend()\n", GetCurrentThreadId() );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::GetSendBufSize
//   ABSTRACT : f[^Mp̃obt@̃TCYݒ肵܂
//   FUNCTION : f[^Mp̃obt@̃TCYݒ肵܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::GetSendBufSize( int* pSendBufSize )
{
	int nValue=0;
	int nLen;

	nLen = sizeof(nValue);

	// Mobt@̃TCYύXꂽmF
	if ( 0 != ::getsockopt( m_Socket, SOL_SOCKET, SO_SNDBUF, ( char FAR* )&nValue, ( int FAR* )&nLen ) )
	{
		return FALSE;
	}

	*pSendBufSize = nValue;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::SetSendBufSize
//   ABSTRACT : f[^Mp̃obt@̃TCYݒ肵܂
//   FUNCTION : f[^Mp̃obt@̃TCYݒ肵܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::SetSendBufSize( const int nSendBufSize )
{
	int nValue=0;
	int nLen;

	nLen = sizeof(nValue);

	// Mobt@̃TCYύX
	if ( 0 != ::setsockopt( m_Socket, SOL_SOCKET, SO_SNDBUF, ( const char FAR* )&nSendBufSize, sizeof( nSendBufSize ) ) )
	{
		return FALSE;
	}

	// Mobt@̃TCYύXꂽmF
	if ( 0 != ::getsockopt( m_Socket, SOL_SOCKET, SO_SNDBUF, ( char FAR* )&nValue, ( int FAR* )&nLen ) )
	{
		return FALSE;
	}

	if ( nSendBufSize != nValue )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::GetNoDelay
//   ABSTRACT : NagleASY̗L擾܂
//   FUNCTION : NagleASY̗L擾܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::GetNoDelay( BOOL* pEnable )
{
	BOOL bValue=FALSE;
	int nLen;

	nLen = sizeof(bValue);

	// Mobt@̃TCYύXꂽmF
	if ( 0 != ::getsockopt( m_Socket, IPPROTO_TCP, TCP_NODELAY, ( char FAR* )&bValue, ( int FAR* )&nLen ) )
	{
		return FALSE;
	}

	*pEnable = bValue;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2Tcp::SetNoDelay
//   ABSTRACT : NagleASY̗Lݒ肵܂
//   FUNCTION : NagleASY̗Lݒ肵܂
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2Tcp::SetNoDelay( const BOOL bEnable )
{
	BOOL bValue=FALSE;
	int nLen;

	nLen = sizeof(bValue);

	//  NagleASY̗LύX
	if ( 0 != ::setsockopt( m_Socket, IPPROTO_TCP, TCP_NODELAY, ( const char FAR* )&bEnable, sizeof( bEnable ) ) )
	{
		return FALSE;
	}

	// NagleASYύXꂽmF
	if ( 0 != ::getsockopt( m_Socket, IPPROTO_TCP, TCP_NODELAY, ( char FAR* )&bValue, ( int FAR* )&nLen ) )
	{
		return FALSE;
	}

	if ( bEnable != bValue )
	{
		return FALSE;
	}

	return TRUE;
}
