// WS2TcpCmd.cpp: CWS2TcpCmd NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "WS2TcpCmd.h"
#include "CmdBuffer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define	TAG01	0x00000001
#define	TAG02	0x00000002
#define	TAG03	0x00000004
#define	TAG04	0x00000008
#define	TAG05	0x00000010
#define	TAG06	0x00000020
#define	TAG07	0x00000040
#define	TAG08	0x00000080
#define	TAG09	0x00000100
#define	TAG10	0x00000200
#define	TAG11	0x00000400
#define	TAG12	0x00000800
#define	TAG13	0x00001000
#define	TAG14	0x00002000
#define	TAG15	0x00004000
#define	TAG16	0x00008000
#define	TAG17	0x00010000
#define	TAG18	0x00020000
#define	TAG19	0x00040000
#define	TAG20	0x00080000
#define	TAG21	0x00100000
#define	TAG22	0x00200000
#define	TAG23	0x00400000
#define	TAG24	0x00800000
#define	TAG25	0x01000000
#define	TAG26	0x02000000
#define	TAG27	0x04000000
#define	TAG28	0x08000000
#define	TAG29	0x10000000
#define	TAG30	0x20000000
#define	TAG31	0x40000000
#define	TAG32	0x80000000

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CWS2TcpCmd::CWS2TcpCmd()
{
	TRACE( "[%08X] CWS2TcpCmd::CWS2TcpCmd()\n", GetCurrentThreadId() );
	
	m_objRecvNpsData.Reset();
}

CWS2TcpCmd::~CWS2TcpCmd()
{
	TRACE( "[%08X] CWS2TcpCmd::~CWS2TcpCmd()\n", GetCurrentThreadId() );
	
	// Ǘ̈悩J
	::GetServerTcpCmd()->RemoveServerSock( this );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2TcpCmd::OnReceive
//   ABSTRACT : I[o[Ch
//   FUNCTION : f[^M p
//////////////////////////////////////////////////////////////////////////////
void CWS2TcpCmd::OnReceive( int nErrorCode )
{
	CWS2Tcp::OnReceive( nErrorCode );

	//TRACE( "[%08X] CWS2TcpCmd::OnReceive()\n", GetCurrentThreadId() );
	bool bLoop = true;
	int nRecvLen = 0;

	while ( true == bLoop )
	{
		nRecvLen = 0;

		switch ( m_objRecvNpsData.GetRecvStatus() )
		{
		case E_RECV_CMD_HEADER:		// R}hwb_[M

			nRecvLen = Receive(
							m_objRecvNpsData.GetPointer(),
							m_objRecvNpsData.GetRemainLengthOfHeader()
						);
			if ( 0 < nRecvLen )
			{
				m_objRecvNpsData.AddRemainLengthOfHeader( (WORD)nRecvLen );
			}

			break;

		case E_RECV_TAG_HEADER:		// ^Owb_M

			nRecvLen = Receive(
							m_objRecvNpsData.GetPointer(),
							m_objRecvNpsData.GetRemainLengthOfTagHeader()
						);
			if ( 0 < nRecvLen )
			{
				m_objRecvNpsData.AddRemainLengthOfTagHeader( (WORD)nRecvLen );
			}

			break;

		case E_RECV_TAG_VALUE:		// ^OlM

			nRecvLen = Receive(
							m_objRecvNpsData.GetPointer(),
							m_objRecvNpsData.GetRemainLengthOfTagValue()
						);
			if ( 0 < nRecvLen )
			{
				m_objRecvNpsData.AddRemainLengthOfTagValue( (WORD)nRecvLen );
			}

			break;

		case E_RECV_END:			// ^OMI

			CmdAnalyze();
			m_objRecvNpsData.Reset();

			bLoop = false;

			break;
		}

		if ( 0 >= nRecvLen )
		{
			bLoop = false;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::CmdAnalyze()
//	ABSTRACT : NPSR}h̉͂sAύXB
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.7.19
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CWS2TcpCmd::CmdAnalyze()
{
	TRACE( "Receive InterfaceId=%04XH wCommandId=%04XH\n",
			m_objRecvNpsData.GetInterfaceId(), m_objRecvNpsData.GetCommandId() );

	{	// Oo
		CString str;
		str.Format( "RECV ----> [%04X] [%04X]",
			m_objRecvNpsData.GetInterfaceId(), m_objRecvNpsData.GetCommandId() );
		NPS_LOGOUT( str );
	}
	
	BOOL bResult=FALSE;
	
	switch ( MAKELONG( m_objRecvNpsData.GetCommandId(), m_objRecvNpsData.GetInterfaceId() ) )
	{
	case 0x60000100:	bResult = RCmd_6000H_0100H();	break;
	case 0x60000200:	bResult = RCmd_6000H_0200H();	break;
	case 0x60000300:	bResult = RCmd_6000H_0300H();	break;
	case 0x60000400:	bResult = RCmd_6000H_0400H();	break;
	case 0x60000500:	bResult = RCmd_6000H_0500H();	break;
	case 0x60000600:	bResult = RCmd_6000H_0600H();	break;
	case 0x60000700:	bResult = RCmd_6000H_0700H();	break;
	case 0x60000800:	bResult = RCmd_6000H_0800H();	break;
	case 0x60000900:	bResult = RCmd_6000H_0900H();	break;
	case 0x60000A00:	bResult = RCmd_6000H_0A00H();	break;
	case 0x60000B00:	bResult = RCmd_6000H_0B00H();	break;
	case 0x60000C00:	bResult = RCmd_6000H_0C00H();	break;
	case 0x60000D00:	bResult = RCmd_6000H_0D00H();	break;
	case 0x60000E00:	bResult = RCmd_6000H_0E00H();	break;
	case 0x60000F00:	bResult = RCmd_6000H_0F00H();	break;
	case 0x60001000:	bResult = RCmd_6000H_1000H();	break;
	//case 0x60001100:	bResult = RCmd_6000H_1100H();	break;
	case 0x60001200:	bResult = RCmd_6000H_1200H();	break;
	case 0x60001300:	bResult = RCmd_6000H_1300H();	break;
	case 0x60001500:	bResult = RCmd_6000H_1500H();	break;
	case 0x60001600:	bResult = RCmd_6000H_1600H();	break;
	case 0x60001700:	bResult = RCmd_6000H_1700H();	break;
	case 0x60001800:	bResult = RCmd_6000H_1800H();	break;
	case 0x60001900:	bResult = RCmd_6000H_1900H();	break;
	case 0x60010100:	bResult = RCmd_6001H_0100H();	break;
	//case 0x60010200:	bResult = RCmd_6001H_0200H();	break;
	//case 0x60010300:	bResult = RCmd_6001H_0300H();	break;
	case 0x60010700:	bResult = RCmd_6001H_0700H();	break;
	case 0x60010A00:	bResult = RCmd_6001H_0A00H();	break;
	case 0x60010B00:	bResult = RCmd_6001H_0B00H();	break;
	case 0x60010C00:	bResult = RCmd_6001H_0C00H();	break;
	case 0x60010D00:	bResult = RCmd_6001H_0D00H();	break;
	case 0x60010E00:	bResult = RCmd_6001H_0E00H();	break;
	case 0x6001B004:	bResult = RCmd_6001H_B004H();	break;
	case 0x6001B006:	bResult = RCmd_6001H_B006H();	break;
	case 0x6001B008:	bResult = RCmd_6001H_B008H();	break;
	case 0x60027300:	bResult = RCmd_6002H_7300H();	break;
	case 0x60027304:	bResult = RCmd_6002H_7304H();	break;
	case 0x70034001:	bResult = RCmd_7003H_4001H();	break;
	default:			bResult = WCmd_6000H_FFFFH();	break;
	}
	
	return;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0100H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0101H()
//	ABSTRACT : v^{̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.7.19
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0100H()
{
	return WCmd_6000H_0101H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0101H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	USHORT aResolutions[8];
	char szValue[20];
	
	cBuffer.Empty();
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0101 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	@햼
		::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeName( szValue, sizeof(szValue) );
		cBuffer.AddTagChar( 2, szValue, ::lstrlen( szValue ) + 1 );
		
		// Tag 3	VAԍ
		::GetVirtualPrinter()->m_cPrinterInfo.GetSerialNumber( szValue, sizeof(szValue) );
		cBuffer.AddTagChar( 3, szValue, ::lstrlen( szValue ) + 1 );
		
		// Tag 4	𑜓x iPʁF0.1 dpij
		::GetVirtualPrinter()->m_cPrinterInfo.GetSupportResolutions( aResolutions );
		cBuffer.AddTagShort( 4, (short*)aResolutions, COUNTOF(aResolutions) );
		
		// Tag 5	@敪
		cBuffer.AddTagShort( 5, ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() );
		
		// Tag 6	\tgEFA	2006.10.18
		::GetVirtualPrinter()->m_cPrinterInfo.GetSoftName( szValue, sizeof(szValue) );
		cBuffer.AddTagChar( 6, szValue, ::lstrlen( szValue ) + 1 );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0200H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0201H()
//	ABSTRACT : v^ݒ̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0200H()
{
	return WCmd_6000H_0201H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0201H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	USHORT aDate[3];
	USHORT aDateTime[8];
	USHORT aPaperTypeCode[6];
	UCHAR aSupport[32];
	char szValue[128];
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0201 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	v^̃e (PʁFByte)
		cBuffer.AddTagLong( 2, ::GetVirtualPrinter()->m_cPrinterConfig.GetTotalMemory() );
		
		// Tag 3	t摜̍̕ŏTCY iPʁFPixelj
		cBuffer.AddTagLong( 3, ::GetVirtualPrinter()->m_cPrinterConfig.GetImageSizeMinWidth() );
		
		// Tag 4	t摜̍̍ŏTCY iPʁFPixelj
		cBuffer.AddTagLong( 4, ::GetVirtualPrinter()->m_cPrinterConfig.GetImageSizeMinHeight() );
		
		// Tag 5	t摜̍̕őTCY iPʁFPixelj
		cBuffer.AddTagLong( 5, ::GetVirtualPrinter()->m_cPrinterConfig.GetImageSizeMaxWidth() );
		
		// Tag 6	t摜̍̍őTCY iPʁFPixelj
		cBuffer.AddTagLong( 6, ::GetVirtualPrinter()->m_cPrinterConfig.GetImageSizeMaxHeight() );
		
		// Tag 7	U\ȃ}KW
		cBuffer.AddTagShort( 7, ::GetVirtualPrinter()->m_cPrinterConfig.GetNumberOfMagazine() );
		
		// Tag 8	v^̓
		::GetVirtualPrinter()->m_cPrinterConfig.GetPrinterTime( aDateTime );
		cBuffer.AddTagShort( 8, (short*)aDateTime, COUNTOF(aDateTime) );
		
		// Tag 9	ő僊s[g
		cBuffer.AddTagLong( 9, ::GetVirtualPrinter()->m_cPrinterConfig.GetRepeatCountMax() );
		
		// Tag 10	T|[g摜
		::GetVirtualPrinter()->m_cPrinterConfig.GetSupportImageFormat( aSupport );
		cBuffer.AddTagChar( 10, (char*)aSupport, COUNTOF(aSupport) );
		
		// Tag 11	~l[^[jbg̑
		cBuffer.AddTagChar( 11, ::GetVirtualPrinter()->m_cPrinterConfig.GetLaminatorUnitAttach() );
		
		// Tag 13	ݒu
		::GetVirtualPrinter()->m_cPrinterConfig.GetInstallationDate( aDate );
		cBuffer.AddTagShort( 13, (short*)aDate, COUNTOF(aDate) );
		
		// Tag 14	ғJn
		::GetVirtualPrinter()->m_cPrinterConfig.GetOperationStartDate( aDate );
		cBuffer.AddTagShort( 14, (short*)aDate, COUNTOF(aDate) );
		
		// Tag 15	vZT[ ivZT[ʁj
		cBuffer.AddTagShort( 15, ::GetVirtualPrinter()->m_cPrinterConfig.GetProcessorType() );
		
		// Tag 16	[ ij
		cBuffer.AddTagShort( 16, ::GetVirtualPrinter()->m_cPrinterConfig.GetEmulsionNumber() );
		
		// Tag 17	[U[`̃v^
		::GetVirtualPrinter()->m_cPrinterConfig.GetPrinterNickname( szValue, sizeof(szValue) );
		cBuffer.AddTagChar( 17, szValue, ::lstrlen( szValue ) + 1 );
		
		// Tag 18	T|[g]px
		cBuffer.AddTagShort( 18, ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportAngle() );
		
		// Tag 19	L
		cBuffer.AddTagShort( 19, ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportIntoPrinter() );
		
		// Tag 20	ڃvgΉ
		cBuffer.AddTagShort( 20, ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportLongPaper() );
		
		// Tag 21	\[^[̃gC̐
		cBuffer.AddTagChar( 21, ::GetVirtualPrinter()->m_cPrinterConfig.GetSorterStatus() );
		
		// Tag 23	CVP󎚍s
		cBuffer.AddTagChar( 23, ::GetVirtualPrinter()->m_cPrinterConfig.GetCvpStatus() );
		
		// Tag 24	T|[gy[p[tBbeBO
		cBuffer.AddTagShort( 24, ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportPaperFitting() );
		
		// Tag 25	T|[gGbW
		cBuffer.AddTagShort( 25, ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportEdgeEnhancement() );
		
		// Tag 26	T|[gCMS
		cBuffer.AddTagShort( 26, ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportCMS() );
		
		// Tag 27	T|[g
		cBuffer.AddTagShort( 27, ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportWithBorder() );
		
		// Tag 28	vt@Cp̋@R[h
		cBuffer.AddTagShort( 28, ::GetVirtualPrinter()->m_cPrinterConfig.GetMachinTypeForProfile() );
		
		// Tag29	vt@Co[W
		::GetVirtualPrinter()->m_cPrinterConfig.GetMachinProfileVersion( szValue, sizeof(szValue) );
		cBuffer.AddTagChar( 29, szValue, ::lstrlen( szValue ) + 1 );
		
		// Tag30	y[p[^CvR[h
		::GetVirtualPrinter()->m_cPrinterConfig.GetPaperTypeCode( aPaperTypeCode );
		cBuffer.AddTagShort( 30, (short*)aPaperTypeCode, COUNTOF(aPaperTypeCode) );

		// Tag31	OEMR[h
		cBuffer.AddTagChar( 31, ::GetVirtualPrinter()->m_cPrinterConfig.GetOemCode() );

		// Tag32	ZbgAbvASY
		cBuffer.AddTagShort( 32, ::GetVirtualPrinter()->m_cPrinterConfig.GetSetupAlgorithm() );

		// Tag33	T|[gʈ
		cBuffer.AddTagShort( 33, ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportDoubleSided() );

		// Tag34	FADڑԍ
		cBuffer.AddTagLong( 34, ::GetVirtualPrinter()->m_cPrinterConfig.GetFadAttachNo() );

		// Tag35	f
		cBuffer.AddTagShort( 35, ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportInterrupt() );
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0300H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0301H()
//	ABSTRACT : v^Ԃ̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0300H()
{
	return WCmd_6000H_0301H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0301H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0301 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	v^Ŝ̏ iv^S̏ԁj
		cBuffer.AddTagChar( 2, ::GetVirtualPrinter()->m_cPrinterState.GetPrinterStatus() );
		
		// Tag 3	t
		cBuffer.AddTagChar( 3, ::GetVirtualPrinter()->m_cPrinterState.GetAcceptStatus() );
		
		// Tag 4	v^L̏
		cBuffer.AddTagChar( 4, ::GetVirtualPrinter()->m_cPrinterState.GetPrinterPossession() );
		
		if ( 1 != ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
		{
			// Tag 5	v^Ŝ̏ inŚj
			cBuffer.AddTagChar( 5, ::GetVirtualPrinter()->m_cPrinterState.GetAdvanceStatus() );
			
			// Tag 6	w[U[̏ iw[U[j
			cBuffer.AddTagChar( 6, ::GetVirtualPrinter()->m_cPrinterState.GetLaserStatus() );
			
			// Tag 7	vZT[Ŝ̏ inŚj
			cBuffer.AddTagChar( 7, ::GetVirtualPrinter()->m_cPrinterState.GetDevelopmentStatus() );
			
			// Tag 8	̏ ij
			cBuffer.AddTagChar( 8, ::GetVirtualPrinter()->m_cPrinterState.GetProcessorStatus() );
			
			// Tag 9	[Ŝ̏ i[j
			cBuffer.AddTagChar( 9, ::GetVirtualPrinter()->m_cPrinterState.GetReplenisherStatus() );
			
			// Tag 10	[J[gbW̌̉ i[J[gbWj
			cBuffer.AddTagChar( 10, ::GetVirtualPrinter()->m_cPrinterState.GetReplaceCartridgeStatus() );
		}
		
		// Tag 11	nƓ_̎{
		cBuffer.AddTagChar( 11, ::GetVirtualPrinter()->m_cPrinterState.GetStartUpChecksStatus() );
		
		if ( 1 != ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
		{
			// Tag 12	I[gZbgAbvł̕␅̎{
			cBuffer.AddTagChar( 12, ::GetVirtualPrinter()->m_cPrinterState.GetRefillWaterStatus() );
			
			// Tag 13	I[gZbgAbvł̃fC[ZbgAbv̎{
			cBuffer.AddTagChar( 13, ::GetVirtualPrinter()->m_cPrinterState.GetDailySetupStatus() );
			
			// Tag 14	I[gZbgAbvł̃Rg[Xgbv̎{
			cBuffer.AddTagChar( 14, ::GetVirtualPrinter()->m_cPrinterState.GetControlStripStatus() );
			
			// Tag 15	eiX
			cBuffer.AddTagChar( 15, ::GetVirtualPrinter()->GetIsMaintenance()+1 );
		}

		if ( 0 != ::GetVirtualPrinter()->m_cPrinterConfig.GetFadAttachNo() )
		{
			// Tag 16	FAD̏
			cBuffer.AddTagChar( 16, ::GetVirtualPrinter()->m_cPrinterState.GetFadStatus() );
		}
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0400H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0401H()
//	ABSTRACT : y[p[̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0400H()
{
	return WCmd_6000H_0401H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0401H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	int nIndex1;
	T_MagInstInfo stMagInfo;
	USHORT nPaperCount=0;
	USHORT aPaperWidth[64];
	USHORT aPaperId[64];
	ULONG  aPaperRemaind[64];
	UCHAR  aPaperFeed[64];
	UCHAR  aPaperPresence[64];
	CHAR   aPaperName[2048];
	DWORD  nPaperNameLen=0;
	
	for ( nIndex1=0 ; ::GetVirtualPrinter()->m_cPrinterConfig.GetNumberOfMagazine() > nIndex1 ; nIndex1++ )
	{
		if ( TRUE == ::GetVirtualPrinter()->m_cPaperInfo.GetMagInstInfo( nIndex1, &stMagInfo ) ) {
			aPaperWidth[nPaperCount]			= stMagInfo.nPaperWidth;
			aPaperId[nPaperCount]				= stMagInfo.nPaperId;
			aPaperRemaind[nPaperCount]			= stMagInfo.nPaperRemaind;
			aPaperFeed[nPaperCount]				= stMagInfo.nPaperFeed;
			aPaperPresence[nPaperCount]			= stMagInfo.nPaperPresence;
			::lstrcpy( &aPaperName[nPaperNameLen], stMagInfo.szPaperName );
			nPaperNameLen += strlen( stMagInfo.szPaperName ) + 1;
			nPaperCount++;
		}
	}
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0401 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag	2	擾y[p[ڍ׏̐
		cBuffer.AddTagShort( 2, nPaperCount );
		
		// Tag	3	y[p[̕
		cBuffer.AddTagShort( 3, (short*)aPaperWidth, nPaperCount );
		
		// Tag	4	y[p[̑蒷̍ŏl
		//		cBuffer.AddTagShort( 4, (short*)aPaperLengthMin, nPaperCount );
		
		// Tag	5	y[p[̑蒷̍ől
		//		cBuffer.AddTagShort( 5, (short*)aPaperLengthMax, nPaperCount );
		
		// Tag	6	y[p[ID iʎj
		cBuffer.AddTagShort( 6, (short*)aPaperId, nPaperCount );
		
		// Tag	7	͉𑜓x
		//		cBuffer.AddTagShort( 7, (short*)aPaperResolution, nPaperCount * 8 );
		
		// Tag	8	XsI[o[㕔
		//		cBuffer.AddTagShort( 8, (short*)aPaperSpilloverTop, nPaperCount );
		
		// Tag	9	XsI[o[
		//		cBuffer.AddTagShort( 9, (short*)aPaperSpilloverBottom, nPaperCount );
		
		// Tag	10	XsI[o[
		//		cBuffer.AddTagShort( 10, (short*)aPaperSpilloverLeft, nPaperCount );
		
		// Tag	11	XsI[o[E
		//		cBuffer.AddTagShort( 11, (short*)aPaperSpilloverRight, nPaperCount );
		
		// Tag	12	y[p[c
		cBuffer.AddTagLong( 12, (long*)aPaperRemaind, nPaperCount );
		
		// Tag	13	@
		cBuffer.AddTagChar( 13, (char*)aPaperFeed, nPaperCount );
		
		// Tag	14	U
		cBuffer.AddTagChar( 14, (char*)aPaperPresence, nPaperCount );
		
		// Tag	15	y[p[^Cv
		//		cBuffer.AddTagChar( 15, (char*)aPaperType, nPaperCount );
		
		// Tag	16	y[p[ʎ
		//		cBuffer.AddTagChar( 16, (char*)aPaperKind, nPaperCount );
		
		// Tag	17	}KWID
		//		cBuffer.AddTagChar( 17, (char*)aMagazineID, nPaperCount );
		
		// Tag	18	WB␳l
		//		cBuffer.AddTagShort( 18, (short*)aWBAdjustLeft, nPaperCount );
		
		// Tag	19	WB␳lE
		//		cBuffer.AddTagShort( 19, (short*)aWBAdjustRight, nPaperCount );
		
		// Tag	20	y[p[
		cBuffer.AddTagChar( 20, (char*)aPaperName, nPaperNameLen );
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0500H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0501H()
//	ABSTRACT : v^LJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : M.Yamamoto 2014.10.30 gIvV(Pvg)
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0500H()
{
	WORD wPort=0;
	WORD wPossessionMode=0;
	WORD wInterruptMode=0;
	WORD wPossessionNo=0;
	DWORD dwExOptions=0;
	UCHAR IsMaintenance = 0;
	ULONG nParamChk=0;
	USHORT nResult=1;	// `G[

	// Tag 1	摜Mp̃|[gԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPort = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;

		{	// Oo
			CString str;
			str.Format( "             ImgPort=%u", wPort );
			NPS_LOGOUT( str );
		}
	}

	// Tag 2	L[h
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 2 ) )
	{
		wPossessionMode = m_objRecvNpsData.GetTagValueInt16( 2 );
		nParamChk |= TAG02;
	}

	// Tag 3	荞݃[h
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 3 ) )
	{
		wInterruptMode = m_objRecvNpsData.GetTagValueInt16( 3 );
		nParamChk |= TAG03;
	}

	// Tag 4	eiX
	if ( 1 == m_objRecvNpsData.GetLengthOfTagValue( 4 ) )
	{
		IsMaintenance = m_objRecvNpsData.GetTagValueInt8( 4 );
		nParamChk |= TAG04;
	}

	// Tag 5	Lԍ
	// @@@RD-151Ή	2012.02.16	T.Mizushima
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 5 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 5 );
		nParamChk |= TAG05;
	}

	// Tag 6	gIvV
	// gIvV(Pvg) 2014.10.30 M.Yamamoto
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 6 ) )
	{
		dwExOptions = m_objRecvNpsData.GetTagValueInt32( 6 );
		nParamChk |= TAG06;
	}

	// p[^̊mF
	if ( 2 != ::GetVirtualPrinter()->m_cPrinterState.GetAcceptStatus() )
	{	// ts
		nResult = 18;	// tsԂł
	}
	else if( ( nParamChk & TAG05 ) &&
			 ( wPossessionNo != 0 ) &&
			 ( TRUE != ::GetVirtualPrinter()->IsWarikomiPossessionNo( wPossessionNo ) ) )
	{	// w肳ꂽLԍ荞܂ꂽLԍ̗ɖ		@@@RD-151Ή	2012.02.16	T.Mizushima
		nResult = 1;	// `G[
	}
	else if (( nParamChk & TAG01 ) && ( wPort != 0 ))
	{
		
		if (( 0 != wPossessionMode ) && ( 0 == ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportIntoPrinter() ))
		{
			nResult = 31;	// w肳ꂽL[h̓T|[gĂ܂
		}
		else if ( TRUE == ::GetVirtualPrinter()->SetPossessionState( wPossessionMode, wInterruptMode, wPort, &wPossessionNo, this, IsMaintenance ) ) {
			nResult = 0;
		} else {
			nResult = 8;		// v^͑̃AvLĂ܂
		}
		
	}

	return WCmd_6000H_0501H( nResult, wPossessionNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0501H( USHORT nResult, USHORT nPossessionNo )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0501 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0600H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0601H()
//	ABSTRACT : v^LI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0600H()
{
	WORD wPossessionNo=0;
	USHORT nResult=1;	// `G[
	ULONG  nParamChk=0;

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}

	// p[^̊mF
	if ( nParamChk & TAG01 ) {
		
		if ( wPossessionNo == ::GetVirtualPrinter()->GetPossessionNo() ) {
			
			::GetVirtualPrinter()->ResetPossession();
			::GetVirtualPrinter()->m_cPrintQue.DisableDuplex();
			nResult = 0;
			
		} else {
			
			if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( wPossessionNo ) )
			{
				if( ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportInterrupt() == 2 )
				{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.15	T.Mizushima
					::GetVirtualPrinter()->DeleteWarikomiPossessionNo( wPossessionNo );
					nResult = 0;	// Ƃĉ
				}
				else
				{
					nResult = 27;	// v^Lf܂		2006.10.31 T.Mizushima	wE59
				}
			}
			else
			{
				nResult = 9;		// v^̐LsĂ܂
			}
			
		}
		
	}
	
	return WCmd_6000H_0601H( nResult, wPossessionNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0601H( USHORT nResult, USHORT nPossessionNo )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0601 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0700H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0701H()
//	ABSTRACT : tJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0700H()
{
	USHORT nResult=1;	// `G[
	CFrame cFrame;
	ULONG  nParamChk=0;
	CString strLogWork;
	CString strLogParam1;
	CString strLogParam2;
	CString strLogCvp1 = _T( "CVP1 " );
	CString strLogCvp2 = _T( "CVP2 " );

	// tԍ̍̔
	cFrame.NumberingReceiptNo();

	// \Pbg̓o^
	cFrame.SetSock( this );

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		cFrame.SetPossessionNo( m_objRecvNpsData.GetTagValueInt16( 1 ) );
		nParamChk |= TAG01;

		strLogWork.Format( "PossessionNo=%d, ", cFrame.GetPossessionNo() );
		strLogParam1 += strLogWork;
	}

	// Tag 2	摜e iPʁFBytej
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 2 ) )
	{
		cFrame.SetImageCapacity( m_objRecvNpsData.GetTagValueInt32( 2 ) );
		nParamChk |= TAG02;

		strLogWork.Format( "ImageCapacity=%d, ", cFrame.GetImageCapacity() );
		strLogParam1 += strLogWork;
	}

	// Tag 3	摜tH[}bg
	if ( 1 == m_objRecvNpsData.GetLengthOfTagValue( 3 ) )
	{
		cFrame.SetImageFormat( m_objRecvNpsData.GetTagValueInt8( 3 ) );
		nParamChk |= TAG03;

		strLogWork.Format( "ImageFormat=%d, ", cFrame.GetImageFormat() );
		strLogParam1 += strLogWork;
	}

	// Tag 4	摜̕ iPʁFPixelj
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 4 ) )
	{
		cFrame.SetImageWidth( m_objRecvNpsData.GetTagValueInt16( 4 ) );
		nParamChk |= TAG04;

		strLogWork.Format( "ImageWidth=%d, ", cFrame.GetImageWidth() );
		strLogParam1 += strLogWork;
	}

	// Tag 5	摜̍ iPʁFPixelj
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 5 ) )
	{
		cFrame.SetImageHeight( m_objRecvNpsData.GetTagValueInt16( 5 ) );
		nParamChk |= TAG05;

		strLogWork.Format( "ImageHeight=%d, ", cFrame.GetImageHeight() );
		strLogParam1 += strLogWork;
	}

	// Tag 6	͉𑜓x iPʁF0.1dpij
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 6 ) )
	{
		cFrame.SetPaperResolution( m_objRecvNpsData.GetTagValueInt16( 6 ) );
		nParamChk |= TAG06;

		strLogWork.Format( "Resolution=%d, ", cFrame.GetPaperResolution() );
		strLogParam1 += strLogWork;
	}

	// Tag 7	y[p[̕ iPʁF0.1mmj
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 7 ) )
	{
		cFrame.SetPaperWidth( m_objRecvNpsData.GetTagValueInt16( 7 ) );
		nParamChk |= TAG07;

		strLogWork.Format( "PaperWidth=%d, ", cFrame.GetPaperWidth() );
		strLogParam1 += strLogWork;
	}

	// Tag 8	y[p[̑蒷 iPʁF0.1mmj
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 8 ) )
	{
		cFrame.SetPaperLength( m_objRecvNpsData.GetTagValueInt16( 8 ) );
		nParamChk |= TAG08;

		strLogWork.Format( "PaperLength=%d, ", cFrame.GetPaperLength() );
		strLogParam1 += strLogWork;
	}

	// Tag 9	y[p[ID
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 9 ) )
	{
		cFrame.SetPaperID( m_objRecvNpsData.GetTagValueInt16( 9 ) );
		nParamChk |= TAG09;

		strLogWork.Format( "PaperID=%d, ", cFrame.GetPaperID() );
		strLogParam1 += strLogWork;
	}

	// Tag 10	s[g
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 10 ) )
	{
		cFrame.SetRepeat( m_objRecvNpsData.GetTagValueInt16( 10 ) );
		nParamChk |= TAG10;

		strLogWork.Format( "Repeat=%d, ", cFrame.GetRepeat() );
		strLogParam1 += strLogWork;
	}

	// Tag 11	@
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 11 ) )
	{
		cFrame.SetPaperFeed( m_objRecvNpsData.GetTagValueInt16( 11 ) );
		nParamChk |= TAG11;

		strLogWork.Format( "PaperFeed=%d, ", cFrame.GetPaperFeed() );
		strLogParam1 += strLogWork;
	}

	// Tag 12	~l[g
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 12 ) )
	{
		cFrame.SetLaminator( m_objRecvNpsData.GetTagValueInt16( 12 ) );
		nParamChk |= TAG12;

		strLogWork.Format( "Lami=%d, ", cFrame.GetLaminator() );
		strLogParam2 += strLogWork;
	}

	// Tag 13	CVP1sڂ̒ʂԍ̏l
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 13 ) )
	{
		cFrame.SetCvpInitialValue1( m_objRecvNpsData.GetTagValueInt16( 13 ) );
		nParamChk |= TAG13;

		strLogWork.Format( "Init=%d, ", cFrame.GetCvpInitialValue1() );
		strLogCvp1 += strLogWork;
	}

	// Tag 14	CVP1sڂ̒ʂԍ}ʒu
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 14 ) )
	{
		cFrame.SetCvpPoint1( m_objRecvNpsData.GetTagValueInt16( 14 ) );
		nParamChk |= TAG14;

		strLogWork.Format( "Point=%d, ", cFrame.GetCvpPoint1() );
		strLogCvp1 += strLogWork;
	}

	// Tag 15	CVP1sڂ̒ʂԍ󎚂錅
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 15 ) )
	{
		cFrame.SetCvpInitialWidth1( m_objRecvNpsData.GetTagValueInt16( 15 ) );
		nParamChk |= TAG15;

		strLogWork.Format( "Width=%d, ", cFrame.GetCvpInitialWidth1() );
		strLogCvp1 += strLogWork;
	}

	// Tag 16	CVP2sڂ̒ʂԍ̏l
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 16 ) )
	{
		cFrame.SetCvpInitialValue2( m_objRecvNpsData.GetTagValueInt16( 16 ) );
		nParamChk |= TAG16;

		strLogWork.Format( "Init=%d, ", cFrame.GetCvpInitialValue2() );
		strLogCvp2 += strLogWork;
	}

	// Tag 17	CVP2sڂ̒ʂԍ}ʒu
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 17 ) )
	{
		cFrame.SetCvpPoint2( m_objRecvNpsData.GetTagValueInt16( 17 ) );
		nParamChk |= TAG17;

		strLogWork.Format( "Point=%d, ", cFrame.GetCvpPoint2() );
		strLogCvp2 += strLogWork;
	}

	// Tag 18	CVP2sڂ̒ʂԍ󎚂錅
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 18 ) )
	{
		cFrame.SetCvpInitialWidth2( m_objRecvNpsData.GetTagValueInt16( 18 ) );
		nParamChk |= TAG18;

		strLogWork.Format( "Width=%d, ", cFrame.GetCvpInitialWidth2() );
		strLogCvp2 += strLogWork;
	}

	// Tag 19	CVP1s
	if ( 0 < m_objRecvNpsData.GetLengthOfTagValue( 19 ) )
	{
		cFrame.SetCvpLine1( m_objRecvNpsData.GetTagValueString( 19 ) );
		nParamChk |= TAG19;

		strLogWork.Format( "Str=\"%s\", ", cFrame.GetCvpLine1() );
		strLogCvp1 += strLogWork;
	}

	// Tag 20	CVP2s
	if ( 0 < m_objRecvNpsData.GetLengthOfTagValue( 20 ) )
	{
		cFrame.SetCvpLine2( m_objRecvNpsData.GetTagValueString( 20 ) );
		nParamChk |= TAG20;

		strLogWork.Format( "Str=\"%s\", ", cFrame.GetCvpLine2() );
		strLogCvp2 += strLogWork;
	}

	// Tag 21	]px
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 21 ) )
	{
		cFrame.SetAngle( m_objRecvNpsData.GetTagValueInt16( 21 ) );
		nParamChk |= TAG21;

		strLogWork.Format( "Angle=%d, ", cFrame.GetAngle() );
		strLogParam2 += strLogWork;
	}

	// Tag 22	Uy[p[w
	if ( 1 == m_objRecvNpsData.GetLengthOfTagValue( 22) )
	{
		cFrame.SetPaperPresence( m_objRecvNpsData.GetTagValueInt8( 22 ) );
		nParamChk |= TAG22;

		strLogWork.Format( "PaperPresence=%d, ", cFrame.GetPaperPresence() );
		strLogParam2 += strLogWork;
	}

	// Tag 23	IJnʒu␳ iPʁF0.1mmj
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 23 ) )
	{
		cFrame.SetEspc( (INT16)m_objRecvNpsData.GetTagValueInt16( 23 ) );
		nParamChk |= TAG23;

		strLogWork.Format( "Espc=%d, ", cFrame.GetEspc() );
		strLogParam2 += strLogWork;
	}

	// Tag 24	MgC
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 24 ) )
	{
		cFrame.SetRetry( (INT16)m_objRecvNpsData.GetTagValueInt16( 24 ) );
		nParamChk |= TAG24;

		strLogWork.Format( "Retry=%d, ", cFrame.GetRetry() );
		strLogParam2 += strLogWork;
	}

	// Tag 25	I[_[ʔԍ
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 25 ) )
	{
		cFrame.SetOrderId( m_objRecvNpsData.GetTagValueInt32( 25 ) );
		nParamChk |= TAG25;

		strLogWork.Format( "OrderId=%d, ", cFrame.GetOrderId() );
		strLogParam2 += strLogWork;
	}

	// Tag 26	y[p[tBbeBO
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 26 ) )
	{
		cFrame.SetPaperFitting( m_objRecvNpsData.GetTagValueInt16( 26 ) );
		nParamChk |= TAG26;

		strLogWork.Format( "PaperFitting=%d, ", cFrame.GetPaperFitting() );
		strLogParam2 += strLogWork;
	}

	// Tag 27	GbW
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 27 ) )
	{
		cFrame.SetEdgeEnhancement( m_objRecvNpsData.GetTagValueInt16( 27 ) );
		nParamChk |= TAG27;

		strLogWork.Format( "Edge=%d, ", cFrame.GetEdgeEnhancement() );
		strLogParam2 += strLogWork;
	}

	// Tag 28	CMS
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 28 ) )
	{
		cFrame.SetCMS( m_objRecvNpsData.GetTagValueInt16( 28 ) );
		nParamChk |= TAG28;

		strLogWork.Format( "CMS=%d, ", cFrame.GetCMS() );
		strLogParam2 += strLogWork;
	}

	// Tag 29	㕔
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 29 ) )
	{
		cFrame.SetWithBorderTop( m_objRecvNpsData.GetTagValueInt16( 29 ) );
		nParamChk |= TAG29;

		strLogWork.Format( "WBTop=%d, ", cFrame.GetWithBorderTop() );
		strLogParam2 += strLogWork;
	}

	// Tag 30	
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 30 ) )
	{
		cFrame.SetWithBorderBottom( m_objRecvNpsData.GetTagValueInt16( 30 ) );
		nParamChk |= TAG30;

		strLogWork.Format( "WBBottom=%d, ", cFrame.GetWithBorderBottom() );
		strLogParam2 += strLogWork;
	}

	// Tag 31	
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 31 ) )
	{
		cFrame.SetWithBorderLeft( m_objRecvNpsData.GetTagValueInt16( 31 ) );
		nParamChk |= TAG31;

		strLogWork.Format( "WBLeft=%d, ", cFrame.GetWithBorderLeft() );
		strLogParam2 += strLogWork;
	}

	// Tag 32	E
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 32 ) )
	{
		cFrame.SetWithBorderRight( m_objRecvNpsData.GetTagValueInt16( 32 ) );
		nParamChk |= TAG32;

		strLogWork.Format( "WBRight=%d, ", cFrame.GetWithBorderRight() );
		strLogParam2 += strLogWork;
	}

	// Tag 33	̐F
	if ( 3 == m_objRecvNpsData.GetLengthOfTagValue( 33 ) )
	{
		UCHAR szWithBorderColor[3] = { 0 };

		szWithBorderColor[0] = m_objRecvNpsData.GetTagValueInt8( 33, 0 );
		szWithBorderColor[1] = m_objRecvNpsData.GetTagValueInt8( 33, 1 );
		szWithBorderColor[2] = m_objRecvNpsData.GetTagValueInt8( 33, 2 );
		cFrame.SetWithBorderColor( szWithBorderColor );

		strLogWork.Format( "WBColor=[%u][%u][%u], ", (UCHAR)szWithBorderColor[0], (UCHAR)szWithBorderColor[1], (UCHAR)szWithBorderColor[2] );
		strLogParam2 += strLogWork;
	}

	// Tag 34	y[p[
	if ( 0 < m_objRecvNpsData.GetLengthOfTagValue( 34 ) )
	{
		cFrame.SetPaperName( m_objRecvNpsData.GetTagValueString( 34 ) );

		strLogWork.Format( "PaperName=\"%s\", ", cFrame.GetPaperName() );
		strLogParam1 += strLogWork;
	}

	// Tag 35	呖vgZ^[ʒuItZbgl
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 35 ) )
	{
		cFrame.SetPrintCenterOffset( (INT16)m_objRecvNpsData.GetTagValueInt16( 35 ) );

		strLogWork.Format( "CenterOffset=%d, ", cFrame.GetPrintCenterOffset() );
		strLogParam2 += strLogWork;
	}

	// Tag 36	CVP󎚃TCY
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 36 ) )
	{
		cFrame.SetCvpPrintSize( m_objRecvNpsData.GetTagValueInt16( 36 ) );

		strLogWork.Format( "CvpPrintSize=%d, ", cFrame.GetCvpPrintSize() );
		strLogParam2 += strLogWork;
	}

	// Tag 37	@
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 37 ) )
	{
		cFrame.SetPrintQuality( m_objRecvNpsData.GetTagValueInt16( 37 ) );

		strLogWork.Format( "PrintQuality=%d, ", cFrame.GetPrintQuality() );
		strLogParam2 += strLogWork;
	}

	// Tag 38	摜gASY
	if ( 1 == m_objRecvNpsData.GetLengthOfTagValue( 38 ) )
	{
		cFrame.SetImageEnLargeType( m_objRecvNpsData.GetTagValueInt8( 38 ) );

		strLogWork.Format( "ImageEnLargeType=%d, ", cFrame.GetImageEnLargeType() );
		strLogParam2 += strLogWork;
	}

	// Tag 39	[fBOJn
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 39 ) )
	{
		cFrame.SetLoadingCount( m_objRecvNpsData.GetTagValueInt16( 39 ) );

		strLogWork.Format( "LoadingCount=%d, ", cFrame.GetLoadingCount() );
		strLogParam2 += strLogWork;
	}

	// Tag 40	roJn
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 40 ) )
	{
		cFrame.SetPrintedCount( m_objRecvNpsData.GetTagValueInt16( 40 ) );

		strLogWork.Format( "PrintedCount=%d, ", cFrame.GetPrintedCount() );
		strLogParam2 += strLogWork;
	}

	// Tag 41	Cxgʎq
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 41 ) )
	{
		cFrame.SetEventId( m_objRecvNpsData.GetTagValueInt32( 41 ) );

		strLogWork.Format( "EventId=%ld, ", cFrame.GetEventId() );
		strLogParam2 += strLogWork;
	}

	// Tag 42	CxgR[hiԁj
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 42 ) )
	{
		cFrame.SetEventCodeMain( m_objRecvNpsData.GetTagValueInt16( 42 ) );

		strLogWork.Format( "EventCodeMain=%ld, ", cFrame.GetEventCodeMain() );
		strLogParam2 += strLogWork;
	}

	{	// Oo
		CString str;
		str.Format( "             %s", strLogParam1 );
		NPS_LOGOUT( str );
		str.Format( "             %s", strLogParam2 );
		NPS_LOGOUT( str );
		str.Format( "             %s", strLogCvp1 );
		NPS_LOGOUT( str );
		str.Format( "             %s", strLogCvp2 );
		NPS_LOGOUT( str );
	}

	if ( TRUE == ::GetVirtualPrinter()->m_cPrintQue.IsEnableDuplex() )
	{
		// ʈ̎
		cFrame.SetDuplexSeqNo( ::GetVirtualPrinter()->m_cPrintQue.GetDuplexSeqNo() );
	}

	// p[^̊mF
	if ( nParamChk & ( TAG01 | TAG02 | TAG03 | TAG04 | TAG05 | TAG06 | TAG07 | TAG08 | TAG09 | TAG24 | TAG25 ) )
	{
		if( ::GetVirtualPrinter()->GetPossessionNo() != cFrame.GetPossessionNo() )
		{	// LԍقȂ		2006.10.31 T.Mizushima	wE59
			if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( cFrame.GetPossessionNo() ) )
			{
				nResult = 27;	// v^Lf܂
			}
			else
			{
				nResult = 9;	// v^̐LsĂ܂
			}
		}
		else if ( 2 != ::GetVirtualPrinter()->m_cPrinterState.GetAcceptStatus() )
		{	// ts
			nResult = 18;	// tsԂł
		}
		// 2006.09.29 T.Mizushima
		else if(::GetVirtualPrinter()->m_cPrinterState.GetMemoryStatus() == 2)
		{	// v^t
			nResult = 13;	// Xv[̈̋󂫗eʂ܂
		}
		else if ( 0 == cFrame.GetPaperLength() )
		{
			// 荇A蒷̎w肪0̏ꍇ̂݃G[ŕԂ 2007.03.08 Y.Yoshinobu
			nResult = 17;
		}
		else if ( TRUE == ::GetVirtualPrinter()->m_cPrintQue.ReciveStartFrame( &cFrame ) )
		{
			::GetVirtualPrinter()->m_cPrintQue.IncrementDuplexSeqNo();
			nResult = 0;
		}
		
	}
	
	return WCmd_6000H_0701H( nResult, cFrame.GetPossessionNo(), cFrame.GetReceiptNo() );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0701H( USHORT nResult, USHORT nPossessionNo, ULONG nReceiptNo )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0701 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if (( 0 == nResult ) ||
		(( 13 == nResult ) && ( 1 != ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() ))) {
		
		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );
		
		// Tag 3	tԍ
		cBuffer.AddTagLong( 3, nReceiptNo );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0800H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0801H()
//	ABSTRACT : 摜MmF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0800H()
{
	int nPos;
	WORD wPossessionNo=0;
	DWORD dwReceiptNo=0;
	USHORT nResult=1;	// `G[
	ULONG  nParamChk=0;
	CString strLogWork;
	CString strLogParam;

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;

		strLogWork.Format( "Possession=%d, ", wPossessionNo );
		strLogParam += strLogWork;
	}

	// Tag 2	tԍ
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 2 ) )
	{
		dwReceiptNo = m_objRecvNpsData.GetTagValueInt32( 2 );
		nParamChk |= TAG02;

		strLogWork.Format( "ReceiptNo=%d, ", dwReceiptNo );
		strLogParam += strLogWork;
	}

	{	// Oo
		CString str;
		str.Format( "             %s", strLogParam );
		NPS_LOGOUT( str );
	}

	// p[^̊mF
	if ( nParamChk & ( TAG01 | TAG02 )) {
		
		if ( wPossessionNo == ::GetVirtualPrinter()->GetPossessionNo() ) {
			
			if ( dwReceiptNo == ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameReceiptNo() ) {
				
				// 摜M܂ōő60bҋ@悤ɕύX (\PCnResult=19Ԃs) 2007.01.22 Y.Yoshinobu
				for ( nPos=0 ; 600 > nPos ; nPos++ )
				{
					if ( CFrame::WAITING != ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameStatus() ) {
						break;
					}
					::Sleep( 100 );
				}
				
				if ( 600 > nPos ) {
					
					// 摜̎M܂őҋ@iő60bҋ@悤ɕύXj
					for ( ; 600 > nPos ; nPos++ )
					{
						if ( CFrame::RECEIVED == ::GetVirtualPrinter()->m_cPrintQue.GetReceivingFrameStatus() ) {
							break;
						}
						::Sleep( 100 );
					}
					if ( 600 > nPos ) {
						::GetVirtualPrinter()->m_cPrintQue.ReciveEndFrame( dwReceiptNo );
						nResult = 0;
					} else {
						::GetVirtualPrinter()->m_cPrintQue.ReciveCancelFrame( dwReceiptNo );
						nResult = 22;	// 摜f[^M^CAEg
					}
					
				} else {
					
					::GetVirtualPrinter()->m_cPrintQue.ReciveCancelFrame( dwReceiptNo );
					nResult = 19;	// 摜̎MɎs܂
					
				}
				
			} else {
				
				nResult = 28;	// ڑJnv󂯕tĂ܂
				
			}
		} else {
			
			if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( wPossessionNo ) )
			{
				nResult = 27;		// v^Lf܂		2006.10.31 T.Mizushima	wE59
			}
			else
			{
				nResult = 9;		// v^̐LsĂ܂
			}
			
		}
		
	}
	
	return WCmd_6000H_0801H( nResult, wPossessionNo, dwReceiptNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0801H( USHORT nResult, USHORT nPossessionNo, ULONG nReceiptNo )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0801 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );
		
		// Tag 3	tԍ
		cBuffer.AddTagLong( 3, nReceiptNo );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0900H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0901H()
//	ABSTRACT : vg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0900H()
{
	USHORT nResult=1;	// `G[
	ULONG  nReceiptNo=0;
	ULONG  nParamChk=0;

	// p[^̉

	// Tag 1	tԍ
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		nReceiptNo = m_objRecvNpsData.GetTagValueInt32( 1 );
		nParamChk |= TAG01;
	}

	// p[^̊mF
	if ( nParamChk & TAG01 ) {
		
		if ( 0 != nReceiptNo ) {
			
			// R}Pʒf
			
			if ( TRUE == ::GetVirtualPrinter()->m_cPrintQue.IsExistReceiptNo( nReceiptNo ) ) {
				
				if ( TRUE == ::GetVirtualPrinter()->m_cPrintQue.CancelRequest( nReceiptNo ) ) {
					
					nResult = 0;
					
				} else {
					
					nResult = 6;	// vg̎Ɏs܂
					
				}
				
			} else {
				
				nResult = 7;	// Ytԍ܂
				
			}
			
		} else {
			
			// SR}f
			
			::GetVirtualPrinter()->m_cPrintQue.CancelAll();
			
			nResult = 0;
			
		}
		
	}
	
	return WCmd_6000H_0901H( nResult, nReceiptNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0901H( USHORT nResult, ULONG nReceiptNo )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0901 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	tԍ
		cBuffer.AddTagLong( 2, nReceiptNo );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0A00H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0A01H()
//	ABSTRACT : v^Cxg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0A00H()
{
	USHORT nResult=1;	// `G[
	ULONG nEventId=0;
	UCHAR nActionId=0;
	ULONG nEventCodeMain;
	ULONG nEventCodeSub;
	ULONG nParamChk=0;
	
	
	// p[^̉

	// Tag 1	Cxgʎq
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		nEventId = m_objRecvNpsData.GetTagValueInt32( 1 );
		nParamChk |= TAG01;
	}

	// Tag 2	Cxg̃ANV
	if ( 1 == m_objRecvNpsData.GetLengthOfTagValue( 2 ) )
	{
		nActionId = m_objRecvNpsData.GetTagValueInt8( 2 );
		nParamChk |= TAG02;
	}

	// p[^̊mF
	if ( nParamChk & ( TAG01 | TAG02 )) {
		
		if ( TRUE == ::GetVirtualPrinter()->m_cErrorInfo.SelectErrorInfo1( nEventId, &nEventCodeMain, &nEventCodeSub ) ) {
			nResult = 0;
		} else {
			nResult = 24;		// YCxgʎq܂
		}
		
	}
	
	return WCmd_6000H_0A01H( nResult, nEventId, nEventCodeMain, nEventCodeSub );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0A01H( USHORT nResult, ULONG nEventId, ULONG nEventCodeMain, ULONG nEventCodeSub )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0A01 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	if ( 0 == nResult ) {
		// v^Cxgʒmij
		::GetServerTcpCmd()->OnNotifyPrinterError( nEventId, nEventCodeMain, nEventCodeSub, 0, 0, 0, 1 );
	}
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0B00H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0B01H()
//	ABSTRACT : gCύX
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0B00H()
{
	WORD wPossessionNo=0;
	USHORT nResult=1;	// `G[
	ULONG nParamChk=0;
	
	
	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}

	// p[^̊mF
	if ( nParamChk & TAG01 ) {
		
		if ( 0 == ::GetVirtualPrinter()->m_cPrinterConfig.GetSorterStatus() ) {
			nResult = 26;		// gCύXł܂
		} else if ( wPossessionNo == ::GetVirtualPrinter()->GetPossessionNo() ) {
			nResult = 0;
		} else {
			if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( wPossessionNo ) )
			{
				nResult = 27;		// v^Lf܂		2006.10.31 T.Mizushima	wE59
			}
			else
			{
				nResult = 9;		// v^̐LsĂ܂
			}
		}
		
	}
	
	return WCmd_6000H_0B01H( nResult, wPossessionNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0B01H( USHORT nResult, USHORT nPossessionNo )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0B01 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0C00H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0C01H()
//	ABSTRACT : vg擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0C00H()
{
	return WCmd_6000H_0C01H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0C01H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0C01 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag	2	v^҂
		cBuffer.AddTagShort( 2, (USHORT)::GetVirtualPrinter()->m_cPrintQue.GetQueueingCount() );
		
		// Tag	3	v^
		cBuffer.AddTagShort( 3, (USHORT)::GetVirtualPrinter()->m_cPrintQue.GetPrintingCount() );
		
		// Tag	4	vZT[
		cBuffer.AddTagShort( 4, (USHORT)::GetVirtualPrinter()->m_cPrintQue.GetAdvancingCount() );
		
		// Tag	5	gpʁ@(PʁFByte)
		cBuffer.AddTagLong( 5, ::GetVirtualPrinter()->m_cPrintQue.GetQueueingImageCapacity() );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0D00H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0D01H()
//	ABSTRACT : vg~
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0D00H()
{
	WORD wPrintStopStart;
	USHORT nResult=1;	// `G[
	ULONG  nParamChk=0;
	
	
	// p[^̉

	// Tag 1	vg~ƒ~
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPrintStopStart = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}


	// p[^̊mF
	if ( nParamChk & TAG01 ) {
		
		switch ( wPrintStopStart )
		{	// vg~ƒ~
		case 0:	::GetVirtualPrinter()->m_cPrintQue.PrintStopCountIncrement();	nResult = 0;	break;	// 0:vg~
		case 1:	::GetVirtualPrinter()->m_cPrintQue.PrintStopCountDecrement();	nResult = 0;	break;	// 1:vg~
		}
		
	}
	
	return WCmd_6000H_0D01H( nResult );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0D01H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0D01 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0E00H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0E01H()
//	ABSTRACT : ڑJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0E00H()
{
	USHORT nResult=1;	// `G[
	ULONG nOemCode=0;
	CString strLogWork;
	CString strLogParam;


	// p[^̉

	// Tag 1	OEMR[h
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		nOemCode = m_objRecvNpsData.GetTagValueInt32( 1 );

		strLogWork.Format( "OemCode=%u ", nOemCode );
		strLogParam += strLogWork;
	}

	{	// Oo
		CString str;
		str.Format( "             %s", strLogParam );
		NPS_LOGOUT( str );
	}

	switch ( nOemCode )
	{
	case 0:			// NKCdl

		if ( 1 == ::GetVirtualPrinter()->m_cPrinterConfig.GetOemCode() ) {

			nResult = 42;	// OEMR[hs

		} else {

			nResult = 0;	// 

		}

		break;

	case 1:			// FFdl


		if ( 1 == ::GetVirtualPrinter()->m_cPrinterConfig.GetOemCode() ) {

			nResult = 0;	// 

		} else {

			nResult = 42;	// OEMR[hs

		}

		break;

	case 267242400:	// ꃂ[hiNKCj
	case 267242401:	// ꃂ[hiFFj

		// ŐԂ
		nResult = 0;

		break;
	}

	return WCmd_6000H_0E01H( nResult );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0E01H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0E01 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	NPS I/F o[W
		cBuffer.AddTagShort( 2, ::GetVirtualPrinter()->m_cPrinterInfo.GetNpsVersion() );
		
	} else {
		CString str;
		str.Format( "SEND <---- [6000] [0E01] nResult=%d", nResult );
		NPS_LOGOUT( str );
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	// 2006.10.06 T.Mizushima
	::GetVirtualPrinter()->m_cErrorInfo.NotifyAllErrors( this );
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_0F00H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_0F01H()
//	ABSTRACT : uU[
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_0F00H()
{
	return WCmd_6000H_0F01H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_0F01H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	cBuffer.Empty();
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x0F01 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_1000H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_1001H()
//	ABSTRACT : \
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_1000H()
{
	return WCmd_6000H_1001H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_1001H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	cBuffer.Empty();
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x1001 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_1100H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_1101H()
//	ABSTRACT : vt@Cf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_1100H()
{
	return WCmd_6000H_1101H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_1101H( USHORT nResult )
{
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_1200H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_1201H()
//	ABSTRACT : vgIvVݒ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_1200H()
{
	USHORT nResult=1;	// `G[
	USHORT nSorterNum=0;
	WORD wPossessionNo=0;
	ULONG  nParamChk=0;

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}

	// Tag 2	tԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 2 ) )
	{
		nSorterNum = m_objRecvNpsData.GetTagValueInt16( 2 );
		nParamChk |= TAG02;
	}

	// p[^̊mF
	if ( nParamChk & TAG01 ) {
		
		if ( wPossessionNo == ::GetVirtualPrinter()->GetPossessionNo() ) {
			nResult = 0;
		} else {
			if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( wPossessionNo ) )
			{
				nResult = 27;		// v^Lf܂		2006.10.31 T.Mizushima	wE59
			}
			else
			{
				nResult = 9;		// v^̐LsĂ܂
			}
		}
		
	}
	
	return WCmd_6000H_1201H( nResult, wPossessionNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_1201H( USHORT nResult, USHORT nPossessionNo )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x1201 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_1300H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_1301H()
//	ABSTRACT : Sy[p[̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.9.22
//	CREATE	 : Y.Yoshinobu	2008.12.11	TAG-21,22,23,24ǉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_1300H()
{
	return WCmd_6000H_1301H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_1301H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	int nIndex;
	T_MagAllInfo stMagInfo;
	USHORT nPaperCount=0;
	USHORT aPaperWidth[1024];
	USHORT aPaperLengthMin[1024];
	USHORT aPaperLengthMax[1024];
	USHORT aPaperId[1024];
	USHORT aPaperResolution[8192];
	USHORT aPaperAllocationTop[1024];
	USHORT aPaperAllocationBottom[1024];
	USHORT aPaperAllocationLeft[1024];
	USHORT aPaperAllocationRight[1024];
	USHORT aSetupStatus[1024];
	UCHAR  aPaperFeed[1024];
	USHORT aPaperTypeCode[1024];
	UCHAR  aPaperKind[1024];
	UCHAR  aMagazineID[1024];
	SHORT  aWBAdjustLeft[1024];
	SHORT  aWBAdjustRight[1024];
	CHAR   aPaperName[32768];
	UCHAR  aPaperType[1024];	// 2006.10.19 T.Mizushima
	UCHAR  aDirection[1024];		// 2008.12.11 Y.Yoshinobu
	UCHAR  aPrintQuality[1024];		// 2008.12.11 Y.Yoshinobu
	USHORT aDoubleSidedPaper[1024];	// 2008.12.11 Y.Yoshinobu
	USHORT aPaperInfo[1024];		// 2008.12.11 Y.Yoshinobu
	DWORD  nPaperNameLen=0;
	
	for ( nIndex=0 ; COUNTOF(aPaperWidth) > nIndex ; nIndex++ )
	{
		if ( TRUE == ::GetVirtualPrinter()->m_cPaperInfo.GetMagAllInfo( nIndex, &stMagInfo ) ) {
			aPaperWidth[nPaperCount]			= stMagInfo.nPaperWidth;
			aPaperLengthMin[nPaperCount]		= stMagInfo.nPaperLengthMin;
			aPaperLengthMax[nPaperCount]		= stMagInfo.nPaperLengthMax;
			aPaperId[nPaperCount]				= stMagInfo.nPaperId;
			aPaperResolution[nPaperCount*8+0]	= stMagInfo.nPaperResolution[0];
			aPaperResolution[nPaperCount*8+1]	= stMagInfo.nPaperResolution[1];
			aPaperResolution[nPaperCount*8+2]	= stMagInfo.nPaperResolution[2];
			aPaperResolution[nPaperCount*8+3]	= stMagInfo.nPaperResolution[3];
			aPaperResolution[nPaperCount*8+4]	= stMagInfo.nPaperResolution[4];
			aPaperResolution[nPaperCount*8+5]	= stMagInfo.nPaperResolution[5];
			aPaperResolution[nPaperCount*8+6]	= stMagInfo.nPaperResolution[6];
			aPaperResolution[nPaperCount*8+7]	= stMagInfo.nPaperResolution[7];
			aPaperAllocationTop[nPaperCount]	= stMagInfo.nPaperAllocationTop;
			aPaperAllocationBottom[nPaperCount]	= stMagInfo.nPaperAllocationBottom;
			aPaperAllocationLeft[nPaperCount]	= stMagInfo.nPaperAllocationLeft;
			aPaperAllocationRight[nPaperCount]	= stMagInfo.nPaperAllocationRight;
			aSetupStatus[nPaperCount]			= stMagInfo.nSetupStatus;
			aPaperFeed[nPaperCount]				= stMagInfo.nPaperFeed;
			aPaperTypeCode[nPaperCount]			= stMagInfo.nPaperTypeCode;
			aPaperKind[nPaperCount]				= stMagInfo.nPaperKind;
			aMagazineID[nPaperCount]			= stMagInfo.nMagazineID;
			aWBAdjustLeft[nPaperCount]			= stMagInfo.nWBAdjustLeft;
			aWBAdjustRight[nPaperCount]			= stMagInfo.nWBAdjustRight;
			::lstrcpy( &aPaperName[nPaperNameLen], stMagInfo.szPaperName );
			nPaperNameLen += strlen( stMagInfo.szPaperName ) + 1;
			aPaperType[nPaperCount]				= stMagInfo.nPaperType;		// 2006.10.19 T.Mizushima
			aDirection[nPaperCount]				= stMagInfo.nDirection;			// 2008.12.11 Y.Yoshinobu
			aPrintQuality[nPaperCount]			= stMagInfo.nPrintQuality;		// 2008.12.11 Y.Yoshinobu
			aDoubleSidedPaper[nPaperCount]		= stMagInfo.nDoubleSidedPaper;	// 2008.12.11 Y.Yoshinobu
			aPaperInfo[nPaperCount]				= stMagInfo.nPaperInfo;			// 2008.12.11 Y.Yoshinobu

			nPaperCount++;
		}
	}
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x1301 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag	2	擾y[p[ڍ׏̐
		cBuffer.AddTagShort( 2, nPaperCount );
		
		// Tag	3	y[p[̕
		cBuffer.AddTagShort( 3, (short*)aPaperWidth, nPaperCount );
		
		// Tag	4	y[p[̑蒷̍ŏl
		cBuffer.AddTagShort( 4, (short*)aPaperLengthMin, nPaperCount );
		
		// Tag	5	y[p[̑蒷̍ől
		cBuffer.AddTagShort( 5, (short*)aPaperLengthMax, nPaperCount );
		
		// Tag	6	y[p[ID iʎj
		cBuffer.AddTagShort( 6, (short*)aPaperId, nPaperCount );
		
		// Tag	7	͉𑜓x
		cBuffer.AddTagShort( 7, (short*)aPaperResolution, nPaperCount * 8 );
		
		// Tag	8	t㕔
		cBuffer.AddTagShort( 8, (short*)aPaperAllocationTop, nPaperCount );
		
		// Tag	9	t
		cBuffer.AddTagShort( 9, (short*)aPaperAllocationBottom, nPaperCount );
		
		// Tag	10	t
		cBuffer.AddTagShort( 10, (short*)aPaperAllocationLeft, nPaperCount );
		
		// Tag	11	tE
		cBuffer.AddTagShort( 11, (short*)aPaperAllocationRight, nPaperCount );
		
		// Tag	12	ZbgAbv
		cBuffer.AddTagShort( 12, (short*)aSetupStatus, nPaperCount );
		
		// Tag	13	@
		cBuffer.AddTagChar( 13, (char*)aPaperFeed, nPaperCount );
		
		// Tag	14	y[p[^CvR[h
		cBuffer.AddTagShort( 14, (short*)aPaperTypeCode, nPaperCount );
		
		// Tag	15	y[p[ʎ
		cBuffer.AddTagChar( 15, (char*)aPaperKind, nPaperCount );
		
		// Tag	16	}KWID
		cBuffer.AddTagChar( 16, (char*)aMagazineID, nPaperCount );
		
		// Tag	17	WB␳l
		cBuffer.AddTagShort( 17, (short*)aWBAdjustLeft, nPaperCount );
		
		// Tag	18	WB␳lE
		cBuffer.AddTagShort( 18, (short*)aWBAdjustRight, nPaperCount );
		
		// Tag	19	y[p[
		cBuffer.AddTagChar( 19, (char*)aPaperName, nPaperNameLen );
		
		// Tag	20	y[p[^Cvi܎j
		cBuffer.AddTagChar( 20, (char*)aPaperType, nPaperCount );
		
		// Tag	21	fBNViBERGpj
		cBuffer.AddTagChar( 21, (char*)aDirection, nPaperCount );

		// Tag	22	iiBERGpj
		cBuffer.AddTagChar( 22, (char*)aPrintQuality, nPaperCount );

		// Tag	23	ʃy[p[iFUJIpj
		cBuffer.AddTagShort( 23, (short*)aDoubleSidedPaper, nPaperCount );

		// Tag	24	y[p[iFUJIpj
		cBuffer.AddTagShort( 24, (short*)aPaperInfo, nPaperCount );

	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_1500H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_1501H()
//	ABSTRACT : ڑmF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2007.2.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_1500H()
{
	return WCmd_6000H_1501H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_1501H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x1501 );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_1600H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_1601H()
//	ABSTRACT : ʈJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.5.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_1600H()
{
	WORD wPossessionNo=0;
	USHORT nResult=1;	// `G[
	ULONG nParamChk=0;

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}


	// p[^̊mF
	if ( nParamChk & TAG01 ) {

		if ( 0 != ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportDoubleSided() ) {
			if ( wPossessionNo == ::GetVirtualPrinter()->GetPossessionNo() ) {
				::GetVirtualPrinter()->m_cPrintQue.EnableDuplex();
				nResult = 0;
			} else {
				if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( wPossessionNo ) )
				{
					nResult = 27;		// v^Lf܂		2006.10.31 T.Mizushima	wE59
				}
				else
				{
					nResult = 9;		// v^̐LsĂ܂
				}
			}
		}
		else
		{
			nResult = 37;				// ʈɑΉĂ܂
		}
		
	}

	return WCmd_6000H_1601H( nResult, wPossessionNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_1601H( USHORT nResult, USHORT nPossessionNo )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x1601 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_1700H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_1701H()
//	ABSTRACT : ʈI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.5.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_1700H()
{
	WORD wPossessionNo=0;
	USHORT nResult=1;	// `G[
	ULONG nParamChk=0;

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}


	// p[^̊mF
	if ( nParamChk & TAG01 ) {
		
		if ( 0 != ::GetVirtualPrinter()->m_cPrinterConfig.GetSupportDoubleSided() ) {
			if ( wPossessionNo == ::GetVirtualPrinter()->GetPossessionNo() ) {
				::GetVirtualPrinter()->m_cPrintQue.DisableDuplex();
				nResult = 0;
			} else {
				if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( wPossessionNo ) )
				{
					nResult = 27;		// v^Lf܂		2006.10.31 T.Mizushima	wE59
				}
				else
				{
					nResult = 9;		// v^̐LsĂ܂
				}
			}
		}
		else
		{
			nResult = 37;				// ʈɑΉĂ܂
		}

	}

	return WCmd_6000H_1701H( nResult, wPossessionNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_1701H( USHORT nResult, USHORT nPossessionNo )
{
	CCmdBuffer cBuffer;

	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x1701 );

	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );

	if ( 0 == nResult ) {

		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );

	}

	// Tag I[
	cBuffer.AddTagFooter();

	// f[^M

	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_1800H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_1801H()
//	ABSTRACT : 󔒃vg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.5.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_1800H()
{
	USHORT nResult=1;	// `G[
	CFrame cFrame;
	ULONG  nParamChk=0;

	// tԍ̍̔
	cFrame.NumberingReceiptNo();

	// \Pbg̓o^
	cFrame.SetSock( this );

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		cFrame.SetPossessionNo( m_objRecvNpsData.GetTagValueInt16( 1 ) );
		nParamChk |= TAG01;
	}

	// Tag 6	͉𑜓x iPʁF0.1dpij
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 6 ) )
	{
		cFrame.SetPaperResolution( m_objRecvNpsData.GetTagValueInt16( 6 ) );
		nParamChk |= TAG06;
	}

	// Tag 7	y[p[̕ iPʁF0.1mmj
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 7 ) )
	{
		cFrame.SetPaperWidth( m_objRecvNpsData.GetTagValueInt16( 7 ) );
		nParamChk |= TAG07;
	}

	// Tag 8	y[p[̑蒷 iPʁF0.1mmj
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 8 ) )
	{
		cFrame.SetPaperLength( m_objRecvNpsData.GetTagValueInt16( 8 ) );
		nParamChk |= TAG08;
	}

	// Tag 9	y[p[ID
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 9 ) )
	{
		cFrame.SetPaperID( m_objRecvNpsData.GetTagValueInt16( 9 ) );
		nParamChk |= TAG09;
	}

	// Tag 10	s[g
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 10 ) )
	{
		cFrame.SetRepeat( m_objRecvNpsData.GetTagValueInt16( 10 ) );
		nParamChk |= TAG10;
	}

	// Tag 11	@
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 11 ) )
	{
		cFrame.SetPaperFeed( m_objRecvNpsData.GetTagValueInt16( 11 ) );
		nParamChk |= TAG11;
	}

	// Tag 12	~l[g
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 12 ) )
	{
		cFrame.SetLaminator( m_objRecvNpsData.GetTagValueInt16( 12 ) );
		nParamChk |= TAG12;
	}

	// Tag 22	Uy[p[w
	if ( 1 == m_objRecvNpsData.GetLengthOfTagValue( 22) )
	{
		cFrame.SetPaperPresence( m_objRecvNpsData.GetTagValueInt8( 22 ) );
		nParamChk |= TAG22;
	}

	// Tag 25	I[_[ʔԍ
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 25 ) )
	{
		cFrame.SetOrderId( m_objRecvNpsData.GetTagValueInt32( 25 ) );
		nParamChk |= TAG25;
	}

	// Tag 34	y[p[
	if ( 0 < m_objRecvNpsData.GetLengthOfTagValue( 34 ) )
	{
		cFrame.SetPaperName( m_objRecvNpsData.GetTagValueString( 34 ) );
	}

	// Tag 37	@
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 37 ) )
	{
		cFrame.SetPrintQuality( m_objRecvNpsData.GetTagValueInt16( 37 ) );
	}

	// Tag 38	摜gASY
	if ( 1 == m_objRecvNpsData.GetLengthOfTagValue( 38 ) )
	{
		cFrame.SetImageEnLargeType( m_objRecvNpsData.GetTagValueInt8( 38 ) );
	}

	// Tag 50	// Tag 50	NACN
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 38 ) )
	{
		cFrame.SetClearInk( m_objRecvNpsData.GetTagValueInt16( 38 ) );
	}

	{	// Oo
		CString str;
		str.Format( "             " );
		NPS_LOGOUT( str );
	}

	if ( TRUE == ::GetVirtualPrinter()->m_cPrintQue.IsEnableDuplex() )
	{
		// ʈ̎
		cFrame.SetDuplexSeqNo( ::GetVirtualPrinter()->m_cPrintQue.GetDuplexSeqNo() );
	}

	// p[^̊mF
	if ( nParamChk & ( TAG01 | TAG06 | TAG07 | TAG08 | TAG09 | TAG25 ) )
	{
		if( ::GetVirtualPrinter()->GetPossessionNo() != cFrame.GetPossessionNo() )
		{	// LԍقȂ
			if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( cFrame.GetPossessionNo() ) )
			{
				nResult = 27;	// v^Lf܂
			}
			else
			{
				nResult = 9;	// v^̐LsĂ܂
			}
		}
		else if ( 2 != ::GetVirtualPrinter()->m_cPrinterState.GetAcceptStatus() )
		{	// ts
			nResult = 18;	// tsԂł
		}
		// 2006.09.29 T.Mizushima
		else if(::GetVirtualPrinter()->m_cPrinterState.GetMemoryStatus() == 2)
		{	// v^t
			nResult = 13;	// Xv[̈̋󂫗eʂ܂
		}
		else if ( 0 == cFrame.GetPaperLength() )
		{
			// 荇A蒷̎w肪0̏ꍇ̂݃G[ŕԂ 2007.03.08 Y.Yoshinobu
			nResult = 17;
		}
		else if ( TRUE == ::GetVirtualPrinter()->m_cPrintQue.ReciveStartFrame( &cFrame ) )
		{
			::GetVirtualPrinter()->m_cPrintQue.ReciveEndFrame( cFrame.GetReceiptNo() );
			::GetVirtualPrinter()->m_cPrintQue.IncrementDuplexSeqNo();
			nResult = 0;
		}

	}

	return WCmd_6000H_1801H( nResult, cFrame.GetPossessionNo(), cFrame.GetReceiptNo() );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_1801H( USHORT nResult, USHORT nPossessionNo, ULONG nReceiptNo )
{
	CCmdBuffer cBuffer;

	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x1801 );

	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );

	if ( 0 == nResult ) {

		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );

		// Tag 3	tԍ
		cBuffer.AddTagLong( 3, nReceiptNo );

	}

	// Tag I[
	cBuffer.AddTagFooter();

	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6000H_1900H()
//	MODULE   : CWS2TcpCmd::WCmd_6000H_1901H()
//	ABSTRACT : I[_[
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2012.04.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6000H_1900H()
{
	WORD wPossessionNo=0;
	USHORT nResult=1;	// `G[
	ULONG nParamChk=0;
	
	
	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}

	// p[^̊mF
	if ( nParamChk & TAG01 ) {
		
		// I[_[Pʒf
		if ( TRUE == ::GetVirtualPrinter()->m_cPrintQue.CancelOrderRequest( wPossessionNo ) ) {
			
			nResult = 0;
			
		} else {
			
			nResult = 46;	// YLԍ܂
			
		}
	}

	return WCmd_6000H_1901H( nResult, wPossessionNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6000H_1901H( USHORT nResult, USHORT nPossessionNo )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0x1901 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_0100H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_0101H()
//	ABSTRACT : XV
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6001H_0100H()
{
	UINT32 nIdx;
	USHORT nResult=1;	// `G[
	CString strDateTime;
	ULONG  nParamChk=0;
	WORD wDateTime[8] = { 0 };

	// p[^̉

	// Tag 1	
	if ( 16 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		for ( nIdx=0 ; 8 > nIdx ; nIdx++ )
		{
			wDateTime[nIdx] = m_objRecvNpsData.GetTagValueInt16( 1, nIdx );
		}
		nParamChk |= TAG01;

		// \p̃Zbg
		strDateTime.Format("Update system time %04d/%02d/%02d %02d:%02d'%02d\"%03d",
			wDateTime[0], wDateTime[1], wDateTime[2],
			wDateTime[3], wDateTime[4], wDateTime[5], wDateTime[6] );
	}

	// p[^̊mF
	if ( nParamChk & TAG01 ) {
		nResult = 0;	// 
	}
	
	return WCmd_6001H_0101H( nResult, strDateTime );
}
// M
BOOL CWS2TcpCmd::WCmd_6001H_0101H( USHORT nResult, CString strDateTime )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6001, 0x0101 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
#if 0
	::AfxMessageBox( strDateTime );
#else
	// ݒ肳ꂽԂCEChEɕ\
	::GetVirtualPrinter()->RequestDspDateTime(strDateTime);
#endif
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_0200H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_0201H()
//	ABSTRACT : v^_v擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6001H_0200H()
{
	return WCmd_6001H_0201H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6001H_0201H( USHORT nResult )
{
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_0300H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_0301H()
//	ABSTRACT : v^_vf[^擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6001H_0300H()
{
	return WCmd_6001H_0301H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6001H_0301H( USHORT nResult )
{
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_0700H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_0701H()
//	ABSTRACT : ^[Qbg擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2007.4.3
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6001H_0700H()
{
	return WCmd_6001H_0701H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6001H_0701H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6001, 0x0701 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	// Tag 2	nR[h
	cBuffer.AddTagChar( 2, 1 );
	
	// Tag 3	擾^[Qbg̐
	cBuffer.AddTagShort( 3, 6 );
	
	// Tag 4	v^[vt@CZ
	FLOAT	pp[192] = { (FLOAT)0 };
	cBuffer.AddTagFloat( 4, pp, 6 );
	
	// Tag 5	y[p[^Cv
	char	pt = 1;
	cBuffer.AddTagChar( 5, &pt, 6 );
	
	// Tag 6	^[Qbgf[^(y[p[^CvR[h)
	USHORT	aPaperTypeCode[6];
	::GetVirtualPrinter()->m_cPrinterConfig.GetPaperTypeCode( aPaperTypeCode );
	cBuffer.AddTagShort( 6, (short*)aPaperTypeCode, 6 );
	
	// Tag 7	^[Qbgf[^(ڕWl)
	FLOAT	tv[60] = { (FLOAT)0 };
	cBuffer.AddTagFloat( 7, tv, 6 );
	
	// Tag 8	^[Qbgf[^(Rg[l)
	FLOAT	dmc[3] = { (FLOAT)0 };
	cBuffer.AddTagFloat( 8, dmc, 6 );
	
	// Tag 9	ޖ
	char	name[26] = { NULL };
	cBuffer.AddTagChar( 9, name, 6 );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_0A00H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_0A01H()
//	ABSTRACT : FADgpJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.12.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2TcpCmd::RCmd_6001H_0A00H()
{
	if ( 0 == ::GetVirtualPrinter()->m_cPrinterConfig.GetFadAttachNo() )
	{
		// FADڑ̏ꍇ́AR}hT|[gƂ
		return WCmd_6000H_FFFFH();
	}

	WORD wPossessionNo=0;
	CString strOrderKey;
	WORD wPrintOut=0;
	DWORD dwTotalDataSize=0;
	DWORD dwDataGetPoint=0;
	WORD wDataSize=0;
	LPBYTE pFadData=NULL;
	USHORT nResult=1;	// `G[
	ULONG  nParamChk=0;

	try {
		pFadData = new UCHAR[65535];
	}
	catch (CFileException* e) {
		pFadData = NULL;
		e->Delete();
	}

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}

	// Tag 2	I[_[ʎq
	if ( 0 < m_objRecvNpsData.GetLengthOfTagValue( 2 ) )
	{
		strOrderKey = m_objRecvNpsData.GetTagValueString( 2 );
		nParamChk |= TAG02;
	}

	// Tag 3	vgro
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 3 ) )
	{
		wPrintOut = m_objRecvNpsData.GetTagValueInt16( 3 );
		nParamChk |= TAG03;
	}

	// Tag 4	Sf[^TCY iPʁFBytej
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 4 ) )
	{
		dwTotalDataSize = m_objRecvNpsData.GetTagValueInt32( 4 );
		nParamChk |= TAG04;
	}

	// Tag 5	f[^MJnʒu iPʁFBytej
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 5 ) )
	{
		dwDataGetPoint = m_objRecvNpsData.GetTagValueInt32( 5 );
		nParamChk |= TAG05;
	}

	// Tag 6	f[^MTCY iPʁFBytej
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 6 ) )
	{
		wDataSize = m_objRecvNpsData.GetTagValueInt16( 6 );
		nParamChk |= TAG06;
	}

	// Tag 7	FADf[^
	if (( nParamChk & TAG06 ) && ( NULL != pFadData ))
	{
		if ( wDataSize == m_objRecvNpsData.GetLengthOfTagValue( 7 ) )
		{
			if ( wDataSize == m_objRecvNpsData.GetTagValueChar( 7, 65535, pFadData ) )
			{
				nParamChk |= TAG07;
			}
		}
	}

	// p[^̊mF
	if ( 0 != ::GetVirtualPrinter()->m_cPrinterConfig.GetFadAttachNo() )
	{
		if ( nParamChk & ( TAG01 | TAG02 | TAG03 ) )
		{
			if( ::GetVirtualPrinter()->GetPossessionNo() != wPossessionNo )
			{	// LԍقȂ		2006.10.31 T.Mizushima	wE59
				if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( wPossessionNo ) )
				{
					nResult = 27;	// v^Lf܂
				}
				else
				{
					nResult = 9;	// v^̐LsĂ܂
				}
			}
			else
			{
				nResult = 0;
			}

		}
	}

	// f[^SppoltH_֏o
	DWORD dwWritten=0;
	if ( 0 == nResult )
	{
		if ( 1 == wPrintOut )
		{
			nResult = 1;
			HANDLE hFile=INVALID_HANDLE_VALUE;
			CString strFileName;
			CString strFilePath;
			strFileName.Format( "FAD_%s_%010u.dat", strOrderKey, dwTotalDataSize );
			strFilePath = NkcComApi::MakeFullPath( ::GetVirtualPrinter()->GetSpoolFolder(), strFileName );

			hFile = ::CreateFile( strFilePath, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
			if ( INVALID_HANDLE_VALUE != hFile )
			{
				if ( dwDataGetPoint == SetFilePointer( hFile, dwDataGetPoint, NULL, FILE_BEGIN ) )
				{
					if ( TRUE == ::WriteFile( hFile, pFadData, (DWORD)wDataSize, &dwWritten, NULL ) )
					{
						nResult = 0;
					}
				}
				::CloseHandle( hFile );
			}
		}
	}

	delete [] pFadData;

	return WCmd_6001H_0A01H( nResult, 0, wPossessionNo, dwDataGetPoint, (WORD)dwWritten );
}
BOOL CWS2TcpCmd::WCmd_6001H_0A01H( USHORT nResult, ULONG nFadResult, USHORT nPossessionNo, ULONG nDataGetPoint, USHORT nDataSize )
{
	CCmdBuffer cBuffer;
	CString	strInfoFile;
	strInfoFile = NkcComApi::MakeFullPath("FAD_Response.ini");

	DWORD dwFadResult = GetPrivateProfileInt( "FadResult", "value", 0, (LPCTSTR)strInfoFile );

	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6001, 0x0A01 );

	if ( 0 == dwFadResult ) {

		// Tag 1	
		cBuffer.AddTagShort( 1, nResult );

		if ( 0 == nResult ) {

			// Tag 2	FAD
			cBuffer.AddTagLong( 2, nFadResult );

			// Tag 3	Lԍ
			cBuffer.AddTagShort( 3, nPossessionNo );

			// Tag 4	f[^MJnʒu iPʁFBytej
			cBuffer.AddTagLong( 4, nDataGetPoint );

			// Tag 5	f[^MTCY iPʁFBytej
			cBuffer.AddTagShort( 5, nDataSize );

		}

	} else {

		// Tag 1	
		cBuffer.AddTagShort( 1, 43 );

		// Tag 2	FAD
		cBuffer.AddTagLong( 2, dwFadResult );

		// Tag 3	Lԍ
		cBuffer.AddTagShort( 3, nPossessionNo );

		// Tag 4	f[^MJnʒu iPʁFBytej
		cBuffer.AddTagLong( 4, nDataGetPoint );

		// Tag 5	f[^MTCY iPʁFBytej
		cBuffer.AddTagShort( 5, nDataSize );

	}

	// Tag I[
	cBuffer.AddTagFooter();

	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_0B00H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_0B01H()
//	ABSTRACT : vgJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2009.03.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6001H_0B00H()
{
	if ( 1 != ::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeID() )
	{
		// 1FCNWFbg^CvȊȌꍇ̓R}hT|[gƂ
		return WCmd_6000H_FFFFH();
	}

	return WCmd_6001H_0B01H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6001H_0B01H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	
	cBuffer.Empty();
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6001, 0x0B01 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );

	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_0C00H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_0C01H()
//	ABSTRACT : đJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu	2011.11.08
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6001H_0C00H()
{
	WORD wPossessionNo = 0;
	USHORT nResult = 1;	// `G[
	ULONG  nParamChk = 0;

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}
	
	// p[^̊mF
	if ( nParamChk & ( TAG01 ) )
	{
		if( ::GetVirtualPrinter()->GetPossessionNo() != wPossessionNo )
		{	// LԍقȂ
			if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( wPossessionNo ) )
			{
				nResult = 27;	// v^Lf܂
			}
			else
			{
				nResult = 9;	// v^̐LsĂ܂
			}
		}
		else
		{
			nResult = 0;
		}
	}

	
	return WCmd_6001H_0C01H( nResult, wPossessionNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6001H_0C01H( USHORT nResult, USHORT nPossessionNo )
{
	CCmdBuffer cBuffer;
	
	cBuffer.Empty();
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6001, 0x0C01 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );

	// Tag 2	Lԍ
	cBuffer.AddTagShort( 2, nPossessionNo );

	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_0D00H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_0D01H()
//	ABSTRACT : đI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu	2011.11.08
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6001H_0D00H()
{
	WORD wPossessionNo = 0;
	USHORT nResult = 1;	// `G[
	ULONG  nParamChk = 0;

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}
	
	// p[^̊mF
	if ( nParamChk & ( TAG01 ) )
	{
		if( ::GetVirtualPrinter()->GetPossessionNo() != wPossessionNo )
		{	// LԍقȂ
			if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( wPossessionNo ) )
			{
				nResult = 27;	// v^Lf܂
			}
			else
			{
				nResult = 9;	// v^̐LsĂ܂
			}
		}
		else
		{
			nResult = 0;
		}
	}

	
	return WCmd_6001H_0D01H( nResult, wPossessionNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6001H_0D01H( USHORT nResult, USHORT nPossessionNo )
{
	CCmdBuffer cBuffer;
	
	cBuffer.Empty();
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6001, 0x0D01 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );

	// Tag 2	Lԍ
	cBuffer.AddTagShort( 2, nPossessionNo );

	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_0E00H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_0E01H()
//	ABSTRACT : fLZ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu	2011.11.08
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6001H_0E00H()
{
	WORD wPossessionNo = 0;
	USHORT nResult = 1;	// `G[
	ULONG  nParamChk = 0;

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}
	
	// p[^̊mF
	if ( nParamChk & ( TAG01 ) )
	{
		if( ::GetVirtualPrinter()->GetPossessionNo() != wPossessionNo )
		{	// LԍقȂ
			if( TRUE == ::GetVirtualPrinter()->IsWarikomiPossessionNo( wPossessionNo ) )
			{
				nResult = 27;	// v^Lf܂
			}
			else
			{
				nResult = 9;	// v^̐LsĂ܂
			}
		}
		else
		{
			// SR}f
			
			::GetVirtualPrinter()->m_cPrintQue.CancelAll();
			
			nResult = 0;		
		}
		
	}
	
	return WCmd_6001H_0E01H( nResult );
}
// M
BOOL CWS2TcpCmd::WCmd_6001H_0E01H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	
	cBuffer.Empty();
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6001, 0x0E01 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );

	// Tag 2	f̃I[_[
	cBuffer.AddTagShort( 2, 3 );

	// Tag 3	ʃvg̕\ʊJnm点
	cBuffer.AddTagShort( 3, 2 );

	// Tag 4	ʃvg̗ʊJnm点
	cBuffer.AddTagShort( 4, 1 );

	// Tag 5	ʃvg̃vg
	cBuffer.AddTagShort( 5, 0 );

	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6002H_7304H()
//	MODULE   : CWS2TcpCmd::WCmd_6002H_7305H()
//	ABSTRACT : o[WmF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.11.29
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6002H_7304H()
{
	return WCmd_6002H_7305H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6002H_7305H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	cBuffer.Empty();
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6002, 0x7305 );
	
	// Tag 5	
	cBuffer.AddTagShort( 5, nResult );
	
	// Tag	581	v^[I/F@o[W
	cBuffer.AddTagChar( 581, "1.016              \0                   \0", 40 );
	
	// Tag	582	v^[@o[W
	cBuffer.AddTagChar( 582, "1.005     004      \0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0", 40 );
	
	// Tag	583	[U[@o[W
	cBuffer.AddTagChar( 583, "1.007 X1 H# 1  #   \0TBF0001            \0", 40 );
	
	// Tag	584	vZT[@o[W
	cBuffer.AddTagChar( 584, "1.008              \0TBF0001            \0", 40 );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_B004H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_B005H()
//	ABSTRACT : NWbgݒ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.4.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6001H_B004H()
{
	ULONG nCreditCount=0;
	USHORT nResult=1;	// `G[
	ULONG nParamChk=0;

	// p[^̉

	// Tag 1	NWbgJEg
	if ( 4 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		nCreditCount = m_objRecvNpsData.GetTagValueInt32( 1 );
		nParamChk |= TAG01;
	}

	// p[^̊mF
	if ( nParamChk & TAG01 ) {
		
		nResult = 0;
		
	}
	
	return WCmd_6001H_B005H( nResult );
}
// M
BOOL CWS2TcpCmd::WCmd_6001H_B005H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6001, 0xB005 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_B006H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_B007H()
//	ABSTRACT : NWbgJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.3.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6001H_B006H()
{
	USHORT nResult=1;	// `G[
	ULONG nParamChk=0;
	WORD wPossessionNo=0;

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}

	// p[^̊mF
	if ( nParamChk & TAG01 ) {
		
		if ( wPossessionNo == ::GetVirtualPrinter()->GetPossessionNo() ) {
			nResult = 0;
		} else {
			nResult = 9;		// v^̐LsĂ܂
		}
		
	}
	
	return WCmd_6001H_B007H( nResult, wPossessionNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6001H_B007H( USHORT nResult, USHORT nPossessionNo )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6001, 0xB007 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6001H_B008H()
//	MODULE   : CWS2TcpCmd::WCmd_6001H_B009H()
//	ABSTRACT : NWbgI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.3.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6001H_B008H()
{
	USHORT nResult=1;	// `G[
	ULONG nParamChk=0;
	WORD wPossessionNo=0;

	// p[^̉

	// Tag 1	Lԍ
	if ( 2 == m_objRecvNpsData.GetLengthOfTagValue( 1 ) )
	{
		wPossessionNo = m_objRecvNpsData.GetTagValueInt16( 1 );
		nParamChk |= TAG01;
	}

	// p[^̊mF
	if ( nParamChk & TAG01 ) {
		
		if ( wPossessionNo == ::GetVirtualPrinter()->GetPossessionNo() ) {
			nResult = 0;
		} else {
			nResult = 9;		// v^̐LsĂ܂
		}
		
	}
	
	return WCmd_6001H_B009H( nResult, wPossessionNo );
}
// M
BOOL CWS2TcpCmd::WCmd_6001H_B009H( USHORT nResult, USHORT nPossessionNo )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6001, 0xB009 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	if ( 0 == nResult ) {
		
		// Tag 2	Lԍ
		cBuffer.AddTagShort( 2, nPossessionNo );
		
	}
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_6002H_7300H()
//	MODULE   : CWS2TcpCmd::WCmd_6002H_7301H()
//	ABSTRACT : [hύXv
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.3.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_6002H_7300H()
{
	return WCmd_6002H_7301H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_6002H_7301H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6002, 0x7301 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::RCmd_7003H_4001H()
//	MODULE   : CWS2TcpCmd::WCmd_7003H_4002H()
//	ABSTRACT : 엚擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.4.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// vM
BOOL CWS2TcpCmd::RCmd_7003H_4001H()
{
	return WCmd_7003H_4002H( 0 );
}
// M
BOOL CWS2TcpCmd::WCmd_7003H_4002H( USHORT nResult )
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x7003, 0x4002 );
	
	// Tag 1	
	cBuffer.AddTagShort( 1, nResult );
	
	// Tag 2	ݐσN[jO
	cBuffer.AddTagLong( 2, 1000 );
	
	// Tag 3	ݐϔpCN^N
	cBuffer.AddTagLong( 3, 2000 );
	
	// Tag 4	ݐσvg
	cBuffer.AddTagLong( 4, 99999 );
	
	// Tag 5	NWbgJE^
	cBuffer.AddTagLong( 5, 3000 );
	
	// Tag 6	CNc(Y)
	cBuffer.AddTagShort( 6, 100 );
	
	// Tag 7	CNc(M)
	cBuffer.AddTagShort( 7, 90 );
	
	// Tag 8	CNc(C)
	cBuffer.AddTagShort( 8, 80 );
	
	// Tag 9	CNc(BK)
	cBuffer.AddTagShort( 9, 70 );
	
	// Tag 10	CNc(R)
	cBuffer.AddTagShort( 10, 60 );
	
	// Tag 11	CNc(V)
	cBuffer.AddTagShort( 11, 50 );
	
	// Tag 12	CNc(CL)
	cBuffer.AddTagShort( 12, 40 );
	
	// Tag 13	ݐσJbĝė
	cBuffer.AddTagLong( 13, 30 );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2TcpCmd::WCmd_6000H_FFFFH()
//	ABSTRACT : v^_vf[^擾
//	FUNCTION : R}hT|[gʒm
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.8.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// ʒm
BOOL CWS2TcpCmd::WCmd_6000H_FFFFH()
{
	CCmdBuffer cBuffer;
	
	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0xFFFF );
	
	// Tag 1	C^[tFCXID
	cBuffer.AddTagShort( 1, m_objRecvNpsData.GetInterfaceId() );
	
	// Tag 2	R}hID
	cBuffer.AddTagShort( 2, m_objRecvNpsData.GetCommandId() );
	
	// Tag I[
	cBuffer.AddTagFooter();
	
	// f[^M
	SendLock();
	Send( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	SendUnlock();
	
	return TRUE;
}
