// Order.h: COrder NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ORDER_H__0D436CED_DFD7_4C2B_AAA9_94E0DB7D9B2D__INCLUDED_)
#define AFX_ORDER_H__0D436CED_DFD7_4C2B_AAA9_94E0DB7D9B2D__INCLUDED_

#include <vector>
#include "Frame.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct {
	DWORD	dwPriority;
	DWORD	dwSortFrame;
	DWORD	dwExOptions;
} T_ORDER_PARAM;

typedef struct {
	DWORD	dwFrame;
	DWORD	dwFrameTransfer;
	DWORD	dwFramePrint;
	DWORD	dwFrameOutput;
} T_ORDER_STATUS;

class COrder  
{
public:
	COrder() {
		m_dwOrderId = 0;
		m_bReceiptEnd = FALSE;
		m_bOrderEnd = FALSE;
		::ZeroMemory( &m_tOrderParam, sizeof(T_ORDER_PARAM) );
		::ZeroMemory( &m_tOrderStatus, sizeof(T_ORDER_STATUS) );
	};
	virtual ~COrder() {};

	CString GetStatusString() {
		CString strStatus;
		if ( TRUE == m_bReceiptEnd )
		{
			strStatus = _T( "t" );
		}
		else
		{
			strStatus = _T( "t" );
		}
		if ( TRUE == m_bOrderEnd )
		{
			switch ( m_dwEndStatus )
			{
			case RESULT_OK:				strStatus += _T(" I");		break;
			case RESULT_NG:				strStatus += _T(" ُI");		break;
			case RESULT_USER_CANCEL:	strStatus += _T(" LZI");	break;
			}
		}
		else
		{
			strStatus += _T(" ");
		}
		return strStatus;
	}

	CString GetPriorityString() {
		if ( 0 == m_tOrderParam.dwPriority )
		{
			return CString( _T("ʏ") );
		}
		return CString( _T("}") );
	};

	CString GetSingleLinePrintString() {
		if ( 0x00000001 & m_tOrderParam.dwExOptions )
		{
			return CString( _T("") );
		}
		return CString( _T("Ȃ") );
	};

public:

	DWORD					m_dwOrderId;
	BOOL					m_bReceiptEnd;
	BOOL					m_bOrderEnd;
	DWORD					m_dwEndStatus;

	T_ORDER_PARAM			m_tOrderParam;
	T_ORDER_STATUS			m_tOrderStatus;

	std::vector<CFrame*>	m_vFrame;
};

#endif // !defined(AFX_ORDER_H__0D436CED_DFD7_4C2B_AAA9_94E0DB7D9B2D__INCLUDED_)
