// PrintQue.cpp: CPrintQue NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsTester.h"
#include "PrintQue.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CPrintQue* g_objPrintQue = NULL;

void CreatePrintQue()		{ g_objPrintQue = new CPrintQue; };
void DropPrintQue()			{ delete g_objPrintQue; };
CPrintQue* GetPrintQue()	{ return g_objPrintQue; };

#define	ORDER_INFO_TREE_ROOT_STRING	_T("vg")

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CPrintQue::CPrintQue()
{
	::InitializeCriticalSection( &m_csMemberData );
}

CPrintQue::~CPrintQue()
{
	Empty();

	::DeleteCriticalSection( &m_csMemberData );
}

// vgL[
// --------------------------------------------------
void CPrintQue::Empty()
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	std::vector<COrder*>::iterator	itOrder;
	std::vector<CFrame*>::iterator	itFrame;

	for ( itOrder=m_vOrder.begin() ; m_vOrder.end() != itOrder ; itOrder++ )
	{
		for ( itFrame=(*itOrder)->m_vFrame.begin() ; (*itOrder)->m_vFrame.end() != itFrame ; itFrame++ )
		{
			delete (CFrame*)(*itFrame);
		}
		(*itOrder)->m_vFrame.clear();
		delete (COrder*)(*itOrder);
	}
	m_vOrder.clear();
}

// I[_[̓o^Jn
// --------------------------------------------------
BOOL CPrintQue::OrderStart( DWORD* pdwOrderId, T_ORDER_PARAM* ptOrderParam )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if ( FALSE == GetNpsLib()->npsDevStartOrderEx( pdwOrderId, ptOrderParam->dwPriority, 0, ptOrderParam->dwSortFrame, ptOrderParam->dwExOptions ) )
	{
		return FALSE;
	}

	COrder* pobjOrder = NULL;

	try {
		pobjOrder = new COrder;
		pobjOrder->m_dwOrderId = *pdwOrderId;
		CopyMemory( &pobjOrder->m_tOrderParam, ptOrderParam, sizeof(T_ORDER_PARAM) );
	}
	catch (...) {
		AfxMessageBox( _T("CPrintQue::OrderStart() : mۂɎs܂B") );
	}

	m_vOrder.push_back( pobjOrder );

	return TRUE;
}

// I[_[̓o^I
// --------------------------------------------------
BOOL CPrintQue::OrderEnd( const DWORD dwOrderId )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if ( FALSE == GetNpsLib()->npsDevEndOrder( dwOrderId ) )
	{
		return FALSE;
	}

	// L[I[_[擾
	std::vector<COrder*>::iterator	itOrder;

	for ( itOrder=m_vOrder.begin() ; m_vOrder.end() != itOrder ; itOrder++ )
	{
		if ( dwOrderId == (*itOrder)->m_dwOrderId )
		{
			break;
		}
	}
	if ( m_vOrder.end() != itOrder )
	{
		(*itOrder)->m_bReceiptEnd = TRUE;
	}

	return TRUE;
}

// ʂJn
// --------------------------------------------------
BOOL CPrintQue::DuplexStart( const DWORD dwOrderId )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if ( FALSE == GetNpsLib()->npsDevStartDuplex( dwOrderId ) )
	{
		return FALSE;
	}

	return TRUE;
}

// ʂI
// --------------------------------------------------
BOOL CPrintQue::DuplexEnd( const DWORD dwOrderId )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if ( FALSE == GetNpsLib()->npsDevEndDuplex( dwOrderId ) )
	{
		return FALSE;
	}

	return TRUE;
}

// R}ǉ
// --------------------------------------------------
BOOL CPrintQue::AddFrame( const DWORD dwOrderId, LPDWORD pPrintID, T_FRAME_PARAM* ptFrameParam )
{
	// 0.1mmC`ZdotɕϊNX
	class CChange
	{
	public:
		CChange() { m_dwResolution = 0; };
		CChange( DWORD dwResolution ) { m_dwResolution = dwResolution; };
		virtual ~CChange() {};
		void SetResolution( DWORD dwResolution ) { m_dwResolution = dwResolution; };
		DWORD MM2IN( DWORD dwValue ) { return ( ( dwValue * m_dwResolution / 254 + 5 ) / 10 ); };
	private:
		DWORD m_dwResolution;
	};

	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	// L[I[_[擾
	std::vector<COrder*>::iterator	itOrder;

	for ( itOrder=m_vOrder.begin() ; m_vOrder.end() != itOrder ; itOrder++ )
	{
		if ( dwOrderId == (*itOrder)->m_dwOrderId )
		{
			break;
		}
	}
	if ( m_vOrder.end() == itOrder )
	{
		AfxMessageBox( _T("CPrintQue::AddFrame() : I[_[JnĂ܂BuI[_[Jnv{^ĂsĂB") );
		return FALSE;
	}

	//======================================================================
	// 摜̍쐬
	//======================================================================
	CChange CHG;
	DWORD dwFrameNo = (DWORD)(*itOrder)->m_vFrame.size() + 1;
	CString strFileName;
	CString strText;
	CString str;
	CDib24 objDib;
	DWORD dwImgWidth;
	DWORD dwImgHeight;
	POINT tPoint = { 0 };
	CRect objFillRect;
	CRect objFrameRect;
	CRect objScaleRect;
	CRect objTxtRect;
	RECT tSp = { 0 };
	COLORREF tTxtColor = { 0 };

	CHG.SetResolution( ptFrameParam->dwResolution );

	dwImgWidth	= (( ptFrameParam->dwPaperWidth + ptFrameParam->tSpillOver.left + ptFrameParam->tSpillOver.right ) * ptFrameParam->dwResolution / 254 + 5 ) / 10;
	dwImgHeight	= (( ptFrameParam->dwPaperLength + ptFrameParam->tSpillOver.top + ptFrameParam->tSpillOver.bottom ) * ptFrameParam->dwResolution / 254 + 5 ) / 10;
	strFileName.Format( "%s\\NpsTesterImage_%010u_%04u.bmp", COMAPI::GetModuleFolder(), dwOrderId, dwFrameNo );
	objDib.Create( dwImgWidth, dwImgHeight );

	if ( 0 <= ptFrameParam->tSpillOver.left )
	{
		tSp.left = CHG.MM2IN( ptFrameParam->tSpillOver.left );
	}
	if ( 0 <= ptFrameParam->tSpillOver.right )
	{
		tSp.right = CHG.MM2IN( ptFrameParam->tSpillOver.right );
	}
	if ( 0 <= ptFrameParam->tSpillOver.top )
	{
		tSp.top = CHG.MM2IN( ptFrameParam->tSpillOver.top );
	}
	if ( 0 <= ptFrameParam->tSpillOver.bottom )
	{
		tSp.bottom = CHG.MM2IN( ptFrameParam->tSpillOver.bottom );
	}

	//----------------------------------------------------------------------
	// Og5m0.5mmԊuɓhׂ
	//----------------------------------------------------------------------
	COLORREF tColor[] = {
		RGB( 128, 128, 128 ),
		RGB( 224, 224, 224 ),
		RGB( 224, 224, 224 ),
		RGB( 224, 224, 224 ),
		RGB( 224, 224, 224 ),
	};
	if ( IMAGE_TYPE2 == ptFrameParam->eAccuracyType )
	{
		int nIdx = 0;

		for ( nIdx=0 ;; nIdx++ )
		{
			objFillRect.left	= ( nIdx * 5 * ptFrameParam->dwResolution / 254 + 5 ) / 10;
			objFillRect.top		= ( nIdx * 5 * ptFrameParam->dwResolution / 254 + 5 ) / 10;
			objFillRect.right	= dwImgWidth - 1  - ( nIdx * 5 * ptFrameParam->dwResolution / 254 + 5 ) / 10;
			objFillRect.bottom	= dwImgHeight - 1 - ( nIdx * 5 * ptFrameParam->dwResolution / 254 + 5 ) / 10;

			if ( objFillRect.top >= objFillRect.bottom )	break;
			if ( objFillRect.left >= objFillRect.right )	break;

			if ( 0 == ( nIdx % 2 ) )
			{
				objDib.FillRect( objFillRect, tColor[ nIdx / 2 % COUNTOF(tColor) ] );
			}
			else
			{
				objDib.FillRect( objFillRect, RGB( 255, 255, 255 ) );
			}
		}
	}

	//----------------------------------------------------------------------
	// E̕`
	//----------------------------------------------------------------------
	objFrameRect.SetRect( 0, 0, dwImgWidth - 1, dwImgHeight - 1 );
	objDib.FrameArea( objFrameRect, RGB( 255, 0, 0 ) );
	objFrameRect.SetRect( tSp.left, tSp.top, dwImgWidth - tSp.right - 1, dwImgHeight - tSp.bottom - 1 );
	objDib.FrameArea( objFrameRect, RGB( 0, 128, 128 ) );

	//----------------------------------------------------------------------
	// 6x6in.tHgubNΉ̃eXg摜
	//----------------------------------------------------------------------
#if 0
	CRect objKeisenH;
	CRect objKeisenV;
	CRect objImage;
	CRect objMark;

	// Z^[r
#if 1
	objKeisenH.SetRect( (dwImgWidth/2) - 1, 0, (dwImgWidth/2) - 1, dwImgHeight );	// c
	objDib.FrameArea( objKeisenH, RGB( 0, 0, 0 ) );
	objKeisenV.SetRect( 0, (dwImgHeight/2) - 1, dwImgWidth, (dwImgHeight/2) - 1 );	// 
	objDib.FrameArea( objKeisenV, RGB( 0, 0, 0 ) );
#else
	objKeisenH.SetRect( (dwImgWidth/2) - 1, 0, (dwImgWidth/2) - 1, CHG.MM2IN( 50 ) );	// c
	objDib.FrameArea( objKeisenH, RGB( 0, 0, 0 ) );
	objKeisenH.SetRect( (dwImgWidth/2) - 1, (dwImgHeight/2) - CHG.MM2IN( 50 ), (dwImgWidth/2) - 1, (dwImgHeight/2) + CHG.MM2IN( 50 ) );	// c
	objDib.FrameArea( objKeisenH, RGB( 0, 0, 0 ) );
	objKeisenH.SetRect( (dwImgWidth/2) - 1, dwImgHeight - CHG.MM2IN( 50 ) - 1, (dwImgWidth/2) - 1, dwImgHeight );	// c
	objDib.FrameArea( objKeisenH, RGB( 0, 0, 0 ) );

	objKeisenV.SetRect( 0, (dwImgHeight/2) - 1, CHG.MM2IN( 50 ), (dwImgHeight/2) - 1 );	// 
	objDib.FrameArea( objKeisenV, RGB( 0, 0, 0 ) );
	objKeisenV.SetRect( (dwImgWidth/2) - CHG.MM2IN( 50 ), (dwImgHeight/2) - 1, (dwImgWidth/2) + CHG.MM2IN( 50 ), (dwImgHeight/2) - 1 );	// 
	objDib.FrameArea( objKeisenV, RGB( 0, 0, 0 ) );
	objKeisenV.SetRect( dwImgWidth - CHG.MM2IN( 50 ), (dwImgHeight/2) - 1, dwImgWidth -1, (dwImgHeight/2) - 1 );	// 
	objDib.FrameArea( objKeisenV, RGB( 0, 0, 0 ) );
#endif

	int nMarge = 15;			// ̊Ԋu0.1mmP
	bool bFront = false;		// \

	// 摜`̈ ()
	objImage.SetRect(
			0,
			0,
			tSp.left + CHG.MM2IN( 1520 - nMarge ),
			tSp.top + CHG.MM2IN( 1520 - nMarge )
		);
	objDib.FrameArea( objImage, RGB( 0, 255, 0 ) );
	//objDib.FillRect( objImage, RGB( 64, 64, 64 ) );

	// 摜`̈ (E)
	objImage.SetRect(
			tSp.left + CHG.MM2IN( 1520 + 10 + nMarge ),
			0,
			dwImgWidth - 1,
			tSp.top + CHG.MM2IN( 1520 - nMarge )
		);
	objDib.FrameArea( objImage, RGB( 0, 255, 0 ) );
	//objDib.FillRect( objImage, RGB( 64, 64, 64 ) );

	// 摜`̈ ()
	objImage.SetRect(
			0,
			tSp.top + CHG.MM2IN( 1520 + 10 + nMarge ),
			tSp.left + CHG.MM2IN( 1520 - 10 ),
			dwImgHeight - 1
		);
	objDib.FrameArea( objImage, RGB( 0, 255, 0 ) );
	//objDib.FillRect( objImage, RGB( 64, 64, 64 ) );

	// 摜`̈ (E)
	objImage.SetRect(
			tSp.left + CHG.MM2IN( 1520 + 10 + nMarge ),
			tSp.top + CHG.MM2IN( 1520 + 10 + nMarge ),
			dwImgWidth - 1,
			dwImgHeight - 1
		);
	objDib.FrameArea( objImage, RGB( 0, 255, 0 ) );
	//objDib.FillRect( objImage, RGB( 64, 64, 64 ) );

	// }[N
if ( true == bFront ) {
	objMark.SetRect(
			objKeisenH.left - CHG.MM2IN( 5 + nMarge ),
			CHG.MM2IN( 100 ),
			objKeisenH.right,
			CHG.MM2IN( 150 )
		);
	objDib.FillRect( objMark, RGB( 0, 0, 0 ) );
}
if ( false == bFront ) {
	objMark.SetRect(
			objKeisenH.left - CHG.MM2IN( 5 + nMarge ),
			CHG.MM2IN( 200 ),
			objKeisenH.right,
			CHG.MM2IN( 250 )
		);
	objDib.FillRect( objMark, RGB( 0, 0, 0 ) );
}
#if 0
	objMark.SetRect(
			objKeisenH.left - CHG.MM2IN( 5 + nMarge ),
			CHG.MM2IN( 1620 ),
			objKeisenH.right,
			CHG.MM2IN( 1670 )
		);
	objDib.FillRect( objMark, RGB( 0, 0, 0 ) );

	objMark.SetRect(
			objKeisenH.left - CHG.MM2IN( 5 + nMarge ),
			CHG.MM2IN( 1720 ),
			objKeisenH.right,
			CHG.MM2IN( 1770 )
		);
	objDib.FillRect( objMark, RGB( 0, 0, 0 ) );
#endif
if ( true == bFront ) {
	objMark.SetRect(
			objKeisenH.left - CHG.MM2IN( 5 + nMarge ),
			CHG.MM2IN( 1820 ),
			objKeisenH.right,
			CHG.MM2IN( 1870 )
		);
	objDib.FillRect( objMark, RGB( 0, 0, 0 ) );
}
if ( false == bFront ) {
	objMark.SetRect(
			objKeisenH.left - CHG.MM2IN( 5 + nMarge ),
			CHG.MM2IN( 1920 ),
			objKeisenH.right,
			CHG.MM2IN( 1970 )
		);
	objDib.FillRect( objMark, RGB( 0, 0, 0 ) );
}

	// }[N
#if 0
	objMark.SetRect(
			CHG.MM2IN( 100 ),
			objKeisenV.top - CHG.MM2IN( 15 ),
			CHG.MM2IN( 150 ),
			objKeisenV.bottom
		);
	objDib.FillRect( objMark, RGB( 196, 64, 196 ) );
#endif
#if 0
	objMark.SetRect(
			CHG.MM2IN( 200 ),
			objKeisenV.top - CHG.MM2IN( 15 ),
			CHG.MM2IN( 250 ),
			objKeisenV.bottom
		);
	objDib.FillRect( objMark, RGB( 196, 64, 196 ) );
#endif
#if 0
	objMark.SetRect(
			CHG.MM2IN( 2640 ),
			objKeisenV.top,
			CHG.MM2IN( 2690 ),
			objKeisenV.bottom + CHG.MM2IN( 15 )
		);
	objDib.FillRect( objMark, RGB( 196, 64, 196 ) );
#endif
#if 0
	objMark.SetRect(
			CHG.MM2IN( 2740 ),
			objKeisenV.top,
			CHG.MM2IN( 2790 ),
			objKeisenV.bottom + CHG.MM2IN( 15 )
		);
	objDib.FillRect( objMark, RGB( 196, 64, 196 ) );
#endif
#if 0
	objMark.SetRect(
			CHG.MM2IN( 2840 ),
			objKeisenV.top,
			CHG.MM2IN( 2890 ),
			objKeisenV.bottom + CHG.MM2IN( 15 )
		);
	objDib.FillRect( objMark, RGB( 196, 64, 196 ) );
#endif
#if 0
	objMark.SetRect(
			CHG.MM2IN( 2940 ),
			objKeisenV.top,
			CHG.MM2IN( 2990 ),
			objKeisenV.bottom + CHG.MM2IN( 15 )
		);
	objDib.FillRect( objMark, RGB( 196, 64, 196 ) );
#endif
#endif

	//----------------------------------------------------------------------
	// XP[̕`
	//----------------------------------------------------------------------
	POINT tPos = { 0 };
	DWORD dwScaleHeight = 0;
	DWORD dwLengthByPixel = 0;

	tPos.x = 250;
	tPos.y = 250;
	dwScaleHeight = 100;
	dwLengthByPixel = ( 100 * ptFrameParam->dwResolution / 254 + 5 ) / 10;
	//  E (1cm)
	if ( 0 <= ptFrameParam->tSpillOver.right )
	{
		objScaleRect.SetRect( 0, dwImgHeight - tPos.y - dwScaleHeight, dwLengthByPixel, dwImgHeight - tPos.y );
		objDib.ScaleHorizontalArea( objScaleRect, ptFrameParam->dwResolution, RGB( 0, 0, 0 ) );
	}
	//   (1cm)
	if ( 0 <= ptFrameParam->tSpillOver.left )
	{
		objScaleRect.SetRect( dwImgWidth - dwLengthByPixel - 1, dwImgHeight - tPos.y - dwScaleHeight, dwImgWidth, dwImgHeight - tPos.y );
		objDib.ScaleHorizontalArea( objScaleRect, ptFrameParam->dwResolution, RGB( 0, 0, 0 ) );
	}
	// c  (1cm)
	if ( 0 <= ptFrameParam->tSpillOver.top )
	{
		objScaleRect.SetRect( dwImgWidth - tPos.x - dwScaleHeight, 0, dwImgWidth - tPos.x, dwLengthByPixel );
		objDib.ScaleVerticalArea( objScaleRect, ptFrameParam->dwResolution, RGB( 0, 0, 0 ) );
	}
	// c  (1cm)
	if ( 0 <= ptFrameParam->tSpillOver.bottom )
	{
		objScaleRect.SetRect( dwImgWidth - tPos.x - dwScaleHeight, dwImgHeight - dwLengthByPixel - 1, dwImgWidth - tPos.x, dwImgHeight );
		objDib.ScaleVerticalArea( objScaleRect, ptFrameParam->dwResolution, RGB( 0, 0, 0 ) );
	}

	dwScaleHeight = 50;
	if ( IMAGE_TYPE1 == ptFrameParam->eAccuracyType )
	{
		tPos.x = 150;
		tPos.y = 150;
	}
	else
	{
		tPos.x = ( dwImgWidth - dwScaleHeight ) / 2;
		tPos.y = ( dwImgHeight - dwScaleHeight ) / 2;
	}
	// 
	objScaleRect.SetRect( tSp.left, dwImgHeight - tPos.y - dwScaleHeight, dwImgWidth - tSp.right, dwImgHeight - tPos.y );
	objDib.ScaleHorizontalArea( objScaleRect, ptFrameParam->dwResolution, RGB( 128, 128, 0 ) );
	// c
	objScaleRect.SetRect( dwImgWidth - tPos.x - dwScaleHeight, tSp.top, dwImgWidth - tPos.x, dwImgHeight - tSp.bottom );
	objDib.ScaleVerticalArea( objScaleRect, ptFrameParam->dwResolution, RGB( 128, 0, 128 ) );

	//----------------------------------------------------------------------
	// ̕`
	//----------------------------------------------------------------------

	// Jnʒu
	if ( IMAGE_TYPE1 == ptFrameParam->eAccuracyType )
	{
		tPoint.x = 10/*P:mm*/ * ptFrameParam->dwResolution / 254;
		tPoint.y = 10/*P:mm*/ * ptFrameParam->dwResolution / 254;
	}
	else
	{
		tPoint.x = ( dwImgWidth - ( 70/*P:mm*/ * ptFrameParam->dwResolution / 254 ) ) / 2;
		tPoint.y = ( dwImgHeight - ( 30/*P:mm*/ * ptFrameParam->dwResolution / 254 ) ) / 2;
	}
	tTxtColor = RGB( 0, 0, 0 );

	// OrderId / D惌x / R}ԍ
	if ( 0 == (*itOrder)->m_tOrderParam.dwPriority )
	{
		tTxtColor = RGB( 0, 0, 255 );	// ʏ F
	}
	else
	{
		tTxtColor = RGB( 255, 0, 0 );	// } ԐF
	}
	strText.Format( "D惌x = %s     OrderId = %u     R}ԍ = %u", (*itOrder)->GetPriorityString(), dwOrderId, dwFrameNo );
	objTxtRect.SetRect( tPoint.x, tPoint.y, dwImgWidth, dwImgHeight );
	objDib.TextArea( objTxtRect, strText, 28, FW_BOLD, FALSE, _T("lr SVbN"), tTxtColor, DT_LEFT );
	// @:Ж,
	tTxtColor = RGB( 0, 0, 0 );
	switch ( ptFrameParam->eDuplexType )
	{
	case SINGLE:		str.Format( _T("%s:Ж"),		( 0 == ptFrameParam->dwFeed ) ? _T("[") : _T("V[g") );	break;
	case DUPLEX_FRONT:	str.Format( _T("%s:(\)"),	( 0 == ptFrameParam->dwFeed ) ? _T("[") : _T("V[g") );	break;
	case DUPLEX_BACK:	str.Format( _T("%s:()"),	( 0 == ptFrameParam->dwFeed ) ? _T("[") : _T("V[g") );	break;
	}
	strText.Format( "%s", str );
	objTxtRect -= CRect( 0, 50, 0, 0 );
	objDib.TextArea( objTxtRect, strText, 28, FW_BOLD, FALSE, _T("lr SVbN"), tTxtColor, DT_LEFT );
	// dオ萡@
	if ( 0 == ptFrameParam->dwFeed )
	{
		strText.Format( "dオ萡@ = %.1fmm x %.1fmm", (double)ptFrameParam->dwPaperWidth / 10., (double)ptFrameParam->dwPaperLength / 10. );
	}
	else
	{
		strText.Format( "dオ萡@ = %s ( %.1fmm x %.1fmm )", ptFrameParam->szPaperName, (double)ptFrameParam->dwPaperWidth / 10., (double)ptFrameParam->dwPaperLength / 10. );
	}
	objTxtRect -= CRect( 0, 50, 0, 0 );
	objDib.TextArea( objTxtRect, strText, 28, FW_BOLD, FALSE, _T("lr SVbN"), tTxtColor, DT_LEFT );
	// 摜TCY
	strText.Format( "摜TCY = %ux%u pixel", dwImgWidth, dwImgHeight );
	objTxtRect -= CRect( 0, 50, 0, 0 );
	objDib.TextArea( objTxtRect, strText, 28, FW_BOLD, FALSE, _T("lr SVbN"), tTxtColor, DT_LEFT );
	// ʎ
	strText.Format( "ʎ = %u", ptFrameParam->dwSurface );
	objTxtRect -= CRect( 0, 50, 0, 0 );
	objDib.TextArea( objTxtRect, strText, 28, FW_BOLD, FALSE, _T("lr SVbN"), tTxtColor, DT_LEFT );
	// s[g
	strText.Format( "s[g = %u", ptFrameParam->dwPrintNum );
	objTxtRect -= CRect( 0, 50, 0, 0 );
	objDib.TextArea( objTxtRect, strText, 28, FW_BOLD, FALSE, _T("lr SVbN"), tTxtColor, DT_LEFT );
	// t
	strText.Format( "t = ( []%.1fmm, []%.1fmm, [E]%.1fmm, []%.1fmm )",
						(double)ptFrameParam->tSpillOver.left / 10., (double)ptFrameParam->tSpillOver.top / 10.,
						(double)ptFrameParam->tSpillOver.right / 10., (double)ptFrameParam->tSpillOver.bottom / 10. );
	objTxtRect -= CRect( 0, 50, 0, 0 );
	objDib.TextArea( objTxtRect, strText, 28, FW_BOLD, FALSE, _T("lr SVbN"), tTxtColor, DT_LEFT );
	// vgvs
	SYSTEMTIME tTime;
	GetLocalTime( &tTime );
	strText.Format( "vgvs = %04u/%02u/%02u %02u:%02u'%02u",
						tTime.wYear, tTime.wMonth, tTime.wDay,
						tTime.wHour, tTime.wMinute, tTime.wSecond );
	objTxtRect -= CRect( 0, 50, 0, 0 );
	objDib.TextArea( objTxtRect, strText, 28, FW_BOLD, FALSE, _T("lr SVbN"), tTxtColor, DT_LEFT );
	// Pvg	2014.10.31 M.Yamamoto
	strText.Format( "Pvg = %s", (*itOrder)->GetSingleLinePrintString() );
	objTxtRect -= CRect( 0, 50, 0, 0 );
	objDib.TextArea( objTxtRect, strText, 28, FW_BOLD, FALSE, _T("lr SVbN"), tTxtColor, DT_LEFT );

	//----------------------------------------------------------------------
	// BMPt@C̍쐬
	//----------------------------------------------------------------------
	if ( FALSE == objDib.WriteBMP( strFileName ) )
	{
		AfxMessageBox( _T("CPrintQue::AddFrame() : 摜t@C݂̏Ɏs܂B") );
		return FALSE;
	}

	//======================================================================
	// p[^̐ݒ
	//======================================================================
	NPS_PrintInfo tPrintInfo = { 0 };

	tPrintInfo.dwImageFormat		= IMGFMT_BMP;
	tPrintInfo.dwColorSpace			= ICS_SRGB;
	tPrintInfo.dwSourceType			= IMGSRC_FILE;
	tPrintInfo.dwDataLength			= COMAPI::GetFileSize( strFileName );
	tPrintInfo.pName				= strFileName;
	tPrintInfo.dwOffset				= 0;
	tPrintInfo.dwImgWidth			= objDib.GetWidth();
	tPrintInfo.dwImgHeight			= objDib.GetHeight();
	tPrintInfo.dwResolution			= ptFrameParam->dwResolution;
	tPrintInfo.dwPaperWidth			= ptFrameParam->dwPaperWidth;
	tPrintInfo.dwPaperLength		= ptFrameParam->dwPaperLength;
	tPrintInfo.dwCvpPrintSize		= CVPSIZE_SMALL;
	if ( SINGLE == ptFrameParam->eDuplexType )
	{
		tPrintInfo.dwCvpInitialValue1	= 1;
		tPrintInfo.dwCvpPoint1			= 37;
		tPrintInfo.dwCvpInitialWidth1	= 4;
#if _MSC_VER >= 1400
		sprintf_s( tPrintInfo.szCvpLine1, "Line1 OrderId=%-4d Frame=%-4d Repeat=#### Size=%dx%d", dwOrderId, dwFrameNo, ptFrameParam->dwPaperWidth, ptFrameParam->dwPaperLength );
#else
		sprintf( tPrintInfo.szCvpLine1, "Line1 OrderId=%-4d Frame=%-4d Repeat=#### Size=%dx%d", dwOrderId, dwFrameNo, ptFrameParam->dwPaperWidth, ptFrameParam->dwPaperLength );
#endif
		tPrintInfo.dwCvpInitialValue2	= 0;
		tPrintInfo.dwCvpPoint2			= 0;
		tPrintInfo.dwCvpInitialWidth2	= 0;
#if _MSC_VER >= 1400
		sprintf_s( tPrintInfo.szCvpLine2, "1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890" );
#else
		sprintf( tPrintInfo.szCvpLine2, "1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890" );
#endif
	}
	tPrintInfo.dwPrintNum			= ptFrameParam->dwPrintNum;
	tPrintInfo.dwFeed				= ptFrameParam->dwFeed;
	tPrintInfo.dwSurface			= ptFrameParam->dwSurface;
	tPrintInfo.dwPaperPresence		= 0;
	tPrintInfo.nEspc				= 0;
	tPrintInfo.wCMS					= PROC_CMSOFF;
	tPrintInfo.wAngle				= PROC_ANGLE0;
	tPrintInfo.wPaperFitting		= PROC_REALSIZE;
	tPrintInfo.wEdgeEnhancement		= PROC_EE_OFF;
	tPrintInfo.wWithBorderTop		= 0;
	tPrintInfo.wWithBorderBottom	= 0;
	tPrintInfo.wWithBorderLeft		= 0;
	tPrintInfo.wWithBorderRight		= 0;
	tPrintInfo.byWithBorderColor[0]	= 255;
	tPrintInfo.byWithBorderColor[1]	= 255;
	tPrintInfo.byWithBorderColor[2]	= 255;
	CopyMemory( tPrintInfo.szPaperName, ptFrameParam->szPaperName, sizeof(tPrintInfo.szPaperName) );
	tPrintInfo.nPcfms				= 0;
	tPrintInfo.wPrintQuality		= PROC_PRNQLT_NORMAL;
	tPrintInfo.byImageEnlargeType	= PROC_IMGENLG_BILINEAR;

	// R}h̔s
	if ( FALSE == GetNpsLib()->npsDevPrint( dwOrderId, pPrintID, &tPrintInfo ) )
	{
		return FALSE;
	}

	// L[ւ̓o^
	CFrame* pobjFrame = NULL;

	try {
		pobjFrame = new CFrame;
		pobjFrame->m_dwPrintID = *pPrintID;
		pobjFrame->m_strFileName = strFileName;
		CopyMemory( &pobjFrame->m_tFrameParam, ptFrameParam, sizeof(T_FRAME_PARAM) );
		pobjFrame->m_tFrameStatus.dwRepeat = pobjFrame->m_tFrameParam.dwPrintNum;
	}
	catch (...) {
		AfxMessageBox( _T("CPrintQue::AddFrame() : ̈̊mۂɎs܂B") );
		return FALSE;
	}

	(*itOrder)->m_vFrame.push_back( pobjFrame );
	(*itOrder)->m_tOrderStatus.dwFrame = (DWORD)(*itOrder)->m_vFrame.size();

	return TRUE;
}

// \[gǉ
// --------------------------------------------------
BOOL CPrintQue::AddSort( const DWORD dwOrderId )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if ( FALSE == GetNpsLib()->npsDevSort( dwOrderId ) )
	{
		return FALSE;
	}

	return TRUE;
}

// I[_[폜
// --------------------------------------------------
BOOL CPrintQue::DelOrder( const DWORD dwOrderId )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	GetNpsLib()->npsDevCancelPrintOrder( dwOrderId, 0 );

	// L[I[_[擾
	std::vector<COrder*>::iterator	itOrder;

	for ( itOrder=m_vOrder.begin() ; m_vOrder.end() != itOrder ; itOrder++ )
	{
		if ( dwOrderId == (*itOrder)->m_dwOrderId )
		{
			break;
		}
	}
	if ( m_vOrder.end() != itOrder )
	{
		(*itOrder)->m_bReceiptEnd = TRUE;
	}

	return TRUE;
}

// R}폜
// --------------------------------------------------
BOOL CPrintQue::DelFrame( const DWORD dwOrderId, DWORD dwPrintID )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if ( FALSE == GetNpsLib()->npsDevCancelPrintOrder( dwOrderId, dwPrintID ) )
	{
		return FALSE;
	}

	return TRUE;
}

// I[_[̏\
void CPrintQue::DrawInitial( CTreeCtrl* pobjTreeCtrl )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	pobjTreeCtrl->DeleteAllItems();
	HTREEITEM hRoot = pobjTreeCtrl->GetRootItem();
	pobjTreeCtrl->InsertItem( ORDER_INFO_TREE_ROOT_STRING, hRoot );
}

// I[_[̕\XV
// --------------------------------------------------
void CPrintQue::DrawUpdate( CTreeCtrl* pobjTreeCtrl )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if ( 0 < m_vOrder.size() )
	{
		// c[Rg[ւ̒ǉƍXV
		CString strOrderText;
		CString strFrameText;

		HTREEITEM hRoot = pobjTreeCtrl->GetNextItem( NULL, TVGN_ROOT );
		HTREEITEM hOrder = NULL;
		HTREEITEM hFrame = NULL;

		std::vector<COrder*>::iterator	itOrder;
		std::vector<CFrame*>::iterator	itFrame;

		for ( itOrder=m_vOrder.begin() ; m_vOrder.end() != itOrder ; itOrder++ )
		{
			strOrderText.Format( "%08u [%u-%u-%u-%u] %s %s",
									(*itOrder)->m_dwOrderId,
									(*itOrder)->m_tOrderStatus.dwFrame,
									(*itOrder)->m_tOrderStatus.dwFrameTransfer,
									(*itOrder)->m_tOrderStatus.dwFramePrint,
									(*itOrder)->m_tOrderStatus.dwFrameOutput,
									(*itOrder)->GetPriorityString(),
									(*itOrder)->GetStatusString() );

			for ( hOrder=pobjTreeCtrl->GetNextItem( hRoot, TVGN_CHILD ); NULL != hOrder ; hOrder=pobjTreeCtrl->GetNextItem( hOrder, TVGN_NEXT ) )
			{
				if ( (*itOrder)->m_dwOrderId == pobjTreeCtrl->GetItemData( hOrder ) )
				{
					break;
				}
			}
			if ( NULL == hOrder )
			{
				// VKǉ
				hOrder = pobjTreeCtrl->InsertItem( strOrderText, hRoot );
				pobjTreeCtrl->SetItemData( hOrder, (*itOrder)->m_dwOrderId );
			}
			else
			{
				// f[^XV
				pobjTreeCtrl->SetItemText( hOrder, strOrderText );
			}

			for ( itFrame=(*itOrder)->m_vFrame.begin() ; (*itOrder)->m_vFrame.end() != itFrame ; itFrame++ )
			{
				strFrameText.Format( "%06u [%u-%u-%u-%u] %s %s",
										(*itFrame)->m_dwPrintID,
										(*itFrame)->m_tFrameStatus.dwRepeat,
										(*itFrame)->m_tFrameStatus.dwTransfer,
										(*itFrame)->m_tFrameStatus.dwPrint,
										(*itFrame)->m_tFrameStatus.dwOutput,
										(*itFrame)->GetDuplexTypeString(),
										(*itFrame)->GetStatusString() );

				for ( hFrame=pobjTreeCtrl->GetNextItem( hOrder, TVGN_CHILD ); NULL != hFrame ; hFrame=pobjTreeCtrl->GetNextItem( hFrame, TVGN_NEXT ) )
				{
					if ( (*itFrame)->m_dwPrintID == pobjTreeCtrl->GetItemData( hFrame ) )
					{
						break;
					}
				}
				if ( NULL == hFrame )
				{
					// VKǉ
					hFrame = pobjTreeCtrl->InsertItem( strFrameText, hOrder );
					pobjTreeCtrl->SetItemData( hFrame, (*itFrame)->m_dwPrintID );
				}
				else
				{
					// f[^XV
					pobjTreeCtrl->SetItemText( hFrame, strFrameText );
				}
			}

			// pobjTreeCtrl->Expand( hOrder, TVE_EXPAND );
		}

		pobjTreeCtrl->Expand( hRoot, TVE_EXPAND );
	}
}

// I[_[ԂXV
// --------------------------------------------------
void CPrintQue::UpdateOrderStatus( NPSORDERINFO* ptOrderInfo )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	std::vector<COrder*>::iterator	itOrder;

	for ( itOrder=m_vOrder.begin() ; m_vOrder.end() != itOrder ; itOrder++ )
	{
		if ( (*itOrder)->m_dwOrderId == ptOrderInfo->dwOrderId )
		{
			// I[_[I
			(*itOrder)->m_bOrderEnd = TRUE;
			(*itOrder)->m_dwEndStatus = ptOrderInfo->dwStatus;
			break;
		}
	}
}

// R}ԂXV
// --------------------------------------------------
void CPrintQue::UpdateFrameStatus( NPSPRINTINFO* ptPrintInfo )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	std::vector<COrder*>::iterator	itOrder;
	std::vector<CFrame*>::iterator	itFrame;

	for ( itOrder=m_vOrder.begin() ; m_vOrder.end() != itOrder ; itOrder++ )
	{
		for ( itFrame=(*itOrder)->m_vFrame.begin() ; (*itOrder)->m_vFrame.end() != itFrame ; itFrame++ )
		{
			if ( (*itFrame)->m_dwPrintID == ptPrintInfo->dwPrintId )
			{
				// R}ԍXV
				switch ( ptPrintInfo->dwStatus )
				{
				case RESULT_TRANSFER:
					(*itFrame)->m_tFrameStatus.dwTransfer	= ptPrintInfo->dwFinishNum;
					if ( 0 == ptPrintInfo->dwFinishNum )
					{
						(*itFrame)->m_bFrameEnd = TRUE;
						// KvȂ̂ŉ摜t@C폜
						::DeleteFile( (*itFrame)->m_strFileName );
					}
					(*itOrder)->m_tOrderStatus.dwFrameTransfer++;
					break;
				case RESULT_PRINT:
					(*itFrame)->m_tFrameStatus.dwPrint		= ptPrintInfo->dwFinishNum;
					if ( 0 == ptPrintInfo->dwFinishNum )
					{
						(*itFrame)->m_bFrameEnd = TRUE;
					}
					(*itOrder)->m_tOrderStatus.dwFramePrint++;
					// KvȂ̂ŉ摜t@C폜
					::DeleteFile( (*itFrame)->m_strFileName );
					break;
				case RESULT_OK:
					(*itFrame)->m_tFrameStatus.dwOutput		= ptPrintInfo->dwFinishNum;
					(*itFrame)->m_bFrameEnd = TRUE;
					(*itOrder)->m_tOrderStatus.dwFrameOutput++;
					break;
				case RESULT_OK_REPEAT:
					(*itFrame)->m_tFrameStatus.dwOutput		= ptPrintInfo->dwFinishNum;
					break;
				case RESULT_PRINT_REPEAT:
					(*itFrame)->m_tFrameStatus.dwPrint		= ptPrintInfo->dwFinishNum;
					break;
				}
				break;
			}
		}
	}
}

// IĂI[_[̓R}LZł邩mF
// --------------------------------------------------
BOOL CPrintQue::IsCanCancel( CTreeCtrl* pobjTreeCtrl )
{
	HTREEITEM hTreeItem = pobjTreeCtrl->GetSelectedItem();
	if ( NULL != hTreeItem )
	{
		CString strText = pobjTreeCtrl->GetItemText( hTreeItem );
		if ( 0 != strText.Compare( ORDER_INFO_TREE_ROOT_STRING ) )
		{
			return TRUE;
		}
	}

	return FALSE;
}

// I[_[̓R}LZ
// --------------------------------------------------
void CPrintQue::Cancel( CTreeCtrl* pobjTreeCtrl )
{
	DWORD dwOrderId = 0;
	DWORD dwPrintID = 0;
	HTREEITEM hTreeItem = NULL;
	HTREEITEM hParent = NULL;

	hTreeItem = pobjTreeCtrl->GetSelectedItem();

	if ( NULL != hTreeItem )
	{
		hParent = pobjTreeCtrl->GetParentItem( hTreeItem );
		if ( NULL != hParent )
		{
			CString strText = pobjTreeCtrl->GetItemText( hParent );
			if ( 0 == strText.Compare( ORDER_INFO_TREE_ROOT_STRING ) )
			{
				// I[_[
				dwOrderId = (DWORD)pobjTreeCtrl->GetItemData( hTreeItem );
				DelOrder( dwOrderId );
			}
			else
			{
				// R}
				dwOrderId = (DWORD)pobjTreeCtrl->GetItemData( hParent );
				dwPrintID = (DWORD)pobjTreeCtrl->GetItemData( hTreeItem );
				DelFrame( dwOrderId, dwPrintID );
			}
		}
	}
}
