// StatusInfo.cpp: CStatusInfo NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "npstester.h"
#include "StatusInfo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CStatusInfo* g_objStatusInfo = NULL;

void CreateStatusInfo()			{ g_objStatusInfo = new CStatusInfo; };
void DropStatusInfo()			{ delete g_objStatusInfo; };
CStatusInfo* GetStatusInfo()	{ return g_objStatusInfo; };

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CStatusInfo::CStatusInfo()
{
	::InitializeCriticalSection( &m_csMemberData );

	m_hItem_npsDevGetUnitInfo		= NULL;
	m_hItem_npsDevGetSetUpInfo		= NULL;
	m_hItem_npsDevGetMagInfo		= NULL;
	m_hItem_npsDevGetTime			= NULL;
	m_hItem_npsDevGetPrintNumInfo	= NULL;
}

CStatusInfo::~CStatusInfo()
{
	::DeleteCriticalSection( &m_csMemberData );
}

void CStatusInfo::DataUpdate( CTreeCtrl* pobjTreeCtrl )
{
	//if ( TVIS_EXPANDED & pobjTreeCtrl->GetItemState( m_hItem_npsDevGetUnitInfo, TVIS_EXPANDED ) )
	if ( pobjTreeCtrl->GetCheck( m_hItem_npsDevGetUnitInfo ) )
	{
		GetNpsLib()->npsDevGetUnitInfo();
	}

	//if ( TVIS_EXPANDED & pobjTreeCtrl->GetItemState( m_hItem_npsDevGetSetUpInfo, TVIS_EXPANDED ) )
	if ( pobjTreeCtrl->GetCheck( m_hItem_npsDevGetSetUpInfo ) )
	{
		GetNpsLib()->npsDevGetSetUpInfo();
	}

	//if ( TVIS_EXPANDED & pobjTreeCtrl->GetItemState( m_hItem_npsDevGetMagInfo, TVIS_EXPANDED ) )
	if ( pobjTreeCtrl->GetCheck( m_hItem_npsDevGetMagInfo ) )
	{
		GetNpsLib()->npsDevGetMagInfo();
	}

	//if ( TVIS_EXPANDED & pobjTreeCtrl->GetItemState( m_hItem_npsDevGetTime, TVIS_EXPANDED ) )
	if ( pobjTreeCtrl->GetCheck( m_hItem_npsDevGetTime ) )
	{
		GetNpsLib()->npsDevGetTime();
	}

	//if ( TVIS_EXPANDED & pobjTreeCtrl->GetItemState( m_hItem_npsDevGetPrintNumInfo, TVIS_EXPANDED ) )
	if ( pobjTreeCtrl->GetCheck( m_hItem_npsDevGetPrintNumInfo ) )
	{
		GetNpsLib()->npsDevGetPrintNumInfo();
	}
}

// ʕ\
// --------------------------------------------------
void CStatusInfo::DrawInitial( CTreeCtrl* pobjTreeCtrl )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	pobjTreeCtrl->DeleteAllItems();
	HTREEITEM hRoot = pobjTreeCtrl->GetRootItem();
	HTREEITEM hMain = NULL;
	HTREEITEM hSub = NULL;

	hMain = pobjTreeCtrl->InsertItem( "npsDevGetMagInfo", hRoot );	m_hItem_npsDevGetMagInfo = hMain;
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_MagInfo_Element1 ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_MagInfo_Element2 ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_MagInfo_Element3 ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_MagInfo_Element4 ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_MagInfo_Element5 ) );

	hMain = pobjTreeCtrl->InsertItem( "npsDevGetUnitInfo", hRoot );	m_hItem_npsDevGetUnitInfo = hMain;
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwPrinterStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwAcceptStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwPrinterPossession ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwAdvanceStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwLaserStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwDevelopmentStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwProcessorStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwReplenisherStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwReplaceCartridgeStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwStartUpChecksStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwRefillWaterStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwDailySetupStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwControlStripStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwMaintenanceStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_dwFadStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_stInstMag ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_UnitInfo_stInfoMag ) );
	//pobjTreeCtrl->Expand( hMain, TVE_EXPAND );

	hMain = pobjTreeCtrl->InsertItem( "npsDevGetSetUpInfo", hRoot );	m_hItem_npsDevGetSetUpInfo = hMain;
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_szMachineTypeName ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_szSoftName ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_szSerialNumber ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wSupportResolutions ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wNpsVersion ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wMachineTypeID ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_dwTotalMemory ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_dwImageSizeMinWidth ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_dwImageSizeMinHeight ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_dwImageSizeMaxWidth ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_dwImageSizeMaxHeight ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_dwNumberOfMagazine ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_PrinterTime ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_dwRepeatCountMax ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_SupportImageFormat ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wLaminatorUnitAttach ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_InstallationDate ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_OperationStartDate ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wProcessorType ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wEmulsionNumber ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_szPrinterNickname ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wSupportAngle ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wSupportIntoPrinter ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wSorterStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wCvpStatus ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wSupportPaperFitting ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wSupportEdgeEnhancement ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wSupportWithBorder ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wMachinTypeForProfile ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wPaperTypeCode ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wSupportCMS ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wSetupAlgorithm ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wSupportDuplex ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_dwFadAttachNo ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_SetUpInfo_wSupportInterrupt ) );	// @@@RD-151Ή	2012.02.20	T.Mizushima

	hMain = pobjTreeCtrl->InsertItem( "npsDevGetTime", hRoot );		m_hItem_npsDevGetTime = hMain;
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_DateTime_tDate ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_DateTime_tTime ) );

	hMain = pobjTreeCtrl->InsertItem( "npsDevGetPrintNumInfo", hRoot );	m_hItem_npsDevGetPrintNumInfo = hMain;
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_PrintNumInfo_dwSdkReserver ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_PrintNumInfo_dwFrmRatio ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_PrintNumInfo_dwReserver ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_PrintNumInfo_dwPrtNumber ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_PrintNumInfo_dwProNumber ) );
	hSub = pobjTreeCtrl->InsertItem( "", hMain );	m_vTreeInfo.push_back( CTreeInfo( hSub, NPS_PrintNumInfo_dwTotalCount ) );

	DrawUpdate( pobjTreeCtrl );
}

// --------------------------------------------------
void CStatusInfo::DrawUpdate( CTreeCtrl* pobjTreeCtrl )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	std::vector<CTreeInfo>::iterator itTreeInfo;

	for ( itTreeInfo=m_vTreeInfo.begin() ; m_vTreeInfo.end() != itTreeInfo ; itTreeInfo++ )
	{
		pobjTreeCtrl->SetItemText( (*itTreeInfo).m_hItem, GetNpsLib()->GetStringData( (*itTreeInfo).m_eType ) );
	}
}
