// NkcLogCommon1.cpp: CNkcLogCommon NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef	CNKCLOGCOMMON_STATIC
#include "nkcLogCommonStatic.h"
#else
#include "nkcLogCommon.h"
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define MAX_LOGGER_NAME		32
#define MAX_FILE_NAME		32
#define MAX_MESSAGE			256

#define NORITSU_HELPER		1

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CNkcLogCommon::CNkcLogCommon()
{

}

CNkcLogCommon::~CNkcLogCommon()
{
	if( NULL != iniInfo.logger)
	{
		delete [] (char*)iniInfo.logger;
		iniInfo.logger = NULL;
	}
	if( NULL != iniInfo.filename)
	{
		delete [] (char*)iniInfo.filename;
		iniInfo.filename = NULL;
	}
	EndLog();
}

///////////////////////////////////////////////////////////////////////////
// MODULE   : CNkcLogCommon::CNkcLogCommon
//
// UPDATE	 : S.AOKI(AVASYS) 2008.07.14 VS2005Ή̂
///////////////////////////////////////////////////////////////////////////
CNkcLogCommon::CNkcLogCommon( LPCSTR configFile, LPCSTR localPath )
{
	//oϐ̏
	m_hFile = INVALID_HANDLE_VALUE;
	m_hMapping = NULL;
	m_pMappingView = NULL;
	m_pMutex = NULL;
	iniInfo.logger = NULL;
	iniInfo.filename = NULL;

	char s1[MAX_INI_PARAM];
	char s2[MAX_INI_PARAM];
	BOOL bIniFile;
	BOOL bSharedMem;
	bSharedMem = FALSE;

	iniInfo.logger = new char[MAX_INI_PARAM];
	iniInfo.filename = new char[MAX_INI_PARAM];

	//2007.10.17 M.Ohkubo VistaΉ
	//OSo[WmF
	OSVERSIONINFOEX	osInfo;		// OSo[W
	ZeroMemory(&osInfo, sizeof(OSVERSIONINFOEX));
	osInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	BOOL bOsType = TRUE;//OSfptO(vista)
	//OSf
	if( GetVersionEx( (OSVERSIONINFO*)&osInfo ) )
	{
		if( osInfo.dwMajorVersion == 5 && osInfo.dwMinorVersion == 0 )
			bOsType = FALSE;//2K
		if( osInfo.dwMajorVersion == 5 && osInfo.dwMinorVersion == 1 )
		bOsType = FALSE;//XP
	}

	//ZLeB VistaΉ
	SECURITY_DESCRIPTOR sd = { 0 };
	SECURITY_ATTRIBUTES sa = { 0 };
	// SɃANZX
	InitializeSecurityDescriptor( &sd, SECURITY_DESCRIPTOR_REVISION );
	SetSecurityDescriptorDacl( &sd, TRUE, NULL, FALSE );
	sa.nLength				= sizeof(sa);
	sa.lpSecurityDescriptor = &sd;
	sa.bInheritHandle		= TRUE;

/*----------NoritsuHelperΉ----------*/
#if	(NORITSU_HELPER)

	char m_strStartupName[256];
	m_pStatrUpMutex = NULL;
	if( bOsType == false){//Create mutex name
		sprintf( m_strStartupName, "%s", STARTUP_MUTEX_NAME );
	}else{
		sprintf( m_strStartupName, "%s%s",  "Global\\" ,STARTUP_MUTEX_NAME );
	}
	m_pStatrUpMutex = new CMutex( FALSE, m_strStartupName, &sa );

	::ZeroMemory( s2, MAX_INI_PARAM );
	if(configFile!=NULL){
		memcpy( s2, configFile, strlen( configFile ) );
	}

	GetFullFilePath( s2, localPath );//t@C̃tpX擾

	CreateStartUpLogInfo( s2 );

	memcpy(inifilename,s2,MAX_PATH);//init@Cޔ
#endif
/*-------------------------------------*/

	// t@C݃`FbN
	bIniFile = ::PathFileExists( s2 );
	// init@C݂ȂꍇAftHglݒ肵AOo͂Ȃ
	if( !bIniFile )
	{
		strcpy( (char*)iniInfo.logger, "controller" );
		iniInfo.maxline = LOG_MAXLINE_DEFAUT;
		strcpy( (char*)iniInfo.filename, "default.log");
		iniInfo.levelfatal = LOGLEVEL_NOT_OUT;
		iniInfo.levelwarn  = LOGLEVEL_NOT_OUT;
		iniInfo.levelinfo  = LOGLEVEL_NOT_OUT;
		iniInfo.leveldebug = LOGLEVEL_NOT_OUT;

		TRACE(_T("Could not find iniFile\n"));
	}
	// init@C݂ꍇ
	else
	{
		GetPrivateProfileString( "log", "logger", ERR, s1, sizeof(s1), s2 );
		memcpy( (char*)(iniInfo.logger), s1, sizeof(s1) );

		iniInfo.maxline = GetPrivateProfileInt( "log", "maxline", LOG_MAXLINE_LOW, s2 );

		GetPrivateProfileString( "log", "filename", ERR, s1, sizeof(s1), s2 );
		GetFullFilePath( s1, localPath );//t@C̃tpX擾
		memcpy( (char*)(iniInfo.filename), s1, sizeof(s1) );

		iniInfo.levelfatal = GetPrivateProfileInt( "log", "levelfatal", LOGLEVEL_NOT_OUT, s2 );
		iniInfo.levelwarn  = GetPrivateProfileInt( "log", "levelwarn" , LOGLEVEL_NOT_OUT, s2 );
		iniInfo.levelinfo  = GetPrivateProfileInt( "log", "levelinfo" , LOGLEVEL_NOT_OUT, s2 );
		iniInfo.leveldebug = GetPrivateProfileInt( "log", "leveldebug", LOGLEVEL_NOT_OUT, s2 );

		// init@Cp[^̃G[`FbN
		if( iniInfo.maxline < LOG_MAXLINE_LOW )
		{
			iniInfo.maxline = LOG_MAXLINE_LOW;
		}
		else if( iniInfo.maxline > LOG_MAXLINE_HIGH )
		{
			iniInfo.maxline = LOG_MAXLINE_HIGH;
		}

		if ((iniInfo.levelfatal != 0) && (iniInfo.levelfatal != 1))
		{
			iniInfo.levelfatal = LOGLEVEL_NOT_OUT;	// o͂Ȃ
		}

		if ((iniInfo.levelwarn != 0) && (iniInfo.levelwarn != 1))
		{
			iniInfo.levelwarn = LOGLEVEL_NOT_OUT;	// o͂Ȃ
		}

		if ((iniInfo.levelinfo != 0) && (iniInfo.levelinfo != 1))
		{
			iniInfo.levelinfo = LOGLEVEL_NOT_OUT;	// o͂Ȃ
		}

		if ((iniInfo.leveldebug != 0) && (iniInfo.leveldebug != 1))
		{
			iniInfo.leveldebug = LOGLEVEL_NOT_OUT;	// o͂Ȃ
		}
	}

	try
	{
		// xx̃}bv쐬
		m_LevelMap.SetAt( 0, "FATAL" );
		m_LevelMap.SetAt( 1, "WARN" );
		m_LevelMap.SetAt( 2, "INFO" );
		m_LevelMap.SetAt( 3, "DEBUG" );

		// t@Cnh擾
/*		m_hFile = ::CreateFile(
			iniInfo.filename,
			GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ,
			0,
			OPEN_ALWAYS,
			FILE_ATTRIBUTE_NORMAL,
			NULL );*/

		// L̃TCY
		shareMemorySize = LOG_BLOCK_SIZE * iniInfo.maxline + 5;

		// L쐬
		char path_buffer[_MAX_PATH];
		char fname[_MAX_FNAME];
		LPTSTR fnameext;
		fnameext = ::PathFindFileName( iniInfo.filename );
		_splitpath( fnameext, NULL, NULL, fname, NULL );
		_makepath( path_buffer, NULL, NULL, fname, NULL );
		m_strMapName.Format( path_buffer );

		m_hMapping = ::OpenFileMapping(
			FILE_MAP_WRITE | FILE_MAP_READ,
			FALSE,
			m_strMapName );

		if( m_hMapping == NULL )
		{
			bSharedMem = TRUE;

			m_hMapping = ::CreateFileMapping(
			(HANDLE)0xffffffff,     // L̏ꍇ0xffffffffw
			&sa,                    // ZLeBBNULLł悢
			PAGE_READWRITE,         // veNgǂݏ\Ɏw
			0,                      // t@CTCY̏32rbg
			shareMemorySize,        // t@CTCỶ32rbg
			m_strMapName );

			if( m_hMapping == NULL)
				TRACE( _T("Failed CreateFileMapping\n") );
		}

		m_pMappingView = ::MapViewOfFile( m_hMapping, FILE_MAP_ALL_ACCESS, 0, 0, 0 );
		if( m_pMappingView == NULL )
			TRACE( _T("Failed MapViewOfFile\n") );
		
		//Write MacineInfo to shared memory

		if( bOsType == false){
			//Create mutex name
			m_strMutexName.Format( "nkcCommonlog_" + m_strMapName + "_mutex" );
		}
		else{
			//Create mutex name
			m_strMutexName.Format( "Global\\nkcCommonlog_" + m_strMapName + "_mutex" );
		}

		//Create mutex
		m_pMutex = new CMutex( FALSE, m_strMutexName, &sa );

		//L쐬Ăꍇ
		if( FALSE == bSharedMem )
		{
			// LɃOĂȂ΁AReadLogFiles
			// s擾
			char linePosStr[5]={0},	lineLoopFlgStr;
			int  linePos,		lineLoopFlg;
			// ܂ԂtO
			memcpy( &lineLoopFlgStr, (LPTSTR)m_pMappingView + 4, 1);
			lineLoopFlg = (int)lineLoopFlgStr;
			// s
			memcpy( linePosStr, (LPTSTR)m_pMappingView, 4 );
			linePosStr[4] = NULL;
			linePos = atoi( linePosStr );
			// sA܂Ԃ0Ȃ
			if(lineLoopFlg==0 && linePos == 0 )//0NAꂽL݂ꍇAReadLogFiles
				bSharedMem = TRUE;
		}

		//Ot@Cǂݍŏ݃|C^XV
		if( TRUE == bSharedMem )
			ReadLogFile();

	}
	catch( CMemoryException e )
	{
		TRACE(_T("MemoryException Occured\n"));
	}
	catch( CException* e )
	{
		TRACE(_T("Exception Occured\n"));
		e->Delete();
	}
	catch( ... )
	{
		TRACE(_T("Failed CNkcLogCommon\n"));
	}

}


//////////////////////////////////////////////////////////////////////////////
//  MODULE   : CNkcLogCommon::LogToMemory
//  ABSTRACT : 
//  FUNCTION : 
//
//  NOTE     : 
//
//  RETURN   : Ȃ
//
//  CREATE   : N.Okada(EAC)		2006.07.07	VK쐬
//  UPDATE   : N.Okada(EAC)		2006.08.02	Cio[̎擾@̕ύX
//  UPDATE   : N.Okada(EAC)		2006.11.02  Lւ̏ݎɃ[NA悤ɕύX
//  UPDATE	 : S.AOKI(AVASYS)	2008.07.14  ISO C++̏itoa  _itoaɕύX
//////////////////////////////////////////////////////////////////////////////
void CNkcLogCommon::LogToMemory( int level, LPCSTR filename, int linenumber, LPCSTR mes )
{
	if( (level == LOG_FATAL) && ( iniInfo.levelfatal == LOGLEVEL_NOT_OUT) ) return;
	if( (level == LOG_WARN)	 && ( iniInfo.levelwarn  == LOGLEVEL_NOT_OUT) ) return;
	if( (level == LOG_INFO)	 && ( iniInfo.levelinfo  == LOGLEVEL_NOT_OUT) ) return;
	if( (level == LOG_DEBUG) && ( iniInfo.leveldebug == LOGLEVEL_NOT_OUT) ) return;

	int	 i;
	char logBuf[LOG_BLOCK_SIZE];			// ObZ[W
	char linePosStr[5], lineLoopFlgStr;		// L̃wb_bZ[W
	int	 linePos,writePointer;
	char lineLoopFlg[1];
	CString tmpbuf;

	try
	{
		// obt@̏i󔒁j
		for( i = 0; i < LOG_BLOCK_SIZE; i ++ )
		{
			logBuf[i] = 0x20;
		}

		// 
		SYSTEMTIME CurTime;
		GetLocalTime( &CurTime );
		sprintf( logBuf + 0, "%02d%02d%02d%02d%02d%03d",
			CurTime.wMonth,
			CurTime.wDay,
			CurTime.wHour,
			CurTime.wMinute,
			CurTime.wSecond,
			CurTime.wMilliseconds );

		// x
		CString strLevel = GetLevel( level );
		memcpy( logBuf + 13,  strLevel, strLevel.GetLength() );
		// logger
		if( strlen(iniInfo.logger) > MAX_LOGGER_NAME )
		{
			tmpbuf.Empty();
			tmpbuf = iniInfo.logger;
			memcpy( logBuf + 18, tmpbuf.Left(MAX_LOGGER_NAME), MAX_LOGGER_NAME );
		}
		else
			memcpy( logBuf + 18, iniInfo.logger, strlen(iniInfo.logger) );
		// t@C
		CString strFileName = GetFileName( filename );
		if( strFileName.GetLength() > MAX_FILE_NAME )
			memcpy( logBuf + 50, strFileName.Left(MAX_FILE_NAME), MAX_FILE_NAME );
		else
			memcpy( logBuf + 50, strFileName, strFileName.GetLength() );

		// sԍ
		CString strLineNumber;
		strLineNumber.Format( "%d", linenumber);		
		int linenumberLen = strLineNumber.GetLength();
		if( linenumberLen < 6)
		{
			// linenumber6oCgɖȂꍇA0x20i󔒁j
			for( i = 0; i < 6 - linenumberLen; i ++ )
			{
				logBuf[82 + i] = 0x20;
			}
			memcpy( logBuf + (82 + 6 - linenumberLen), strLineNumber, linenumberLen );
		}
		else
		{
			memcpy( logBuf + 82, strLineNumber, linenumberLen );
		}

		// bZ[W
		if( strlen(mes) > MAX_MESSAGE - 1 )
		{
			tmpbuf.Empty();
			tmpbuf = mes;
			CString strTmp;
			strTmp = tmpbuf.Left(MAX_MESSAGE - 1);
			strncpy( logBuf + 88, strTmp, MAX_MESSAGE );
//			memcpy( logBuf + 88, tmpbuf.Left(MAX_MESSAGE), MAX_MESSAGE );
		}
		else
			strncpy( logBuf + 88, mes, MAX_MESSAGE );
//			memcpy( logBuf + 88, mes, strlen(mes) );
	}
	catch( CMemoryException e)
	{
		TRACE(_T("MemoryException Occured\n"));
	}
	catch( ... )
	{
		TRACE(_T("Failed LogToMemory - Create Log Format\n"));
	}
	
	// Write to shared memory 
	m_pMutex->Lock(INFINITE);

	try
	{
		// ݃|C^擾
		memcpy( linePosStr, (LPTSTR)m_pMappingView, 4 );
		linePosStr[4] = NULL;
		linePos = atoi( linePosStr );

		memcpy( &lineLoopFlgStr, (LPTSTR)m_pMappingView + 4, 1);

		// Lւ̏݃X^[gʒu
		writePointer = linePos * LOG_BLOCK_SIZE + 5;

		// LɃO
//		for (i = 0; i < LOG_BLOCK_SIZE; i++)
//		{
			memcpy( (LPTSTR)m_pMappingView + writePointer, logBuf, LOG_BLOCK_SIZE );
//		}

		// ݃|C^XV
		linePos ++;
		if( linePos >= iniInfo.maxline )
		{
			linePos = 0;
			memcpy( (char*)lineLoopFlg, "1", 1);
			memcpy( (LPTSTR)m_pMappingView + 4, lineLoopFlg, 1 );
		}

		// int to char
		_itoa( linePos, linePosStr, 10 );
		linePosStr[4] = NULL;
		for( i = 0; i < 4; i ++ )
		{
			memcpy( (LPTSTR)m_pMappingView, linePosStr, 4 );

		}
	}
	catch( ... )
	{
		TRACE( _T("Failed LogToMemory - Write to Shared Memory\n") );
	}

	m_pMutex->Unlock();

	return;
}


//////////////////////////////////////////////////////////////////////////////
//  MODULE   : CNkcLogCommon::FileOut
//  ABSTRACT : L̃Ot@Cɏo͂
//  FUNCTION : 
//
//  NOTE     : 
//
//  RETURN   : Ȃ
//
//  CREATE   : N.Okada(EAC)		2006.07.10	VK쐬
//  UPDATE   : N.Okada(EAC)		2006.08.02	Cio[̎擾@̕ύX
//  UPDATE   : N.Okada(EAC)		2006.08.07  mutex̕svLock폜
//  UPDATE   : N.Okada(EAC)		2006.08.18  t@Cnh̃N[YʒuύX
//  UPDATE   : N.Okada(EAC)		2006.10.31  t@C̃I[vύX
//////////////////////////////////////////////////////////////////////////////
void CNkcLogCommon::FileOut( void )
{
	char linePosStr[5], lineLoopFlgStr;		// L̃wb_bZ[W
	long linePos;
	int  lineLoopFlg;

	CString strLog;

	int i;

	try
	{
		m_pMutex->Lock(INFINITE);

		//t@CnhN[Y
		if( m_hFile != INVALID_HANDLE_VALUE )
		{
			CloseHandle( m_hFile );
			m_hFile = INVALID_HANDLE_VALUE;
		}

		// t@Cnh擾
		m_hFile = ::CreateFile(
			iniInfo.filename,
			GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ,
			0,
			CREATE_ALWAYS,
			FILE_ATTRIBUTE_NORMAL,
			NULL );

//		::SetFilePointer( m_hFile, NULL, NULL, FILE_END );

		// t@Cnh̎擾Ɏsꍇ(tH_݂Ȃꍇ)At@Cɏo͂Ȃ
		if(m_hFile == INVALID_HANDLE_VALUE )
		{
			TRACE(_T("Failed Get File Handle\n"));
			m_pMutex->Unlock();

			return;
		}

		// ݃|C^擾
		memcpy( linePosStr, (LPTSTR)m_pMappingView, 4 );
		linePosStr[4] = NULL;
		linePos = atoi( linePosStr );
		
		memcpy( &lineLoopFlgStr, (LPTSTR)m_pMappingView + 4, 1);
		lineLoopFlg = (int)lineLoopFlgStr;

		// L烍O擾At@Cɏo͂
		// O[vĂꍇ
		if( lineLoopFlg != 0 )
		{
			for( i = linePos; i < iniInfo.maxline; i ++ )
			{
				strLog = makeFileOutLogStr( i );
				WriteLogFile( strLog );
			}
		}
		for( i = 0; i < linePos; i ++ )
		{
			strLog = makeFileOutLogStr( i );
			WriteLogFile( strLog );
		}

		//t@CnhN[Y
		if( m_hFile != INVALID_HANDLE_VALUE )
		{
			CloseHandle( m_hFile );
			m_hFile = INVALID_HANDLE_VALUE;
		}
	}
	catch( ... )
	{
		TRACE( _T("Failed FileOut\n") );
	}

	m_pMutex->Unlock();

	return ;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void CNkcLogCommon::FileOut( LPCSTR dirPath )
{
	char linePosStr[5], lineLoopFlgStr;		// L̃wb_bZ[W
	long linePos;
	int  lineLoopFlg;

	CString strLog;

	int i;

	int x;
	char s1[MAX_PATH],s2[MAX_PATH];
	char* p1;

	//INIt@C當擾
	GetPrivateProfileString( "log", "filename", ERR, s1, sizeof(s1), inifilename );
	if(strcmp(s1,ERR)==0)	return;

	//擾Ɉُ킪ΏI
	if((NULL==dirPath)||(0==*dirPath)||(strlen(s1)==0))	return;

	//t@C擾
	p1 = strrchr(s1,'\\');
	//t@Ĉ
	if(!p1){
		p1 = s1;
	}else{
		p1++;//\\̎
	}
	

	strcpy(s2,dirPath);
	x=strlen(s2);
	if(s2[x-1]!='\\'){
		s2[x]='\\';
		s2[x+1]=0;
	}
	strcat(s2,p1);

	try
	{
		m_pMutex->Lock(INFINITE);

		//t@CnhN[Y
		if( m_hFile != INVALID_HANDLE_VALUE )
		{
			CloseHandle( m_hFile );
			m_hFile = INVALID_HANDLE_VALUE;
		}

		// t@Cnh擾
		m_hFile = ::CreateFile(
			s2,
			GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ,
			0,
			OPEN_ALWAYS,
			FILE_ATTRIBUTE_NORMAL,
			NULL );

//		::SetFilePointer( m_hFile, NULL, NULL, FILE_END );

		// t@Cnh̎擾Ɏsꍇ(tH_݂Ȃꍇ)At@Cɏo͂Ȃ
		if(m_hFile == INVALID_HANDLE_VALUE )
		{
			TRACE(_T("Failed Get File Handle\n"));
			m_pMutex->Unlock();

			return;
		}

		// ݃|C^擾
		memcpy( linePosStr, (LPTSTR)m_pMappingView, 4 );
		linePosStr[4] = NULL;
		linePos = atoi( linePosStr );
		
		memcpy( &lineLoopFlgStr, (LPTSTR)m_pMappingView + 4, 1);
		lineLoopFlg = (int)lineLoopFlgStr;

		// L烍O擾At@Cɏo͂
		// O[vĂꍇ
		if( lineLoopFlg != 0 )
		{
			for( i = linePos; i < iniInfo.maxline; i ++ )
			{
				strLog = makeFileOutLogStr( i );
				WriteLogFile( strLog );
			}
		}
		for( i = 0; i < linePos; i ++ )
		{
			strLog = makeFileOutLogStr( i );
			WriteLogFile( strLog );
		}

		//t@CnhN[Y
		if( m_hFile != INVALID_HANDLE_VALUE )
		{
			CloseHandle( m_hFile );
			m_hFile = INVALID_HANDLE_VALUE;
		}
	}
	catch( ... )
	{
		TRACE( _T("Failed FileOut\n") );
	}

	m_pMutex->Unlock();

	FileOut();

	return ;
}


//////////////////////////////////////////////////////////////////////////////
//  MODULE   : CNkcLogCommon::EndLog
//  ABSTRACT : Oo͂̏I
//  FUNCTION : 
//
//  NOTE     : 
//
//  RETURN   :
//
//  CREATE   : N.Okada(EAC)		2006.07.10	VK쐬
//  UPDATE   : N.Okada(EAC)		2006.07.20
//  UPDATE   : M.Ohkubo(VSN)	2007.10.12
//////////////////////////////////////////////////////////////////////////////
void CNkcLogCommon::EndLog()
{
	if( m_pMappingView != NULL )
	{
		UnmapViewOfFile( m_pMappingView );
		m_pMappingView = NULL;
	}

	if( m_pStartUpMappingView != NULL )
	{
		UnmapViewOfFile( m_pStartUpMappingView );
		m_pStartUpMappingView = NULL;
	}

	if( m_hMapping != NULL )
	{
		CloseHandle(m_hMapping);
		m_hMapping = NULL;
	}

	if( m_hFile != INVALID_HANDLE_VALUE )
	{
		CloseHandle(m_hFile);
		m_hFile = INVALID_HANDLE_VALUE;
	}

	if( m_pMutex != NULL )
	{
		delete m_pMutex;
		m_pMutex = NULL;
	}

/*----------NoritsuHelperΉ----------*/
#if	(NORITSU_HELPER)
	if( m_pStatrUpMutex != NULL )
	{
		delete m_pStatrUpMutex;
		m_pStatrUpMutex = NULL;
	}
#endif
/*-------------------------------------*/

	return;

}


//////////////////////////////////////////////////////////////////////////////
//  MODULE   : CNkcLogCommon::WriteLogFile
//  ABSTRACT : t@Cɏ
//  FUNCTION : 
//
//  NOTE     : 
//
//  RETURN   : Ȃ
//
//  CREATE   : N.Okada(EAC)		2006.07.07	VK쐬
//  UPDATE   : N.Okada(EAC)		2006.07.20
//////////////////////////////////////////////////////////////////////////////
void CNkcLogCommon::WriteLogFile( LPCSTR mes )
{
	CString strMes;
	strMes = mes;

	unsigned long num;

	try
	{
		::WriteFile( m_hFile, strMes, strMes.GetLength(), &num, NULL );
	}
	catch( ... )
	{
		TRACE(_T("Failed WriteToFile\n"));
	}

	return;
}


//////////////////////////////////////////////////////////////////////////////
//  MODULE   : CNkcLogCommon::GetLevel
//  ABSTRACT : xx擾
//  FUNCTION : 
//
//  NOTE     : 
//
//  RETURN   :
//
//  CREATE   : N.Okada(EAC)		2006.07.07	VK쐬
//  UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CString CNkcLogCommon::GetLevel( int level )
{
	CString strLevel;

	try
	{
		m_LevelMap.Lookup( level, strLevel );
	}
	catch( ... )
	{
		TRACE(_T("Failed GetLevel\n"));

	}
	return strLevel;
}


//////////////////////////////////////////////////////////////////////////////
//  MODULE   : CNkcLogCommon::GetFileName
//  ABSTRACT : t@CpXt@C擾
//  FUNCTION : 
//
//  NOTE     : 
//
//  RETURN   :t@C
//
//  CREATE   : N.Okada(EAC)		2006.07.11	VK쐬
//  UPDATE   : N.Okada(EAC)		2006.07.20
//////////////////////////////////////////////////////////////////////////////
CString CNkcLogCommon::GetFileName( LPCSTR filename )
{
	return ::PathFindFileName( filename );
}


//////////////////////////////////////////////////////////////////////////////
//  MODULE   : CNkcLogCommon::makeFileOutLogStr
//  ABSTRACT : L̃Cԍ當f[^쐬
//  FUNCTION : 
//
//  NOTE     : 
//
//  RETURN   : o̓bZ[W
//
//  CREATE   : N.Okada(EAC)		2006.07.10	VK쐬
//  UPDATE   : N.Okada(EAC)		2006.07.20
//  UPDATE   : N.Okada(EAC)		2006.08.18  CStringւ̑@ύX
//  UPDATE   : N.Okada(EAC)		2006.10.31  ȂisȕjꍇAEmptyԂ悤ύX
//  UPDATE   : N.Okada(EAC)		2006.11.02  Lǂݍ񂾕̍Ō\0t
//////////////////////////////////////////////////////////////////////////////
CString CNkcLogCommon::makeFileOutLogStr( int linePos )
{
	char logBuf[LOG_BLOCK_SIZE];			// ObZ[W

	CString strTmpLog, strLog;
	strTmpLog.Empty();
	strLog.Empty();

	try
	{
		// L烍O擾
//		memcpy( logBuf, (LPTSTR)m_pMappingView + 5 + LOG_BLOCK_SIZE * linePos, LOG_BLOCK_SIZE );
		strncpy( logBuf, (LPTSTR)m_pMappingView + 5 + LOG_BLOCK_SIZE * linePos, LOG_BLOCK_SIZE );
		strTmpLog = logBuf;

		if( strTmpLog.GetLength() > 88 )
		{
			strLog.Format( strTmpLog.Left(2) + "/" );
			strTmpLog.Delete( 0, 2 );
			strLog.Format( strLog + strTmpLog.Left(2) + " " );
			strTmpLog.Delete( 0, 2 );
			strLog.Format( strLog + strTmpLog.Left(2) + ":" );
			strTmpLog.Delete( 0, 2 );
			strLog.Format( strLog + strTmpLog.Left(2) + ":" );
			strTmpLog.Delete( 0, 2 );
			strLog.Format( strLog + strTmpLog.Left(2) + "." );
			strTmpLog.Delete( 0, 2 );
			strLog.Format( strLog + strTmpLog.Left(3) );
			strTmpLog.Delete( 0, 3 );
			strLog.Format( strLog + "[" + strTmpLog.Left(5) + "]" );
			strTmpLog.Delete( 0, 5 );
			strLog.Format( strLog + " [" + strTmpLog.Left(32) + "]" );
			strTmpLog.Delete( 0, 32 );
			strLog.Format( strLog + " [" + strTmpLog.Left(32) + "]" );
			strTmpLog.Delete( 0, 32 );
			strLog.Format( strLog + " [" + strTmpLog.Left(6) + "]" );
			strTmpLog.Delete( 0, 6 );
			strLog = strLog + " - " + strTmpLog.Left(256) + "\r\n";
		}
	}
	catch( CMemoryException e )
	{
		TRACE(_T("MemoryException Occured\n"));
	}
	catch( ... )
	{
		TRACE(_T("Failed makeFileOutLogStr\n"));
	}

	return strLog;
}


//////////////////////////////////////////////////////////////////////////////
//  MODULE   : CNkcLogCommon::ReadLogFile
//  ABSTRACT : LogFileǂݍōsJEg
//			   JEgsŋL̃CԍXV
//  FUNCTION : 
//
//  NOTE     : 
//
//  RETURN   : o̓bZ[W
//
//  CREATE   : N.Okada(EAC)		2006.08.18	VK쐬
//  UPDATE   : N.Okada(EAC)		2006.08.28  Ot@Cǂݍݎ̃[v񐔂CBt@CnhN[YʒuύX
//  UPDATE   : N.Okada(EAC)		2006.11.02  Ǎݕ̕`FbNǉ
//  UPDATE	 : S.AOKI(AVASYS)	2008.07.14  ISO C++̏itoa  _itoaɕύX
//////////////////////////////////////////////////////////////////////////////
int CNkcLogCommon::ReadLogFile()
{
	unsigned long lnum;
	DWORD i = 0, j = 0;
	CString strbuf;
	LPBYTE  lpData, lpDatatmp;
	int count;
	count = 0;

	char linePosStr[5], lineLoopFlgStr;		// L̃wb_bZ[W
	int	 linePos,writePointer;
	char lineLoopFlg[1];

	linePos = 0;

	try
	{
		m_pMutex->Lock(INFINITE);

		// t@Cnh擾
		if( INVALID_HANDLE_VALUE == m_hFile )
		{
			m_hFile = ::CreateFile(
				iniInfo.filename,
				GENERIC_READ | GENERIC_WRITE,
				FILE_SHARE_READ,
				0,
				OPEN_ALWAYS,
				FILE_ATTRIBUTE_NORMAL,
				NULL );
			//t@C擾s
			if( m_hFile == INVALID_HANDLE_VALUE ){
				m_pMutex->Unlock();
				return 0;
			} 
		}

		DWORD dwfSize = ::GetFileSize(m_hFile, NULL);

		lpData = (LPBYTE)GlobalAlloc( GPTR, dwfSize );
		lpDatatmp = lpData;
		::ReadFile( m_hFile, lpData, dwfSize, &lnum, NULL);
		while( i < dwfSize )
		{
			if( *lpDatatmp == '\r')
			{
				count = 0;
//				strbuf += "\r\n";

				///////////////////////////////////
				CString strWritebuf;
				if( strbuf.GetLength() > LOG_BLOCK_SIZE - 1 )
				{
					strWritebuf = strbuf.Left( LOG_BLOCK_SIZE - 1 );
				}
				else
				{
					strWritebuf = strbuf;
				}
//				strWritebuf += "\0";
				///////////////////////////////////

				// ݃|C^擾
				memcpy( linePosStr, (LPTSTR)m_pMappingView, 4 );
				linePosStr[4] = NULL;
				linePos = atoi( linePosStr );

				memcpy( &lineLoopFlgStr, (LPTSTR)m_pMappingView + 4, 1);

				// Lւ̏݃X^[gʒu
				writePointer = linePos * LOG_BLOCK_SIZE + 5;

				// LɃO
//				for (i = 0; i < LOG_BLOCK_SIZE; i++)
//				{
//					memcpy( (LPTSTR)m_pMappingView + writePointer, strbuf, LOG_BLOCK_SIZE );
					strncpy( (LPTSTR)m_pMappingView + writePointer, strWritebuf, LOG_BLOCK_SIZE );
//				}

				// ݃|C^XV
				linePos ++;
				if( linePos >= iniInfo.maxline )
				{
					linePos = 0;
					memcpy( (char*)lineLoopFlg, "1", 1);
					memcpy( (LPTSTR)m_pMappingView + 4, lineLoopFlg, 1 );
				}

				// int to char
				memset( linePosStr, 0, 4 );
				_itoa( linePos, linePosStr, 10 );
				linePosStr[4] = NULL;
				for( j = 0; j < 4; j ++ )
				{
					memcpy( (LPTSTR)m_pMappingView, linePosStr, 4 );

				}

				strbuf.Empty();
				i ++;
				lpDatatmp ++;
			}
			else
			{
				//Lނ߁Asvȕ폜
				strbuf += ( *lpDatatmp );
				count ++;
				switch( count )
				{
				case 2:
				case 5:
				case 8:
				case 11:
				case 14:
				case 18:
					lpDatatmp ++;
					i ++;
					count ++;
					break;
				case 24:
				case 59:
				case 94:
					lpDatatmp += 3;
					i += 3;
					count += 3;
					break;
				case 103:
					lpDatatmp += 4;
					i += 4;
					count += 4;
					break;
				default:
					break;
				}
			}
			i ++;
			lpDatatmp ++;
		}
	}
	catch( CMemoryException e )
	{
		TRACE(_T("MemoryException Occured"));
	}
	catch( ... )
	{
		TRACE(_T("Failed ReadLogFile"));
	}

	//t@CnhN[Y
	if( m_hFile != INVALID_HANDLE_VALUE )
	{
		CloseHandle( m_hFile );
		m_hFile = INVALID_HANDLE_VALUE;
	}

	if( lpData != NULL )
	{
		GlobalFree( (LPBYTE)lpData );
		lpData = NULL;
	}

	m_pMutex->Unlock();

	return linePos;
}


/*----------NoritsuHelperΉp---------------------------------------------*/

//////////////////////////////////////////////////////////////////////////////
//  MODULE   : CreateStartUpLogInfo
//  ABSTRACT : Lɐݒt@C̃pXǋL 
//			  
//  FUNCTION : 
//
//  NOTE     : 
//
//  RETURN   : 
//
//  CREATE   : N.Okada(EAC)		2006.08.18	VK쐬
//  CREATE   : N.Okada(EAC)		2006.10.19	L̃Cԍ̎擾C܂
//  CREATE   : M.Ohkubo(VSN)	2007.10.17	VistaΉZLeB̒ǉ
//////////////////////////////////////////////////////////////////////////////
void CNkcLogCommon::CreateStartUpLogInfo( LPCSTR configFile )
{
	char logBuf[STARTUP_LOG_BLOCK_SIZE+1]={0};
	int  linePos, writePointer;
	int i;
	BYTE nlinePos;		// L擾Aݒ肷郉Cԍ

	//ZLeB VistaΉ
	SECURITY_DESCRIPTOR sd = { 0 };
	SECURITY_ATTRIBUTES sa = { 0 };
	// SɃANZX
	InitializeSecurityDescriptor( &sd, SECURITY_DESCRIPTOR_REVISION );
	SetSecurityDescriptorDacl( &sd, TRUE, NULL, FALSE );
	sa.nLength				= sizeof(sa);
	sa.lpSecurityDescriptor = &sd;
	sa.bInheritHandle		= TRUE;

	m_pStatrUpMutex->Lock();

	//L쐬
	m_hStartUpMapping = ::OpenFileMapping(
			FILE_MAP_WRITE | FILE_MAP_READ,
			FALSE,
			MEM_NAME_STARTUP );

	if( m_hStartUpMapping == NULL )
	{
		m_hStartUpMapping = ::CreateFileMapping(
		(HANDLE)0xffffffff,
		&sa,
		PAGE_READWRITE,
		0,
		MEM_SIZE_STARTUP,
		MEM_NAME_STARTUP );

		if( m_hStartUpMapping == NULL)
		{
			TRACE( _T("Failed CreateFileMapping - CreateStartUpLogInfo\n") );
			return;
		}
	}

	m_pStartUpMappingView = ::MapViewOfFile( m_hStartUpMapping, FILE_MAP_ALL_ACCESS, 0, 0, 0 );
	if( m_pStartUpMappingView == NULL ){
		TRACE( _T("Failed MapViewOfFile - CreateStartUpLogInfo\n") );
		return;
	}


	//t@C݈ʒu擾
//	memcpy( linePosStr, (LPTSTR)m_pStartUpMappingView, 1 );
//	linePos = atoi( linePosStr );
	memcpy( &nlinePos, (LPTSTR)m_pStartUpMappingView, 1 );
	linePos = (int)nlinePos;
	
	//͈͊OȂۂ߂
	if( linePos > (MAX_STARTUP_MEM_LINE+1)){ 
		linePos = MAX_STARTUP_MEM_LINE;
	}
	else if(linePos < 0){
		linePos = 0;
	}

	//d`FbN
	CString strtmp;
	for( i = 0; i < linePos; i ++ )
	{
		memcpy( logBuf, (LPTSTR)m_pStartUpMappingView + 1 + STARTUP_LOG_BLOCK_SIZE * i, STARTUP_LOG_BLOCK_SIZE );
		strtmp = logBuf;
		if( 0 == strtmp.Compare(configFile) )
		{
			TRACE( _T("Same Data - CreateStartUpLogInfo\n") );
			m_pStatrUpMutex->Unlock();
			return;
		}
	}
	
	//ő僉C𒴂ĂꍇALɒǋLȂ
	if( linePos > MAX_STARTUP_MEM_LINE)
	{
		TRACE( _T("Could not add data - CreateStartUpLogInfo\n") );
		m_pStatrUpMutex->Unlock();
		return;
	}

	//t@Cɏ
	writePointer = linePos * STARTUP_LOG_BLOCK_SIZE + 1;
//	for (i = 0; i < LOG_BLOCK_SIZE; i++)
//	{
		memcpy( (LPTSTR)m_pStartUpMappingView + writePointer, configFile, STARTUP_LOG_BLOCK_SIZE );
//	}

	char logbuf[_MAX_PATH];
	memcpy( logbuf, (LPTSTR)m_pStartUpMappingView + 1 + STARTUP_LOG_BLOCK_SIZE * 0, STARTUP_LOG_BLOCK_SIZE );

	//݃|C^XV
	linePos ++;
//	itoa( linePos, linePosStr, 10 );
	nlinePos = (BYTE)linePos;
//	memcpy( (LPTSTR)m_pStartUpMappingView, linePosStr, 1 );
	memcpy( (LPTSTR)m_pStartUpMappingView, &nlinePos, 1 );

	m_pStatrUpMutex->Unlock();

	return;
}


//////////////////////////////////////////////////////////////////////////////
//  MODULE   : GetFullFilePath
//  ABSTRACT : ΃t@CpX΃t@CpXɂB
//			  
//  FUNCTION : 
//
//  NOTE     : 
//
//  RETURN   : 
//
//  CREATE   : M.Ohkubo(VSN)		2006.10.05	VK쐬
//  UPDATE   :
//////////////////////////////////////////////////////////////////////////////
void CNkcLogCommon::GetFullFilePath( char* filename,  LPCSTR localpath )
{
	char str[MAX_INI_PARAM*2];
	int i,j;

	//2ڂ':'ł΃tpXƔf
	if( *(filename+1) == ':' )	return;


	if( localpath == NULL ){
		sprintf(str,"%s",_pgmptr);//ďost@C擾
	}else{
		sprintf(str,"%s",localpath);//w̃pXJnʒuƂ
	}

	//st@C
	for(i=strlen(str);0<i;i--)
	{	//납'\'܂Ŗ߂A炻̌؂B
		if(str[i-1]=='\\'){
			str[i-1] = 0;
			break;
		}
	}

	//st@C̎擾ɎsύXÂɏI(̃p^[͖Ǝv)
	if(!i)	return;


	// .\ ..\ 
	j=0;
	while(1)
	{
		if( *(filename + j) == '.'){			//"."
			if( *(filename + j+1) == '\\'){		//".\"Ȃ
				//".\"؂
				j+=2;
				break;
			}
			else if(*(filename + j+1) == '.'){	//".."
				if( *(filename + j+2) == '\\'){	//"..\"Ȃ
					for(i=strlen(str);0<i;i--)
					{	//납'\'܂Ŗ߂A炻̌؂B
						if(str[i-1]=='\\'){
							str[i-1] = 0;
							break;
						}
					}
					//st@C̎擾ɎsύXÂɏI(̃p^[͖Ǝv)
					if(!i)	return;

					//"..\"؂
					j+=3;
				}
				else{	return;	}
			}
			else{	return;	}
		}
		else{	break;	}

		//I[o[
		if( j > (int)strlen(filename) )	return;
	}

	//tH_ƃt@CA
	sprintf(str,"%s\\%s",str,filename + j);

	//t@C
	if( MAX_INI_PARAM < strlen(str) )	return;

	//tt@CpXԂ
	memcpy(filename,str,MAX_INI_PARAM);
	return;
}
